#include "g7to.h"
static const LONGdouble CONVERT = 11930464.7111111111;  /* 2^31 / 180 */

INT dsplines=0;
INT dsppixels=0;
//=====================================================================
// Data from Garmin Beta Document
//
//=====================================================================
INT  SPWptNo=0;
BYTE *StreetPilotWptName;
BYTE *StreetPilotLnk_ident;
INT go_on=1;
//
// Defines of Known Product_ID's
//
#define GPSIIP               73
#define GPS12_12XLA          77
#define GPS12                87
#define GPS12_12XLB          96
#define GPSIIP_1             97
#define GPS12CX             116
#define GPS12XL_J           105  // Japanese
#define GPS12XL_C           106  // Chinese
#define GPS38_40_45_45XL_A   31
#define GPS38_40_45_45XL_B   41
#define GPSII                59
#define GPS38_C              56
#define GPS38_J              62
#define GPSIIIPILOT          71
#define GPSIII_ID            72
#define STREETPILOT          67
#define STREETPILOTCOLORMAP 118
#define GPS3P               119

// Garmin GPS Family for Icons
//
INT Ggps=0;
#define     G12XL           1
#define     GPSIII          2
#define     GPSIIIP         3
#define     SPILOT          4
#define     SPILOTCOLOR     5

//=====================================================================
//
// Garmin symbol numbers
//
//=====================================================================
enum
{
//
// * indicates those in the GPS III revision 2.05 and greater
//
//---------------------------------------------------------------
// Symbols for marine (group 0...0-8191...bits 15-13=000).
//---------------------------------------------------------------
	sym_anchor =			0,	// 0x0000 * white anchor symbol 
	sym_bell =				1,	// 0x0001 * white bell symbol 
	sym_diamond_grn =		2,	// 0x0002   green diamond symbol 
	sym_diamond_red =		3,	// 0x0003   red diamond symbol 
	sym_dive1 =				4,	// 0x0004   diver down flag 1 
	sym_dive2 =				5,	// 0x0005   diver down flag 2 
	sym_dollar =			6,	// 0x0006 * white dollar symbol 
	sym_fish =				7,	// 0x0007 * white fish symbol 
	sym_fuel =				8,	// 0x0008 * white fuel symbol 
	sym_horn =				9,	// 0x0009   white horn symbol 
	sym_house =			   10,	// 0x000a * white house symbol 
	sym_knife =			   11,	// 0x000b * white knife & fork symbol 
	sym_light =			   12,	// 0x000c   white light symbol 
	sym_mug =			   13,	// 0x000d * white mug symbol 
	sym_skull =			   14,	// 0x000e * white skull and crossbones symbol
	sym_square_grn =	   15,	// 0x000f   green square symbol 
	sym_square_red =	   16,	// 0x0010   red square symbol 
	sym_wbuoy =			   17,	// 0x0011   white buoy waypoint symbol 
	sym_wpt_dot =		   18,	// 0x0012 * waypoint dot 
	sym_wreck =			   19,	// 0x0013   white wreck symbol 
	sym_null =			   20,	// 0x0014   null symbol (transparent) 
	sym_mob =			   21,	// 0x0015 * man overboard symbol 
//------------------------------------------------------
// Marine navaid symbols
//------------------------------------------------------
	sym_buoy_ambr =		   22,	// 0x0016   amber map buoy symbol 
	sym_buoy_blck =		   23,	// 0x0017   black map buoy symbol 
	sym_buoy_blue =		   24,	// 0x0018   blue map buoy symbol 
	sym_buoy_grn =		   25,	// 0x0019   green map buoy symbol 
	sym_buoy_grn_red =	   26,	// 0x001a   green/red map buoy symbol 
	sym_buoy_grn_wht =	   27,	// 0x001b   green/white map buoy symbol 
	sym_buoy_orng =		   28,	// 0x001c   orange map buoy symbol 
	sym_buoy_red =		   29,	// 0x001d   red map buoy symbol 
	sym_buoy_red_grn =	   30,	// 0x001e   red/green map buoy symbol 
	sym_buoy_red_wht =	   31,	// 0x001f   red/white map buoy symbol 
	sym_buoy_violet =	   32,	// 0x0020   violet map buoy symbol 
	sym_buoy_wht =		   33,	// 0x0021   white map buoy symbol 
	sym_buoy_wht_grn =	   34,	// 0x0022   white/green map buoy symbol 
	sym_buoy_wht_red =	   35,	// 0x0023   white/red map buoy symbol 
	sym_dot =			   36,	// 0x0024   white dot symbol 
	sym_rbcn =			   37,	// 0x0025   radio beacon symbol 
//------------------------------------------------------
// ... leave space for more navaids (up to 128 total)
//------------------------------------------------------
	sym_boat_ramp =		  150,	// 0x0096 * boat ramp symbol 
	sym_camp =			  151,	// 0x0097 * campground symbol 
	sym_restrooms =		  152,	// 0x0098 * restrooms symbol 
	sym_showers =		  153,	// 0x0099 * shower symbol 
	sym_drinking_wtr =	  154,	// 0x009a * drinking water symbol 
	sym_phone =			  155,	// 0x009b * telephone symbol 
	sym_1st_aid =		  156,	// 0x009c * first aid symbol 
	sym_info =			  157,	// 0x009d * information symbol 
	sym_parking =		  158,	// 0x009e * parking symbol 
	sym_park =			  159,	// 0x009f * park symbol 
	sym_picnic =		  160,	// 0x00a0 * picnic symbol 
	sym_scenic =		  161,	// 0x00a1 * scenic area symbol 
	sym_skiing =		  162,	// 0x00a2 * skiing symbol 
	sym_swimming =		  163,	// 0x00a3 * swimming symbol 
	sym_dam =			  164,	// 0x00a4 * dam symbol 
	sym_controlled =	  165,	// 0x00a5   controlled area symbol 
	sym_danger =		  166,	// 0x00a6   danger symbol 
	sym_restricted =	  167,	// 0x00a7   restricted area symbol 
	sym_null_2 =		  168,	// 0x00a8   null symbol 
	sym_ball =			  169,	// 0x00a9 * ball symbol 
	sym_car =			  170,	// 0x00aa * car symbol 
	sym_deer =			  171,	// 0x00ab * deer symbol 
	sym_shpng_cart =	  172,	// 0x00ac * shopping cart symbol 
	sym_lodging =		  173,	// 0x00ad * lodging symbol 
	sym_mine =            174,  // 0x00ae * mine symbol
//---------------------------------------------------------------
// Symbols for land (group 1...8192-16383...bits 15-13=001).
//---------------------------------------------------------------
	sym_is_hwy =		 8192,	// 0x2000   interstate hwy symbol 
	sym_us_hwy =		 8193,	// 0x2001   us hwy symbol 
	sym_st_hwy =		 8194,	// 0x2002   state hwy symbol 
	sym_mi_mrkr =		 8195,	// 0x2003   mile marker symbol 
	sym_trcbck =		 8196,	// 0x2004 * TracBack (feet) symbol 
	sym_golf =			 8197,	// 0x2005 * golf symbol 
	sym_sml_cty =		 8198,	// 0x2006 * small city symbol 
	sym_med_cty =		 8199,	// 0x2007 * medium city symbol 
	sym_lrg_cty =		 8200,	// 0x2008 * large city symbol 
	sym_freeway =		 8201,	// 0x2009   intl freeway hwy symbol 
	sym_ntl_hwy =		 8202,	// 0x200a   intl national hwy symbol 
	sym_cap_cty =		 8203,	// 0x200b   capitol city symbol (star) 
	sym_amuse_pk =		 8204,	// 0x200c   amusement park symbol 
	sym_bowling =		 8205,	// 0x200d   bowling symbol 
	sym_car_rental =	 8206,	// 0x200e   car rental symbol 
	sym_car_repair =	 8207,	// 0x200f   car repair symbol 
	sym_fastfood =		 8208,	// 0x2010   fast food symbol 
	sym_fitness =		 8209,	// 0x2011   fitness symbol 
	sym_movie =			 8210,	// 0x2012   movie symbol 
	sym_museum =		 8211,	// 0x2013   museum symbol 
	sym_pharmacy =		 8212,	// 0x2014   pharmacy symbol 
	sym_pizza =			 8213,	// 0x2015   pizza symbol 
	sym_post_ofc =		 8214,	// 0x2016   post office symbol 
	sym_rv_park =		 8215,	// 0x2017   RV park symbol 
	sym_school =		 8216,	// 0x2018   school symbol 
	sym_stadium =		 8217,	// 0x2019   stadium symbol 
	sym_store =			 8218,	// 0x201a   dept. store symbol 
	sym_zoo =			 8219,	// 0x201b   zoo symbol 
//---------------------------------------------------------------
// Symbols for aviation (group 2...16383-24575...bits 15-13=010).
//---------------------------------------------------------------
	sym_airport =		16384,	// 0x4000 * airport symbol 
	sym_int =			16385,	// 0x4001   intersection symbol 
	sym_ndb =			16386,	// 0x4002   non-directional beacon symbol 
	sym_vor =			16387,	// 0x4003   VHF omni-range symbol 
	sym_heliport =		16388,	// 0x4004 * heliport symbol 
	sym_private =		16389,	// 0x4005 * private field symbol 
	sym_soft_fld =		16390,	// 0x4006 * soft field symbol 
	sym_tall_tower =	16391,	// 0x4007 * tall tower symbol 
	sym_short_tower =	16392,	// 0x4008 * short tower symbol 
	sym_glider =		16393,	// 0x4009 * glider symbol 
	sym_ultralight =	16394,	// 0x400a * ultralight symbol 
	sym_parachute =		16395,	// 0x400b * parachute symbol 
	sym_vortac =		16396,	// 0x400c   VOR/TACAN symbol 
	sym_vordme =		16397,	// 0x400d   VOR-DME symbol 
	sym_faf =			16398,	// 0x400e   first approach fix 
	sym_lom =			16399,	// 0x400f   localizer outer marker 
	sym_map =			16400,	// 0x4010   missed approach point 
	sym_tacan =			16401,	// 0x4011   TACAN symbol 
	sym_seaplane =		16402,	// 0x4012 * Seaplane Base 
};
//---------------------------------------------------------------
//D103_Wpt_Type symbols:
//---------------------------------------------------------------
enum
{
	smbl_dot = 				0,	//   0x00 dot symbol 
	smbl_house =			1,	//   0x01 house symbol 
	smbl_gas =				2,	//   0x02 gas symbol 
	smbl_car =				3,	//   0x03 car symbol 
	smbl_fish =				4,	//   0x04 fish symbol 
	smbl_boat =				5,	//   0x05 boat symbol 
	smbl_anchor =			6,	//   0x06 anchor symbol 
	smbl_wreck =			7,	//   0x07 wreck symbol 
	smbl_exit =				8,	//   0x08 exit symbol 
	smbl_skull =			9,	//   0x09 skull symbol 
	smbl_flag =			   10,	//   0x0a flag symbol 
	smbl_camp =			   11,	//   0x0b camp symbol 
	smbl_duck =			   12,	//   0x0c duck symbol 
	smbl_deer =			   13,	//   0x0d deer symbol 
	smbl_buoy =			   14,	//   0x0e buoy symbol 
	smbl_back_track =	   15 	//   0x0f back track symbol 
};

//=====================================================================
//  Default Packet IDs
//
enum {
	Pid_Ack_Byte		=   6, // 0x06
	Pid_Nak_Byte		=  21, // 0x15
	Pid_Protocol_Array	= 253, // 0xfd
	Pid_Product_Rget	= 254, // 0xfe
	Pid_Product_Data	= 255  // 0xff
};

//=====================================================================
// L001 - Link Protocol 1
//
enum {
	Pid_Command_data	=  10, // 0x0a
	Pid_Xfer_Cmplt		=  12, // 0x0c
	Pid_Date_Time_Data	=  14, // 0x0e
	Pid_Position_Data	=  17, // 0x11
	Pid_Prx_Wpt_Data	=  19, // 0x13
	Pid_Records			=  27, // 0x1b
	Pid_Rte_Hdr			=  29, // 0x1d
	Pid_Rte_Wpt_Data	=  30, // 0x1e
	Pid_Almanac_Data	=  31, // 0x1f
	Pid_Trk_Data		=  34, // 0x22
	Pid_Wpt_Data		=  35, // 0x23
	Pid_Pvt_Data		=  51, // 0x33  // also seen on GPS III with DeLorme
//  ????                =  65, // 0x41  // seen on GPS III with DeLorme
	Pid_Display_Data    =  69, // 0x45  // GPS III only (so far)
};

//=====================================================================
// L002 - Link Protocol 2
//
enum {
	Pid_Almanac_Data2	=   4, // 0x04
	Pid_Command_Data2	=  11, // 0x0b
	Pid_Xfer_Cmplt2		=  12, // 0x0c
	Pid_Date_Time_Data2	=  20, // 0x14
	Pid_Position_Data2	=  24, // 0x18
	Pid_Records2		=  35, // 0x23
	Pid_Rte_Hdr2		=  37, // 0x25
	Pid_Rte_Wpt_Data2	=  39, // 0x27
	Pid_Wpt_Data2		=  43  // 0x2b
};

//=====================================================================
// A000 - Product Data Protocol
//
//typedef struct
//{
//	INT product_ID;
//	INT software_version;
//	byte a[1];  // fake for below ...
// char product_description[]; null-terminated string
// ... zero or more additional null-terminated strings
//} Product_Data_Type;

//=====================================================================
// A010 - Device Command Protocol 1
//
enum
{
	Cmnd_Abort_Transfer	=  0, // 0x00	abort current transfer
	Cmnd_Transfer_Alm 	=  1, // 0x01	transfer almanac
	Cmnd_Transfer_Posn 	=  2, // 0x02	transfer position   added by crh
	Cmnd_Transfer_Prx 	=  3, // 0x03	transfer proximity waypoints
	Cmnd_Transfer_Rte 	=  4, // 0x04	transfer routes
	Cmnd_Transfer_Time	=  5, // 0x05	transfer date/time  added by crh
	Cmnd_Transfer_Trk 	=  6, // 0x06	transfer track log
	Cmnd_Transfer_Wpt 	=  7, // 0x07	transfer waypoints
	Cmnd_Turn_Off_Pwr   =  8, // 0x08	Turn unit off
	Cmnd_Send_Voltages  = 17, // 0x11	Send voltage readings (some units)
	Cmnd_Send_Display   = 32, // 0x20   Send GPS III display
	Cmnd_Start_Pvt_Data = 49, // 0x31	start transmitting PVT
	Cmnd_Stop_Pvt_Data	= 50  // 0x32	stop transmitting PVT data
};

//=====================================================================
// A011 - Device Command Protocol 2 (I added the '2' below crh 3/23/98)
//
enum
{
	Cmnd_Abort_Transfer2=  0, // 0x00	abort current transfer
	Cmnd_Transfer_Alm2 	=  4, // 0x04	transfer almanac
	Cmnd_Transfer_Rte2	=  8, // 0x08	transfer routes
	Cmnd_Transfer_Time2 = 20, // 0x14   transfer time
	Cmnd_Transfer_Wpt2	= 21, // 0x15	transfer waypoints
	Cmnd_Turn_Off_Pwr2  = 26  // 0x19   Turn unit off
};
//=====================================================================
// Index into Protocols Array for the various protocol id's
//
//   For example, the III is index 72 which has the following data:
//
//  Product_ID		:  72	Garmin's product ID for the III
//	Product_Ver		:   0	(0 indicates all versions of the III)
//	link			:   1	Link version L001
//	Command			:  10	Command version A010
//	WaypDataRecord	: 104	Waypoint data	D104
//	RouteRecord		: 201	RouteRecord		D201
//	RouteTrkRecord	: 104	RouteTrack		D104
//	TrackDataRecord	: 300	TrackRecord		D300
//	ProxDataRecord  :  -1	ProximityData is not supported on this model gps
//	AlmanacRecord	: 501	AlmanacData		D501
//

INT WaypointType;

//=====================================================================
// Current product info			Examples		Range allowed by doc
//=====================================================================
extern INT D105orD106;			// 1 if current waypoint is from/to a StreetPilot

extern INT Product_ID;			// 72  GPS III 	... 
extern INT Product_Ver;			// 000 - all	...

extern INT PhysicalProtocol;	// 000 = P000	P000

extern INT LinkProtocol;		// 001 = L001	L001,L002
 
extern INT CommandProtocol;		// 010 = A010	A010,A011

extern INT WaypXferProtocol;	// 100 = A100	A100
extern INT WaypDataRecord;		// 104 = D104	D100,D101,D102,D103,D104,D105,D106,D150
								//				D151,D152,D154,D155

extern INT RouteXferProtocol;	// 200 = A200	A200
extern INT RouteHdrType;		// 201 = D201	D200,D201,D202
extern INT RouteDataRecord;		// 104 = D104	D100,D101,D102,D103,D104,D105,D106,D150
								//				D151,D152,D154,D155

extern INT TrackXferProtocol;	// 300 = A300	A300
extern INT TrackDataRecord;		// 300 = D300	D300

extern INT ProxXferProtocol;	// 000 = None	A400
extern INT ProxDataRecord;		// 000 = None	D101,D102,D152,D400,D403,D450

extern INT AlmanacXferProtocol;	// 500 = A500	A500
extern INT AlmanacDataRecord;	// 501 = D501	D500,D501,D550,D551

extern INT UTCXferProtocol;		// 600 = A600	A600
extern INT UTCDataRecord;		// 600 = D600	D600

extern INT PositionXferProtocol;// 700 = A700	A700
extern INT PositionDataRecord;	// 700 = D700	D700

extern INT PVTXferProtocol;		// 000 = None	A800
extern INT PVTDataRecord;		// 000 = None	D800

//=====================================================================
// Product ID vs Protocols supported.  These products do not currently
//  support PVT data transfer (A800-D800).  They do not support the
//  Protocol Capability Protocol, either
//
INT Protocols[55][12] = {
// ID Ver Link Cmnd        Wpt          Rte        Trk       Prx          Alm
// -- --- ---- ----        ---        --------   --------  --------       ---
 { 13,  0,   1,  10,       100,       201, 100,  300, 300, 400, 400,      500},
 { 14,  0,   1,  10,       100,       200, 100,  300, 300, 400, 400,      500},
 { 15,  0,   1,  10,       151,       200, 151,  300, 300, 400, 400,      500},
 { 18,  0,   1,  10,       100,       201, 100,  300, 300, 400, 400,      500},
 { 20,  0,   2,  11,       150,       201, 150,   -1,  -1, 400, 450,      550},
 { 22,  0,   1,  10,       152,       201, 152,  300, 300, 400, 152,      500},
 { 23,  0,   1,  10,       100,       201, 100,  300, 300, 400, 400,      500},
 { 24,  0,   1,  10,       100,       201, 100,  300, 300, 400, 400,      500},
 { 29,-400,  1,  10,       101,       201, 101,  300, 300, 400, 101,      500},
 { 29, 400,  1,  10,       102,       200, 102,  300, 300, 400, 102,      500},
 { 31,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 33,  0,   2,  11,       150,       201, 150,   -1,  -1, 400, 450,      550},
 { 34,  0,   2,  11,       150,       201, 150,   -1,  -1, 400, 450,      550},
 { 35,  0,   1,  10,       100,       201, 100,  300, 300, 400, 400,      500},
 { 36,-300,  1,  10,       152,       201, 152,  300, 300, 400, 152,      500},
 { 36, 300,  1,  10,       152,       201, 152,  300, 300,  -1,  -1,      500},
 { 39,  0,   1,  10,       151,       201, 151,  300, 300,  -1,  -1,      500},
 { 41,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 42,  0,   1,  10,       100,       201, 100,  300, 300, 400, 400,      500},
 { 44,  0,   1,  10,       101,       201, 101,  300, 300, 400, 101,      500},
 { 45,  0,   1,  10,       152,       201, 152,  300, 300,  -1,  -1,      500},
 { 47,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 48,  0,   1,  10,       154,       201, 154,  300, 300,  -1,  -1,      501},
 { 49,  0,   1,  10,       102,       201, 102,  300, 300, 400, 102,      501},
 { 50,  0,   1,  10,       152,       201, 152,  300, 300,  -1,  -1,      501},
 { 52,  0,   2,  11,       150,       201, 150,   -1,  -1, 400, 450,      550},
 { 53,  0,   1,  10,       152,       201, 152,  300, 300,  -1,  -1,      501},
 { 55,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 56,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 59,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 61,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 62,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 64,  0,   2,  11,       150,       201, 150,   -1,  -1, 400, 450,      551},
 { 71,  0,   1,  10,       155,       201, 155,  300, 300,  -1,  -1,      501},
 { 72,  0,   1,  10,       104,       201, 104,  300, 300,  -1,  -1,      501},
 { 73,  0,   1,  10,       103,       201, 103,  300, 300,  -1,  -1,      501},
 { 74,  0,   1,  10,       100,       201, 100,  300, 300,  -1,  -1,      500},
 { 76,  0,   1,  10,       102,       201, 102,  300, 300, 400, 102,      501},
 { 77,-301,  1,  10,       100,       201, 100,  300, 300, 400, 400,      501},
 { 77,-350,  1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 { 77,-361,  1,  10,       103,       201, 103,  300, 300,  -1,  -1,      501},
 { 77, 361,  1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 { 87,  0,   1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 { 95,  0,   1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 { 96,  0,   1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 { 97,  0,   1,  10,       103,       201, 103,  300, 300,  -1,  -1,      501},
 { 98,  0,   2,  11,       150,       201, 150,   -1,  -1, 400, 450,      551},
 {100,  0,   1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 {105,  0,   1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 {106,  0,   1,  10,       103,       201, 103,  300, 300, 400, 403,      501},
 { -1, -1,   -1,  -1,       -1,       -1, -1,    -1,   -1,  -1,  -1,      -1}
};
INT ProtocolIndex=-1;	// index into above table which holds the valid
						//  protocols for this connected device
/* -------------------------------------------------------------------------- */
D100_Wpt_Type 		*D100_Wpt;
D101_Wpt_Type 		*D101_Wpt;
D102_Wpt_Type 		*D102_Wpt;
D103_Wpt_Type 		*D103_Wpt;
D104_Wpt_Type 		*D104_Wpt;
D105_Wpt_Type 		*D105_Wpt; // StreetPilot Waypoint
D106_Wpt_Type 		*D106_Wpt; // StreetPilot Route Waypoint
D107_Wpt_Type       *D107_Wpt; // 12CX
D108_Wpt_Type       *D108_Wpt; // eMap
D150_Wpt_Type 		*D150_Wpt;
D151_Wpt_Type 		*D151_Wpt;
D152_Wpt_Type 		*D152_Wpt;
D154_Wpt_Type 		*D154_Wpt;
D155_Wpt_Type 		*D155_Wpt;
D200_Rte_Hdr_Type 	D200;
D201_Rte_Hdr_Type 	*D201;
D202_Rte_Hdr_Type 	*D202;
D300_Trk_Point_Type *D300_Trk_Point;
D400_Prx_Wpt_Type	*D400_Prx_Wpt;
D403_Prx_Wpt_Type	*D403_Prx_Wpt;
D450_Prx_Wpt_Type	*D450_Prx_Wpt;
D600_Date_Time_Type *dtime;

short SerialMsgLen;
FILE *disout;
INT gLine=0;					//  GPS III Scan line (0-99) being read

unsigned char bmh[118] = {
	 66,  77, 182,  31,   0,   0,   0,   0,   0,   0, 118,   0,   0, 
	  0,  40,   0,   0,   0, 160,   0,   0,   0, 100,   0,   0,   0, 
	  1,   0,   4,   0,   0,   0,   0,   0,  64,  31,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,  16,   0,   0,   0,  16,   0, 
	  0,   0,   0,   0,   0,   0,  99,  99,  99,   0, 181, 181, 181, 
	  0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 
	255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 
	255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 
	255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0 
}; // bmh[118]

unsigned char (*bmdata)[80];	// GPS III

/* -------------------------------------------------------------------------- */
PROCX void settime_record(time_t dot)
{
	if(dot==0)	dot = time(NULL) - 631065600L;
    strcpy(record.datetime,secs2dt(dot, (short)gPrefs.offset));
} // settime_record()

/* -------------------------------------------------------------------------- */
PROCX long toSemiCircles(double b)
{
	return((long)(b*CONVERT));
} // toSemiCircles(double b)

/* -------------------------------------------------------------------------- */
PROCX double toDegrees(long a)
{
	LONGdouble t;

	t=(LONGdouble)(a);
	return ((double)(t/CONVERT));
} // toDegrees(long a)
//
// Performs a strncpy and then converts all but first 0 to a ' ' in dest string
//
PROCX void strncpad(char *d, char *s, INT count)
{
	INT i;

	strncpy(d,s,count);
	for(i=0;i<count;i++) {
		if(d[i]==0) break;
	}
	i++;
	for(i=i;i<count;i++) d[i]=' ';
} // strncpad

/* -------------------------------------------------------------------------- */
/*
 * Send a waypoint to the GPS
 * Returns a result code--zero if GPS receiver did not respond
 */

PROCX void doSWaypoint(INT prox)
{
	short ret;
	byte mlen=0;
	long laa,loo;
	char msgtype[50];
	INT wpt_type;
//
// first waypoint?  Then send number to send if known
//
 	if(prox==0) {
		strcpy(msgtype,"Waypoint Data");
		if(firstwaypoint&&!in_route)
			send_num_points(waypoints,"Waypoints");
		firstwaypoint=0;
	}
	if(prox==1) {
		if(ProxDataRecord==0) {
			fprintf(stderr,"Proximity waypoints are not supported in this GPS unit.\n");
			return;
		}
		strcpy(msgtype,"Proximity Waypoint Data");
		if(firstPwaypoint&&!in_route)
			send_num_points(proximityp,"Proximity");
		firstPwaypoint=0;
	}
//
// convert symbols if Product_ID is that of a 12/II+ gps
//

	if(Ggps == G12XL) {
				ret = record.icon_smbl  = convert_to_12xl(record.icon_smbl);
				if(ret < 0)
					record.icon_smbl=convert_to_12xl(default_G12_icon);
	}
	memset(message,' ',MAX_LENGTH); // set space
	laa = toSemiCircles(record.la);
	loo = toSemiCircles(record.lo);

// blank fill name
	for(ret=0;ret<6;ret++) {
		if(record.ident[ret]==0) break;
	}
	for(ret=ret;ret<6;ret++) record.ident[ret]=0x20;

//
// setup common parts, i.e. the first part of the format is the same for
//  the following Data transfer protocols
//
	if(in_route) wpt_type=RouteDataRecord;
	else wpt_type=WaypDataRecord;

	switch(wpt_type) {
		case 100:
					mlen=sizeof(D100_Wpt_Type);
		case 101:
		case 102:
		case 103:
		case 104:
		case 107:
		case 151:
		case 152:
		case 154:
		case 155:
					D100_Wpt = (D100_Wpt_Type *)&message[2];
					D100_Wpt->posn.lat = laa;
					D100_Wpt->posn.lon = loo;

// clear out ident
					memset(D100_Wpt->ident,' ',6);
					if(datatype==105 || datatype==106) {
						strncpy(D100_Wpt->ident,(char*) StreetPilotWptName,6);
					}
					else {
						strncpy(D100_Wpt->ident, record.ident,6);
					}

// stick in the date just for fun	
					D100_Wpt->unused= 0L;	// dt2secs((short)gPrefs.offset);
				
// clear out comment
					memset(D100_Wpt->cmnt,' ',40);
					if(strlen(record.comment)) {
						 strncpad(D100_Wpt->cmnt, record.comment, 40);
					}
	} // switch(wpt_type)

	switch(wpt_type) {
		case 101: {
			D101_Wpt = (D101_Wpt_Type *)&message[2];
			D101_Wpt->smbl= record.icon_smbl|(record.icon_dspl<<8);
			if(prox==1) D101_Wpt->dst = record.ProxDist; else D101_Wpt->dst=0.0;
			mlen=sizeof(D101_Wpt_Type);
			break;
		}
		case 102: {
			D102_Wpt = (D102_Wpt_Type *)&message[2];
			D102_Wpt->smbl= record.icon_smbl|(record.icon_dspl<<8);
			if(prox==1) D102_Wpt->dst = record.ProxDist; else D102_Wpt->dst=0.0;
			mlen=sizeof(D102_Wpt_Type);
			break;
		}
		case 103: {
			D103_Wpt = (D103_Wpt_Type *)&message[2];

//
// Translate to 12/II+ icon display type
//
//		Program   12/II+      Display mode
//			3        0         Symbol with Waypoint Name
//			1        1         Symbol
//			5        2         Symbol with Waypoint Comment
//
			switch(record.icon_dspl) {
				case 3: record.icon_dspl = 0; break;
				case 5: record.icon_dspl = 2; break;
			}
			D103_Wpt->dspl = record.icon_dspl;
			D103_Wpt->smbl = record.icon_smbl;
			mlen=sizeof(D103_Wpt_Type);
			break;
		}
		case 104: {
			D104_Wpt = (D104_Wpt_Type *)&message[2];
			D104_Wpt->smbl = record.icon_smbl;
			D104_Wpt->dspl = record.icon_dspl;
			if(prox==1) D104_Wpt->dst = record.ProxDist; else D104_Wpt->dst=0.0;
			mlen=sizeof(D104_Wpt_Type);
			break;
		}
		case 105: {
			D105_Wpt = (D105_Wpt_Type *)&message[2];
			D105_Wpt->posn.lat = laa;
			D105_Wpt->posn.lon = loo;
			D105_Wpt->smbl     = record.icon_smbl;
			if(D105orD106 == 0) strcpy((char*)StreetPilotWptName,record.ident);
			strcpy((char*)D105_Wpt->wpt_ident, (char*)StreetPilotWptName);
			mlen=sizeof(D105_Wpt_Type)+strlen((char*)D105_Wpt->wpt_ident);
			break;
		}
// 7.5.7. D106_Wpt_Type
//  Example products: StreetPilot (route waypoints).
//typedef struct
//{
//	byte class;				// class
//	byte subclass[13];		// subclass
//	Semicircle_Type posn;	// position
//	Symbol_Type smbl;		// symbol id
//	char wpt_ident[1];  	// null-terminated string -- length isn't
//	                        //   really specified, I added 10 for a place
//							//   holder for the decode of D106 waypoints
///* char lnk_ident[]; null-terminated string */
//} D106_Wpt_Type;
		case 106: {
			if(record.class == 255) record.class = 0;	// 'user'
//d106:;
			D106_Wpt 			= (D106_Wpt_Type *)&message[2];
			D106_Wpt->class		= record.class;
			for(ret=0;ret<13;ret++) D106_Wpt->subclass[ret] = record.subclass[ret];
			D106_Wpt->posn.lat	= laa;
			D106_Wpt->posn.lon	= loo;
			D106_Wpt->smbl    	= record.icon_smbl;
//
// This code segment concatonates the name and link ident into two null
//  terminated strings.
//
			if(D105orD106 == 0) strcpy((char*)StreetPilotWptName,record.ident);
			for(ret=0;ret<strlen((char*)StreetPilotWptName);ret++)
				if(StreetPilotWptName[ret]=='|') StreetPilotWptName[ret]=' ';
			trim((char*)StreetPilotWptName);
			for(ret=0;ret<strlen((char*)StreetPilotLnk_ident);ret++)
				if(StreetPilotLnk_ident[ret]=='|') StreetPilotLnk_ident[ret]=' ';
			trim((char *)StreetPilotLnk_ident);
			strcpy((char*)D106_Wpt->wpt_ident, (char*)StreetPilotWptName);
			D106_Wpt->wpt_ident[ret=strlen((char*)StreetPilotWptName)]=' ';
			D106_Wpt->wpt_ident[ret+1]=0;
			strcat((char*)D106_Wpt->wpt_ident, (char*)StreetPilotLnk_ident);
			D106_Wpt->wpt_ident[ret]=0;
			mlen=sizeof(D106_Wpt_Type) +
				strlen((char*)StreetPilotWptName) +
				strlen((char*)StreetPilotLnk_ident)+1;
			break;
		}
		case 107: {
			D107_Wpt = (D107_Wpt_Type *)&message[2];

//
// Translate to 12/II+ icon display type
//
//		Program   12/II+      Display mode
//			3        0         Symbol with Waypoint Name
//			1        1         Symbol
//			5        2         Symbol with Waypoint Comment
//
			switch(record.icon_dspl) {
				case 3: record.icon_dspl = 0; break;
				case 5: record.icon_dspl = 2; break;
			}
			D107_Wpt->dspl = record.icon_dspl;
			D107_Wpt->smbl = record.icon_smbl;
			if(prox==1) D107_Wpt->dst = record.ProxDist; else D107_Wpt->dst=0.0;
			switch(record.color) {
				case 0: 	// SA Black
				case 4: 	// SA Yellow
					D107_Wpt->color=0;
					break;
				case 1: 	// SA Red = 12CX Red
					D107_Wpt->color=1;
					break;
				case 2: 	// SA Blue 
					D107_Wpt->color=3;
					break;
				case 3: 	// SA Green
					D107_Wpt->color=2;
					break;
			}
			mlen=sizeof(D107_Wpt_Type);
			break;
		} // case 107
		case 150: {
			if(record.class == 255) record.class = 4;	// 'user'
			D150_Wpt = (D150_Wpt_Type *)&message[2];
			D150_Wpt->posn.lat = laa;
			D150_Wpt->posn.lon = loo;
			D150_Wpt->class = record.class;
			D150_Wpt->alt = record.alt;
			strncpad(D150_Wpt->ident,record.ident, 6);
			strncpad(D150_Wpt->cc,record.cc, 2);
			strncpad(D150_Wpt->city,record.city, 24);
			strncpad(D150_Wpt->state,record.state, 2);
			strncpad(D150_Wpt->name,record.name, 30);
			strncpad(D150_Wpt->cmnt,record.comment, 40);
			mlen=sizeof(D150_Wpt_Type);
			break;
		}
		case 151: {
			if(record.class == 255) record.class = 2;	// 'user'
			D151_Wpt = (D151_Wpt_Type *)&message[2];
			if(prox==1) D151_Wpt->dst = record.ProxDist; else D151_Wpt->dst=0.0;
			strncpad(D151_Wpt->ident,record.ident, 6);
			strncpad(D151_Wpt->name, record.name, 30);
			strncpad(D151_Wpt->city, record.city, 24);
			strncpad(D151_Wpt->state, record.state, 2);
			D151_Wpt->alt = record.alt;
			strncpad(D151_Wpt->cc, record.cc, 2);
			D151_Wpt->class = record.class;
			mlen=sizeof(D151_Wpt_Type);
			break;
		}
		case 152: {
			if(record.class == 255) record.class = 4;	// 'user'
			D152_Wpt = (D152_Wpt_Type *)&message[2];
			D152_Wpt->unused2=0;
			if(prox==1) D152_Wpt->dst = record.ProxDist; else D152_Wpt->dst=0.0;
			strncpad(D152_Wpt->ident,record.ident, 6);
			strncpad(D152_Wpt->name, record.name, 30);
			strncpad(D152_Wpt->city, record.city, 24);
			strncpad(D152_Wpt->state, record.state, 2);
			D152_Wpt->alt = record.alt;
			strncpad(D152_Wpt->cc, record.cc, 2);
			D152_Wpt->class = record.class;
			mlen=sizeof(D152_Wpt_Type);
			break;
		}
		case 154: {
			if(record.class == 255) record.class = 4;	// 'user'
			D154_Wpt = (D154_Wpt_Type *)&message[2];
			D154_Wpt->unused2=0;
			if(prox==1) D154_Wpt->dst = record.ProxDist; else D154_Wpt->dst=0.0;
			if(strlen(D154_Wpt->ident)) {
				strncpad(D154_Wpt->ident,record.ident, 6);
			}
			if(strlen(D154_Wpt->name)) {
				strncpad(D154_Wpt->name, record.name, 30);
			}
			if(strlen(D154_Wpt->city)) {
				strncpad(D154_Wpt->city, record.city, 24);
			}
			strncpad(D154_Wpt->state, record.state, 2);
			D154_Wpt->alt = record.alt;
			strncpad(D154_Wpt->cc, record.cc, 2);
			D154_Wpt->class = record.class;
			D154_Wpt->smbl = record.icon_smbl;
			mlen=sizeof(D154_Wpt_Type);
			break;
		}
		case 155: {
			if(record.class == 255) record.class = 4;
			D155_Wpt = (D155_Wpt_Type *)&message[2];
			D155_Wpt->unused2=0;
			if(prox==1) D155_Wpt->dst = record.ProxDist; else D155_Wpt->dst=0.0;
			if(strlen(record.ident)) {
				strncpad(D155_Wpt->ident,record.ident, 6);
			}
			if(strlen(record.name)) {
				strncpad(D155_Wpt->name, record.name, 30);
			}
			if(strlen(record.city)) {
				strncpad(D155_Wpt->city, record.city, 24);
			}
			if(strlen(record.state)) {
				strncpad(D155_Wpt->state, record.state, 2);
			}
			D155_Wpt->alt = record.alt;
			if(strlen(record.cc)) {
				strncpad(D155_Wpt->cc, record.cc, 2);
			}
			D155_Wpt->class = record.class; 	// 4;// user defined class == 4
			D155_Wpt->smbl = record.icon_smbl;
			D155_Wpt->dspl = record.icon_dspl;
			mlen=sizeof(D155_Wpt_Type);
			break;
		}
	} // switch(wpt_type)
	if(prox==1) {
		switch(ProxDataRecord) {
			case 101:
			case 102:
			case 107:
			case 152:  break;

			case 400:  D400_Prx_Wpt = (D400_Prx_Wpt_Type *) D100_Wpt;
					   D400_Prx_Wpt->dst = record.ProxDist;
					   mlen=sizeof(D400_Prx_Wpt_Type);
					   break;

			case 403:  D403_Prx_Wpt = (D403_Prx_Wpt_Type *) D103_Wpt; 
					   D403_Prx_Wpt->dst = record.ProxDist;
					   mlen=sizeof(D403_Prx_Wpt_Type);
					   break;

			case 450:  D450_Prx_Wpt = (D450_Prx_Wpt_Type *) D150_Wpt; 
					   D450_Prx_Wpt->dst = record.ProxDist;
					   mlen=sizeof(D450_Prx_Wpt_Type);
					   break;

			default: fprintf(stderr,"Unknown Proximity Protocol %d\n",ProxDataRecord); 
		} // switch(ProxDataRecord)
	}
//-----------------------------------------------------------
	if (in_route) /* type == ROUTE */
		message[0] = Pid_Rte_Wpt_Data;
	else {
		if(prox) message[0] = Pid_Prx_Wpt_Data;
		else     message[0] = Pid_Wpt_Data;
	}
	message[1]=mlen;
	SendGarminMessage(message, (short)(message[1]+2),msgtype);
	getGarminMessage(1);
} /* doSWaypoint */
/* -------------------------------------------------------------------------- */
//
// This routine is common to almost all waypoint data records of all Garmin Units.
//  The only formats not using the basic D100 format are D105,106 and D150
//
/* -------------------------------------------------------------------------- */
PROCX void readD100(BYTE * aa, INT wpt)
{
	D100_Wpt = (D100_Wpt_Type*)aa;

	record.la = toDegrees(D100_Wpt->posn.lat);
	record.lo = toDegrees(D100_Wpt->posn.lon);
	set_ns();
/*
 * waypoint name
 */
	strncpy(record.ident,D100_Wpt->ident,6);
	record.ident[6]=0; trim(record.ident);
/*
 * Comment, up to 40 characters
 */
	strncpy(record.comment,D100_Wpt->cmnt,40);
	record.comment[40]=0; trim(record.comment);

/*
 * Date/Time  Always unused in D104, so set it to system time
 */
 	settime_record(0);
//
// process rest of records
//
	switch(wpt) {
		case 100:
		case 400: break;
		case 101:
			    D101_Wpt=(D101_Wpt_Type *)aa;
				record.ProxDist = D101_Wpt->dst;
				record.icon_smbl= D101_Wpt->smbl;
				break;

		case 102:
			    D102_Wpt=(D102_Wpt_Type *)aa;
				record.ProxDist = D102_Wpt->dst;
				record.icon_smbl= D102_Wpt->smbl;
				break;

		case 103:
		case 403:
			    D103_Wpt=(D103_Wpt_Type *)aa;
				record.icon_smbl  = D103_Wpt->smbl;
				record.icon_dspl = D103_Wpt->dspl;
//
// Translate from GPS 12 & II+ Icons
//
//	Program   12/II+      Display mode
//	   3        0         Symbol with Waypoint Name
//	   1        1         Symbol
//	   5        2         Symbol with Waypoint Comment
//
				switch(record.icon_dspl){
					case 0: record.icon_dspl=3;break;
					case 2: record.icon_dspl=5;break;
				}
				break;

		case 104:
			    D104_Wpt=(D104_Wpt_Type *)aa;
				record.ProxDist   = D104_Wpt->dst;
				record.icon_smbl  = D104_Wpt->smbl;
				record.icon_dspl = D104_Wpt->dspl;
				break;

		case 107:
			D107_Wpt=(D107_Wpt_Type *)aa;
			record.ProxDist   = D107_Wpt->dst;
			record.icon_smbl  = D107_Wpt->smbl;
			record.icon_dspl  = D107_Wpt->dspl;
			switch(record.icon_dspl){
				case 0: record.icon_dspl=3;break;
				case 2: record.icon_dspl=5;break;
			}
			record.ProxDist = D107_Wpt->dst;
			record.color = D107_Wpt->color;
			switch(record.color) {
				case 0: break;  // no change
				case 1: break;  // no change
				case 2:
					record.color=3;
					break;
				case 3:
					record.color=2;
					break;
			}
			break;

		case 151:
			    D151_Wpt=(D151_Wpt_Type *)aa;
				record.ProxDist = D151_Wpt->dst;
				strncpy(record.name, D151_Wpt->name, 30);
				strncpy(record.city, D151_Wpt->city, 24);
				strncpy(record.state, D151_Wpt->state, 2);
				record.alt = D151_Wpt->alt;
				strncpy(record.cc, D151_Wpt->cc,2);
				record.class = D150_Wpt->class;
				break;

		case 152:
			    D152_Wpt=(D152_Wpt_Type *)aa;
				record.ProxDist = D152_Wpt->dst;
				strncpy(record.name, D152_Wpt->name, 30);
				strncpy(record.city, D152_Wpt->city, 24);
				strncpy(record.state, D152_Wpt->state, 2);
				record.alt = D152_Wpt->alt;
				strncpy(record.cc, D152_Wpt->cc,2);
				record.class = D152_Wpt->class;
				break;

		case 154:
			    D154_Wpt=(D154_Wpt_Type *)aa;
				record.ProxDist = D154_Wpt->dst;
				strncpy(record.name, D154_Wpt->name, 30);
				strncpy(record.city, D154_Wpt->city, 24);
				strncpy(record.state, D154_Wpt->state, 2);
				record.alt = D154_Wpt->alt;
				strncpy(record.cc, D154_Wpt->cc,2);
				record.class = D154_Wpt->class;
				record.icon_smbl = D154_Wpt->smbl;
				break;

		case 155:
			    D155_Wpt=(D155_Wpt_Type *)aa;
				record.ProxDist = D155_Wpt->dst;
				strncpy(record.name, D155_Wpt->name, 30);
				strncpy(record.city, D155_Wpt->city, 24);
				strncpy(record.state, D155_Wpt->state, 2);
				record.alt = D155_Wpt->alt;
				strncpy(record.cc, D155_Wpt->cc,2);
				record.class = D155_Wpt->class;
				record.icon_smbl = D155_Wpt->smbl;
				record.icon_dspl = D155_Wpt->dspl;
				break;

		default: fprintf(stderr,"Unknown Data protocol in readD100\n");
				return;
	} // switch(wpt)
	record.name[30]=0; trim(record.name);
	record.city[24]=0; trim(record.city);
	record.state[2]=0; trim(record.state);
	record.cc[2]=0; trim(record.cc);
} // readD100

/* -------------------------------------------------------------------------- */
PROCX void readD105(BYTE * aa)
{
	D105_Wpt=(D105_Wpt_Type *)aa;
/*
 * Date/Time  Not used in D105, so set it to system time
 */
 	settime_record(0);

	SPWptNo++;						// starts at 1
	record.la = toDegrees(D105_Wpt->posn.lat);
	record.lo = toDegrees(D105_Wpt->posn.lon);
	set_ns();
	record.icon_smbl=D105_Wpt->smbl;
	memset(StreetPilotWptName,0,MAX_LENGTH);
	memset(record.comment,0,40);
	memset(record.ident,0,6);
	strncpy((char*) StreetPilotWptName, D105_Wpt->wpt_ident,255);
	strncpy(record.comment,(char*)StreetPilotWptName,40);
	sprintf(record.ident,"SPW%03d",SPWptNo);
} // readD105

// 7.5.6. D105_Wpt_Type
//typedef struct
//{
//	Semicircle_Type posn;	// position
//	Symbol_Type smbl;		// symbol id
//	char wpt_ident[1]; 		// null-terminated string -- length isn't
//	                        //   really specified, I added 1 for a place
//							//   holder for the decode of D105 waypoints
//} D105_Wpt_Type;

// 7.5.7. D106_Wpt_Type
//  Example products: StreetPilot (route waypoints).
//typedef struct
//{
//	byte class;				// class
//	byte subclass[13];		// subclass
//	Semicircle_Type posn;	// position
//	Symbol_Type smbl;		// symbol id
//	char wpt_ident[1];  	// null-terminated string -- length isn't
//	                        //   really specified, I added 10 for a place
//							//   holder for the decode of D106 waypoints
///* char lnk_ident[]; null-terminated string */
//} D106_Wpt_Type;

/* -------------------------------------------------------------------------- */
PROCX void readD106(BYTE *aa)
{
	unsigned char *p;
	INT i;
	D106_Wpt=(D106_Wpt_Type *)aa;
/*
 * Date/Time  Not unused in D106, so set it to system time
 */
	settime_record(0);
	SPWptNo++;						// starts at 1
	record.la = toDegrees(D106_Wpt->posn.lat);
	record.lo = toDegrees(D106_Wpt->posn.lon);
	set_ns();
	record.icon_smbl=D106_Wpt->smbl;
	memset(StreetPilotWptName,0,MAX_LENGTH);
	memset(StreetPilotLnk_ident,0,MAX_LENGTH);
	memset(record.comment,0,40);
	memset(record.ident,0,6);
	strncpy((char*) StreetPilotWptName, D106_Wpt->wpt_ident,255);
	strncpy(record.comment,(char*)StreetPilotWptName,40);
	sprintf(record.ident,"SPW%03d",SPWptNo);
	record.class = D106_Wpt->class;
	for(i=0;i<13;i++) record.subclass[i]=D106_Wpt->subclass[i];
	strncpy((char*)StreetPilotWptName, D106_Wpt->wpt_ident,255);
	p=(unsigned char *)&D106_Wpt->wpt_ident;

	while(*p)
		p++; // look for null of string
	p++; // skip over null
	strncpy((char*)StreetPilotLnk_ident,(char*) p, 255);
} // readD106

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
// D108_Wpt_Type
//  Example products: eMap
//typedef struct 														// size
//{
//	byte			wpt_class; 		// class (see below) 				1
//	byte			color; 			// color (see below) 				1 
//	byte			dspl; 			// display options (see below) 		1
//	byte			attr; 			// attributes (see below) 			1
//	Symbol_Type		smbl; 			// waypoint symbol 					2
//	byte			subclass[18]; 	// subclass 						18
//	Semicircle_Type	posn; 			// 32 bit semicircle 				8
//	float 			alt; 			// altitude in meters 				4
//	float 			dpth; 			// depth in meters 					4
//	float 			dist; 			// proximity distance in meters		4
//	char 			state[2]; 		// state 							2
//	char 			cc[2]; 			// country code 					2
// char 			ident[]; 			variable length string 			1-51
// char 			comment[]; 			waypoint user comment 			1-51
// char 			facility[]; 		facility name 					1-31
// char 			city[]; 			city name 						1-25
// char 			addr[]; 			address number 					1-51
// char 			cross_road[]; 		intersecting road label 		1-51
//} D108_Wpt_Type;

//enum
//{
//	USER_WPT =      0x00, // User waypoint
//	AVTN_APT_WPT =  0x40, // Aviation Airport waypoint
//	AVTN_INT_WPT =  0x41, // Aviation Intersection waypoint
//	AVTN_NDB_WPT =  0x42, // Aviation NDB waypoint
//	AVTN_VOR_WPT =  0x43, // Aviation VOR waypoint
//	AVTN_ARWY_WPT = 0x44, // Aviation Airport Runway waypoint
//	AVTN_AINT_WPT = 0x45, // Aviation Airport Intersection
//	AVTN_ANDB_WPT = 0x46, // Aviation Airport NDB waypoint
//	MAP_PNT_WPT =   0x80, // Map Point waypoint
//	MAP_AREA_WPT =  0x81, // Map Area waypoint
//	MAP_INT_WPT =   0x82, // Map Intersection waypoint
//	MAP_ADRS_WPT =  0x83, // Map Address waypoint
//	MAP_LABEL_WPT = 0x84, // Map Label Waypoint
//	MAP_LINE_WPT =  0x85, // Map Line Waypoint
//};

//The "color" member can be one of the following values:
//enum {	Black, 
//		Dark_Red, 
//		Dark_Green, 
//		Dark_Yellow,
//		Dark_Blue, 
//		Dark_Magenta, 
//		Dark_Cyan, 
//		Light_Gray,
//		Dark_Gray, 
//		Red, 
//		Green, 
//		Yellow,
//		Blue, 
//		Magenta, 
//		Cyan, 
//		White,
//		Default_Color = 0xFF
//};

// The enumerated values for the "dspl" member of the D108_Wpt_Type are the
//     same as the the "dspl" member of the D103_Wpt_Type.

// The "attr" member should be set to a value of 0x60.

// The "subclass" member of the D108_Wpt_Type is used for map waypoints
//   only, and should be set to 0x0000 0x00000000 0xFFFFFFFF 0xFFFFFFFF
//   0xFFFFFFFF for other classes of waypoints.

// The "alt" and "dpth" members may or may not be supported on a given
//    unit.  A value of 1.0e25 in either of these fields indicates that this
//    parameter is not supported or is unknown for this waypoint.

/* -------------------------------------------------------------------------- */
//
//  in points to a string which contains null terminated values.
//
PROCX void SplitOutD108Data(char *in, char *a, char *b, char *c, char *d, char *e, char *f)
{
	int done;
	char *p;

	p=a;
	done =0;
	while(!done) {
		if(*in==0)  done=1;
		*p++ = *in++;
	} //!done

	p=b;
	done =0;
	while(!done) {
		if(*in==0)  done=1;
		*p++ = *in++;
	} //!done

	p=c;
	done =0;
	while(!done) {
		if(*in==0)  done=1;
		*p++ = *in++;
	} //!done

	p=d;
	done =0;
	while(!done) {
		if(*in==0)  done=1;
		*p++ = *in++;
	} //!done

	p=e;
	done =0;
	while(!done) {
		if(*in==0)  done=1;
		*p++ = *in++;
	} //!done

	p=f;
	done =0;
	while(!done) {
		if(*in==0)  done=1;
		*p++ = *in++;
	} //!done

} // SplitOutD108Data

/* -------------------------------------------------------------------------- */
PROCX void readD108(BYTE *aa)
{
	unsigned char *p;
	float altitude;
	INT i;
	D108_Wpt=(D108_Wpt_Type *)aa;
/*
 * Date/Time  Not unused in D108, so set it to system time
 */
	settime_record(0);
	record.class = D108_Wpt->wpt_class;
 	record.la = toDegrees(D108_Wpt->posn.lat);
 	record.lo = toDegrees(D108_Wpt->posn.lon);
 	set_ns();
 	record.icon_smbl=D108_Wpt->smbl;
 	record.class = D108_Wpt->wpt_class;
 	for(i=0;i<18;i++) record.subclass[i]=D108_Wpt->subclass[i];
	record.altitude=D108_Wpt->alt;

	SplitOutD108Data(D108_Wpt->ident,record.ident,
	                                 record.comment,
									 record.facility,
									 record.city,
	                                 record.addr,
									 record.cross_road);
} // readD108

/* -------------------------------------------------------------------------- */
PROCX void readD150(BYTE *aa)
{
	D150_Wpt=(D150_Wpt_Type *)aa;
	strncpy(record.ident, D150_Wpt->ident, 6);
	strncpy(record.cc, D150_Wpt->cc,2);
	record.class = D150_Wpt->class;
	record.la = D150_Wpt->posn.lat;
	record.lo = D150_Wpt->posn.lon;
	set_ns();
	record.alt = D150_Wpt->alt;
	strncpy(record.city, D150_Wpt->city, 24);
	strncpy(record.state, D150_Wpt->state, 2);
	strncpy(record.name, D150_Wpt->name, 30);
	strncpy(record.comment, D150_Wpt->cmnt, 40);
} // readD150

/* -------------------------------------------------------------------------- */
PROCX void doWaypoint(INT wpt)
{
	extern struct PREFS gPrefs;

	BYTE *pp;
	char buf[100];

	set_record_icon();
	pp = (BYTE *)(&SerialMessage[3]); 
	datatype=wpt;

	switch(wpt) {
		case 100:
		case 101:
		case 102:
		case 103:
		case 104:
		case 107:
		case 151:
		case 152:
		case 154:
		case 155:
		case 400:
		case 403:
				readD100(pp, wpt);
				break;

		case 105:
				D105orD106=1;
				readD105(pp);
				break;

		case 106:
				D105orD106=1;
				readD106(pp);
				break;

		case 108:
				readD108(pp);
				break;

		case 150:
		case 450:
				readD150(pp);
				break;
		default:
				fprintf(stderr,"Unknown Waypoint Protocol in doWaypoint -- aborting\n");
				byebye(7);
	} // switch(wpt)
//
// convert symbols if ID is of a 12/II+ gps
//
	if(Ggps == G12XL ) {
				record.icon_smbl  = convert_from_12xl(record.icon_smbl);
	}
	sprintf(Text,"%c;%d;%s;%s",'W',datatype,record.ident,record.comment);
	trim(Text);
	strcpy(buf,Text);
	if(in_route) {
		strcpy(buf,Text);
		push_route();
		strcpy(Text,buf);
	}
	push_waypoint();
	D105orD106=0;
} // doWaypoint

/* -------------------------------------------------------------------------- */
PROCX void doProxWaypoint()
{
	proximity=1;

	doWaypoint(ProxDataRecord);			// decode most of waypoint

	datatype=ProxDataRecord;
	switch(ProxDataRecord) {
// 101, 102 and 152 records contain proximity data no special handling is
//  necessary
		case 101:
		case 102:
		case 152:  break;

		case 400:  D400_Prx_Wpt = (D400_Prx_Wpt_Type *) D100_Wpt;
				   record.ProxDist = D400_Prx_Wpt->dst;
				   break;
		case 403:  D403_Prx_Wpt = (D403_Prx_Wpt_Type *) D103_Wpt; 
				   record.ProxDist = D403_Prx_Wpt->dst;
				   break;
		case 450:  D450_Prx_Wpt = (D450_Prx_Wpt_Type *) D150_Wpt; 
				   record.ProxDist = D450_Prx_Wpt->dst;
				   break;

		default: fprintf(stderr,"Unknown Proximity Protocol %d\n",ProxDataRecord); 
	}

	sprintf(Text,"%c;%d;%s;%s",'P',datatype,record.ident,record.comment);
	strupr(Text);
	push_proximity();
} // doProxWaypoint

/* -------------------------------------------------------------------------- */
PROCX void doTrack()
{
	if(TrackDataRecord!=300) {
		fprintf(stderr,"Unknown TrackDataRecord protocol: %d\n",TrackDataRecord);
	}

	datatype=TrackDataRecord;
	D300_Trk_Point = (D300_Trk_Point_Type *)&SerialMessage[3];

	settime_record((time_t)D300_Trk_Point->time);

	if (D300_Trk_Point->new_trk) {	// New track
		record.type='N';
	}
	else record.type='T';
	record.la = toDegrees(D300_Trk_Point->posn.lat);
	record.lo = toDegrees(D300_Trk_Point->posn.lon);
	sprintf(Text,"%c;%d;;",record.type,datatype);
	push_track();
} // doTrack

/* ----------------------------------------------------------- */
PROCX void doSTrack()
{

	if(firsttrackpoint) send_num_points(tracks,"tracks");
	firsttrackpoint=0;

	D300_Trk_Point = (D300_Trk_Point_Type *)&message[2];

	D300_Trk_Point->posn.lat = toSemiCircles(record.la);
	D300_Trk_Point->posn.lon = toSemiCircles(record.lo);

	message[0] = Pid_Trk_Data;
	message[1] = sizeof(D300_Trk_Point_Type);	/* number of message bytes to follow */

	D300_Trk_Point->time = dt2secs((short)gPrefs.offset);

	if(newTrack==255) newTrack=1;
	D300_Trk_Point->new_trk = newTrack;		/* new track flag */
	newTrack = 0;
	SendGarminMessage(message, 15,"Track data");
	getGarminMessage(1);	/* make sure GPS receiver responded */
} /* doSTrack */

/* -------------------------------------------------------------------------- */
PROCX void doTime(void)
{
	dtime = (D600_Date_Time_Type *)&SerialMessage[3];

	record.year=dtime->year;
	record.monthn=dtime->month;
	record.dayofmonth=dtime->day;
	record.ht=dtime->hour;
	record.mt=dtime->minute;
	record.st=dtime->second;
	sprintf(record.datetime, "%s %s %02d %02d:%02d:%02d %04d", 
		days[dow(record.dayofmonth,record.monthn,record.year)],
		months[record.monthn], 
		record.dayofmonth, record.ht, record.mt, record.st,
		record.year);
} // doTime

/* -------------------------------------------------------------------------- */
PROCX void doSTime(void)
{
	time_t t;
	struct tm *gmt;

	dtime=(D600_Date_Time_Type *)&message[2];
	message[0]=Pid_Date_Time_Data;
	message[1]=sizeof(D600_Date_Time_Type); // 8 bytes
	t=time(NULL);
	gmt=gmtime(&t);
	dtime->month=gmt->tm_mon+1;
	dtime->day=gmt->tm_mday;
	dtime->year=gmt->tm_year+1900;
	dtime->hour=gmt->tm_hour;
	dtime->minute=gmt->tm_min;
	dtime->second=gmt->tm_sec;

	SendGarminMessage(message, 10, "Sending UTC date/time");
	getGarminMessage(1);	/* make sure GPS receiver responded */
} // doSTime()

/* -------------------------------------------------------------------------- */
PROCX void doGPSPos(void)
{
	D700_Position_Type *a;
	LONGdouble Degree=Pi/180.0;

	a=(D700_Position_Type *)&SerialMessage[3];
	record.la = (double)((LONGdouble)a->lat/Degree);
	record.lo = (double)((LONGdouble)a->lon/Degree); 
} /* doGPSPos */

//	Cmnd_Start_Pvt_Data = 49, // 0x31	start transmitting PVT
//	Cmnd_Stop_Pvt_Data	= 50  // 0x32	stop transmitting PVT data
//	Pid_Pvt_Data		= 51, // 0x33   PVT record ID
/* -------------------------------------------------------------------------- */
//
// Tell GPS to send PVT data
//
PROCX void getPVT(void)
{
	SendGarminMessage(PVTon,4,"Start sending PVT Data");	// ask for PVT data
	getGarminMessage(1); 									// get & parse the ack
} // getPVT(void)

/* -------------------------------------------------------------------------- */
//typedef struct
//{
//	float alt; /* altitude above WGS 84 ellipsoid (meters) */
//	float epe; /* estimated position error, 2 sigma (meters) */
//	float eph; /* epe, but horizontal only (meters) */
//	float epv; /* epe, but vertical only (meters) */
//	INT fix; /* type of position fix */
//	double tow; /* time of week (seconds) */
//	Radian_Type posn; /* latitude and longitude (radians) */
//	float east; /* velocity east (meters/second) */
//	float north; /* velocity north (meters/second) */
//	float up; /* velocity up (meters/second) */
//	float msl_hght; /* height of WGS 84 ellipsoid above MSL (meters) */
//	INT leap_scnds; /* difference between GPS and UTC (seconds) */
//	long wn_days; /* week number days */
//} D800_Pvt_Data_Type;


PROCX void doPVT(void)
{
	D800_Pvt_Data_Type *p;
	double la,lo;

	p = (D800_Pvt_Data_Type *)&SerialMessage[3];

	la=p->posn.lat*RADtoDEG;
	lo=p->posn.lon*RADtoDEG;

	printf("%f,%f,%f,%f,%d,%lf,%lf,%lf,%f,%f,%f,%f,%d,%ld\n",
	p->alt,p->epe,p->eph,p->epv,p->fix,p->tow,la,lo,p->east,p->north,p->up,p->msl_hght,
	p->leap_scnds,p->wn_days);
} // doPVT

/* -------------------------------------------------------------------------- */
//
// Tell GPS to stop sending PVT data
//
PROCX void stopPVT(void)
{
	SendGarminMessage(PVToff,4,"Stop sending PVT Data");	// ask for PVT data
	getGarminMessage(1);		 						// get & parse the ack
} // stopPVT()

/* -------------------------------------------------------------------------- */
PROCX void getGPSTime(void)
{
	SendGarminMessage(GPStime,4,"Send GPS Time");	/* ask for time */
	getGarminMessage(1); 		/* get ack	*/
	getGarminMessage(1);		/* get time	*/
} /* getGPSTime */

/* -------------------------------------------------------------------------- */
PROCX void getGPSPosition(void)
{
	SendGarminMessage(GPSPos,4,"Send GPS Position");	// ask for position
	getGarminMessage(1); 									// get & parse ack
	getGarminMessage(1);									// get & parse Position
} /* getGPSPosition */

/* -------------------------------------------------------------------------- */
PROCX void getGPSVolts(void)
{
	SendGarminMessage(VoltsM,4,"Send Voltages");	// ask for volts
	getGarminMessage(1); 						// get & parse ack
	getGarminMessage(1);						// get & parse volts
	printf("Int: %5.2lf,  Ext: %5.2lf\n",InternalVolts,ExternalVolts);
} /* getGPSVolts */

/* -------------------------------------------------------------------------- */
PROCX void doRouteName()
{
	char ix[MAX_LENGTH];

	if(in_route==1) {
		sprintf(ix,"E  %02d\n",route_number);
		push_record(ix,0);
	}
	in_route=1;
	switch(RouteHdrType) {
		case 200:
				D200=*(SerialMessage+3);
				route_number=D200;
				strcpy(route_comment,"None");
				break;
		case 201:
				D201=(D201_Rte_Hdr_Type *)&SerialMessage[3];
				route_number=D201->nmbr;
				strncpy(route_comment,D201->cmnt,20);
				break;
		case 202:
				D202=(D202_Rte_Hdr_Type *)&SerialMessage[3];
				strcpy(route_comment,D202->rte_ident);
				null_newline(route_comment);
				break;
	} // switch(RouteHdrType)

	if(RouteHdrType==202) route_number++;
	sprintf(rtn,"%02d",route_number);
	sprintf(ix,"R  %02d %s",route_number,route_comment);
	push_record(ix,0);
} /* doRouteName */

/* -------------------------------------------------------------------------- */
/* Returns a result code--zero if GPS receiver did not respond */
/*
 *  When sending route data the sequence is:
 *
 *  1.  Send 'Route/ID' record.  Read the responding ACK/NAK
 *  2.  Send 'Number of records to follow' record, Read ACK/NAK
 *  3.  Send each waypoint in the route as a route waypoint record and
 *       read each ACK/NAK
 *  4.  Send 'Route end of database record'.  Read ACK/NAK
 * 
 */
PROCX void doSRouteHdr()
{
/*
 * send number of route waypoint records to send +1 for the route name
 */
	*((short*)(bgnxfr+2)) = routeXpts[route_number]+1;
	SendGarminMessage(bgnxfr, 4, "bgnxfr, Route");
	getGarminMessage(1);	/* make sure GPS receiver responded */
/*
 * setup buffer to send route ID record
 */
	if(LinkProtocol==1)
		message[0] = Pid_Rte_Hdr;
	else
		message[0] = Pid_Rte_Hdr2;
	strupr(route_comment);
	switch(RouteHdrType) {
		case 200:
				D200=*(SerialMessage+3);
				route_number=D200;
				strcpy(route_comment,"NONE");
				message[1] = 1;  // Just the route number
				message[2] = route_number;
				break;
		case 201:
				D201=(D201_Rte_Hdr_Type *)&message[2];
				memset(&message[3],' ',20);
				message[19]=0;
				D201->nmbr=route_number;
				strncpy(D201->cmnt,route_comment,20);
				message[1] = 21;  // 21 data bytes in the 201 record
				break;
		case 202:
				D202=(D202_Rte_Hdr_Type *)&message[2];
				strncpy(D202->rte_ident, route_comment,20);
				trim(D202->rte_ident);
				message[1] = strlen(D202->rte_ident)+1;
				break;
	} // switch(RouteHdrType)

	SendGarminMessage(message, (short)(message[1]+2), "Pid_Rte_Hdr record");
	getGarminMessage(1);	/* make sure GPS receiver responded */
} /* doSRouteHdr */

/* -------------------------------------------------------------------------- */
PROCX void doID(void)
{
	BYTE *x;  
	BYTE *q;
	char *p;

	INT i;

	Product_Data_Type *dd;

	if(gotID==1) return;
	dd=(Product_Data_Type *)&SerialMessage[3];

	x=&SerialMessage[2]; 			/* data length */

	Product_ID=dd->product_ID;
	SWVersion=dd->software_version;

	Ggps=0;
	switch(Product_ID) {
	    case GPS38_40_45_45XL_A:
	    case GPS38_40_45_45XL_B:
	    case GPSII:
	    case GPS38_C:
	    case GPS38_J:
	    case GPSIIP:
	    case GPS12_12XLA:
	    case GPS12:
	    case GPS12CX:
	    case GPS12_12XLB:
	    case GPSIIP_1:
	    case GPS12XL_J:
	    case GPS12XL_C:
	        Ggps=G12XL;
	        break;
	
	    case GPSIII_ID:
	    case GPSIIIPILOT:
	        Ggps=GPSIII;
	        break;
	
	    case GPS3P:
	        Ggps=GPSIIIP;
	        break;
	
	    case STREETPILOT:
	    case STREETPILOTCOLORMAP:
	        Ggps=SPILOT;
	        break;
	}
//
// decode null terminated strings
//
	q=dd->a;
	p=getstrings((char*)q,"",0);


	if(p != NULL) {
		strcpy(VersionString,p);
		trim(VersionString);
		q+=(strlen(p)+1);
	}

	i=0;
	while(q < (dd->a + *x - 4)) {
		p=getstrings(NULL,"",1);
		if(p != NULL) {
			VersionSubString[i]=strdup(p);
			q+=(strlen(p)+1);
		}
		i++;
		VersionSubString[i]=NULL;
	}
	VersionSubStrings=i;
	gotID=1;
} /* doID */

/* -------------------------------------------------------------------------- */
PROCX void doEOFRec(void)
{
	AlmanacEOF=RouteEOF=TrackEOF=ProxWaypointEOF=WaypointEOF=0;
	switch(SerialMessage[3]) {
		case 1: AlmanacEOF=1; break;
		case 3: ProxWaypointEOF=1;break;
		case 4: RouteEOF=1; break;
		case 6: TrackEOF=1; break;
		case 7: WaypointEOF=1; break;
		default: break;
	}
} /* doEOFRec */

/* -------------------------------------------------------------------------- */
PROCX void doGPSVolts(void)
{
	INT i;
	i=*((int*)(SerialMessage+3));
	InternalVolts=(float)i/100.0;
	i=*((int*)(SerialMessage+5));
	ExternalVolts=(float)i/100.0;
} /* doGPSVolts */

struct alm {
	INT wk;			/* Week       -1 if poor health */
	float ta;		/* Time of Applicability(s)		*/
	float af0;		/* Af0(s)						*/
	float af1;		/* Af1(s)						*/
	float ecc;		/* Eccentricity					*/
	float sqrta;	/* SQRT(A)  (m^1/2)				*/
	float meananom;	/* Mean Anom(rad)				*/
	float argper;	/* Argument of Perigee(rad)		*/
	float RA;		/* Right Ascen at TOA(rad)		*/
	float RRA;		/* Rate of Right Ascen(r/s)		*/
	float OI;		/* Orbital Inclination(rad)		*/
	byte hlth;		// added for type D501 protocol
} *almm;

struct alm *alm;

/* -------------------------------------------------------------------------- */
PROCX void doSAlmanac500()
{
/*
 * we assume all 32 satellites.  Some Garmin GPS units do not have a method
 *  for inputting the satellite number....
 */
	INT mlen;
	INT sending=0,id,hold,health;
 	char lb[150];

	memset(message,' ',MAX_LENGTH);

	bgnxfr[2]=32;  // Number of satellites to send

	SendGarminMessage(bgnxfr,4,"Send number of sats");  /* send # sats */
	getGarminMessage(1);	/* make sure GPS receiver responded */

	almm=(struct alm*)(&message[2]);  // ok for D500

	if(AlmanacDataRecord==500) mlen=0;else mlen=1;

	while(fgets((char*)lb,MAX_LENGTH,in) != NULL) { /* get first line */
		sending++;
		fgets(lb,MAX_LENGTH,in);	/* ID */
		id=atoi(&lb[25]);
		fgets(lb,MAX_LENGTH,in);	/* Health (also in week# for Garmin) */
		health=atoi(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* ecc */
		almm->ecc=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* ta */
		almm->ta=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* OI */
		almm->OI=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* rra */
		almm->RRA=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* sqrta */
		almm->sqrta=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* RA */
		almm->RA=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* argper */
		almm->argper=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* meananom */
		almm->meananom=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* af0 */
		almm->af0=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* af1 */
		almm->af1=(float)atof(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* wk */
		almm->wk=atoi(&lb[25]);

		fgets(lb,MAX_LENGTH,in);	/* blank line */

		if(health!=0)
			hold=-1;
		else 
			hold=almm->wk;

		almm->wk=-1;
		message[0]=0x1f; message[1]=0x2a+mlen;
		almm->hlth = 0;//0xe6;
		while(sending != id) { /* sending dummy */
			SendGarminMessage(message, (short)(44+mlen), "Almanac Record Dummy");
			getGarminMessage(1);
			sending++;
		}
		almm->wk=hold;
		almm->hlth=0;
		SendGarminMessage(message, (short)(44+mlen), "Almanac Record good");
		getGarminMessage(1);
	}
	while(sending!=32) {
		almm->wk=-1;
		almm->hlth=0;//0xe6;
		SendGarminMessage(message, (short)(44+mlen), "Almanac record rest");
		getGarminMessage(1);
		sending++;
	}
	doSTime();
	SendGarminMessage(almt,(short)4, "Almanac terminator");  /* almanac data terminator */
	getGarminMessage(1);   /* get ack/nak, assume ack */
} /* doSAlmanac500 */

D500_Almanac_Type *D500_Almanac;
D501_Almanac_Type *D501_Almanac;
D550_Almanac_Type *D550_Almanac;
D551_Almanac_Type *D551_Almanac;
/* -------------------------------------------------------------------------- */
PROCX void doAlmanac()
{
/**** Week 851 almanac for PRN-01 ***********
ID:                          001
Health:                      000
Eccentricity:                3.608226776e-03
Time of Applicability(s):    5.898240000e+05
Orbital Inclination(rad):    9.540965021e-01
Rate of Right Ascen(r/s):   -8.091765626e-09
SQRT(A) (m^1/2):             5.153528809e+03
Right Ascen at TOA(rad):    -7.805333171e-01
Argument of Perigee(rad):   -1.456979147e+00
Mean Anom(rad):              2.899803800e+00
Af0(s):                      6.866455078e-05
Af1(s/s):                    1.382431947e-10
week:                        851
*/
	if(AlmanacDataRecord == 500 || AlmanacDataRecord == 501) {
		alm = (void *)(SerialMessage+3);
		D501_Almanac = (void *)(SerialMessage+3);
		if(satnum>1) printf("\n");
		printf("**** Week %3d almanac for PRN-%02d ***********\n",alm->wk,satnum);
		printf("%-29s%03d\n","ID:",satnum);
		if(AlmanacDataRecord==500) 	printf("%-29s%3s\n","Health:",alm->wk<0?"111":"000");
		else printf("%-29s%03x\n","Health:",D501_Almanac->hlth);
		printf("%-25s%19.9e\n","Eccentricity:",alm->ecc);
		printf("%-25s%19.9e\n","Time of Applicability(s):",alm->ta);
		printf("%-25s%19.9e\n","Orbital Inclination(rad):",alm->OI);
		printf("%-25s%19.9e\n","Rate of Right Ascen(r/s):",alm->RRA);
		printf("%-25s%19.9e\n","SQRT(A) (m^1/2):",alm->sqrta);
		printf("%-25s%19.9e\n","Right Ascen at TOA(rad):",alm->RA);
		printf("%-25s%19.9e\n","Argument of Perigee(rad):",alm->argper);
		printf("%-25s%19.9e\n","Mean Anom(rad):",alm->meananom);
		printf("%-25s%19.9e\n","Af0(s):",alm->af0);
		printf("%-25s%19.9e\n","Af1(s/s):",alm->af1);
		printf("%-29s%d\n","week:",alm->wk);
	}
	if(AlmanacDataRecord==550) fprintf(stderr, "Almanac data record D550 not implemented\n");
	if(AlmanacDataRecord==551) fprintf(stderr, "Almanac data record D550 not implemented\n");
} /* doAlmanac */

/* -------------------------------------------------------------------------- */
PROCX void AsyncSend(BYTE *message, INT bytes)
{
	INT i;

#if __BORLANDC__
	for(i=0;i<bytes;i++) {
		if(WinNT==1) msdelay(2);
		AsyncOut(message[i]);
	}
#else
	AsyncOut(message,bytes);
#endif
} // AsyncSend()

/* -------------------------------------------------------------------------- */
PROCX void SendGarminMessage(BYTE *message, short bytes, char *msgtype)
{
	short c,i;
	INT n;
	BYTE qq,csum = 0;
	BYTE *p = SerialMessageOut;

	ok=-1;	
//
// Frame start byte
//
	*p++ = 0x10;    /* Start of message */
//
// Transfer message buffer to transmit buffer duplicating any 0x10 bytes
//
	for (i=0; i<bytes; i++) {
		*p++ = message[i];
		csum -= message[i];
		if (message[i] == 0x10)
			*p++ = 0x10;
	}
//
// Add in checksum
//
	*p++ = csum;
	if (csum == 0x10) *p++ = 0x10;
//
// Add frame trailer
//
	*p++ = 0x10;
	*p++ = 0x03;
//
// Message length in bytes
//
	n =(int)(p - SerialMessageOut);
//
// Dumping the send buffer to a file?
//
	if(Gdebug==1) {
		if(strcmp(msgtype,"ACK")!=0) fprintf(Gdebug_out,"\n");
		fprintf(Gdebug_out,"Sending: %s\n",msgtype);
		c=0;
		for(i=0;i<n;i++) {
			fprintf(Gdebug_out,outfmt,qq=*(SerialMessageOut+i));
			if(qq>=32 && qq<=126) {
				fprintf(Gdebug_out,"%c ",qq);
			}
			else {
				fprintf(Gdebug_out,"  ");
			}
			if(++c>15) {
				fprintf(Gdebug_out,"\n");
				c=0;
			}
	    }
		fprintf(Gdebug_out,"\n");
	}
//
// 'virus..check?  a 0x2b record apparently causes the erasure of
//  the GPS's program.
//
	if( ((SerialMessageOut[1] & 0x0f)==0x0b) &&
	    ((SerialMessageOut[1] & 0xf0)==0x20)       ) {
	        fprintf(stderr,"Error 141, aborting...\n");
			byebye(0);
	}
//
// Save message
//
	if(strcmp(msgtype,"ACK") != 0) {
		LastGarminLen=bytes;  		// Length w/o header, checksum and trailer
		memcpy(LastGarminGPSMsg,message,bytes);
	}
#if !DEBUGREAD
	AsyncSend(SerialMessageOut, n);
#endif
} /* SendGarminMessage() */

//-------------------------------------------------------------------------- 
//  The data is sent as scan lines, 100 lines with 160 pixels per line.
//
//  The data is stored in unsigned long format, starting at the 9th byte
//   in the SerialMessage string.  The left most pixel in the display is
//   in the lowest 2bits of the word.  The next pixel is in the next 2 and
//   so on.  There are 16 pixels per unsigned long.  Each pixel can be
//
//     0 == off
//     1 == Light grey
//     2 == Darker grey
//     3 == Fully on - black
//
//  Example:
//				Word = 1001 0101 0011 0001 0101 1010 1001 1001   (binary format)
//                     1615 1413 1211 10 9  8 7  6 5  4 3  2 1   Pixel number
//                      2 1  1 1  0 3  0 1  1 1  2 2  2 1  2 1   Pixel Value
//
//   If the above were the first long in the first line then Pixel #1 (value=1)
//    would be light grey and would be the pixel in the lower left corner of the
//    display--display is vertical.
//
struct dspheader {
	unsigned char len;
	unsigned INT  rectype;
	unsigned INT unk0;
	unsigned INT unk1;
	unsigned INT unk2;
	unsigned INT unk3;
	unsigned INT linelength;
	unsigned INT bitsperpixel;
	unsigned INT pixels;
	unsigned INT lines;
};

struct dsprecord {
	unsigned char len;
	unsigned INT rectype;
	unsigned long pixelcount;
};

PROCX void doDisplay()
{
	INT datalen, index,i,j,k,bit_shift;
	unsigned long *q,mask;
	unsigned char a,b;
	struct dspheader *dsp;
	struct dsprecord *dspr;

	dsp=(struct dspheader *)&SerialMessage[2];
	if(dsp->rectype == 0) {
		dsplines=dsp->lines;
		dsppixels=dsp->pixels;
		return;
	}
	dspr=(struct dsprecord *)&SerialMessage[2];
	datalen=dspr->len-6;
	index=0;
	q=(unsigned long *)&SerialMessage[5];		// read pixel count
	gLine=((int)(*q))/datalen;					// convert to Scan line 0-xxx
	q=(unsigned long *)&SerialMessage[9];		// get first long word of data
	for(i=0;i<(dsppixels/16);i++) {			// for each long in line (16 pixels/long)
		mask=0x3L;
		bit_shift=0;
		for(j=1;j<5;j++) {		// for each byte in long
			for(k=1;k<3;k++) {	// for each pixel in the byte
//
// Our bmp output file has one nibble per pixel
//
// first nibble of byte
//
				a=(~(int)(((*q)&mask)>>bit_shift))&3;
				bit_shift+=2;
				mask=mask<<2;
//
// second nibble of byte
//
				b=(~(int)(((*q)&mask)>>bit_shift))&3;
				bit_shift+=2;
				mask=mask<<2;
//
// place into memory array
//
				bmdata[(dsplines-1)-gLine][index++]=(a<<4)|b;
			}
		}
		q++;  // index pointer to next 4 bytes (unsigned long)
	} // for(i=0;i<(dsppixels/16);i++)
} // doDisplay()

//-------------------------------------------------------------------------- 
/*
 * checksums an incoming GPS record *after* repeating 0x10 characters are
 *  removed
 */
PROCX INT checksum(unsigned char *m,INT l)
{
	INT i;
	unsigned char cs;

	cs=0;
	for(i=1;i<l-3;i++) {
		cs-=m[i];
	}
	if(cs==m[l-3]) return 1;
	return 0;
} /* checksum */

/* -------------------------------------------------------------------------- */
// Garmin message type characters
//  ACK	     0x06	 last record received was ok
//  ALM 	 0x1f	 Almanac record
//  EOFREC   0x0c	 EOF leadin for transters
//  GPSpos	 0x11	 GPS Position record
//  PROX  	 0x13	 Proximity Waypoint record
//  MYID	 0xff	 Version/ID record
//  NAK	     0x15	 last record received was bad
//  NREC	 0x1b	 number of records to receive
//  RTE_NAM  0x1d	 Route name record
//  RTE_WPT  0x1e	 Route waypoint record
//  TIMEREC  0x0e	 UTC Time record 
//  TRK 	 0x22	 Track record
//  WPT 	 0x23	 Waypoint record
//  Volts	 0x28	 Voltages
//  SENDID   0xfe    Send your ID.  Probably a bogus record
//
// L001 - Link Protocol 1
//
//enum {
//	Pid_Command_data	=  10, // 0x0a
//	Pid_Xfer_Cmplt		=  12, // 0x0c			EOFREC
//	Pid_Date_Time_Data	=  14, // 0x0e			TIMEREC
//	Pid_Position_Data	=  17, // 0x11			GPSpos
//	Pid_Prx_Wpt_Data	=  19, // 0x13			PROX
//	Pid_Records			=  27, // 0x1b			NREC
//	Pid_Rte_Hdr			=  29, // 0x1d			RTE_NAM
//	Pid_Rte_Wpt_Data	=  30, // 0x1e			RTE_WPT
//	Pid_Almanac_Data	=  31, // 0x1f			ALM
//	Pid_Trk_Data		=  34, // 0x22			TRK
//	Pid_Wpt_Data		=  35, // 0x23			WPT
//	Pid_Pvt_Data		=  51, // 0x33
//	Pid_Protocol_Array	= 253  // 0xfd
//};
//
////
//// L002 - Link Protocol 2
////
//enum {
//	Pid_Almanac_Data2	=  4, // 0x04
//	Pid_Command_Data2	= 11, // 0x0b
//	Pid_Xfer_Cmplt2		= 12, // 0x0c			EOFREC
//	Pid_Date_Time_Data2	= 20, // 0x14
//	Pid_Position_Data2	= 24, // 0x18
//	Pid_Records2		= 35, // 0x23
//	Pid_Rte_Hdr2		= 37, // 0x25
//	Pid_Rte_Wpt_Data2	= 39, // 0x27
//	Pid_Wpt_Data2		= 43  // 0x2b
//};
//
/* -------------------------------------------------------------------------- */
PROCX void parseGPS(void)
{	
	INT i;
//
// SerialMessage[0] is always 0x10 in a valid message string
//
// Product data, ACK and NAK are common to all Garmin Units
//
	switch(SerialMessage[1]) { // All units support ACK, NAK, Pid_Protocol_Data
		case Pid_Product_Data:		/* Version/ID record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Product_Data record\n");
			doID();
			return;

		case Pid_Protocol_Array:
			doProtocolArray();
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Protocol_Array record\n");
			return;

		case Pid_Ack_Byte:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Ack_Byte record\n");
			ok=1;
			return;

		case Pid_Nak_Byte:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Nak_Byte record\n");
			ok=0;
			return;

		case Pid_Display_Data:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Display_Data record\n");
			doDisplay();
			return;

	} // switch(SerialMessage[1]) #1

	if(LinkProtocol==1)
		switch (SerialMessage[1]) {

		case Pid_Xfer_Cmplt:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Xfer_Cmplt record\n");
			doEOFRec();
			return;
		
		case Pid_Rte_Hdr:	/* Route name record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Rte_Hdr record\n");
			doRouteName();
			return;

		case Pid_Rte_Wpt_Data:	/* Route waypoint record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Rte_Wpt_Data record\n");
			doWaypoint(RouteDataRecord);
			return;

		case Pid_Almanac_Data:		/* Almanac record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Almanac_Data record\n");
			doAlmanac();
			return;

		case Pid_Trk_Data:		/* Track record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Trk_Data record\n");
			doTrack();
			return;

		case Pid_Prx_Wpt_Data:		/* Waypoint record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Prx_Wpt_Data record\n");
			doProxWaypoint();
			return;

		case Pid_Wpt_Data:		/* Waypoint record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Wpt_Data record\n");
			doWaypoint(WaypDataRecord);
			return;

		case Pid_Records:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Records # of Records record\n");
			numrecords=*((unsigned INT *)(SerialMessage+3));
			return;

		case Pid_Date_Time_Data:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Date_Time_Data record\n");
			doTime();
			return;

		case Pid_Position_Data:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Position_Data record\n");
			doGPSPos();
			return;

		case Volts:
			if(Gdebug==1) fprintf(Gdebug_out,"Voltages record\n");
			doGPSVolts();
			return;

		case Pid_Pvt_Data:
			if(Gdebug==1) fprintf(Gdebug_out,"PVT data record\n");
			doPVT();
			return;

		case SENDID:
			if(Gdebug==1) fprintf(Gdebug_out,"Received unexpected SEND ID\n");
			strcat(outfmt,"  ");
			for(i=0;i<SerialMsgLen;i++) 
				fprintf(stderr,outfmt,SerialMessage[i]);
			fprintf(stderr,"\n");
			trim(outfmt);
			return;

		default:
			strcat(outfmt,"  ");
			fprintf(stderr,
			    "New Garmin Record ID found: 0x%02x (%03d dec).  Entire message is:\n",
				SerialMessage[1],SerialMessage[1]);
			for(i=0;i<SerialMsgLen;i++) 
				fprintf(stderr,outfmt,SerialMessage[i]);
			fprintf(stderr,"\n");
			trim(outfmt);
			if(Gdebug==1) {
				strcat(outfmt,"  ");
				fprintf(Gdebug_out,
			       "New Garmin Record ID found: 0x%02x (%03d dec).  Entire message is:\n",
				    SerialMessage[1],SerialMessage[1]);
				for(i=0;i<SerialMsgLen;i++)
					fprintf(Gdebug_out,outfmt,SerialMessage[i]);
				fprintf(Gdebug_out,"\n");
				trim(outfmt);
			}
			return;
 	    } // switch(SerialMessage[1]) #2

	if(LinkProtocol==2)
		switch(SerialMessage[1]) {

		case Pid_Xfer_Cmplt2:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Xfer_Cmplt2 record\n");
			doEOFRec();
			return;
		
		case Pid_Wpt_Data2:		/* Waypoint record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Wpt_Data2 record\n");
			doWaypoint(WaypDataRecord);
			return;

		case Pid_Rte_Hdr2:	/* Route name record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Rte_Hdr2 record\n");
			doRouteName();
			return;

		case Pid_Rte_Wpt_Data2:	/* Route waypoint record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Rte_Wpt_Data2 record\n");
			doWaypoint(RouteDataRecord);
			return;

		case Pid_Almanac_Data2:		/* Almanac record */
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Almanac_Data2 record\n");
			doAlmanac();
			return;

		case Pid_Records2:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Records2 # of Records record\n");
			numrecords=*((unsigned INT *)(SerialMessage+3));
			return;

		case Pid_Date_Time_Data2:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Date_Time_Data2 record\n");
			doTime();
			return;

		case Pid_Position_Data2:
			if(Gdebug==1) fprintf(Gdebug_out,"Pid_Position_Data2 record\n");
			doGPSPos();
			return;

		} // switch(SerialMessage[1]) #2
		if(go_on==1) return;
		if(LinkProtocol==-1) {
			fprintf(stderr,"Link Protocol Violation, aborting...\n");
			if(Gdebug==1) 
				fprintf(Gdebug_out,"Link Protocol Violation, aborting...\n");
		}
		else {
			fprintf(stderr,"Unknown Link Protocol L%03d, aborting\n",LinkProtocol);
			if(Gdebug==1) 
				fprintf(Gdebug_out,"Unknown Link Protocol L%03d, aborting\n",LinkProtocol);
		}
		byebye(7);
} /* parseGPS */


/* -------------------------------------------------------------------------- */
PROCX void send_num_points(int num1, char *bb)
{
	INT num;
	char cc[100];

	if(num1>=MAXWAYP && strcmp(bb,"Waypoints")==0) {
		fprintf(stderr,"Too many waypoints for a Garmin GPS receiver.\n");
		fprintf(stderr,"  Sending first 750\n");
		num=750;
	}
	else {
		num=num1;
	}
/*
 * send number of records to send
 */
 	sprintf(cc,"bgnxfr: # of %s",bb);
	*((short*)(bgnxfr+2)) = num;
	SendGarminMessage(bgnxfr, 4, cc);
	getGarminMessage(1);	/* make sure GPS receiver responded */
} /* send_num_points */

#if DEBUGREAD
extern void debugOUT(BYTE *message, INT len);
extern FILE *qq;
extern INT fileopen;
PROCX void getGarminMessage(INT exit_on_error)
{
	char bun[777];
	char *p;
	BYTE qqq;
	INT done,j,c,i;
	int	GPSchecksum;// 0=bad, 1=ok

	if(fileopen==0) {
		qq=fopen(debugin_name,"r");
	}
	fileopen=1;
	memset(SerialMessage,0,MAX_LENGTH);
	GPSchecksum=1;
	done=0;
//
// Read until next "Received" line
//
	while(done==0) {
		if(fgets(bun,777,qq)==NULL) {
			fprintf(stderr,"EOF (1) in file %s\n",debugin_name);
			j=0;
			goto linedone;
//			byebye(0);
		}
		if(instr(bun,"Received")) done=1;
	}
	done=0;
//
// Read until we have a valid data line
//
	while(done==0) {
		if(fgets(bun,777,qq)==NULL) {
			fprintf(stderr,"EOF (2) in file %s\n",debugin_name);
			byebye(0);
		}
		if(bun[1] != '1') continue;  // first non space character in a received
		                             //  data line is always '1'
		done=1;
	}
//
// We now have first line of code. read and process line until line is completed
//
	j=0;

processnext:;

	null_newline(bun);
	trim(bun);
	strupr(bun);

	p=strtok(bun," ");
	if(strlen(p)>2) p[2]=0;
	SerialMessage[j++]=htoi(p);

	while(1) {
		p=strtok(NULL," ");
		if(p==NULL) break;
		if(p[0]==0) break;
		if(strlen(p)>2) p[2]=0;
		SerialMessage[j++]=htoi(p);
	}

//	debugOUT(SerialMessage,j-1);

//
// get next line
//
	if(fgets(bun,777,qq)==NULL) {
		fprintf(stderr,"EOF (3) in file %s\n",debugin_name);
		byebye(0);
	}
	if(bun[0] != ' ') goto linedone;
	if(instr(bun,"Sending")) goto linedone;
	if(instr(bun,"Pid")) goto linedone;
	if(strlen(bun) == 0) goto linedone;
	goto processnext;

linedone:;
	if(Gdebug==1) {
		fprintf(Gdebug_out,"\nfake Received:\n");
		c=0;
		for(i=0;i<j;i++) {
			fprintf(Gdebug_out,outfmt,qqq=*(SerialMessage+i));
			if(qqq>=32 && qqq<=126) fprintf(Gdebug_out,"%c ",qqq);
			else fprintf(Gdebug_out,"  ");
			if(++c>15) {
				fprintf(Gdebug_out,"\n");
				c=0;
			}
	    }
		if(c)fprintf(Gdebug_out,"\n");
		fflush(Gdebug_out);
	}
//	if(exit_on_error)return; // len=SerialMsgLen=j;	
	len=SerialMsgLen=j;	
	if(len) parseGPS();
} // getGarminMessage(INT exit_on_error)

#else
/* -------------------------------------------------------------------------- */
/*
 *	getGarminMessage(1) returns the number of bytes in the message. If the
 *	timeout period has lapsed without completing a message, 0 is returned.
 *  
 *  The string SerialMessage contains the entire data string returned
 *   from the GPS
 */
PROCX void getGarminMessage(INT exit_on_error)
{
	extern short gInRefNum;
	INT i, fails, GPSchecksum;
	time_t t;
	BYTE qq;
	BYTE c, *p, last;
	short length, ne;
	
	Garmin_NAKS_Sent=0;

redoit:
	p = SerialMessage;
	length = len = SerialMsgLen = ne = last = 0;
	memset(SerialMessage,0,MAX_LENGTH);
	t = time(NULL);
	COMtimeout=fails=0;
	for (;;) {
		if ((time(NULL)-t) > TIMEOUT) {
			if(++fails>3) {
				COMtimeout=1;
				if(exit_on_error==1) byebye(5);
				return;
			}
			t=time(NULL);
//
// Re-send last message
//
			SendGarminMessage(LastGarminGPSMsg,LastGarminLen,"Re-send");
		}
		COMtimeout=0;
		while (AsyncInStat()) {
			fails=0;
			if (length >= MAX_LENGTH-1) {
				strcat(outfmt,"  ");
				fprintf(stderr,"GPS communication protocol error length:%d\n",length);
				for(ne=0;ne<length;ne++) fprintf(stderr,outfmt,SerialMessage[ne]);
				fprintf(stderr,"\n");
				trim(outfmt);
				return;
			}
			c=AsyncIn();
			t = time(NULL);  /* reset time */

			if(c==0x03 && last==0x10)
				ne = 1;
			else
				ne = 0;
			
			if (c == 0x10 && last == 0x10)
				last = 0;
			else {
				last = *p++ = c;
				++length;
			}

			if (*(p-1) == 0x03 && *(p-2) == 0x10 && ne) {
				GPSchecksum=checksum(SerialMessage,length);
				if(Gdebug==1) {
					fprintf(Gdebug_out,"\nReceived:");
					if(GPSchecksum==0) fprintf(Gdebug_out," (Checksum is BAD)");
					fprintf(Gdebug_out,"\n");
					fflush(Gdebug_out);
					c=0;
					for(i=0;i<length;i++) {
						fprintf(Gdebug_out,outfmt,qq=*(SerialMessage+i));
						if(qq>=32 && qq<=126) fprintf(Gdebug_out,"%c ",qq);
						else fprintf(Gdebug_out,"  ");
						if(++c>15) {
							fprintf(Gdebug_out,"\n");
							c=0;
						}
						fflush(Gdebug_out);
				    }
					if(c)fprintf(Gdebug_out,"\n");
					fflush(Gdebug_out);
				}
				if(GPSchecksum==0) {
					SendGarminMessage(nak1,4, "NAK");   /* send NAK */
					if(++Garmin_NAKS_Sent<7) goto redoit;
					fprintf(stderr,"Too Many NAKS in reading from GPS, aborting\n");
					byebye(6);
				}
				ack1[2]=SerialMessage[1];	// setup proper ack response
				if(SerialMessage[1]!=0x06) // Don't ACK an ACK!
					SendGarminMessage(ack1,4, "ACK");   /* send ACK */
				len=SerialMsgLen=length;
				parseGPS();
				return;
			} //if (*(p-1) == 0x03 && *(p-2) == 0x10 && ne) 
		} // while 
	} // for (;;)
} /* getGarminMessage(INT exit_on_error) */
#endif

/* -------------------------------------------------------------------------- */
/*
 * Gets records from the GPS.  recordtype holds the type of record
 *  the program expects to see
 */
PROCX void getGPSrecords(void)
{
	INT cc,i;

//
// get number of records to send
//
	getGarminMessage(1);

	if(numrecords == -2) return;
	if(numrecords < 0 ) {
		fprintf(stderr,"Error getting number of records to receive...aborting\n");
		return;
	}
	if(numrecords==0) {
		fprintf(stderr,"GPS: No %s records to send\n",
		         recordtype==TRK?"Track":recordtype==WPT?"Waypoint":"Proximity Waypoint");
		getGarminMessage(1); /* get RouteEOF */
		return;
	}
	nak1[2]=recordtype;			// setup proper NAK response
	fprintf(stderr,"%c%05d of %d\r",
		         recordtype==TRK?'T':recordtype==WPT?'W':'P',0,numrecords);
	for(i=1;i<=numrecords;i++) {
		fprintf(stderr,"%c%05d\r",recordtype==TRK?'T':recordtype==WPT?'W':'P',i);
		lastlat=record.la;
		lastlon=record.lo;
		getGarminMessage(1); /* get record */
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='X' || cc=='Y') {
			SendGarminMessage(Gabort,4,"Gabort");	// Abort the transfer
			getGarminMessage(1); 					// get ACK/NAK
			if(cc=='Y') {
				fprintf(stderr,"\nOperator Abort\n");
				return;
			}
			else {
				fprintf(stderr,"\nOperator Exit\n");
				byebye(0);
			}
		}
	} // for(i=1;i<=numrecords;i++)
	fprintf(stderr,"\n");
} /* getGPSrecords */

/* -------------------------------------------------------------------------- */
PROCX void getGPSstart(unsigned char *m, INT c, char *msg)
{
	char msg1[100];

	sprintf(msg1,"GetGPSstart from  %s",msg);
	SendGarminMessage(m,(short)c,msg1);
	getGarminMessage(1);	/* make sure GPS receiver responded */
/*
 * gps will respond with the first record of the requested data.  Usually a
 *  count of the number to follow.  This is read by getGPSrecords.....
 */
} /* getGPSstart */

/* -------------------------------------------------------------------------- */
//
// typedef struct
// {
//		byte tag;
//		word data;
// } Protocol_Data_Type;

Protocol_Data_Type (*a)[1];
PROCX void printArray(void)
{
	INT i;

	fprintf(stderr,"An error occurred while decoding the Protocol Array\n");
	fprintf(stderr,"Here is the array as read: \n");
	for(i=0;i<(SerialMsgLen-6)/3;i++) fprintf(stderr,"%c%03d\n",a[i]->tag,a[i]->data);
	fprintf(stderr,"Aborting...\n");
	fflush(stderr);
	byebye(9);
} // printArray()

// Decodes Protocol Capability Array
PROCX void doProtocolArray(void)
{
	INT i;

// GPS 12XL ver 3.53:
// Received:
// 10   fd   3c   50P  00   00   4cL  01   00   41A  0a   00   41A  64d  00   44D  67g  00
// 41A  c8   00   44D  c9   00   44D  67g  00   41A  2c   01   44D  2c   01   41A  90   01
// 44D  93   01   41A  f4   01   44D  f5   01   41A  58X  02   44D  58X  02   41A  bc   02
// 44D  bc   02   41A  20   03   44D  20   03   d0   10   03  
// Pid_Protocol_Array record

// GPS II+ ver 2.07:
// Received:
// 10   fd   366  50P  00   00   4cL  01   00   41A  0a   00   41A  64d  00   44D  67g  00
// 41A  c8   00   44D  c9   00   44D  67g  00   41A  2c   01   44D  2c   01   41A  f4   01
// 44D  f5   01   41A  58X  02   44D  58X  02   41A  bc   02   44D  bc   02   41A  20   03
// 44D  20   03   80   10   03  
// Pid_Protocol_Array record
//
	a=(void *)&SerialMessage[3];
//
// 0 is a valid value, so Preset values to -1
//
	CommandProtocol=WaypXferProtocol=WaypDataRecord=RouteXferProtocol=RouteHdrType=-1;
	RouteDataRecord=TrackXferProtocol=TrackDataRecord=ProxXferProtocol=ProxDataRecord=-1;
	AlmanacXferProtocol=AlmanacDataRecord=UTCXferProtocol=UTCDataRecord=-1;
	PositionXferProtocol=PositionDataRecord=PVTXferProtocol=PVTDataRecord=-1;
	LinkProtocol=PhysicalProtocol=-1;

	for(i=0;i<(SerialMsgLen-6)/3;i++) {
		switch(a[i]->tag) {
			case 'A':
/////=================================================================================================
					if(a[i]->data >= 10 && a[i]->data <= 99) {
							CommandProtocol=a[i]->data;
					}
					else 
					if((a[i]->data>=100) && (a[i]->data<=199)) {
							WaypXferProtocol=a[i]->data;
							i++; // if(a[++i]->tag!='D') printArray();// exits
							WaypDataRecord=a[i]->data;
					} // 100-199: WaypXfrProtocol
					else
					if((a[i]->data>=200) && (a[i]->data<=299)) {
							RouteXferProtocol=a[i]->data;
  							i++; //if(a[++i]->tag!='D') printArray();// exits
							RouteHdrType=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							RouteDataRecord=a[i]->data;
					} // 200-299: RouteXfrProtocol & RouteHdrType
					else
					if((a[i]->data>=300) && (a[i]->data<=399)) {
							TrackXferProtocol=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							TrackDataRecord=a[i]->data;
					} // 300-399: TrackDataRecord
					else
					if((a[i]->data>=400) && (a[i]->data<=499)) {
							ProxXferProtocol=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							ProxDataRecord=a[i]->data;
					} // ProxXferProtocol & ProxDataRecord
					else
					if((a[i]->data>=500) && (a[i]->data<=599)) {
							AlmanacXferProtocol=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							AlmanacDataRecord=a[i]->data;
					} // AlmanacXferProtocol & AlmanacDataRecord
					else
					if((a[i]->data>=600) && (a[i]->data<=699)) {
							UTCXferProtocol=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							UTCDataRecord=a[i]->data;
					} // UTCXferProtocol & UTCDataRecord
					else
					if((a[i]->data>=700) && (a[i]->data<=799)) {
							PositionXferProtocol=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							PositionDataRecord=a[i]->data;
					} // PositionXferProtocol & PositionDataRecord
					else
					if((a[i]->data>=800) && (a[i]->data<=899)) {
							PVTXferProtocol=a[i]->data;
 							i++; //if(a[++i]->tag!='D') printArray();// exits
							PVTDataRecord=a[i]->data;
					} // PVTXferProtocol & PVTDataRecord
//					else
//							printf("Undocumented Protocol: A%03d, ignored.\n\n", a[i]->data);
					break;
/////=================================================================================================
			case 'L': LinkProtocol=a[i]->data; break;
			case 'P': PhysicalProtocol=a[i]->data; break;
		  } // switch(a[i]->tag)
	}
	haveProtocolArray=1;
} // doProtocolArray()

/* -------------------------------------------------------------------------- */
PROCX void setProtocolParams()
{
	INT svi;
	INT i;
	
	if(haveProtocolArray==1) return;

	i=0;
	while(Protocols[i][0] != Product_ID ) {
		if(Protocols[i][0]==-1) {
			fprintf(stderr,"No Protocol Array and Protocol not in Table\n");
			fprintf(stderr,"  program can't continue.\n");
			byebye(10);
		}
		i++;
	}
// assume that the product ID found in the array matches.  Set the program
//  protocols to the protocols found in the table.
//
	ProtocolIndex=i;

//
//  If Version is != 0 then this is the first of at least 2 sub-codes.
//  If our version is less than the absolute value of the table entry then we use it.
//
	while(Product_ID == Protocols[i][0]) {
		if((svi=Protocols[i][1]) < 0) {
			svi*=(-1);
			if(SWVersion < svi) goto process;
			svi=Protocols[++i][1];
			if(svi < 0) {
				svi*=(-1);
				if(SWVersion < svi) goto process;
			}
			else if(SWVersion >= svi) goto process;
			i++;
			if(i>60) byebye(9);
		} // if((svi=Protocols[i][1]) < 0)
		else break;
	} // while(Product_ID == Protocols[i][0])
//
// set program protocols
//
process:;
	if(Protocols[i][0] != Product_ID) {
		fprintf(stderr,"No Protocol Array and Protocol not in Table\n");
		fprintf(stderr,"  program can't continue.\n");
		byebye(10);
	}
	Product_Ver 		= Protocols[i][1];
	LinkProtocol		= Protocols[i][2];
	CommandProtocol		= Protocols[i][3];

	WaypXferProtocol	= 100;
	WaypDataRecord 		= Protocols[i][4];

	RouteXferProtocol	= 200;
	RouteHdrType 		= Protocols[i][5];
	RouteDataRecord 	= Protocols[i][6];

	TrackXferProtocol	= Protocols[i][7];
	TrackDataRecord 	= Protocols[i][8];

	ProxXferProtocol	= Protocols[i][9];
	ProxDataRecord		= Protocols[i][10];

	AlmanacXferProtocol	= 500;
	AlmanacDataRecord 	= Protocols[i][11];

	UTCXferProtocol		= 600;
	UTCDataRecord		= 600;

	PositionXferProtocol= 700;
	PositionDataRecord	= 700;

	PVTXferProtocol		= -1;
	PVTDataRecord		= -1;

 	if(LinkProtocol==1) bgnxfr[0]=Pid_Records;
	if(LinkProtocol==2) bgnxfr[0]=Pid_Records2;

	switch(CommandProtocol) {
		case 10:
				Gabort[2]	= Cmnd_Abort_Transfer;
				alm1[2]		= Cmnd_Transfer_Alm;
				almt[2]		= Cmnd_Transfer_Alm;
				GPSPos[2]	= Cmnd_Transfer_Posn;
				pwpt1[2]	= Cmnd_Transfer_Prx;
				prxt[2] 	= Cmnd_Transfer_Prx;
				rte1[2]		= Cmnd_Transfer_Rte;
				rtet[2]		= Cmnd_Transfer_Rte;
				GPStime[2]	= Cmnd_Transfer_Time;
				trk1[2]		= Cmnd_Transfer_Trk;
				trkt[2]		= Cmnd_Transfer_Trk;
				wpt1[2]		= Cmnd_Transfer_Wpt;
				wptt[2]		= Cmnd_Transfer_Wpt;
				pwroff[2]	= Cmnd_Turn_Off_Pwr;
				VoltsM[2]	= Cmnd_Send_Voltages;
				PVTon[2] 	= Cmnd_Start_Pvt_Data;
				PVToff[2]	= Cmnd_Stop_Pvt_Data;
				break;
		case 11:
				Gabort[2]	= Cmnd_Abort_Transfer2;
				alm1[2]		= Cmnd_Transfer_Alm2;
				almt[2]		= Cmnd_Transfer_Alm2;
				rte1[2]		= Cmnd_Transfer_Rte2;
				rtet[2]		= Cmnd_Transfer_Rte2;
				wpt1[2]		= Cmnd_Transfer_Wpt2;
				wptt[2]		= Cmnd_Transfer_Wpt2;
				GPStime[2]	= Cmnd_Transfer_Time2;
				pwroff[2]	= Cmnd_Turn_Off_Pwr2;
				break;
		default: fprintf(stderr,"Unknown Command Protocol:A%03d  Aborting...\n",
					CommandProtocol);
				 byebye(7);
	} // switch(CommandProtocol)

} // setProtocolParams

PROCX void print_protocols(void)
{

	char pdp[5], pp[5], lp[5], cp[5], wxp[5], wdr[5], rxp[5], rht[5], rdr[5], txp[5];
	char tdr[5], pxp[5], pdr[5], axp[5], adr[5], uxp[5], udr[5];
	char Ppxp[5],Ppdr[5],PVxr[5],PVpdr[5];
	char dum[5]="None";

	printf("\nProduct ID: %d, Version string: '%s'\n\n",Product_ID,VersionString);
	printf("This GPS supports the following Protocols (source: %s)\n\n",haveProtocolArray==1?"GPS Protocol Array":"Garmin Protocol Table");

	if(ProductDataProtocol>=0) sprintf(pdp,"A%03d",ProductDataProtocol);
	else strcpy(pdp,dum);
	
	if(PhysicalProtocol>=0) 	sprintf(pp,"P%03d",PhysicalProtocol);
	else strcpy(pp,dum);

	if(LinkProtocol>=0) 		sprintf(lp,"L%03d",LinkProtocol);
	else strcpy(lp,dum);

	if(CommandProtocol>=0)	 	sprintf(cp,"A%03d",CommandProtocol);
	else strcpy(cp,dum);

	if(WaypXferProtocol>=0) 	sprintf(wxp,"A%03d",WaypXferProtocol);
	else strcpy(wxp,dum);

	if(WaypDataRecord>=0) 		sprintf(wdr,"D%03d",WaypDataRecord);
	else strcpy(wdr,dum);

	if(RouteXferProtocol>=0) 	sprintf(rxp,"A%03d",RouteXferProtocol);
	else strcpy(rxp,dum);

	if(RouteHdrType>=0) 		sprintf(rht,"D%03d",RouteHdrType);
	else strcpy(rht,dum);

	if(RouteDataRecord>=0) 		sprintf(rdr,"D%03d",RouteDataRecord);
	else strcpy(rdr,dum);

	if(TrackXferProtocol>=0) 	sprintf(txp,"A%03d",TrackXferProtocol);
	else strcpy(txp,dum);

	if(TrackDataRecord>=0) 		sprintf(tdr,"D%03d",TrackDataRecord);
	else strcpy(tdr,dum);

	if(ProxXferProtocol>=0) 	sprintf(pxp,"A%03d",ProxXferProtocol);
	else strcpy(pxp,dum);

	if(ProxDataRecord>=0) 		sprintf(pdr,"D%03d",ProxDataRecord);
	else strcpy(pdr,dum);

	if(AlmanacXferProtocol>=0) 	sprintf(axp,"A%03d",AlmanacXferProtocol);
	else strcpy(axp,dum);

	if(AlmanacDataRecord>=0) 	sprintf(adr,"D%03d",AlmanacDataRecord);
	else strcpy(adr,dum);

	if(UTCXferProtocol>=0) 		sprintf(uxp,"A%03d",UTCXferProtocol);
	else strcpy(uxp,dum);

	if(UTCDataRecord>=0) 		sprintf(udr,"D%03d",UTCDataRecord);
	else strcpy(udr,dum);

	if(PositionXferProtocol>=0)	sprintf(Ppxp,"A%03d",PositionXferProtocol);
	else strcpy(Ppxp,dum);

	if(PositionDataRecord>=0) 	sprintf(Ppdr,"D%03d",PositionDataRecord);
	else strcpy(Ppdr,dum);

	if(PVTXferProtocol>=0) 		sprintf(PVxr,"A%03d",PVTXferProtocol);
	else strcpy(PVxr,dum);

	if(PVTDataRecord>=0) 		sprintf(PVpdr,"D%03d",PVTDataRecord);
	else strcpy(PVpdr,dum);

	printf("Product Data      : %s, Physical      : %s\n", pdp, pp);
	printf("Link              : %s, Command       : %s\n", lp, cp);
	printf("Waypoint Transfer : %s, Waypoint Data : %s\n", wxp, wdr);
	printf("Route Transfer    : %s, Route Header  : %s, Route Data: %s\n",rxp,rht,rdr);
	printf("Track Transfer    : %s, Track Data    : %s\n", txp, tdr);
	printf("Proximity Transfer: %s, Proximity Data: %s\n", pxp, pdr);
	printf("Almanac Transfer  : %s, Almanac Data  : %s\n", axp, adr);
	printf("Date/Time Transfer: %s, Date/Time Data: %s\n", uxp, udr);
	printf("Position Transfer : %s, Position Data : %s\n", Ppxp, Ppdr);	
	printf("PVT Transfer      : %s, PVT Data      : %s\n", PVxr, PVpdr);
} // print_protocols()

/* -------------------------------------------------------------------------- */
PROCX void getID(void)
{

	if(gotID==1) return;
	go_on=1;
	SendGarminMessage(Gabort,4,"Gabort");	// JIC Abort the transfer
	getGarminMessage(1);						// get ack to  abort
	SendGarminMessage(m1,3,"Send ID");		// Send your ID
	ok=0;
	getGarminMessage(1);						// get ack to Send your ID
	if(ok==0) {							// try again
		SendGarminMessage(m1,3,"Send ID");	// Send your ID
		getGarminMessage(1);					// get ack to Send your ID
	}
	getGarminMessage(1);						// read the ID
	delay(300); 						// allow unit to respond with Protocol Array
										//  if supported
#if !DEBUGREAD
	if(AsyncInStat()) {					// Assume if we have a character that 
#endif
		getGarminMessage(1);					// This should be the Protocol Array
										//  Protocol Array is supported
#if !DEBUGREAD
	}
#endif
	if(haveProtocolArray==0) setProtocolParams(); // If not, try the table
	go_on=0;
	gotID=1;
} // getID

/* -------------------------------------------------------------------------- */
PROCX void getProxWaypoints(void)
{
	recordtype=PROX;
	numrecords=-1;
	getGPSstart(pwpt1,4,"getProxWaypoints");
	getGPSrecords();
	if(numrecords==-2) proximityp=0;
	if(numrecords<=0) return;
	getGarminMessage(1); 		/* get ProxWaypointEOF */
	if(!ProxWaypointEOF) fprintf(stderr,"No Proximity Waypoint EOF received\n");
} /* getProxWaypoints */

/* -------------------------------------------------------------------------- */
PROCX void getWaypoints(void)
{
	recordtype=WPT;
	getGPSstart(wpt1,4,"getWaypoints");
	getGPSrecords();
	if(numrecords==-2) waypoints=0;
	if(numrecords<=0) return;
	getGarminMessage(1); /* get WaypointEOF */
	if(!WaypointEOF) fprintf(stderr,"No Waypoint EOF received\n");
} /* getWaypoints */

/* -------------------------------------------------------------------------- */
PROCX void getTrack(void)
{
	recordtype=TRK;
	getGPSstart(trk1,4,"getTrack");
	getGPSrecords();
	if(numrecords==-2) tracks=0;
	if(numrecords<=0) return;
	getGarminMessage(1); /* get TrackEOF */
	if(!TrackEOF) fprintf(stderr,"No Track EOF received\n");
} /* getTrack */

/* -------------------------------------------------------------------------- */
PROCX void getRoute(void)
{
	INT i;
	static lastr;

/*
 * ask for routes
 */
	getGPSstart(rte1,4, "getRoute");
/*
 * get number of records to receive
 */
	getGarminMessage(1);
/*
 * the number of records includes all the waypoints plus one for each
 *   route name.  It does not include route end data.  It does not include
 *   the number of waypoints in each route.  The beginning of a new route
 *   signifies the end of the old one.
 */
	if(numrecords==0) {
		getGarminMessage(1); /* get RouteEOF */
		fprintf(stderr,"GPS: No Route records to send\n");
		return;
	}
	recordtype=RTE_WPT;
	nak1[2]=recordtype;
	fprintf(stderr,"Route# xx RR000 of %3d total records\r",numrecords);
	lastr=-1;
	for(i=1;i<=numrecords;i++) {
//
// not necessary to send 'send next route point'.  In fact, it screws up the
//  route download on some GPS's.  The ACK sent is sufficient
//
//SendGarminMessage(rte2,4,"Send next route point"); /* send next route pt */
		getGarminMessage(1); /* get route */
		if(lastr==(-1)) lastr=route_number;
		if(lastr!=route_number) {
			fprintf(stderr,"\n");
			lastr=route_number;
		}
		fprintf(stderr,"Route# %02d RR%03d\r",route_number,i);
	}
	fprintf(stderr,"\n");
	getGarminMessage(1); /* get RouteEOF */
	if(!RouteEOF) {
		fprintf(stderr,"No Route EOF received\n");
	}
	else {
		in_route=0;
	}
} /* getRoute */

/* -------------------------------------------------------------------------- */
PROCX void getAlmanac(void)
{
	getGPSstart(alm1,4, "getAlmanac");
/* get number of records to receive */
	getGarminMessage(1);
	if(!numrecords) fprintf(stderr,"GPS: No almanac records to send\n");
	for(satnum=1;satnum<=numrecords;satnum++) {
		SendGarminMessage(alm2,4,"Send Next ALM record"); /* send next almanac */
		getGarminMessage(1); /* get almanac */
	}
	getGarminMessage(1); /* get AlmanacEOF */
	if(!AlmanacEOF) printf("No Almanac EOF received\n");
	else printf("\n");
} /* getAlmanac */

/* -------------------------------------------------------------------------- */
PROCX void poweroff(void)
{
	SendGarminMessage(pwroff, 4, "Power off");
	while(AsyncOutStat());
} /* poweroff */

/* -------------------------------------------------------------------------- */
PROCX void set_contrast(void)
{
	contrast[2]=(BYTE)contrast_val;
	SendGarminMessage(contrast, 3, "Set contrast");
	while(AsyncOutStat());
} /* set_contrast */

/* -------------------------------------------------------------------------- */
PROCX void light_on(void)
{
	if( (Product_ID==73 || Product_ID==97   || Product_ID==72)  ||
		((SWVersion>300) && (Product_ID==77)) 
	  ) {
			lightiiP[2]=light;
			SendGarminMessage(lightiiP, 3,"Light on, II+");
	}
	else
		SendGarminMessage(lighton, 3,"Light on");
	while(AsyncOutStat());
} /* light_on */

/* -------------------------------------------------------------------------- */
PROCX void light_off(void)
{
	if(Product_ID==73 || Product_ID==97) {
		lightiiP[2]=0;
		SendGarminMessage(lightiiP, 3,"Light off II+");
	}
	else
		SendGarminMessage(lightoff, 3,"Light off");
	while(AsyncOutStat());
} /* light_off */

/* -------------------------------------------------------------------------- */
PROCX void getGarminDisplay(void)
{
	INT i,cc,dispt;
	long tlong,screenmem;

	if(Product_ID != 71 && Product_ID != 72 && Product_ID != 67 && Product_ID !=119 ) {
		fprintf(stderr,"Warning.  Product may not support display download\n");
		fprintf(stderr,"          and a display download will likely fail.\n");
	}
	SendGarminMessage(display, 4, "Send GPS display");
	getGarminMessage(1); 				// get ACK record */
	getGarminMessage(1); 				// get height/width record */

	if(open_output("wb")==0) return;

	screenmem=(long)((long)dsplines*(long)dsppixels)/2L;
	if((bmdata=calloc((int)screenmem+10,1)) == NULL) {
		fprintf(stderr,"Not enough memory to allocate GPS III display array\n");
		return;
	}
//
// write a standard 118 byte header for AxBx16 windows bitmaps
//
	bmh[18]=dsppixels;
	dispt=bmh[22]=dsplines;


	tlong=dispt*dsppixels/2;
	memcpy(&bmh[34],&tlong,4);
	tlong+=118;
	memcpy(&bmh[2],&tlong,4);

	fwrite(bmh,118,1,out);
	fprintf(stderr,"L000 of %3d\r",dsplines);
	for(i=1;i<=dsplines;i++) {		// get rest of lines
		fprintf(stderr,"L%03d\r",i);
		getGarminMessage(1); /* get record */
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='X' || cc=='Y') {
			SendGarminMessage(Gabort,4,"Gabort"); // Abort the transfer
			if(cc=='Y') {
				fprintf(stderr,"\nOperator Abort\n");
				return;
			}
			else {
				fprintf(stderr,"\nOperator Exit\n");
				byebye(0);
			}
		}
	} // for(i=1;i<=dsplines;i++)
//
// Write the data array to the bitmap file
//
	fwrite(bmdata,dispt*dsppixels/2,1,out);
	fclose(out);
	fprintf(stderr,"\n");
} // getGarminDisplay(void)
