#include "g7to.h"
#define PROCX

long	BaseLatitude;
long	BaseLongitude;
long	TailAdrPointer;
long	HeadAdrPointer;
INT		timeoutp;
INT		validwp;

INT LwrRangeLo=1;			// If retrieving a range of waypoints from a LEI unit this
							//  is the start waypoint #
INT LwrRangeHi=-1;			// If retrieving a range of waypoints from a LEI unit this
							//  is the finish waypoint #
extern	unsigned char bmh[118]; // = {
//     66,  77, 182,  31,   0,   0,   0,   0,   0,   0, 118,   0,   0,
//      0,  40,   0,   0,   0, 160,   0,   0,   0, 100,   0,   0,   0,
//      1,   0,   4,   0,   0,   0,   0,   0,  64,  31,   0,   0,   0,
//      0,   0,   0,   0,   0,   0,   0,  16,   0,   0,   0,  16,   0,
//      0,   0,   0,   0,   0,   0,  99,  99,  99,   0, 181, 181, 181,
//      0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0,
//    255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 255,
//    255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 255,
//    255,   0, 255, 255, 255,   0, 255, 255, 255,   0, 255, 255, 255,   0
//}; // bmh[118]

void 	readstarttofinish(long Start, long Finish, char * what, void (*fcn)(INT));
void	debugOUTstd(BYTE *message, INT len,INT width);
INT		totalread=0;
INT		Total;
long	rstfOffset=0;
INT		AbortNow=0;
INT		TotalDeltas=0;
INT		NumberOfIcons=0;
INT		NumOfGraphSymbols=0;
#if __BORLANDC__
extern	INT WinNT;
#endif
BYTE	LowrLogin;
INT	LastCommand=0;
INT	LowrValidWpts=0;
INT LowrMemBytesRead=0;
long LowrLastLat, LowrLastLong;

struct LowrID  {
	BYTE Reserved;
	INT ProductID;
	INT ProtocolVersion;
	INT ScreenType;
	INT ScreenWidth;
	INT ScreenHeight;
	INT NumOfWaypoints;
	INT NumOfIcons;
	INT NumOfRoutes;
	INT NumOfWaypointsPerRoute;
	BYTE NumOfPlotTrails;
	BYTE NumOfIconSym;
	BYTE ScreenRotateAngle;
	long RunTime;
} LowrID;

struct LowrWPTr {
	BYTE Reserved;
	short WaypointNumber;
	BYTE Status;
	BYTE IconSymbol;
	long Latitude;  // LONG (Mercator Meter)
	long Longitude; // LONG (Mercator Meter)
	BYTE Name[13];
	long Date;		// seconds since 00:00 January 1, 1992
} LowrWPTr;

union Hdr {
	BYTE Header[8];
	struct hdrs {
		INT preamble;
		INT command;
		INT length;
		BYTE  reserved;
		BYTE  checksum;
	} hdrs;
} Hdr;

struct LowrTrailOrigin {
	BYTE Reserved;
	BYTE PlotTrailNumber;
	long OriginY;
	long OriginX;
	short NumberOfDeltas;
} LowrTrailOrigin;

struct ND {
	BYTE pt;
	short no;
} ND;

struct LowrTrailOriginMem {
	BYTE Reserved;
	BYTE PlotTrailNumber;
	long StructurePointer;
	short StructureSize;
} LowrTrailOriginMem;

struct LowrMemGet {
	long Address;
	short Count;
	BYTE CtgSelect;
} LowrMemGet;

struct LowrMemRead {
	BYTE reserved;
	union data {
		struct ptp {				// for reading Plot trail structure
			long BaseLatitude;
			long BaseLongitude;
			long TailAdrPointer;
			long HeadAdrPointer;
		} ptp;
		short data[80];				// for reading 80 shorts
		BYTE  bytes[160];			// for reading 360 bytes
		unsigned long lbytes[40];   // for reading longs
	} data;
} LowrMemRead;
	
#define MAX_Lowr_LENGTH 256

//
// Lowrance Serial Port Commands
//
enum {
	ReadMem				=0x0008,  // Read from a memory location
	WriteMem			=0x0009,  // Write to a memory location
	Login				=0x000D,  // Wake up external serial port
	BaudChange			=0x010A,  // Change NMEA Baud Rate
	GetScreenPointer	=0x0301,  // Request Screen Pointer to download the current Screen
	UnfreezeScreen		=0x0302,  // unfreeze the current screen (happens after downloading screen)
	GetWaypoint			=0x0303,  // Get a Waypoint
	SendWaypoint		=0x0304,  // Send a Waypoint
	GetRoute			=0x0305,  // Get a Route
	SendRoute			=0x0306,  // Send a Route
	GetPlotTrail		=0x0307,  // Get plot trail Pointer
	GetNumIcons			=0x0308,  // Get number of icons
	GetIconSymbol		=0x0309,  // Get icon symbol
	SetNumIcons			=0x030A,  // Set number of icons
	SendIcon			=0x030B,  // Send icon
	GetNumGraphSymbols	=0x030C,  // Get number of Graphical symbols
	GetIconGraphSymbol	=0x030D,  // Get Icon Graphical symbol
	GetProductInfo		=0x030E,  // Get product information
	GetPlotTrailOrigin	=0x0312,  // Get Plot Trail Origin (Protocol version 2.0)
	GetPlotTrailDeltas	=0x0313,  // Get Plot Trail Deltas (Protocol version 2.0)
	SetPlotTrailOrigin	=0x0314,  // Set Plot Trail Origin (Protocol version 2.0)
	SetPlotTrailDeltas	=0x0315,  // Set Plot Trail Deltas (Protocol version 2.0)
};


// Constants needed 

#define RADtoDEG  57.295779513082322
#define EarthRad  6356752.3142 
#define DEGtoRAD  0.017453292519943296

#define PI        3.14159265358979323846
#define PIdiv2    1.57079632679489661923
#define EarthRadxRADtoDEG 364215079.013679028

/* -------------------------------------------------------------------------- */
PROCX BYTE sethigh(BYTE b, BYTE val)
{
	val&=0xf;
	b&=0x0f;
	b|=(val<<4);
	return b;
} // sethigh
/* -------------------------------------------------------------------------- */
PROCX BYTE setlo(BYTE b, BYTE val)
{
	val&=0xf;
	b&=0xf0;
	b|=val;
	return b;
} // setlo

/* -------------------------------------------------------------------------- */
PROCX long swaplongendian(long in)
{
	union a {
		long b;
		BYTE c[4];
	} a;
	BYTE temp;

	a.b = in;
	temp=a.c[0];
	a.c[0]=a.c[3];
	a.c[3]=temp;

	temp=a.c[2];
	a.c[2]=a.c[1];
	a.c[1]=temp;

	return a.b;
} // long swaplongendian(long a)

/* -------------------------------------------------------------------------- */
//
// Search the currend pushed waypoints for a name, latitude and longitud
//  match.  Returns the number of the waypoint in the list.  This number is
//  a number 1-waypoints
//
PROCX INT MatchRoute(char * namein, double la, double lo)
{
	int i;
	double lat,lon;
	char name[20];
	char *p;
	char *b;
	for(i=1;i<=waypoints;i++) {
		b=strdup(waypoint_push[i]);
		p=strtok3(b,";");				// Skip waypoint type
		p=strtok3(NULL,";");			// Skip datatype
		p=strtok3(NULL,";");			// Get name
		strcpy(name,p);
		p=strtok3(NULL,"!");
//
// skipping lat/long compare because at this point duplicate waypoint names
//   are removed.
//		lat=atof(strtok3(NULL,";"));	// Get Latitude
//		lon=atof(strtok3(NULL,";"));	// Get Longitude
		lat=la;
		lon=lo;
		free(b);
		if((strncmp(name,namein,15) == 0) && la==lat && lo==lon) {
			return i;
		}
	} // for
	return -1;
} // MatchRoute

struct DispParms {
	BYTE Reserved;
	short PixelX;
	short PixelY;
	long BlackAddress;
	short BlackCount;
	long GreyAddress;
	short GreyCount;
} DispParms;

BYTE *black,*grey;
/* -------------------------------------------------------------------------- */
//
// concatonates bytes to the black array
//
PROCX void DoScreenBlack(INT cnt)
{
	static INT ptr=0;

	memcpy(&black[ptr],&SerialMessage[1],cnt); // skip login id byte
	ptr+=cnt;
} // DoScreenBlack

/* -------------------------------------------------------------------------- */
//
// concatonates bytes to the grey array
//
PROCX void DoScreenGrey(INT cnt)
{
	static INT ptr=0;

	memcpy(&grey[ptr],&SerialMessage[1],cnt); // skip login id byte
	ptr+=cnt;
} // DoScreenGrey

BYTE *nib;
BYTE *nib2;
INT	vertical,horizontalblack;
INT	nibsize,siz,rowlen,linebytes;

/* -------------------------------------------------------------------------- */
PROCX void rotatedisp(void)
{
	BYTE *raw;
	INT i,j,k,rl,lb;

// printf("nibsize: %d, siz: %d, rowlen: %d, vertical: %d, horizontal: %d, linebytes: %d\n",
// 			nibsize, siz, rowlen,vertical,horizontalblack,linebytes);
//
// nib2 contains the data in slices of vertical size, but the length of each
//   slice is rowlen bytes;
//
//	rowlen:			The actual number of bytes involved in the bitmap row (vertical)
//	vertical:		The actual number of pixels in the vertical row
//	horizontalblack:The actual number of pixels in a horizontal row
//  linebytes:		The actual number of bytes that contain data in the vertical row
//
//  For the EEII:
//
//	rowlen: 52, vertical: 100, horizontal: 65, linebytes: 50
//
// for the GM100:
//
//  siz: 8320, rowlen: 80, vertical: 160, horizontal: 104, linebytes: 80
//
// First we must move the 2 pixels per byte into a 1 pixel per byte array
//
	if((raw=(BYTE*)calloc(nibsize*2+1000,1)) == NULL) {
		oomem("rotatedisp1");
		byebye(0);
	}
	j=k=0;
	for(i=0;i<(nibsize);i++) {  // was rowlen*horizontalblack
		if(++j<=linebytes) {
			raw[k++] = (nib[i]>>4)&0x0f;
			if((j==linebytes) && (vertical&1)) continue;
			raw[k++] = nib[i]&0x0f;
			if(j==rowlen) j=0;  // just in case rowlen=linebytes, i.e. no padding to skip
		}
		else {
			if(j>=rowlen) j=0; // skip padding
		}
	}
//
// code checked good to here
//
	lb=(horizontalblack/2)+(horizontalblack&1);
	rl=(lb+3)&~3;
	siz=vertical*rl;
//
// for the EEII
//
// rowlen: 36, vertical: 100, horizontal: 65, linebytes: 33
//
// for the GM100:
//
// siz: 8320, rowlen: 52, vertical: 160, horizontal: 104, linebytes: 52
//
// stuff the raw array into lines of horizontal black with 2 bits per pixel
//
	k=0;
	for(i=0;i<vertical;i++) {
		for(j=0;j<horizontalblack;j+=2) {
			nib2[k]=0;
			nib2[k]=sethigh(nib2[k],raw[vertical*j+i]);		
			if((horizontalblack&1) && (j==(horizontalblack-1))) {
				k++;
				continue;
			}
			nib2[k]=setlo(nib2[k],raw[vertical*(j+1)+i]);
			k++;
		}
		for(j=0;j<(rl-lb);j++) {
			nib2[k]=0xff;
			k++;
		}
	}
  	bmh[18]=horizontalblack;
  	bmh[22]=vertical;
} // rotatedisp

/* -------------------------------------------------------------------------- */
PROCX void DoScreenPointer(void)
{
//	INT horizontal;
	long tlong,greyadr,blackadr;
	INT i,j,k;

	if(open_output("wb")==0) return;
	memcpy(&DispParms,SerialMessage,sizeof(struct DispParms));
	blackadr=(DispParms.BlackAddress);
	greyadr=(DispParms.GreyAddress);
	vertical=LowrID.ScreenHeight;
	if(LowrID.ScreenType<2) vertical++;
	horizontalblack=(DispParms.BlackCount*8)/(DispParms.PixelX);
//	horizontal     =(DispParms.GreyCount/vertical)*8;
// printf("PixelX       : %d\n",DispParms.PixelX);
// printf("PixelY       : %d\n",DispParms.PixelY);
// printf("BlackAddress : 0x%08lx\n",blackadr);
// printf("BlackCount   : %d\n",DispParms.BlackCount);
// printf("GreyAddress  : 0x%08lx\n",greyadr);
// printf("GreyCount    : %d\n",DispParms.GreyCount);
// printf("vertical: %d, Horizontal: %d\n",vertical,horizontalblack);
// fflush(stdout);
//
// Get Planes
//
	rstfOffset=0;
	if((black=(BYTE*)calloc(DispParms.BlackCount+100,1)) == NULL) {
		oomem("DoScreenPointer1");
		byebye(0);
	}
	totalread=0;
	readstarttofinish(blackadr, blackadr+DispParms.BlackCount-1, "black plane", DoScreenBlack);

	if(LowrID.ScreenType>0 && DispParms.GreyCount>0) {
		if((grey=(BYTE*)calloc(DispParms.GreyCount+100,1)) == NULL) {
			oomem("DoScreenPointer2");
			byebye(0);
		}
		totalread=0;
		readstarttofinish(greyadr, greyadr+DispParms.GreyCount-1, "grey plane",DoScreenGrey);
	}

	rowlen= (((vertical/2) + (vertical&1) + 3)&~3);  // must end on a long boundary
	linebytes=(vertical/2)+(vertical&1);			 // if vertical is odd must add 1

	if(LowrID.ScreenType<2) siz=horizontalblack*vertical;
	else siz=horizontalblack*vertical/2;
	if((nib=(BYTE*)calloc(siz+1000,1))==NULL)
		oomem("Allocating nibble buffer1");
	if((nib2=(BYTE*)calloc(siz+1000,1))==NULL)
		oomem("Allocating nibble buffer2");
	k=0;
//
// Combine planes into 'nibble' buffer
//
//  The code here takes the screen memory and converts it from 8 pixels
//   per byte to 2 pixels per byte.  By using the BlackCount we include
//   the screen padding bytes.
//
	for(i=0;i<DispParms.BlackCount;i++) {
		for(j=6;j>=0;j-=2) {

			if(DispParms.GreyCount>0)
				if((grey[i]>>j)&1) nib[k]=setlo(nib[k],(BYTE)0x2);
			if((black[i]>>j)&1) nib[k]=setlo(nib[k],(BYTE)3);

			if((nib[k]&0x3) == 3) nib[k]=0;						// invert the black
			else if((nib[k]&0xf) == 0) nib[k]=3;

			if(DispParms.GreyCount>0)
				if((grey[i]>>(j+1))&1) nib[k]=sethigh(nib[k],(BYTE)2);
			if((black[i]>>(j+1))&1) nib[k]=sethigh(nib[k],(BYTE)3);

			if((nib[k]&0x30) == 0x30) nib[k]=sethigh(nib[k],0);// invert the black
			else if((nib[k]&0xf0) == 0) nib[k]=sethigh(nib[k],3);

			k++;
		}
	}
	nibsize=k; 										// bytes in nib

	free(black);
	if(DispParms.GreyCount>0) free(grey);

	k=j=0;
//
// process expanding nibble buffer into proper format
//
//  In the following the scan 'row' is actually one vertical line in the
//   display.
//
//  In a .bmp of 16 colors the pixels each take up a nibble, i.e.
//   two pixels per byte.  Each row must end on a 4 byte boundary
//   if not, 0 nibbles are added until a 4 byte boundary is reached
//
//   The 4 byte boundary of x bytes can be calculated by (x+3)&~3
//
//  In the input buffer, the GPS screen memory scan row is '0 padded'
//   until it's length is equal to DispParms.PixelX.  For example,
//   in the EEII the DispParms.PixelX value is 112, but the screen scan row is
//   only 100 pixels 'wide'.  That means that 12 pixels of padding is added.  This
//   equates to 3 nibbles (8 pixels per byte in screen memory) of padding.
//
//  In the code below the 'if(j<=rowlen)' takes care of
//   adding the padding for the .bmp file.  linebytes-rowlen gives the bytes of
//   padding to add.
//
//   If the last byte is only one nibble, the lower nibble  is already
//   set to 0 by the conversion from the screen format and doesn't need to be
//   counted and the remainder is sufficient.
//
//  The 'if(j>=DispParms.PixelX/2)' line takes care of the GPS screen 
//   padding bytes by skipping them if they exist.  Not all units send padding bytes.
//

// printf("DispParms.BlackCount*4: %d\n",DispParms.BlackCount*4);
// printf("horizontal: %d, vertical: %d, vertical/2: %d\n",horizontalblack,vertical,vertical/2);
// printf("siz: %d\n",siz);
// 
	for(i=0;i<DispParms.BlackCount*4;i++) { // blackcount * 8 / 2 is the size of the source bfr
		if(++j<=linebytes)					// actual data
			nib2[k++]=nib[i];
		else {
			if(j<=rowlen)  nib2[k++]=0;
		}
		if(j>=DispParms.PixelX/2) j=0;
	}
	memcpy(nib,nib2,siz);
//
// mirror display horizontally on output
//
// work a row at a time starting with the last row in the array
//  and working toward the front
//
	j=0;
	k=siz/horizontalblack;
	for(i=siz-k;i>=0;i-=k) {
		memcpy(&nib2[j],&nib[i],k);
		j+=k;
	}
  	bmh[18]=vertical;
  	bmh[22]=horizontalblack;
	if(LowrID.ScreenRotateAngle==90) rotatedisp();
//
// set size of data
//
	tlong=siz;
	memcpy(&bmh[34],&tlong,4);
//
// set size of file
//
	tlong+=118;
	memcpy(&bmh[2],&tlong,4);
//
// write a standard 118 byte header for AxBx16 windows bitmaps
//
   	fwrite(bmh,118,1,out);
	fwrite(nib2,siz,1,out);
//
// close out and free memory
//
    fclose(out);
	free(nib2);
	free(nib);
} // DoScreenPointer

//struct LowrMemGet {
//	long Address;
//	short Count;
//	BYTE CtgSelect;
//} LowrMemGet;

/* -------------------------------------------------------------------------- */
PROCX void GetLowrDisplay(void)
{
	BYTE *temp;

	temp=NULL;
	LastCommand=0x0301;
	SendLowrMessage(LastCommand,temp,0,"GetLowrDispParams");
	GetLowrMessage(1);
	LastCommand=0x0302;
	SendLowrMessage(LastCommand,temp,0,"UnfreezeLowrDisp");
	GetLowrMessage(1);
} // GetLowrDisplay(void)

/* -------------------------------------------------------------------------- */
PROCX BYTE SetLowrChkSum(BYTE * a, INT len)
{
	INT i;

	BYTE sum=0;

	for(i=0;i<len;i++) {
		sum+=a[i];
	}
	sum=-sum;
	return sum;
} // SetLowrChkSum()

/* -------------------------------------------------------------------------- */
PROCX void debugOUT(BYTE *message, INT len)
{
	INT i,c;
	BYTE qq;

    c=0;
    for(i=0;i<len;i++) {
		fprintf(Gdebug_out,outfmt,qq=*(message+i));
		if(qq>=32 && qq<=126) {
			fprintf(Gdebug_out,"%c ",qq);
        }
        else {
        	fprintf(Gdebug_out,"  ");
        }
        if(++c>15) {
        	fprintf(Gdebug_out,"\n");
        	c=0;
        }
    }
    fprintf(Gdebug_out,"\n");fflush(Gdebug_out);
} // void debugOUT

/* -------------------------------------------------------------------------- */
PROCX void debugOUTstd(BYTE *message, INT len, INT width)
{
	INT i,c;

    c=0;
    for(i=0;i<len;i++) {
		printf("%02x  ",message[i]);
        if(++c>width-1) {
        	printf("\n");
        	c=0;
        }
    }
    printf("\n");fflush(stdout);
} // void debugOUTstd

/* -------------------------------------------------------------------------- */
//
// builds header and message and transmits it to the serial port.  Does NOT check
//  for receipt of message.
//
//  NOTE:  MsgLen does not include the checksum byte so the number of bytes sent
//         in a data message is MsgLen+1
//
PROCX void SendLowrMessage(INT command, BYTE *message, INT MsgLen, char *msgtype)
{
//
// Set 'Lasts'
//
	LastLowrLen=MsgLen;
	LastCommand=command;
	memcpy(LastLowrGPSMsg,message,MsgLen);//
// build header
//
	Hdr.hdrs.command = command;
	Hdr.hdrs.preamble = 0x8155;
	Hdr.hdrs.length = MsgLen;
	Hdr.hdrs.reserved = 0;
	Hdr.hdrs.checksum = SetLowrChkSum(Hdr.Header,7);

	memset(SerialMessageOut,0,MAX_LENGTH);
//
// Send Header to Serial Port
//
#if !DEBUGREAD
	AsyncSend(Hdr.Header, 8);
#endif
	if(Gdebug==1) {
		fprintf(Gdebug_out,"Sending header for: %s\n",msgtype);
		debugOUT(Hdr.Header,8);
	}
//
// do we have data to send after the header?
//
	if(MsgLen) {  // Yes, data to send with Header
		memcpy(SerialMessageOut,message,MsgLen);
//
//  Set checksum on message
//
		SerialMessageOut[MsgLen] = SetLowrChkSum(SerialMessageOut,MsgLen);
#if !DEBUGREAD
		AsyncSend(SerialMessageOut, (INT)(MsgLen+1));
#endif
//
// Dumping the send buffer to a file?
//
		if(Gdebug==1) {
			fprintf(Gdebug_out,"Sending: %s\n",msgtype);
			debugOUT(SerialMessageOut,(INT)(MsgLen+1));
		}
	} // if(MsgLen)
} // SendLowrMessage
/* -------------------------------------------------------------------------- */
PROCX short swapshortendian(short val)
{
	BYTE temp;

	union swap {
		BYTE a[2];
		short num;
	} swap;

	swap.num=val;
	temp=swap.a[0];
	swap.a[0]=swap.a[1];
	swap.a[1]=temp;

	return swap.num;

} // short swapshortendian

/* -------------------------------------------------------------------------- */
PROCX void	DoMemoryDeltas(INT b)
{
	INT i,a,q;
	INT deltas;


	deltas=b/4;
	for(i=1;i<deltas*2;i+=2) {
		a = swapshortendian(LowrMemRead.data.data[i-1]);
		LowrLastLat += a;
		q = swapshortendian(LowrMemRead.data.data[i]);
		LowrLastLong += q;
    	record.type='T';	// Not first record this track
    	record.la = LatMMtoDeg(LowrLastLat);
		record.lo = LongMMtoDeg(LowrLastLong);
		set_ns();
    	settime_record(0);  // no time on Lowrance track points
    	sprintf(Text,"%c;%d;;",record.type,datatype);
    	push_track();
	}
} // DoMemoryDeltas

/* -------------------------------------------------------------------------- */
PROCX void GetPlotTrailPointer(INT trk)
{
	BYTE Message[5];

	Message[0]=trk-1;
	LastCommand=0x0307;
	SendLowrMessage(LastCommand, Message, (INT)1, (char*)"GetPlotTrailPointer");
	GetLowrMessage(1);
} // GetPlotTrailPointer

/* -------------------------------------------------------------------------- */
PROCX void readstarttofinish(long Start, long Finish, char * what, void (*fcn)(INT))
{
	short cnt,cc;
	INT chunk;

	chunk=160;
	Finish+=rstfOffset;
	while((Finish-Start+1) >= (long)chunk)
	{
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='Y') {
    		fprintf(stderr,"\nOperator Abort rstf 1\n");
			AbortNow=1;
			return;
		} else if(cc=='X') {
   			fprintf(stderr,"\nOperator Exit rstf 1\n");
			byebye(0);
		}
		LowrMemGet.Address=Start;
		LowrMemGet.CtgSelect = 0;
		LowrMemGet.Count = chunk;			// get structure elements
		LastCommand=0x0008;
		SendLowrMessage(LastCommand,(BYTE*)&LowrMemGet,
		                 sizeof(struct LowrMemGet), (char*)"Reading Memory1");
		GetLowrMessage(1);
		fcn(chunk);
		totalread+=chunk;
		fprintf(stderr,"%05d Bytes of %s Read\r",totalread,what);
		Start+=chunk;
	}
//
// get the rest of the Tail side
//
	cnt=Finish-Start+1;

	if(cnt > 0) {
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='Y') {
   			fprintf(stderr,"\nOperator Abort rstf 2\n");
			AbortNow=1;
   			return;
		} else if(cc=='X') {
    		fprintf(stderr,"\nOperator Exit rstf 2\n");
			byebye(0);
		}
		LastCommand=0x0008;
		LowrMemGet.Address=Start;
		LowrMemGet.CtgSelect = 0;
		LowrMemGet.Count = cnt;
		SendLowrMessage(LastCommand, (BYTE*)&LowrMemGet,
		                 sizeof(struct LowrMemGet), (char*)"Reading Memory2");
		GetLowrMessage(1);
		fcn(cnt);
		totalread+=cnt;
		fprintf(stderr,"%05d Bytes of %s Read\r",totalread,what);
	}
	fprintf(stderr,"\n");
} // readstarttofinish

/* -------------------------------------------------------------------------- */
PROCX void GetLowrTrackMem(INT trk)
{
	long StartOfBuffer, EndOfBuffer;

	GetPlotTrailPointer(trk);
//
// Evidently the last 4 bytes of the structure is the checksum.
//
// End the first reading at the end of the structure - 4
//
	EndOfBuffer=LowrTrailOriginMem.StructurePointer+LowrTrailOriginMem.StructureSize-4;
//
// We will start reading the second read just after the Structure and will read through the
//  Head pointer. 
//
	StartOfBuffer=LowrTrailOriginMem.StructurePointer+16;
//
// Read the 4 longs in the structure 
//
	LowrMemGet.Address=LowrTrailOriginMem.StructurePointer;
	LowrMemGet.CtgSelect = 0;
	LowrMemGet.Count = 16;
	LastCommand=0x0008;
	SendLowrMessage(LastCommand,(BYTE*)&LowrMemGet,
	                 sizeof(struct LowrMemGet), (char*)"GetLowrMem");
//
// read and parse the returned 0x0088 record which contains the 4 longs of the structure
//
	GetLowrMessage(1);
//
// Set up origins remembering the structure elements are BIG endian not little endian
//
	BaseLatitude	= swaplongendian(LowrMemRead.data.ptp.BaseLatitude);
	BaseLongitude	= swaplongendian(LowrMemRead.data.ptp.BaseLongitude);
	TailAdrPointer	= swaplongendian(LowrMemRead.data.ptp.TailAdrPointer);
	HeadAdrPointer	= swaplongendian(LowrMemRead.data.ptp.HeadAdrPointer);
	if((TailAdrPointer==0L) || (HeadAdrPointer == 0L) || (HeadAdrPointer==TailAdrPointer)) {
		fprintf(stderr,"No Tracks to send\n");
		return;
	}
    datatype=10000;  // ID's lowrance track
    settime_record(0);  // no time on Lowrance track points
    record.type='N';	// first record
	LowrLastLat=BaseLatitude;
	LowrLastLong=BaseLongitude; 

    record.la = LatMMtoDeg(LowrLastLat);
	record.lo = LongMMtoDeg(LowrLastLong);
	set_ns();
    sprintf(Text,"%c;%d;;",record.type,datatype);
    push_track();
//
//  Start reading at TailAdrPointer
//
//  Use chunks of 160 bytes cuz spec recommend that number.  160 bytes is 40 delta pairs
//
//  Read from Tail to end of buffer to end first reading 160 bytes at a time
//
//  If TailPointer<HeadPointer, read through HeadPtr, not the end of the buffer
//
	totalread=1;  // Allow for base
//
// is the read just one chunk?
//
	rstfOffset=-1;
	if(TailAdrPointer<HeadAdrPointer) {
		readstarttofinish(TailAdrPointer,HeadAdrPointer,"deltas", DoMemoryDeltas);
		return;
	} // if(TailAdrPointer<HeadAdrPointer)
//
// Read the head side.  We read from the point just past the 4 longs in the structure up
//  to but not including the tail pointer
//
//
// Two chunks must be read
//
// First, from the tail pointer to the end of the buffer
//
	readstarttofinish(TailAdrPointer,EndOfBuffer,"deltas", DoMemoryDeltas);
//
// and then from the start of the buffer through the head pointer
   readstarttofinish(StartOfBuffer,HeadAdrPointer,"deltas", DoMemoryDeltas);
} // void GetLowrTrackMem(INT trk)

/* -------------------------------------------------------------------------- */
PROCX void DoLowrMemRead(void)
{
	memcpy(&LowrMemRead, SerialMessage, LowrMemBytesRead); 
} // void DoLowrMemRead(void)

/* -------------------------------------------------------------------------- */
PROCX void DoLowrTrackMem(void)
{
	memcpy(&LowrTrailOriginMem, SerialMessage, sizeof(struct LowrTrailOriginMem)); 
} // void DoLowrTrackMem(void)

/* -------------------------------------------------------------------------- */
PROCX void GetLowrTrack(INT trk)
{
	BYTE Message[5];
	short i,chunk;

	Message[0]=trk-1;
	LastCommand=0x0312;
	SendLowrMessage(LastCommand, Message, (INT)1, (char*)"GetLowrTrack");
	GetLowrMessage(1);
	TotalDeltas=LowrTrailOrigin.NumberOfDeltas;
	if(TotalDeltas == 0) {
		fprintf(stderr,"No points in trail %d\n",trk); fflush(stdout);
		return;
	}
    datatype=10000;  // ID's lowrance track

    settime_record(0);  // not time on Lowrance track points

    record.type='N';	// first record
   
	LowrLastLat=LowrTrailOrigin.OriginY;
	LowrLastLong=LowrTrailOrigin.OriginX; 

    record.la = LatMMtoDeg(LowrLastLat);
	record.lo = LongMMtoDeg(LowrLastLong);
	set_ns();
    sprintf(Text,"%c;%d;;",record.type,datatype);
    push_track();
//
// get chunks of 40
//
	Total=1;
	fprintf(stderr,"T%05d of %d\r", Total, TotalDeltas+1);
	chunk=TotalDeltas/40;
	ND.pt=trk-1;
	ND.no=40;
	for(i=1;i<=chunk;i++)
	{
		LastCommand=0x0313;
		SendLowrMessage(LastCommand, (BYTE*)&ND, (INT)3, (char*)"GetLowrTrack Deltas");
		GetLowrMessage(1);
	}
//
// get the rest
//
	ND.pt=trk-1;
	ND.no=TotalDeltas-(chunk*40);
	LastCommand=0x0313;
	SendLowrMessage(LastCommand, (BYTE *)&ND, (INT)3, (char*)"GetLowrTrack Deltas");
	GetLowrMessage(1);
	fprintf(stderr,"\n");
} // GetLowrTrack()

struct LowrPlotTrailDeltas {
	BYTE Reserved; 
	BYTE PlotTrailNumber;
	short NumberofDeltas;
	short Deltas[80];
} LowrPlotTrailDeltas;

/* -------------------------------------------------------------------------- */
PROCX void DoLowrPlotTrailDeltas(void)
{
	INT i;

	memcpy(&LowrPlotTrailDeltas, SerialMessage, sizeof(struct LowrPlotTrailDeltas)); 
	for(i=1;i<LowrPlotTrailDeltas.NumberofDeltas*2;i+=2) {
		LowrLastLat += LowrPlotTrailDeltas.Deltas[i-1];
		LowrLastLong += LowrPlotTrailDeltas.Deltas[i];
    	record.type='T';	// Not first record this track
    	record.la = LatMMtoDeg(LowrLastLat);
		record.lo = LongMMtoDeg(LowrLastLong);
		set_ns();
    	settime_record(0);  // no time on Lowrance track points
    	sprintf(Text,"%c;%d;;",record.type,datatype);
    	push_track();
		++Total;
		fprintf(stderr,"T%05d\r", Total);
	}
} // void DoLowrPlotTrailDeltas(void);

/* -------------------------------------------------------------------------- */
PROCX void DoLowrPlotTrailOrigin(void)
{
	memcpy(&LowrTrailOrigin, SerialMessage, sizeof(struct LowrTrailOrigin)); 
} // void DoLowrPlotTrailOrigin(void)
/* -------------------------------------------------------------------------- */
PROCX void GetLowrWPT(short no)
{
	BYTE *M;
	M=(BYTE *)&no;
	LastCommand=GetWaypoint;
	LastLowrLen=2;
	SendLowrMessage(LastCommand, M, LastLowrLen, (char *)"GetLowrWPT");
	GetLowrMessage(1);
} // GetLowrWPT(short no)

/* -------------------------------------------------------------------------- */
//
// * Note:  unix_time = garmin_time   + 631065600L
//          unix_time = Lowrance_time + 694224000L
//          garmin_time = Lowrance_time + 63158400L
//          Lowrance_time = garmin_time - 63158400L

// Called by LowrParse
//
PROCX void DoLowrWPT(void)
{
	struct LowrWPTr * kstat;

	kstat = (struct LowrWPTr *)SerialMessage;
	validwp=0;
	if(kstat->Status==0) return;
	validwp=1;
	++LowrValidWpts;
	memcpy(&LowrWPTr,SerialMessage,sizeof(struct LowrWPTr));

	settime_record(LowrWPTr.Date+63158400L);
	record.type='W';
	record.la=LatMMtoDeg(LowrWPTr.Latitude);
	record.lo=LongMMtoDeg(LowrWPTr.Longitude);
	set_ns();
	strcpy(record.ident,(char *)LowrWPTr.Name);
	record.ident[13]=0;
	trim(record.ident);
	record.icon_smbl=convert_from_Lowr(LowrWPTr.IconSymbol);
//	strcpy(record.comment,(char *)LowrWPTr.Name);
	record.comment[0]=0;
//	trim(record.comment);
	datatype=30000+LowrWPTr.WaypointNumber;
	sprintf(Text,"%c;%d;%s;%s",'W',datatype,record.ident,record.comment);
	trim(Text);
	set_ns();

//	printf("WPT#                : %d\n",LowrWPTr.WaypointNumber);
//	printf("WPT Status          : %d\n",LowrWPTr.Status);
//	printf("WPT IconSymbol      : %d\n",LowrWPTr.IconSymbol);
//	printf("WPT Latitude: (mm)  : %ld\n",LowrWPTr.Latitude);
//	printf("WPT Longitude (mm)  : %ld\n",LowrWPTr.Longitude);
//	printf("WPT Latitude (h.hhh): %lf\n",LatMMtoDeg(LowrWPTr.Latitude));
//	printf("WPT Longitude(h.hhh): %lf\n",LongMMtoDeg(LowrWPTr.Longitude));
//	printf("WPT Name            : %s\n",LowrWPTr.Name);
//	printf("WPT Date (secs)     : %ld\n",LowrWPTr.Date);
} // DoLowrWPT

/* -------------------------------------------------------------------------- */
PROCX void GetLowrWpts()
{
	INT i;
	INT cc;
	INT readto;
//
// Zero based, i.e. wpt #0 is the first
//
	if(LwrRangeHi<0)
		readto=LowrID.NumOfWaypoints;
	else
		readto=LwrRangeHi;
	if(readto>LowrID.NumOfWaypoints) readto = LowrID.NumOfWaypoints;
	fprintf(stderr,"W0000 of %04d Active:%04d\r",readto,LowrValidWpts);
	for(i=LwrRangeLo-1;i<readto;i++) {
		GetLowrWPT((short)i);
		if(validwp) push_waypoint();
		fprintf(stderr,"W%04d of %04d Active:%04d\r",i+1,readto,LowrValidWpts);
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='X') {
    		fprintf(stderr,"\nOperator Exit 1\n");
    		byebye(0);
		} else if(cc=='Y') {
    		fprintf(stderr,"\nOperator Abort 1\n");
    		return;
		}
	}
} // GetLowrWpts()

struct RteGet {
	BYTE Reserved;
	short RouteNumber;
	BYTE NumOfWaypoints;
	BYTE Name[13];
	short Waypoints[200];  // Room for 200 wpts per route
} RteGet;

/* -------------------------------------------------------------------------- */
PROCX void GetLowrRoute(short rte)
{
	route_number=rte+1;  // Route printed will be Lowr/Eagle external number.
	route_point=0;
	LastCommand=0x0305;
	SendLowrMessage(LastCommand,(BYTE*)&rte,2,"GetLowrRoute");
	GetLowrMessage(1);
} // GetLowrRoute()

/* -------------------------------------------------------------------------- */
PROCX void GetLowrRts()
{
    INT i;
    for(i=0;i<LowrID.NumOfRoutes;i++) GetLowrRoute(i);
	fprintf(stderr,"\n");
} // GetLowrRts()

PROCX void DoLowrRoute(void)
{
	INT i;
	char buf[100];

	memcpy(&RteGet,SerialMessage,4);
	if(RteGet.NumOfWaypoints>200) {
		fprintf(stderr,"Too Many Route Points, 200 is the maximum supported\n");
		return;
	}
	memcpy(&RteGet,SerialMessage,RteGet.NumOfWaypoints*2+17);
	strcpy(route_comment,(char*)RteGet.Name);
	fprintf(stderr,"R%05d of %d  W%05d of %5d\r",
		route_number,LowrID.NumOfRoutes,0,RteGet.NumOfWaypoints);
	for(i=0;i<RteGet.NumOfWaypoints;i++) {
		fprintf(stderr,"R%05d of %d  W%05d of %5d\r",
			route_number,LowrID.NumOfRoutes,i+1,RteGet.NumOfWaypoints);
		LastCommand=0x0303;
		SendLowrMessage(LastCommand,(BYTE*)&RteGet.Waypoints[i],2,"GetLowrWaypoint,GetLowrRoute");
		GetLowrMessage(1);
		strcpy(buf,Text);
		push_route();
		strcpy(Text,buf);
		push_waypoint();
	}
} // DoLowrRoute

struct IconGet {
	BYTE Reserved;
	short IconNumber;
	long Latitude;
	long Longitude;
	BYTE IconSymbol;
} IconGet;

/* -------------------------------------------------------------------------- */
PROCX void DoNumIcons(void)
{
	memcpy(&IconGet,SerialMessage,3);
} // void DoNumIcons

/* -------------------------------------------------------------------------- */
PROCX void DoLowrIcons(void)
{
	memcpy(&IconGet,SerialMessage,sizeof(struct IconGet));
	record.la=LatMMtoDeg(IconGet.Latitude);
	record.lo=LongMMtoDeg(IconGet.Longitude);
	set_ns();
	record.icon_smbl=convert_from_Lowr(IconGet.IconSymbol);
	record.type='I';
    sprintf(Text,"%c;%d;;",record.type,20000+IconGet.IconNumber+1);
	push_icon();
	fprintf(stderr,"I%05d\r",IconGet.IconNumber+1);
} // void DoLowrIcons
/* -------------------------------------------------------------------------- */
PROCX void GetLowrIcons(void)
{
	short i;
//
	if(LowrID.NumOfIcons<1) {
		fprintf(stderr,"Icons not supported on this Lowrance/Eagle unit\n");
		return;
	}
//
// get number of icons in unit
//
	LastCommand=0x0308;
	SendLowrMessage(LastCommand,(BYTE*)&IconGet,0,"GetNumOfIcons");
	GetLowrMessage(1);
	NumberOfIcons=IconGet.IconNumber;
	if(NumberOfIcons==0) {
		fprintf(stderr,"No Icons to send\n");
		return;
	}
	fprintf(stderr,"I%05d of %5d\r",0,NumberOfIcons);
	for(i=0;i<NumberOfIcons;i++) {
		LastCommand=0x0309;
		SendLowrMessage(LastCommand,(BYTE*)&i,2,"GetLowrIcons");
		GetLowrMessage(1);
	}
} // GetLowrIcons()
/* -------------------------------------------------------------------------- */

PROCX void GetLowrID()
{
	BYTE M[2];

	if(gotID==1) return;
	M[0]=0;
	LastCommand=Login;
	LastLowrLen=0;
	SendLowrMessage(LastCommand, M, LastLowrLen, (char *)"GetLowrIDLogin");
	timeoutp=3;
	GetLowrMessage(0);
	if(COMtimeout==1) return;
	timeoutp=1;
	COMtimeout=0;
	LastCommand=GetProductInfo;
	SendLowrMessage(LastCommand, M, (INT)0, (char *)"GetLowrID");
	GetLowrMessage(1);  // also parses via DoLowrID
	gotID=1;
} // GetLowrID()

PROCX void DoLowrID(void)
{
	memcpy(&LowrID,SerialMessage,sizeof(struct LowrID));
} // DoLowrID()

//struct LowrTrailOriginMem {
//	BYTE Reserved;
//	BYTE PlotTrailNumber;
//	long StructurePointer;
//	short StructureSize;
//} LowrTrailOriginMem;

//struct LowrMemRead {
//	BYTE reserved;
//	union data {
//		struct ptp {				// for reading Plot trail structure
//			long BaseLatitude;
//			long BaseLongitude;
//			long TailAdrPointer;
//			long HeadAdrPointer;
//		} ptp;
//		short data[180];			// for reading 80 shorts
//		BYTE  bytes[260];			// for reading 160 bytes
//	} data;
//} LowrMemRead;
/* -------------------------------------------------------------------------- */
PROCX void SendLowrTracks(INT trk)
{
	unsigned INT trk_index;
	INT track_to_use,i, ii, indx, left;
	long bla, blo;

	struct TrailOrigin {
		BYTE PlotTrailNumber;
		long OriginY;
		long OriginX;
		short NumberOfDeltas;
	} TrailOrigin;

	struct delta {
		BYTE PlotTrailNumber;
		short Number;
		short deltas[40][2];
	} delta;

    count_tracks();
	if(to_lowr_track>LowrID.NumOfPlotTrails) {
		fprintf(stderr,"This unit supports %d trails, not %d\n",LowrID.NumOfPlotTrails,to_lowr_track);
		fprintf(stderr," Sending info to last track: %d\n",to_lowr_track);
		to_lowr_track=LowrID.NumOfPlotTrails;
	}
//
// if user specified we send track 1 or 2 then we will send track 1
//
	if(to_lowr_track!=0) {
		trk=1;
		track_to_use=to_lowr_track-1;
	}
	else {
		track_to_use=trk-1;
	}
	if(trk==1)
		trk_index=0;
	else
		trk_index=trks[trk-1];

//
// Track 'trk' data?
//
    if(trks[trk]>1) {
        fill_track((unsigned INT)(trk_index+1),0);        // get origin of track 'trk'
		TrailOrigin.PlotTrailNumber=track_to_use;
		bla=TrailOrigin.OriginY=LatDegtoMM(record.la);
		blo=TrailOrigin.OriginX=LongDegtoMM(record.lo);
		TrailOrigin.NumberOfDeltas=trks[trk]-1;
		LastCommand=0x0314;
		SendLowrMessage(LastCommand,(BYTE*)&TrailOrigin,sizeof(struct TrailOrigin),"SetPlotTrailOrigin");
		GetLowrMessage(1);
//
// Send the actual deltas
//
		indx=i=0;
		left=trks[trk]-1;
		do {
			if(left>=40) {
				while(indx<=39) {
					fill_track((unsigned INT)(trk_index+i+2),0);
					left--;
					set_sign();
					delta.deltas[indx][0]=LatDegtoMM(record.la) - bla;
					bla=LatDegtoMM(record.la);
					delta.deltas[indx][1]=LongDegtoMM(record.lo) - blo;
					blo=LongDegtoMM(record.lo);
					i++;
					indx++;
				}; // while
				indx=0;
//
// Send array in 40 pair chunks
//
				LastCommand=0x0315;  // Set Plot Trail Deltas
				delta.PlotTrailNumber=track_to_use;
				delta.Number=40;
				SendLowrMessage(LastCommand, (BYTE*)&delta, sizeof(struct delta), "SetPlotTrailDeltas");
				fprintf(stderr,"T%05d Sent\r",i+1);
				GetLowrMessage(1);
			} // if(left>=40);
		} while(left>=40);
//
// Send rest of chunks
//
		memset(&delta.deltas,0,163);
		ii=left;
		indx=0;
		if(left>0) {
			while(left>0) {
				fill_track((unsigned INT)(trk_index+i+2),0);
				left--;
				set_sign();
				delta.deltas[indx][0]=LatDegtoMM(record.la) - bla;
				bla=LatDegtoMM(record.la);
				delta.deltas[indx][1]=LongDegtoMM(record.lo) - blo;
				blo=LongDegtoMM(record.lo);
				i++;
				indx++;
			} // while
//
// Send rest of array
//
			LastCommand=0x0315;  // Set Plot Trail Deltas
			delta.PlotTrailNumber=track_to_use;
			delta.Number=ii;
			SendLowrMessage(LastCommand, (BYTE*)&delta, (INT)(delta.Number*4+3), "SendLowrTrkMemDeltas");
			fprintf(stderr,"T%05d Sent\n",i+1);
			GetLowrMessage(1);
		} // if(left>0);
	}
} // void SendLowrTracks

#define HDR_SIZ 0x10
#define DELTA_SIZ 160
/* -------------------------------------------------------------------------- */
PROCX void SendLowrTracksMem(INT trk)
{
	INT track_to_use,i,left,chnksiz,indx,trk_index=0;
	INT maxdeltas;
	long cksum;
	INT cki, deltas;

	long bla,blo;
	struct SendTrkHdrs {
		long	Adr;
		long	BaseLa;
		long	BaseLo;
		long	Tail;
		long	Head;
	} SendTrkHdrs;

	struct deltasend {
		long  Adr;
		union d {
			short deltas[41][2];
			long  lbytes[41];    // room for 40 deltas + checksum (if needed)
		} d;
	} deltasend;
//
// if user specified we send track 1 or 2 then we will send track 1
//
	count_tracks();
	if(to_lowr_track>LowrID.NumOfPlotTrails) {
		to_lowr_track=LowrID.NumOfPlotTrails;
		fprintf(stderr,"This unit supports %d trails\n",LowrID.NumOfPlotTrails);
		fprintf(stderr," Sending info to last track: %d\n",to_lowr_track);
	}
	if(to_lowr_track!=0) {
		trk=1;
		track_to_use=to_lowr_track;
	}
	else {
		track_to_use=trk;
	}
	if(trk==1)
		trk_index=0;
	else
		trk_index=trks[trk-1];

//
// Track 'trk' data?
//
	if(trks[trk]>1) {
		deltas=trks[trk]-1;  							// how many deltas we sending?
		GetPlotTrailPointer(track_to_use);
		fill_track((unsigned INT)(trk_index+1),0);		// get origin of track 'trk'
		set_sign();
//
// Setup structure values
//
		SendTrkHdrs.BaseLa=swaplongendian(bla=LatDegtoMM(record.la));
		SendTrkHdrs.BaseLo=swaplongendian(blo=LongDegtoMM(record.lo));
		SendTrkHdrs.Tail=swaplongendian(LowrTrailOriginMem.StructurePointer+HDR_SIZ);
		SendTrkHdrs.Head=swaplongendian(LowrTrailOriginMem.StructurePointer+HDR_SIZ+(deltas)*4);
		SendTrkHdrs.Adr=LowrTrailOriginMem.StructurePointer;
		maxdeltas=(LowrTrailOriginMem.StructureSize-HDR_SIZ)/4 - 1;
//
// checksum header
//
		cksum=0;
		cksum+=bla;
		cksum+=blo;
		cksum+=swaplongendian(SendTrkHdrs.Tail);
		cksum+=swaplongendian(SendTrkHdrs.Head);

//
// Write structure values
//
		LastCommand=0x0009;
		SendLowrMessage(LastCommand,(BYTE*)&SendTrkHdrs, HDR_SIZ+4, (char*)"SendLowrTrkHdrs");
		GetLowrMessage(1);
//
// Now we send the deltas.  Up to 40 at a time
//
//
		memset(&deltasend.d.deltas,0,DELTA_SIZ);
		deltasend.Adr=LowrTrailOriginMem.StructurePointer+HDR_SIZ;
		indx=i=0;
		left=deltas;
//
// only send a GPS's track buffer's full, not more
//
		if(left>maxdeltas) {
			left=maxdeltas;
			fprintf(stderr,"Too many plot points. Sending the first %d points.\n",left+1);
		}
		do {
			if(left>=40) {
//
// Fill deltas array
//
				while(indx<=39) {
					fill_track((unsigned INT)(trk_index+i+2),0);
					left--;
					set_sign();
					deltasend.d.deltas[indx][0]=swapshortendian((short)(LatDegtoMM(record.la)-bla));
					bla=LatDegtoMM(record.la);
					deltasend.d.deltas[indx][1]=swapshortendian((short)(LongDegtoMM(record.lo)-blo));
					blo=LongDegtoMM(record.lo);
					i++;
					indx++;
				}; // while
				indx=0;
//
// checksum this chunk
//
				for(cki=0;cki<40;cki++) cksum+=swaplongendian(deltasend.d.lbytes[cki]);
//
// Send array in 40 pair chunks
//
				LastCommand=0x0009;  // write memory
				SendLowrMessage(LastCommand, (BYTE*)&deltasend, DELTA_SIZ+4,"SendLowrTrkMemDeltas");
//
// update display
//
				fprintf(stderr,"T%05d Sent\r",i+1);
				GetLowrMessage(1);
				deltasend.Adr+=DELTA_SIZ;
			} // if(left>=40);
		} while(left>=40);
//
// Send rest of chunks
//
		memset(&deltasend.d.deltas,0,DELTA_SIZ);
		chnksiz=left;
		indx=0;
		if(left>0) {
			while(left>0) {
				fill_track((unsigned INT)(trk_index+i+2),0);
				left--;
				set_sign();
				deltasend.d.deltas[indx][0]=swapshortendian((short)(LatDegtoMM(record.la) - bla));
				bla=LatDegtoMM(record.la);
				deltasend.d.deltas[indx][1]=swapshortendian((short)(LongDegtoMM(record.lo) - blo));
				blo=LongDegtoMM(record.lo);
				i++;
				indx++;
			} // while
//
// checksum this chunk
//
			for(cki=0;cki<chnksiz;cki++) cksum+=swaplongendian(deltasend.d.lbytes[cki]);
//
// Send rest of array
//
			LastCommand=0x0009;  // write memory
			SendLowrMessage(LastCommand,(BYTE*)&deltasend,(INT)(chnksiz*4+4),"SendLowrTrkMemDeltas");
//
// update display
//
			fprintf(stderr,"T%05d Sent\n",i+1);
			GetLowrMessage(1);
		} // if(left>0);
		deltasend.Adr+=(chnksiz*4);
//=======================================================================================
// 
// Send zeroes...
//
		left=maxdeltas-deltas;
		memset(&deltasend.d.deltas,0,DELTA_SIZ);
		fprintf(stderr,"Clearing buffer\n");
		do {
			if(left>=40) {
				fprintf(stderr,"T%05d left\r",left);
				left=left-40;
//
// Send array in 40 pair chunks, all zeroes
//
				LastCommand=0x0009;  // write memory
				SendLowrMessage(LastCommand,(BYTE*)&deltasend,DELTA_SIZ+4,"SendLowrTrkMemDeltas0");
				GetLowrMessage(1);
				deltasend.Adr+=DELTA_SIZ;
			} // if(left>=40);
		} while(left>=40);
//
// Send rest of chunks
//
		fprintf(stderr,"T%05d left\r",left);
		if(left>0) {
//
// Send rest of array and checksum
//
			deltasend.d.lbytes[left]=swaplongendian(cksum);
			LastCommand=0x0009;  // write memory
			SendLowrMessage(LastCommand,(BYTE*)&deltasend,(INT)(left*4+8),"SendLowrTrkMemDeltas02");
			fprintf(stderr,"\n");
			GetLowrMessage(1);
		} // if(left>0);
//=======================================================================================
	} // if(trks[trk]>1)
} // SendLowrTracksMem

struct LowrWPTs {
	short WaypointNumber;
	BYTE Status;
	BYTE IconSymbol;
	long Latitude;  // LONG (Mercator Meter)
	long Longitude; // LONG (Mercator Meter)
	BYTE Name[13];
	long Date;		// seconds since 00:00 January 1, 1992
} LowrWPTs;

/* -------------------------------------------------------------------------- */
//
// Sends the waypoint currently in the record structure to waypoint slot 'no'
// on the GPS
//
// * Note:  unix_time = garmin_time   + 631065600L
//          unix_time = Lowrance_time + 694224000L
//          garmin_time = Lowrance_time + 63158400L
//          Lowrance_time = garmin_time - 63158400L
PROCX void SendLowrWPT(short no)
{
		LastCommand=SendWaypoint;
		LowrWPTs.WaypointNumber=no;
		LowrWPTs.Status=record.status;
		LowrWPTs.IconSymbol=convert_to_Lowr(record.icon_smbl);

		set_sign();  // makes N+ and W+
		LowrWPTs.Latitude=LatDegtoMM(record.la);
		LowrWPTs.Longitude=LongDegtoMM(record.lo); // LWR Wants E+
// blank fill name
		record.ident[13]=0;
		trim(record.ident);
		strcpy((char*)LowrWPTs.Name,(char*)record.ident);
		LowrWPTs.Date = dt2secs((short)gPrefs.offset) - 63158400L;
		SendLowrMessage(LastCommand,(BYTE*)&LowrWPTs,sizeof(struct LowrWPTs),(char *)"SendLowrWPT");
		GetLowrMessage(1);  // get response
} // void SendLowrWPT

/* -------------------------------------------------------------------------- */
PROCX void SendLowrWaypoints(void)
{
   unsigned INT i,cc,inactives,ia=0;
   INT maxw,tosend;

	maxw=LowrID.NumOfWaypoints;
	tosend=waypoints;
	if(maxw<waypoints) {
		fprintf(stderr,"This GPS only supports %d waypoints.\n",maxw);	
		fprintf(stderr,"Sending %d of %d waypoints.\n",maxw,waypoints);
	}
	record.status=1;
	if(maxw<(LwrStartPt+tosend-1)) {
		fprintf(stderr,"Sending too many waypoints to start at #%d\n",LwrStartPt);
		tosend=maxw-LwrStartPt;
		fprintf(stderr,"Sending only the first %d waypoints\n",tosend);
	}
	fprintf(stderr,"W00000 of %d\r",waypoints);
	inactives=LowrID.NumOfWaypoints-tosend-LwrStartPt+1;
	for(i=1;i<=tosend;i++) {
		fprintf(stderr,"W%05d\r",i);
		fill_waypoint_from_push(i,NORMAL_WP,0);
		SendLowrWPT((short)(LwrStartPt+i-2));
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='X') {
    		fprintf(stderr,"\nOperator Exit 2\n");
    		byebye(0);
		} else if(cc=='Y') {
			fprintf(stderr,"\nOperator Abort 2\n");
			goto rtss;
		}
	}
	if(!SendLowrInactives) goto rtss;
	fprintf(stderr,"\nSending Inactives\n");
	fprintf(stderr,"IA%04d of %04d\r",0,inactives);
	record.status=0;
	record.icon_smbl=default_LWR_icon; 					//usually a diamond
	for(i=LwrStartPt+tosend;i<=LowrID.NumOfWaypoints;i++) {
		fprintf(stderr,"IA%04d of %04d\r",++ia,inactives);
		SendLowrWPT((short)(i-1));
		cc=kbraw();
		cc=toupper(cc);
		if(cc=='X') {
    		fprintf(stderr,"\nOperator Exit 3\n");
    		byebye(0);
		} else if(cc=='Y') {
			fprintf(stderr,"\nOperator Abort 3\n");
			goto rtss;
		}
	}
rtss:;
	fprintf(stderr,"\n");
} // void SendLowrWaypoints

/* -------------------------------------------------------------------------- */
PROCX void DoNumGraphSymbols(void)
{
	struct s {
		BYTE a;
		BYTE num;
	} s;
	memcpy(&s,SerialMessage,sizeof(struct s));
	NumOfGraphSymbols=s.num;
} // void DoNumGraphSymbols

/* -------------------------------------------------------------------------- */
PROCX void SendLowrIcons(void)
{
	INT i,maxi;
	short num;
	struct SendIcons {
		short IconNumber;
		long Latitude;
		long Longitude;
		BYTE IconSymbol;
	} SendIcons;

//
// Get the number of Icons the unit supports
//
	num=LowrID.NumOfIcons;
	maxi=icons;
	if(num<icons) {
		fprintf(stderr,"This unit supports %d icons.\n",num);
		fprintf(stderr,"Sending %d of %d Icons.\n",num,icons);
		maxi=num;
	}
//
// Send the # of Icons we're sending
//
	num=icons;
	LastCommand=0x030A;
	SendLowrMessage(LastCommand, (BYTE*)&num, 2, "SendNumOfIconsToSend");
	GetLowrMessage(1);
//
// Send each icon separately
//
	fprintf(stderr,"I%05d of %05d\r",0,maxi);
	for(i=1;i<=maxi;i++) {
		fill_icon(i,(unsigned char*)"",0);
		LastCommand=0x030B;
		SendIcons.IconNumber=i-1;
		set_sign();
		SendIcons.Latitude=LatDegtoMM(record.la);
		SendIcons.Longitude=LongDegtoMM(record.lo);
		SendIcons.IconSymbol=convert_to_Lowr(record.icon_smbl);
		SendLowrMessage(LastCommand, (BYTE*)&SendIcons, sizeof(struct SendIcons),"SendLowrIcons");
		GetLowrMessage(1);
		fprintf(stderr,"I%05d\r",i);
	}
	fprintf(stderr,"\n");

} // void SendLowrIcons(void)

/* -------------------------------------------------------------------------- */
PROCX void SendLowrRoutes(void)
{
	INT i,j,cc,points;
	INT maxr,maxp;
	
	maxr=LowrID.NumOfRoutes;
	maxp=LowrID.NumOfWaypointsPerRoute;

	RteGet.Reserved=LowrID.Reserved;
	for(i=0;i<maxr;i++) {
		in_route=1;
		route_number=i;
		points=0;
		for(j=1;j<=maxp;j++) {
			if(route_push[i][j] == NULL) continue;
			++points;
			strcpy((char*)bin,route_push[i][j]);
			if(j==1) {
				fill_waypoint_from_push(i,ROUTE_1_WP,0);
				strupr(route_comment);
				strcpy((char*)RteGet.Name,route_comment);
			}
			else {
				fill_waypoint_from_push(i,ROUTE_WP,0);
			}
			RteGet.Waypoints[points-1]=(short)MatchRoute(record.ident,record.la,record.lo)-2+LwrStartPt;
			if(RteGet.Waypoints[points-1] < 0) {
				fprintf(stderr,"Waypoint missing in route. Route %d skipped.\n",i+1);
				goto skiproute;
			}
			cc=kbraw();
			cc=toupper(cc);
			if( cc=='Y') {
				fprintf(stderr,"\nOperator Abort SendLowrRoutes\n");
				in_route=0;
				return;
			} else if(cc=='X') {
				fprintf(stderr,"\nOperator Exit SendLowrRoutes\n");
				byebye(0);
			}
		} // for(j=0;j<=MAXPOINTS;j++)
		if(points) {
			RteGet.RouteNumber=i;
			RteGet.NumOfWaypoints=points;
			LastCommand=0x0306;
			SendLowrMessage(LastCommand,(BYTE*)&RteGet.RouteNumber,(INT)(16+2*points),"SendLowrRoutes");
			GetLowrMessage(1);
			fprintf(stderr, "R%05d Sent\n",i);
		} // if(points)
skiproute:;
		points=0;
	} // for(i=0;i<=MAXROUTES;i++) {
	in_route=0;
} // void SendLowrRoutes()

/* -------------------------------------------------------------------------- */
PROCX void OutputLowr(void)
{
	INT i;

	if(input_files) {
		if(waypoints) {
			SendLowrWaypoints();
		} // if(waypoints)
		if(routes) {
			SendLowrRoutes();
			if(AbortNow==1) return;
		}
		if(tracks) {
			if(LowrID.ProtocolVersion==0) {
				if(to_lowr_track==0) {
					for(i=1;i<=LowrID.NumOfPlotTrails;i++)
						SendLowrTracksMem(i);		    // Protocol version 1.0 tracks
				}
				else {
						SendLowrTracksMem(to_lowr_track); // Protocol version 1.0 tracks
				}
			}
			else {
				if(to_lowr_track==0) {
					for(i=1;i<=LowrID.NumOfPlotTrails;i++)
			    		SendLowrTracks(i);			    // Protocol version 2.0 tracks
				}
				else {
						SendLowrTracks(to_lowr_track); // Protocol version 2.0 tracks
				}
			}
		} // if(tracks)
		if(icons) {
			SendLowrIcons();
		} // if(icons
	}	
} // OutputLowr()

/* -------------------------------------------------------------------------- */
PROCX BYTE ChkLowrChkSum(BYTE * s, INT l)
{
	BYTE sum=0;
	INT i;

	for(i=0;i<l;i++) {
		sum+=s[i];
//		if(l==8) printf("%2d %02x %02x\n",i, sum, s[i]);
	}
	return sum;
} // ChkLowrChkSum();


/* -------------------------------------------------------------------------- */
PROCX void LowrParse()
{
	INT hdr;

	if((Hdr.hdrs.command & 0x80) == 0) { //  Not a response, print msg
		fprintf(stderr,"Warning: Header command:%04x is not a response command\n",Hdr.hdrs.command);
	}
//
// Clear response bit.  All from here on should be a response
//
	hdr = Hdr.hdrs.command&=0xff7f;
	switch(hdr) {
		case 0x0008:	//	ReadMem			 -- Read from a memory location
				LowrMemBytesRead=Hdr.hdrs.length; // don't copy checksum
				DoLowrMemRead();
				break;

		case 0x0009:	//	WriteMem		 -- Write to a memory location
				//fprintf(stderr,"LowrParse of %04x not written yet\n",Hdr.hdrs.command);
				break;

		case 0x000D:	//	Login			 -- Wake up external serial port
					LowrLogin=SerialMessage[0];
					break;

		case 0x010A:	//	BaudChange		 -- Change NMEA Baud Rate
				fprintf(stderr,"LowrParse of %04x not written yet\n",Hdr.hdrs.command); break;

		case 0x0301:	//	GetScreenPointer -- Request Screen Pointer to download the current Screen
				DoScreenPointer();
				break;

		case 0x0302:	//	UnfreezeScreen 	 -- unfreeze the current screen
				break;
						//		(happens after downloading screen)

		case 0x0303:	//	GetWaypoint		 --	Get a Waypoint
				DoLowrWPT();
				break;

		case 0x0304:	//	SendWaypoint 	 --	Send a Waypoint response
				break;

		case 0x0305:	//	GetRoute 		 -- Get a Route
				DoLowrRoute();
				break;

		case 0x0306:	//	SendRoute		 -- Send a Route
				break;

		case 0x0307:	//	GetPlotTrail	 -- Get plot trail Pointer
				DoLowrTrackMem();
				break;

		case 0x0308:	//	GetNumIcons		 -- Get number of icons
				DoNumIcons();
				break;

		case 0x0309:	//	GetIconSymbol	 -- Get icon symbol
				DoLowrIcons();
				break;

		case 0x030A:	//	SetNumIcons		 -- Set number of icons
				break;

		case 0x030B:	//	SendIcon		 -- Send icon
				break;

		case 0x030C:	//	GetNumGraphSymbols -- Get number of Graphical symbols
				DoNumGraphSymbols();
				break;

		case 0x030D:	//	GetIconGraphSymbol -- Get Icon Graphical symbol
				fprintf(stderr,"LowrParse of %04x not written yet\n",Hdr.hdrs.command); break;

		case 0x030E:	//	GetProductInfo	 -- Get product information
					DoLowrID();
					break;

		case 0x0312:	//	GetPlotTrailOrigin -- Get Plot Trail Origin (Protocol version 2.0)
					DoLowrPlotTrailOrigin();
					break;

		case 0x0313:	//	GetPlotTrailDeltas -- Get Plot Trail Deltas (Protocol version 2.0)
					DoLowrPlotTrailDeltas();
					break;

		case 0x0314:	//	SetPlotTrailOrigin -- Set Plot Trail Origin (Protocol version 2.0)
				break;	// just used as an ACK
		case 0x0315:	//	SetPlotTrailDeltas -- Set Plot Trail Deltas (Protocol version 2.0)
				break;  // just used as an ACK
	} // switch(Hdr.hdrs.command)
} // LowrParse()

#if DEBUGREAD
FILE *qq;
INT fileopen=0;
PROCX void GetLowrMessage(INT exit_on_error)
{
	char bun[777];
	char *p;
	BYTE qqq;
	INT done,j,c,i;

	if(fileopen==0) {
		qq=fopen(debugin_name,"r");
		if(qq==NULL) {
			fprintf(stderr,"Can't open debug input file: %s\n",debugin_name);
			byebye(0);
		}
	}
	fileopen=1;
	memset(SerialMessage,0,MAX_LENGTH);
	done=0;
//
// Read until next "Received" line--looking for 'good' header
//
	while(done==0) {
		if(fgets(bun,777,qq)==NULL) {
    		fprintf(stderr,"EOF in file %s\n",debugin_name);
    		byebye(0);
		}
		if(instr(bun,"and skipped")) continue;
		if(instr(bun,"Received")) done=1;
	}
	done=0;
//
// Read until we have a valid header data line
//
	while(done==0) {
		if(fgets(bun,777,qq)==NULL) {
    		fprintf(stderr,"EOF in file %s\n",debugin_name);
    		byebye(0);
		}
		if(bun[1] != '5') continue;  // first non space character in a received
		                             //  header data line is always '5'
		done=1;
	}
//
// We now have first line of code. read and process line until line is completed
//
	null_newline(bun);
	trim(bun);
	strupr(bun);

	p=strtok(bun," ");
	if(strlen(p)>2) p[2]=0;
	Hdr.Header[0]=htoi(p);
	for(i=1;i<8;i++) {
		p=strtok(NULL," ");
		if(p==NULL) break;
		if(p[0]==0) break;
		if(strlen(p)>2) p[2]=0;
		Hdr.Header[i]=htoi(p);
	}
	if(Hdr.hdrs.length==0) goto linedone;
//
// finished reading header, now read any data
//
// Read until next "Received" line
//
	done=0;
	while(done==0) {
		if(fgets(bun,777,qq)==NULL) {
    		fprintf(stderr,"EOF in file %s\n",debugin_name);
    		byebye(0);
		}
		if(instr(bun,"and skipped")) continue;
		if(instr(bun,"Received")) done=1;
	}
	done=0;
	j=0;
processnext:;
	if(fgets(bun,777,qq)==NULL) {
		fclose(qq);
		j=0;
		fileopen=0;
		goto linedone;
	}
	if(instr(bun,"Sending")) goto linedone; 
	if(strlen(bun) == 0) goto processnext;
	if(bun[0] != ' ') goto processnext;
//
// Read bytes into SerialMessage
//
	null_newline(bun);
	trim(bun);
	strupr(bun);

	p=strtok(bun," ");
	if(strlen(p)>2) p[2]=0;
	SerialMessage[j]=htoi(p);
	j++;

	while(1) {
		p=strtok(NULL," ");
		if(p==NULL) break;
		if(p[0]==0) break;
		if(strlen(p)>2) p[2]=0;
		SerialMessage[j]=htoi(p);
		j++;
	}
	goto processnext;

linedone:;
	if(Gdebug==1) {
		fprintf(Gdebug_out,"\nfake Received:\n");
		c=0;
		for(i=0;i<j;i++) {
			fprintf(Gdebug_out,outfmt,qqq=*(SerialMessage+i));
			if(qqq>=32 && qqq<=126) fprintf(Gdebug_out,"%c ",qqq);
			else fprintf(Gdebug_out,"  ");
			if(++c>15) {
				fprintf(Gdebug_out,"\n");
				c=0;
			}
	    }
		if(c)fprintf(Gdebug_out,"\n");
		fflush(Gdebug_out);
	}
//	if(exit_on_error)return; // len=SerialMsgLen=j;	
	len=SerialMsgLen=j;	
	LowrParse();
} // GetLowrMessage(INT exit_on_error)
#else
/* -------------------------------------------------------------------------- */
/*
 *	GetLowrMessage(1) reads and decodes the header 'Hdr.Header[]' then reads the data into the
 *   message buffer 'SerialMessage' and calls LowrParse.
 *  
 *  The string SerialMessage contains the entire data string returned
 *   from the GPS
 */
PROCX void GetLowrMessage(INT exit_on_error)
{
	INT i, fails;
	time_t t;
	BYTE c;
	
	Lowr_NAKS_Sent=0;

redoit:
	memset(SerialMessage,0,MAX_LENGTH);
	memset(Hdr.Header,0,8);
	SerialMsgLen = 0;

	t = time(NULL);
	COMtimeout=fails=0;
	for (;;) {
		if ((time(NULL)-t) >= TIMEOUT/timeoutp) {
			if(++fails>=3/timeoutp) {
				COMtimeout=1;
				if(exit_on_error==1) byebye(5);
				return;
			}
			t=time(NULL);
//
// Re-send last message
//
 			SendLowrMessage(LastCommand, LastLowrGPSMsg, LastLowrLen,"Re-send");
		}
		COMtimeout=0;
		while (AsyncInStat()) {
			fails=0;

			c=AsyncIn();
			t = time(NULL);  /* reset time */

			if(c!=0x81 || Hdr.Header[0]!=0x55)  {
				Hdr.Header[0]=c;
				continue; // Hdr.Header Preamble is 0x8155 in Little Endian format
			}
			Hdr.Header[1]=c;
//
// we have a header preamble, now read 6 more bytes.  In this first pass of the code
//  there is a real chance of a 'hang' because no error checking is performed.  That
//  will be added later when I know more about how the Lowrance GPS's behave.
//
			for(i=2;i<8;i++) {
				while(!AsyncInStat());  // look out! a hang is possible
				Hdr.Header[i]=AsyncIn();
			}
			if((i=ChkLowrChkSum(Hdr.Header,8))!=0) {
				fprintf(stderr,"Bad Lowrance Header: sum:%d\n  ",i);
				for(i=0;i<8;i++) fprintf(stderr,"%02x  ",Hdr.Header[i]);
				fprintf(stderr,"\n");
			}
			if(LastCommand==Hdr.hdrs.command) {
				if(Gdebug == 1) {
					fprintf(Gdebug_out,"Received (and skipped): Header\n");
					debugOUT(Hdr.Header,8);
				}
				goto redoit;  // an echo of our command?
			}
			if(Gdebug==1) {
				fprintf(Gdebug_out,"Received: Header\n");
				debugOUT(Hdr.Header,8);
			}
//
// we now have a valid header.  What is the command?  How do we read and decode it:
//
			if(Hdr.hdrs.length) {  // non-zero length data
				for(i=0;i<=Hdr.hdrs.length;i++) {
					while(!AsyncInStat());  // look out! a hang is possible
					SerialMessage[i]=AsyncIn();
				}
			}
			if(Gdebug==1 && Hdr.hdrs.length) {
				fprintf(Gdebug_out,"Received:\n");
				debugOUT(SerialMessage,(INT)(Hdr.hdrs.length+1));
			}
//
// decode by Hdr (Header)...
//
			LowrParse();
			return;
		} // while 
	} // for (;;)
} /* GetLowrMessage(INT exit_on_error) */
#endif

/* -------------------------------------------------------------------------- */
// rounds to dig places using sprintf
PROCX double round(double n, int dig)
{
	char buf[50], buf1[50];

	sprintf(buf,"%%.%dlf",dig);
	sprintf(buf1,buf,n);
	return atof(buf1);
} // round

/* -------------------------------------------------------------------------- */
//Convert Latitude in degrees to Mercator meters 
PROCX long LatDegtoMM(double d)
{
	double temp;
	
	temp=((d*DEGtoRAD) + PIdiv2)/2.0;
	temp=tan(temp);
	temp=log(temp);			// natural log?
	temp=temp * EarthRad;
	return  (long)temp;
} // LatDegtoMM

/* -------------------------------------------------------------------------- */
// Convert Mercator meters to Latitude Degrees 
PROCX double LatMMtoDeg(long m)
{
	double temp;

	temp=(double)m / (double) EarthRad;
	temp=exp(temp);
	temp=(2.0 * atan(temp)) - (double)PIdiv2;
	return  (temp * (double)RADtoDEG);
} // LatMMtoDeg

/* -------------------------------------------------------------------------- */
// Convert Longitude in degrees to Mercator Meters 
PROCX long LongDegtoMM(double d)
{
	return (long)(d * EarthRad * DEGtoRAD);
} // LongDegtoMM


/* -------------------------------------------------------------------------- */
//Convert Mercator Meters to Longitude degrees 
PROCX double LongMMtoDeg(long m)
{
	double t;

	t = (double)m / (double) 6356752.3142;
	t = t * RADtoDEG;
	return t;
} // LongMMtoDeg
