#define PROCX
#define PGMBETA			""
#define PGMVER			"3.04.33"
#if __BORLANDC__
#define	PGMSUF			"_dos"
#else
#define	PGMSUF			"_win"
#endif
#include "g7to.h"
#define DISABLE			0
#define ENABLE			1
#define ChkFree(a)		if((a)!=NULL)free(a)
//
// File types supported
//
#define NOFILE		-2  // file not found
#define UNKNOWN		 0  // Unknown file type
#define TEXT_IO		 1	// text/gd7
#define GARMIN		 2	// GPS i/o
#define SA3			 3	// Street Atlas 3
#define ALMANAC_D	 4	// Almanac data
#define NAVROUTE 	 5	// Navigate route
#define SA4          6	// Street Atlas 4
#define SA5          7	// Street Atlas 5
#define SA_GPL		 8  // Street Atlas GPL files
#define SA6          9	// Street Atlas 6
#define FUGAWI_WPT	10	// Fugawi waypoint file
#define FUGAWI_TRK	11	// Fugawi track file
#define OZI_EVT		12	// OziExplorer events (Icons)
#define CSV_IN 		14	// CSV input file
#define LOWRANCE	15	// GPS i/o
#define OZI_PLT		16	// OziExplorer track file
#define OZI_WPT		17	// OziExplorer waypoint file
#define OZI_RTE		18	// OziExplorer route file
//
// degree modes for input
//
#define UTMMODE		 1
#define DMS			 2
#define DMM			 3
#define DDD			 4
//
// SA sub type being read/written
//
#define NONE		 0
#define SA_SYMBOL	 1
#define SA_TRACK	 2
#define SA_CIRCLE	 3
//
// Garmin GPS input/commands
//
#define TRACKS		 1
#define WAYPOINTS	 2
#define ROUTES		 3
#define ID			 4
#define TIME		 5
#define POSITION	 6
#define ALMANAC		 7
#define PROXIMITY	 8
#define VOLTAGES 	 9
#define PVT			12
#define PPROTOCOLS	14
#define GERROR		99
#define LOWRERROR	99
//
// Lowrance GPS input/commands
//
#define TRACK1 		1
#define TRACK2 		2
#define LWRWPTS 	3
#define LWRRTS 		4
#define LWRICONS	5
#define LWRID		6
//
// Garmin offset for time
//
#define START		2447892L	// Julian date for 00:00 12/31/1989
#define STARTLOWR	2448623L 	// Julian date for 00:00 01/01/1992 
//
// Serial port constants
//
#define GARMIN_BAUD_RATE	9600
#define LOWR_BAUD_RATE		115200L

#if __BORLANDC__
#define	COM_SETTINGS	(BITS_8 | STOP_1 | NO_PARITY)
INT		WinNT=0;
#else
#define NOPARITY            0
#define ODDPARITY           1
#define EVENPARITY          2
#define MARKPARITY          3
#define SPACEPARITY         4

#define ONESTOPBIT          0
#define ONE5STOPBITS        1
#define TWOSTOPBITS         2
#define BYTESIZE			8
#endif
//===============================================================================
//
// 
extern struct sa3symbol {
	unsigned long latR;
	unsigned long lonR;
	INT ItemNum;
	unsigned INT Const;
	unsigned char paramlen;
	INT ObjCode;
	INT ObjSize;
	INT ObjColor;
	INT TextSize;
	INT TextColor;
	INT TextAlign;
	unsigned char TextLen;
	unsigned char *Text;
	double lat;
	double lon;
} sa3symbol;

extern struct sa3mapnote {
	unsigned long latR;
	unsigned long lonR;
	INT ItemNum;
	unsigned INT Const;
	unsigned char paramlen;
	INT TextSize;
	INT TextColor;
	INT TextJustification;
	INT TextXoffset;
	INT TextYoffset;
	unsigned char TextLen;
	unsigned char *Text;
	double lat;
	double lon;
} sa3mapnote;

extern struct sa3text {
	unsigned long latR;
	unsigned long lonR;
	INT ItemNum;
	unsigned INT Const;
	unsigned char paramlen;
	INT TextSize;
	INT TextColor;
	unsigned char TextLen;
	unsigned char *Text;
	double lat;
	double lon;
} sa3text;

extern struct sa4mapline {
	unsigned long latR;
	unsigned long lonR;
	unsigned INT ItemNum;
	unsigned INT Const1;
	unsigned char paramlen;
	INT LineColor;
	INT LineWidth;
	INT LineStyle;
	INT Points;
	double lat;
	double lon;
} sa4mapline;

extern struct sa4maparea {
	unsigned long latR;
	unsigned long lonR;
	unsigned INT ItemNum;
	unsigned INT Const1;
	unsigned char paramlen;
	INT area_draw_line;
	INT area_draw_fill;
	INT LineColor;
	INT LineWidth;
	INT Const3;
	INT area_fill_color;
	INT area_fill_style;
	INT Points;
	double lat;
	double lon;
} sa4maparea;

extern struct sa4mapcircle {
	unsigned long latR;
	unsigned long lonR;
	unsigned INT ItemNum;
	unsigned INT Const1;
	unsigned char paramlen;
	INT area_draw_line;
	INT area_draw_fill;
	INT LineColor;
	INT LineWidth;
	INT Const3;
	INT area_fill_color;
	INT area_fill_style;
	INT const4;
	unsigned long latCntr;
	unsigned long lonCntr;
	unsigned long latPnt;
	unsigned long lonPnt;
} sa4mapcircle;

extern struct sa4route {
	unsigned long startLo;
	unsigned long startLa;
	unsigned long startLo1;
	unsigned long startLa1;
	unsigned INT unk1;
	unsigned INT unk2;
	unsigned INT unk3;
	unsigned INT unk4;
	unsigned INT unk5;
	unsigned INT unk6;
	unsigned long st_name_l;
	char *st_name;
	unsigned long st_st_name_l;
	char *st_st_name;
	unsigned long finishLo;
	unsigned long finishLa;
	unsigned long finishLo1;
	unsigned long finishLa1;
	unsigned INT unk7;
	unsigned INT unk8;
	unsigned INT unk9;
	unsigned INT unk10;
	unsigned INT unk11;
	unsigned INT unk12;
	unsigned long fi_name_l;
	char *fi_name;
	unsigned long fi_st_name_l;
	char *fi_st_name;
	unsigned long NumObjs;
} sa4route;

extern struct sa4routepts {
	unsigned long startLo;
	unsigned long startLa;
	unsigned long startLo1;
	unsigned long startLa1;
	unsigned long checksum;
	unsigned INT unk3;
	unsigned INT unk4;
	unsigned INT unk5;
	unsigned INT unk6;
	unsigned long st_name_l;
	char *st_name;
	unsigned long st_st_name_l;
	char *st_st_name;
} sa4routepts;

extern struct MapConstM {
	unsigned INT a; unsigned INT b; unsigned INT c;
	unsigned INT d; unsigned INT e; unsigned INT f;
	unsigned INT g;
	unsigned INT h; unsigned INT i; unsigned INT j;
	unsigned INT k; unsigned INT l; unsigned INT m;
	unsigned INT n; unsigned INT o; unsigned INT p;
	unsigned INT q; unsigned INT r; unsigned INT s;
	unsigned INT t; unsigned INT u; unsigned INT v;
} MapConstM;

extern struct MapConstM0 {
	INT a; INT b; INT c; INT d; INT e;
	INT f; INT g; INT h; INT i; INT j;
	INT k; INT l; INT m; INT n; INT o;
	INT p; INT q; INT r; INT s; INT t;
	INT u; INT v;
} MapConstM0;

//===============================================================================
INT LwrStartPt=1;				// Set to LEI wpt # where upload is to start

INT Lwrout=0;					// set to 1 is Ozi is set for Lowrance units
INT Ozi_to_12=0;				// set to 1 by command line '-1' when transfer to/from Ozi is
                                //   from/to a Garmin 16 icon GPS (12, 12XL, GII+)
INT G45out=0;					// set to 1 is Ozi is set for Garmin units
INT	SendLowrInactives=0;		// set to 1 if inactive waypoints are not to be sent
INT to_lowr_track=0;			// set to 1 or 2 if all track points should be sent
								//  to track1 or to track2
//
// Program constants
//
static const double Degree=Pi/180.0;
char chch;

char debugin_name[MAX_LENGTH];

char ProgramName[MAX_LENGTH];

char outputdatum[150];
char inputdatum[150];

int	 NoM=1;						// 1 indicates that a 'M' line has not been read yet
int  DMSMode=DMM;				// default to degrees minutes.mm on reads
int  timeonsa3=0;
int  ZeroTime=0;				// if set to 1 time output to .txt files go as 'Sun Dec 31 00:00:00 1989'
								//  which is time==0 for Garmin units

int cycle_track_colors=0;

#ifdef unix
char commp[]="/dev/ttyS0";
#else
char commp[5]="COM1";
#endif
extern double UTMa_in,UTMf_in;
extern double UTMa,UTMf;
extern double UTMa_out,UTMf_out;

extern double LA,LO;
BYTE NumOfPlotTrails;
//Lowrance Product Info Structure
extern struct LowrID  {
	BYTE Reserved;
	INT ProductID;
	INT ProtocolVersion;
	INT ScreenType;
	INT ScreenWidth;
	INT ScreenHeight;
	INT NumOfWaypoints;
	INT NumOfIcons;
	INT NumOfRoutes;
	INT NumOfWaypointsPerRoute;
	BYTE NumOfPlotTrails;
	BYTE NumOfIconSym;
	BYTE ScreenRotateAngle;
	long RunTime;
} LowrID;

INT datatype;			// The type of data stored in the current record.  This is based
						//  upon the record type used to store the data

//
// structure of record from g7to.h
//
//struct RECORD {
//	char type;			// Record Type W,T,R,D,P
//	char ident[40];		// Record ident
//	char ns;			//  N/S for latitude
//	double la;			// latitude   in dd.ddddddd
//	char ew;			//  E/W for longitude
//	double lo;			// longitude  in dd.ddddddd
//	INT monthn;			// month number of record
//	char day_week[4];	// day of week of record
//	char datetime[25];	// date/time string as read
//	INT dayofmonth;		// day of month 1-31
//	INT year;			// 4 digit year of record
//	INT ht,mt,st;		// time of record
//	char comment[40];	// Comment field 20 max for 45
//	INT dla, mla;		// Deg & Min for Lat
//	INT dlo, mlo;		// Deg & Min for Long
//	INT tnthsla, tnthslo;	// tenths of a minute*10000
//	double minla,minlo;	// Lat/Long minutes in decimal
//	double secla,seclo;	// Lat/Long seconds in decimal
//	float ProxDist;		// Proximity Distance
//	short icon_smbl; 	// Garmin smbl coverted to SA
//	short icon_dspl;	// Display style.  Consistant with
//						//  later garminunits, i.e.
//
//	    Program   12/II+    Ozi    Display mode
//	       3        0        N      Symbol with Waypoint Name
//	       1        1        S      Symbol
//	       5        2        C      Symbol with Waypoint Comment
//  
////
//// garmin additions from beta.  I'm not using most of these yet, but
////  JIC...
//	BYTE class;
//	BYTE status;		// Lowrance waypoint status 0 or 1
//  BYTE subclass[13];
//	INT alt;
//	char city[24];
//	char state[2];
//	char cc[2];			// garmin
//	char name[30];		// garmin
//};
	
enum
{
//
// * indicates those in the GPS III revision 2.05 and greater
//
//---------------------------------------------------------------
// Symbols for marine (group 0...0-8191...bits 15-13=000).
//---------------------------------------------------------------
	sym_anchor =			0,	// 0x0000 * white anchor symbol 
	sym_bell =				1,	// 0x0001 * white bell symbol 
	sym_diamond_grn =		2,	// 0x0002 green diamond symbol 
	sym_diamond_red =		3,	// 0x0003 red diamond symbol 
	sym_dive1 =				4,	// 0x0004 diver down flag 1 
	sym_dive2 =				5,	// 0x0005 diver down flag 2 
	sym_dollar =			6,	// 0x0006 * white dollar symbol 
	sym_fish =				7,	// 0x0007 * white fish symbol 
	sym_fuel =				8,	// 0x0008 * white fuel symbol 
	sym_horn =				9,	// 0x0009 white horn symbol 
	sym_house =			   10,	// 0x000a * white house symbol 
	sym_knife =			   11,	// 0x000b * white knife & fork symbol 
	sym_light =			   12,	// 0x000c white light symbol 
	sym_mug =			   13,	// 0x000d * white mug symbol 
	sym_skull =			   14,	// 0x000e * white skull and crossbones symbol
	sym_square_grn =	   15,	// 0x000f green square symbol 
	sym_square_red =	   16,	// 0x0010 red square symbol 
	sym_wbuoy =			   17,	// 0x0011 white buoy waypoint symbol 
	sym_wpt_dot =		   18,	// 0x0012 * waypoint dot 
	sym_wreck =			   19,	// 0x0013 white wreck symbol 
	sym_null =			   20,	// 0x0014 null symbol (transparent) 
	sym_mob =			   21,	// 0x0015 * man overboard symbol 
//------------------------------------------------------
// Marine navaid symbols
//------------------------------------------------------
	sym_buoy_ambr =		   22,	// 0x0016 amber map buoy symbol 
	sym_buoy_blck =		   23,	// 0x0017 black map buoy symbol 
	sym_buoy_blue =		   24,	// 0x0018 blue map buoy symbol 
	sym_buoy_grn =		   25,	// 0x0019 green map buoy symbol 
	sym_buoy_grn_red =	   26,	// 0x001a green/red map buoy symbol 
	sym_buoy_grn_wht =	   27,	// 0x001b green/white map buoy symbol 
	sym_buoy_orng =		   28,	// 0x001c orange map buoy symbol 
	sym_buoy_red =		   29,	// 0x001d red map buoy symbol 
	sym_buoy_red_grn =	   30,	// 0x001e red/green map buoy symbol 
	sym_buoy_red_wht =	   31,	// 0x001f red/white map buoy symbol 
	sym_buoy_violet =	   32,	// 0x0020 violet map buoy symbol 
	sym_buoy_wht =		   33,	// 0x0021 white map buoy symbol 
	sym_buoy_wht_grn =	   34,	// 0x0022 white/green map buoy symbol 
	sym_buoy_wht_red =	   35,	// 0x0023 white/red map buoy symbol 
	sym_dot =			   36,	// 0x0024 white dot symbol 
	sym_rbcn =			   37,	// 0x0025 radio beacon symbol 
//------------------------------------------------------
// ... leave space for more navaids (up to 128 total)
//------------------------------------------------------
	sym_boat_ramp =		  150,	// 0x0096 * boat ramp symbol 
	sym_camp =			  151,	// 0x0097 * campground symbol 
	sym_restrooms =		  152,	// 0x0098 * restrooms symbol 
	sym_showers =		  153,	// 0x0099 * shower symbol 
	sym_drinking_wtr =	  154,	// 0x009a * drinking water symbol 
	sym_phone =			  155,	// 0x009b * telephone symbol 
	sym_1st_aid =		  156,	// 0x009c * first aid symbol 
	sym_info =			  157,	// 0x009d * information symbol 
	sym_parking =		  158,	// 0x009e * parking symbol 
	sym_park =			  159,	// 0x009f * park symbol 
	sym_picnic =		  160,	// 0x00a0 * picnic symbol 
	sym_scenic =		  161,	// 0x00a1 * scenic area symbol 
	sym_skiing =		  162,	// 0x00a2 * skiing symbol 
	sym_swimming =		  163,	// 0x00a3 * swimming symbol 
	sym_dam =			  164,	// 0x00a4 * dam symbol 
	sym_controlled =	  165,	// 0x00a5 controlled area symbol 
	sym_danger =		  166,	// 0x00a6 danger symbol 
	sym_restricted =	  167,	// 0x00a7 restricted area symbol 
	sym_null_2 =		  168,	// 0x00a8 null symbol 
	sym_ball =			  169,	// 0x00a9 * ball symbol 
	sym_car =			  170,	// 0x00aa * car symbol 
	sym_deer =			  171,	// 0x00ab * deer symbol 
	sym_shpng_cart =	  172,	// 0x00ac * shopping cart symbol 
	sym_lodging =		  173,	// 0x00ad * lodging symbol 
	sym_mine =            174,  // 0x00ae * mine symbol
//---------------------------------------------------------------
// Symbols for land (group 1...8192-16383...bits 15-13=001).
//---------------------------------------------------------------
	sym_is_hwy =		 8192,	// 0x2000 interstate hwy symbol 
	sym_us_hwy =		 8193,	// 0x2001 us hwy symbol 
	sym_st_hwy =		 8194,	// 0x2002 state hwy symbol 
	sym_mi_mrkr =		 8195,	// 0x2003 mile marker symbol 
	sym_trcbck =		 8196,	// 0x2004 * TracBack (feet) symbol 
	sym_golf =			 8197,	// 0x2005 * golf symbol 
	sym_sml_cty =		 8198,	// 0x2006 * small city symbol 
	sym_med_cty =		 8199,	// 0x2007 * medium city symbol 
	sym_lrg_cty =		 8200,	// 0x2008 * large city symbol 
	sym_freeway =		 8201,	// 0x2009 intl freeway hwy symbol 
	sym_ntl_hwy =		 8202,	// 0x200a intl national hwy symbol 
	sym_cap_cty =		 8203,	// 0x200b capitol city symbol (star) 
	sym_amuse_pk =		 8204,	// 0x200c amusement park symbol 
	sym_bowling =		 8205,	// 0x200d bowling symbol 
	sym_car_rental =	 8206,	// 0x200e car rental symbol 
	sym_car_repair =	 8207,	// 0x200f car repair symbol 
	sym_fastfood =		 8208,	// 0x2010 fast food symbol 
	sym_fitness =		 8209,	// 0x2011 fitness symbol 
	sym_movie =			 8210,	// 0x2012 movie symbol 
	sym_museum =		 8211,	// 0x2013 museum symbol 
	sym_pharmacy =		 8212,	// 0x2014 pharmacy symbol 
	sym_pizza =			 8213,	// 0x2015 pizza symbol 
	sym_post_ofc =		 8214,	// 0x2016 post office symbol 
	sym_rv_park =		 8215,	// 0x2017 RV park symbol 
	sym_school =		 8216,	// 0x2018 school symbol 
	sym_stadium =		 8217,	// 0x2019 stadium symbol 
	sym_store =			 8218,	// 0x201a dept. store symbol 
	sym_zoo =			 8219,	// 0x201b zoo symbol 
//---------------------------------------------------------------
// Symbols for aviation (group 2...16383-24575...bits 15-13=010).
//---------------------------------------------------------------
	sym_airport =		16384,	// 0x4000 * airport symbol 
	sym_int =			16385,	// 0x4001 intersection symbol 
	sym_ndb =			16386,	// 0x4002 non-directional beacon symbol 
	sym_vor =			16387,	// 0x4003 VHF omni-range symbol 
	sym_heliport =		16388,	// 0x4004 * heliport symbol 
	sym_private =		16389,	// 0x4005 * private field symbol 
	sym_soft_fld =		16390,	// 0x4006 * soft field symbol 
	sym_tall_tower =	16391,	// 0x4007 * tall tower symbol 
	sym_short_tower =	16392,	// 0x4008 * short tower symbol 
	sym_glider =		16393,	// 0x4009 * glider symbol 
	sym_ultralight =	16394,	// 0x400a * ultralight symbol 
	sym_parachute =		16395,	// 0x400b * parachute symbol 
	sym_vortac =		16396,	// 0x400c VOR/TACAN symbol 
	sym_vordme =		16397,	// 0x400d VOR-DME symbol 
	sym_faf =			16398,	// 0x400e first approach fix 
	sym_lom =			16399,	// 0x400f localizer outer marker 
	sym_map =			16400,	// 0x4010 missed approach point 
	sym_tacan =			16401,	// 0x4011 TACAN symbol 
	sym_seaplane =		16402,	// 0x4012 * Seaplane Base 
};
//---------------------------------------------------------------
//D103_Wpt_Type symbols:
//---------------------------------------------------------------
//
// These 16 are from the GPS II+, 12, 12XL group, i.e D103 data record type
//
enum
{
	smbl_dot = 				0,	//   0x00 dot symbol 
	smbl_house =			1,	//   0x01 house symbol 
	smbl_gas =				2,	//   0x02 gas symbol 
	smbl_car =				3,	//   0x03 car symbol 
	smbl_fish =				4,	//   0x04 fish symbol 
	smbl_boat =				5,	//   0x05 boat symbol 
	smbl_anchor =			6,	//   0x06 anchor symbol 
	smbl_wreck =			7,	//   0x07 wreck symbol 
	smbl_exit =				8,	//   0x08 exit symbol 
	smbl_skull =			9,	//   0x09 skull symbol 
	smbl_flag =			   10,	//   0x0a flag symbol 
	smbl_camp =			   11,	//   0x0b camp symbol 
	smbl_duck =			   12,	//   0x0c duck symbol 
	smbl_deer =			   13,	//   0x0d deer symbol 
	smbl_buoy =			   14,	//   0x0e buoy symbol 
	smbl_back_track =	   15 	//   0x0f back track symbol 
};
//=================================================================
//  Garmin <-> Ozi symbols

#if 0
INT Garmin_to_Ozi[48][2] = {
	{16384,'A'}, {  169,'B'}, {    6,'C'}, {   13,'D'}, {  150,'E'}, //  0 -  4
	{  151,'F'}, {  170,'G'}, { 8200,'H'}, { 8199,'I'}, { 8198,'J'}, //  5 -  9
	{  164,'K'}, {   14,'L'}, {  154,'M'}, {    7,'N'}, {    8,'O'}, // 10 - 14
	{16393,'P'}, { 8197,'Q'}, {16388,'R'}, {  173,'S'}, {  171,'T'}, // 15 - 19
	{  157,'U'}, {   21,'V'}, {    0,'W'}, {  156,'X'}, {16395,'Y'}, // 20 - 24
	{  159,'Z'}, {  158,'['}, {  160,'\\'},{16389,']'}, {   10,'^'}, // 25 - 29
	{   11,'_'}, {  152,'`'}, {  161,'a'}, {    1,'b'}, {16402,'c'}, // 30 - 34
	{   19,'d'}, {  172,'e'}, {16392,'f'}, {  153,'g'}, {  162,'h'}, // 35 - 39
	{16390,'i'}, {  163,'j'}, {16391,'k'}, {  155,'l'}, { 8196,'m'}, // 40 - 44
	{16394,'n'}, {   18,'o'}, {  174,'p'}							 // 45 - 47
};
#endif

struct GARMINSYMBOL {
	short Garmin;
	BYTE giii;
    char *Garminname;
	short GM100;
	short XL;
	char OziG;
	short SA;
	char *SAname;
};

//=================================================================
//
// Garmin symbol numbers
//
struct GARMINSYMBOL const Garmin_Symbol_Table[] = {
//---------------------------------------------------------------
// Symbols for marine (group 0...0-8191...bits 15-13=000).
//---------------------------------------------------------------
//    Garmin   Garmin                           LEI  12XL OziG   SA"
//  Symbol #   Name                              #     #  Ltr     #    SA Name
//    ======  =============================     ==   ===  ===    ==    ===============
	{     0, 1, "white anchor",                 25,    6,  22,   51,   "Triangle Up"        },
	{     1, 1, "white bell",                    0,   -1,  33,   18,   "Education"          },
	{     2, 0, "green diamond",                -1,   -1,  -1,   -1,   "-"                  },
	{     3, 0, "red diamond",                  -1,   -1,  -1,   -1,   "-"                  },
	{     4, 0, "diver down flag 1",            -1,   -1,  -1,   -1,   "-"                  },
	{     5, 0, "diver down flag 2",            -1,   -1,  -1,   -1,   "-"                  },
	{     6, 1, "white dollar",                  1,   -1,   2,    7,   "Bank"               },
	{     7, 1, "white fish",                   21,    4,  13,   20,   "Fishing"            },
	{     8, 1, "white fuel",                    6,    2,  14,   21,   "Fuel"               },
	{     9, 0, "white horn",                   -1,   -1,  -1,   -1,   "-"                  },
	{    10, 1, "white house",                   4,    1,  29,   25,   "Home"               },
	{    11, 1, "white knife & fork",            8,   -1,  30,   44,   "Restaurant"         },
	{    12, 0, "white light",                  -1,   -1,  -1,   -1,   "-"                  },
	{    13, 1, "white mug",                    15,   -1,   3,    2,   "Amusement"          },
	{    14, 1, "white skull & crossbones",     20,    9,  11,   11,   "Cemetery"           },
	{    15, 0, "green square",                 -1,   -1,  -1,   -1,   "-"                  },
	{    16, 0, "red square",                   -1,   -1,  -1,   -1,   "-"                  },
	{    17, 0, "white buoy waypoint",          27,   -1,  -1,   -1,   "-"                  },
	{    18, 1, "waypoint dot",                  3,    0,  46,   46,   "Square"             },
	{    19, 1, "white wreck",                  24,    7,  35,   34,   "One Way Right"      },
	{    20, 0, "null symbol (transparent)",    -1,   -1,  -1,   -1,   "-"                  },
	{    21, 1, "man overboard",                23,   -1,  21,   47,   "Star"               },
//------------------------------------------------------
// Marine navaid symbols
//------------------------------------------------------
	{    22, 0, "amber map buoy",               -1,   -1,  -1,   -1,   "-"                  },
	{    23, 0, "black map buoy",               -1,   -1,  -1,   -1,   "-"                  },
	{    24, 0, "blue map buoy",                -1,   -1,  -1,   -1,   "-"                  },
	{    25, 0, "green map buoy",               -1,   -1,  -1,   -1,   "-"                  },
	{    26, 0, "green/red map buoy",           -1,   -1,  -1,   -1,   "-"                  },
	{    27, 0, "green/white map buoy",         -1,   -1,  -1,   -1,   "-"                  },
	{    28, 0, "orange map buoy",              -1,   -1,  -1,   -1,   "-"                  },
	{    29, 0, "red map buoy",                 -1,   -1,  -1,   -1,   "-"                  },
	{    30, 0, "red/green map buoy",           -1,   -1,  -1,   -1,   "-"                  },
	{    31, 0, "red/white map buoy",           -1,   -1,  -1,   -1,   "-"                  },
	{    32, 0, "violet map buoy",              -1,   -1,  -1,   -1,   "-"                  },
	{    33, 0, "white map buoy",               -1,   -1,  -1,   -1,   "-"                  },
	{    34, 0, "white/green map buoy",         -1,   -1,  -1,   -1,   "-"                  },
	{    35, 0, "white/red map buoy",           -1,   -1,  -1,   -1,   "-"                  },
	{    36, 0, "white dot",                    16,   -1,  -1,   24,   "Historic Site"      },
	{    37, 0, "radio beacon",                 -1,   -1,  -1,   55,   "Church"             },
//------------------------------------------------------
//... leave space for more navaids (up to 128 total)
//------------------------------------------------------
	{   150, 1, "boat ramp",                    26,    5,   4,    9,   "Boat Ramp"          },
	{   151, 1, "campground",                   13,   11,   5,   10,   "Campground"         },
	{   152, 1, "restrooms",                    19,   -1,  31,   23,   "Government Building" },
	{   153, 1, "shower",                       22,   -1,  38,   56,   "Police"             },
	{   154, 1, "drinking water",               -1,   -1,  12,    3,   "Arrow Down"         },
	{   155, 1, "telephone",                     7,   -1,  43,   38,   "Phone"              },
	{   156, 1, "first aid",                     2,   14,  23,   19,   "Emergency"          },
	{   157, 1, "information",                  10,   -1,  20,   27,   "Information"        },
	{   158, 1, "parking",                      -1,   -1,  26,   37,   "Parking"            },
	{   159, 1, "park",                         11,   -1,  25,   36,   "Park"               },
	{   160, 1, "picnic",                       14,   -1,  27,   39,   "Picnic"             },
	{   161, 1, "scenic area",                  -1,   -1,  32,   49,   "Stop Sign"          },
	{   162, 1, "skiing",                       -1,   -1,  39,   17,   "Doctor/Dentist"     },
	{   163, 1, "swimming",                     -1,   -1,  41,    8,   "Beach"              },
	{   164, 1, "dam",                          -1,   -1,  10,   54,   "Bridge"             },
	{   165, 0, "controlled area",              -1,   -1,  -1,   32,   "One Way Down"       },
	{   166, 0, "danger",                       -1,   -1,  -1,   -1,   "-"                  },
	{   167, 0, "restricted area",              -1,   -1,  -1,   -1,   "-"                  },
	{   168, 0, "null",                         -1,   -1,  -1,   -1,   "-"                  },
	{   169, 1, "ball",                         -1,   -1,   1,   45,   "Sports"             },
	{   170, 1, "car",                           5,    3,   6,   15,   "Delivery Stop"      },
	{   171, 1, "deer",                         17,   13,  19,    0,   "Agricultural"       },
	{   172, 1, "shopping cart",                -1,   -1,  36,   -1,   "-"                  },
	{   173, 1, "lodging",                      -1,   -1,  18,   29,   "Lodging"            },
	{   174, 1, "mine",                         -1,   -1,  47,   14,   "Cross"              },
    {   175, 2, "trail head",                   27,   -1,  -1,   53,   "Bike"               },
    {   176, 2, "truck stop",                   -1,   -1,  -1,   41,   "Power"              },
	{   177, 1, "user exit",                    -1,    8,  -1,   -1,   "-"                  },
	{   178, 1, "flag",                         -1,   10,  -1,   -1,   "-"                  },
	{   179, 1, "circle_x",                     -1,   12,  -1,   -1,   "-"                  },
//---------------------------------------------------------------
// Symbols for land (group 1...8192-16383...bits 15-13=001).
//---------------------------------------------------------------
	{  8192, 1, "interstate hwy",               -1,   -1,  -1,   48,   "State Capitol"      },
	{  8193, 0, "us hwy",                       -1,   -1,  -1,   -1,   "-"                  },
	{  8194, 0, "state hwy",                    -1,   -1,  -1,   -1,   "-"                  },
	{  8195, 0, "mile marker",                  -1,   -1,  -1,   -1,   "-"                  },
	{  8196, 1, "TracBack (feet)",              18,   15,  44,    4,   "Arrow Left"         },
	{  8197, 1, "golf",                         -1,   -1,  16,   22,   "Golf Course"        },
	{  8198, 1, "small city",                   -1,   -1,   9,   12,   "Circle"             },
	{  8199, 1, "medium city",                  -1,   -1,   8,   43,   "Religious Cross"    },
	{  8200, 1, "large city",                   -1,   -1,   7,   42,   "Religious Star"     },
	{  8201, 0, "intl freeway hwy",             -1,   -1,  -1,   28,   "Library"            },
	{  8202, 0, "intl national hwy",            -1,   -1,  -1,   -1,   "-"                  },
	{  8203, 0, "capitol city (star)",          -1,   -1,  -1,   31,   "National Capitol"   },
	{  8204, 0, "amusement park",               -1,   -1,  -1,   -1,   "-"                  },
	{  8205, 0, "bowling",                      -1,   -1,  -1,   -1,   "-"                  },
	{  8206, 0, "car rental",                   -1,   -1,  -1,   -1,   "-"                  },
	{  8207, 0, "car repair",                   -1,   -1,  -1,   -1,   "-"                  },
	{  8208, 0, "fast food",                    -1,   -1,  -1,   -1,   "-"                  },
	{  8209, 0, "fitness",                      -1,   -1,  -1,   -1,   "-"                  },
	{  8210, 0, "movie",                        -1,   -1,  -1,   -1,   "-"                  },
	{  8211, 0, "museum",                       -1,   -1,  -1,   -1,   "-"                  },
	{  8212, 0, "pharmacy",                     -1,   -1,  -1,   -1,   "-"                  },
	{  8213, 0, "pizza",                        -1,   -1,  -1,   -1,   "-"                  },
	{  8214, 0, "post office",                  -1,   -1,  -1,   40,   "Post Office"        },
	{  8215, 0, "RV park",                      -1,   -1,  -1,   -1,   "-"                  },
	{  8216, 0, "school",                       -1,   -1,  -1,   -1,   "-"                  },
	{  8217, 0, "stadium",                      -1,   -1,  -1,   -1,   "-"                  },
	{  8218, 0, "dept. store",                  -1,   -1,  -1,   -1,   "-"                  },
	{  8219, 0, "zoo",                          -1,   -1,  -1,   52,   "Zoo"                },
//-------------------------------------------------------------
// Symbols for aviation (group 2...16383-24575...bits 15-13=010).
//---------------------------------------------------------------
	{ 16384, 1, "airport",                       9,   -1,   0,    1,   "Airport"            },
	{ 16385, 0, "intersection",                 -1,   -1,  -1,   -1,   "-"                  },
	{ 16386, 0, "non-directional beacon",       -1,   -1,  -1,   -1,   "-"                  },
	{ 16387, 0, "VHF omni-range",               -1,   -1,  -1,   -1,   "-"                  },
	{ 16388, 1, "heliport",                     -1,   -1,  17,   26,   "Industrial"         },
	{ 16389, 1, "private field",                -1,   -1,  28,   13,   "Construction"       },
	{ 16390, 1, "soft field",                   -1,   -1,  40,   16,   "Diamond"            },
	{ 16391, 1, "tall tower",                   -1,   -1,  42,    6,   "Arrow Up"           },
	{ 16392, 1, "short tower",                  12,   -1,  37,   30,   "Mountain"           },
	{ 16393, 1, "glider",                       -1,   -1,  15,    5,   "Arrow Right"        },
	{ 16394, 1, "ultralight",                   -1,   -1,  45,   35,   "One Way Up"         },
	{ 16395, 1, "parachute",                    -1,   -1,  24,   50,   "Triangle Down"      },
	{ 16396, 0, "VOR/TACAN",                    -1,   -1,  -1,   -1,   "_"                  },
	{ 16397, 0, "VOR-DME",                      -1,   -1,  -1,   -1,   "-"                  },
	{ 16398, 0, "first approach fix",           -1,   -1,  -1,   -1,   "-"                  },
	{ 16399, 0, "localizer outer marker",       -1,   -1,  -1,   -1,   "-"                  },
	{ 16400, 0, "missed approach point",        -1,   -1,  -1,   -1,   "-"                  },
	{ 16401, 0, "TACAN",                        -1,   -1,  -1,   -1,   "-"                  },
	{ 16402, 1, "Seaplane Base",                -1,   -1,  34,   33,   "One Way Left"       },
	{    -1, 0, "Dummy",                        -1,   -1,  -1,   -1,   "Dummy"              },
};
//
//  Default Packet IDs
//
enum {
	Pid_Ack_Byte		=   6, // 0x06
	Pid_Nak_Byte		=  21, // 0x15
	Pid_Product_Rget	= 254, // 0xfe
	Pid_Product_Data	= 255  // 0xff
};

//=====================================================================
// L001 - Link Protocol 1
//
enum {
	Pid_Command_data	=  10, // 0x0a
	Pid_Xfer_Cmplt		=  12, // 0x0c
	Pid_Date_Time_Data	=  14, // 0x0e
	Pid_Position_Data	=  17, // 0x11
	Pid_Prx_Wpt_Data	=  19, // 0x13
	Pid_Records			=  27, // 0x1b
	Pid_Rte_Hdr			=  29, // 0x1d
	Pid_Rte_Wpt_Data	=  30, // 0x1e
	Pid_Almanac_Data	=  31, // 0x1f
	Pid_Trk_Data		=  34, // 0x22
	Pid_Wpt_Data		=  35, // 0x23
	Pid_Pvt_Data		=  51, // 0x33
	Pid_Protocol_Array	= 253  // 0xfd
};

//=====================================================================
// L002 - Link Protocol 2
//
enum {
	Pid_Almanac_Data2	=  4, // 0x04
	Pid_Command_Data2	= 11, // 0x0b
	Pid_Xfer_Cmplt2		= 12, // 0x0c
	Pid_Date_Time_Data2	= 20, // 0x14
	Pid_Position_Data2	= 24, // 0x18
	Pid_Records2		= 35, // 0x23
	Pid_Rte_Hdr2		= 37, // 0x25
	Pid_Rte_Wpt_Data2	= 39, // 0x27
	Pid_Wpt_Data2		= 43  // 0x2b
};

//=====================================================================
// A000 - Product Data Protocol
//
// Product_Data_Type Product_Data;

//=====================================================================
// A010 - Device Command Protocol 1
//
enum
{
	Cmnd_Abort_Transfer	=  0,	// abort current transfer
	Cmnd_Transfer_Alm 	=  1,	// transfer almanac
	Cmnd_Transfer_Pos 	=  2,	// transfer position   added by crh
	Cmnd_Transfer_Prx 	=  3,	// transfer proximity waypoints
	Cmnd_Transfer_Rte 	=  4,	// transfer routes
	Cmnd_Transfer_Date	=  5,	// transfer date/time  added by crh
	Cmnd_Transfer_Trk 	=  6,	// transfer track log
	Cmnd_Transfer_Wpt 	=  7,	// transfer waypoints
	Cmnd_Power_Off      =  8,   // Turn unit off
	Cmnd_Send_Voltages  = 17,   // Send voltage readings (some units)
	Cmnd_Start_Pvt_Data = 49,	// start transmitting PVT
	Cmnd_Stop_Pvt_Data	= 50	// stop transmitting PVT data
};

//=====================================================================
// A011 - Device Command Protocol 2 (I added the '2' below crh 3/23/98)
//
enum
{
	Cmnd_Abort_Transfer2 =  0,	// abort current transfer
	Cmnd_Transfer_Alm2   =  4,	// transfer almanac
	Cmnd_Transfer_Rte2   =  8,	// transfer routes
	Cmnd_Transfer_Wpt2   = 21	// transfer waypoints
};
//=====================================================================
// Index into Protocols Array for the various protocol id's
//
//   For example, the III is index 72 which has the following data:
//
//  Product_ID			:  72	Garmin's product ID for the III
//	Product_Ver			:   0	(0 indicates all versions of the III)
//	LinkProtocol		:   1	Link version L001
//	Command				:  10	Command version A010
//	WaypDataRecord		: 104	Waypoint data	D104
//	RouteHdrType		: 201	RouteRecord		D201
//	RouteDataRecord		: 104	RouteTrack		D104
//	TrackDataRecord		: 300	TrackRecord		D300
//	ProxDataRecord		:  -1	ProximityData is not supported on this model gps
//	AlmanacDataRecord	: 501	AlmanacData		D501
//

//=====================================================================
//=====================================================================
//
//P000 - Physical Protocol Layer

//A000 - Product Data Protocol
//A001 - Protocol Capability Protocol

//=====================================================================
//A010 - Device Command Protocol 1
//A011 - Device Command Protocol 2

//=====================================================================
//A100 - Waypoint Transfer Protocol
//D100_Wpt_Type
//D101_Wpt_Type
//D102_Wpt_Type
//D103_Wpt_Type
//D104_Wpt_Type
//D105_Wpt_Type
//D106_Wpt_Type
//D150_Wpt_Type
//D151_Wpt_Type
//D152_Wpt_Type
//D154_Wpt_Type
//D155_Wpt_Type

//=====================================================================
//A200 - Route Transfer Protocol
//D200_Rte_Hdr_Type 
//D201_Rte_Hdr_Type 
//D202_Rte_Hdr_Type 
//D100_Wpt_Type
//D101_Wpt_Type
//D102_Wpt_Type
//D103_Wpt_Type
//D104_Wpt_Type
//D105_Wpt_Type
//D106_Wpt_Type
//D150_Wpt_Type
//D151_Wpt_Type
//D152_Wpt_Type
//D154_Wpt_Type
//D155_Wpt_Type

//=====================================================================
//A300 - Track Log Transfer Protocol
//D300_Trk_Point_Type

//=====================================================================
//A400 - Proximity Waypoint Transfer Protocol
//D101_Wpt_Type
//D102_Wpt_Type
//D152_Wpt_Type
//D400_Prx_Wpt_Type
//D403_Prx_Wpt_Type
//D450_Prx_Wpt_Type

//=====================================================================
//A500 - Almanac Transfer Protocol
//D500_Almanac_Type
//D501_Almanac_Type
//D550_Almanac_Type
//D551_Almanac_Type

//=====================================================================
//A600 - Date and Time Initialization Protocol
//D600_Date_Time_Type 

//=====================================================================
//A700 - Position Initialization Protocol
//D700_Position_Type

//=====================================================================
//A800 - PVT Data Protocol
//D800_Pvt_Data_Type 

//=====================================================================
//L001 - Link Protocol 1
//L002 - Link Protocol 2

//=====================================================================
// Current product info			Examples           Range allowed by doc
//=====================================================================
INT D105orD106=0;				// 1 if current waypoint is to/from a D105 or D106 record

INT	Product_ID;					// 72  GPS III  	... 
INT	Product_Ver;				// 000 - all		...

INT ProductDataProtocol=0;      // 000 - A000		A000  ALL GPS's support this

INT PhysicalProtocol;			// 000 - P000		P000

INT	LinkProtocol=-1;			// 001 = L001		L001,L002

INT	CommandProtocol;			// 010 = A010		A010,A011

INT	WaypXferProtocol;			// 100 = A100		A100
INT	WaypDataRecord;				// 104 = D104		D100,D101,D102,D103,D104,D105,D106,D150
								//					D151,D152,D154,D155

INT RouteXferProtocol;			// 200 = A200		A200
INT RouteHdrType;				// 201 = D201		D200,D201,D202
INT	RouteDataRecord;			// 104 = D104		D100,D101,D102,D103,D104,D105,D106,D150
								//					D151,D152,D154,D155
INT RouteLinkDataRecord;        // 210 = D210       D210

INT TrackXferProtocol;          // 300 = A300       A300
INT TrackDataRecord;            // 300 = D300       D300,D301 if TrackHdrType=310
INT TrackHdrType;               // 310 = D310       D301

INT ProxXferProtocol;			//  -1 = None		A400
INT	ProxDataRecord;				//  -1 = None		D101,D102,D152,D400,D403,D450


INT	AlmanacXferProtocol;		// 500 = A500		A500
INT AlmanacDataRecord;			// 501 = D501		D500,D501,D550,D551

INT UTCXferProtocol;			// 600 = A600		A600
INT UTCDataRecord;				// 600 = D600		D600

INT	PositionXferProtocol;		// 700 = A700		A700
INT PositionDataRecord;			// 700 = D700		D700

INT PVTXferProtocol;			// 000 = None		A800
INT PVTDataRecord;				// 000 = None		D800

INT haveProtocolArray=0;		// set to 1 if the GPS sends a protocol array

extern INT Protocols[55][12];
extern INT ProtocolIndex;	// index into above table which holds the valid

//=====================================================================
// File names
//
char	*fname_in_all;	 	// current input file
char	*fname_out_all;		// current output file
char	*os;
//
// File Stream designators
//
FILE	*in;
FILE	*out;
FILE	*trks_out;			// used when sending internal track rcords to a file
FILE	*Gdebug_out;		// send serial debug info to this file

long	port_speed=0;		// Serial port baud rate
long	via;				// Set to 1 if point is a Via in sa6
INT		default_Garmin_icon=18;// default icon used in icon type conversion
INT		default_G12_icon=0; // 
INT		default_SA5_icon=46;
INT		default_GM2_icon=-1;
INT		default_SA52_icon=-1;
INT		default_LWR_icon=0;
INT		Gdebug=0;			// ==1, record input & output RS232
char    outfmt[10];			// holds protocol output format
long	interval;			// used in get position command
INT		Garmin_NAKS_Sent=0;	// number of NAKs sent to Garmin GPS this session
INT		Lowr_NAKS_Sent=0;	// number of NAKs sent to Lowrance GPS this session
unsigned char recordtype;	// record type being sent
unsigned INT valid_records=0;	// number of valid records from input file
double	minlat,maxlat;		// min/max latitude.  SA4 Center of map calc
double  minlon,maxlon;		// min/max longitude.  SA4 Center of map calc
double  minla,minlo;        // used in toDMSxx
double  NoProximity=0;		// number of proximity waypoints found
INT		proximity=0;		// processing a proximity waypoint
INT		doAsyncStat=0;		// if 1 print stats from rs232 port
INT		new_com=0;			// if 1 a new com port has been input
INT		no_N=1;				// set to 0 if a 'N' record is read
INT		total_dist=0;		// flag to total distance of track line
double	track_d=0.0;		// distance of current track segment
double	sum_dist=0.0;		// total distance of all track segments
INT		satnum;				// satellite number for doAlmanac
INT		COMtimeout=0;		// Set to 1 on a receiver timeout
INT		PVTvar=0;			// used in getting PVT data
INT		sa_fileout=0;		// 1 if any output file has suffix .sa(3/4/5)
//
// SA output drawing options
//
INT		draw_route_1_19_obj=1;// if 1 route waypoints are plotted on sa output
INT		draw_route_0=1;		// if 1 route 0 is drawn in sa4 output
INT		draw_route_0_obj=1;	// if 1 route 0 waypoints are plotted on sa4 output
INT		draw_track_lines=1;	// if 1 track lines are plotted on sa output
INT		draw_route_0_line=1;// if the output is to an SA5 file lines are drawn
                            // for route 0
INT		draw_route_1_19_lines=1;// if 1 draw lines between route points
							//  in routes 1-19 when output is SA4
INT		draw_prox_circles=1;// if 1 prox waypoints are plotted on sa output
INT		draw_waypoints=1;	// if 1 waypoints are plotted on sa output

INT		route_lines=0;		// Number of lines needed to draw routes
INT 	route_pushed=0;		// set to 1 when a route 0-19 is read
							//  from a SA file

INT		gotID=0;			// set to 1 when the connected GPS has been
							//  ID'd
unsigned	INT maxtrkptrs;	// maximum no of track points
unsigned	INT maxiconptrs;// maximum no of icons
//
// used in resending last message
//
BYTE 	*LastLowrGPSMsg;
BYTE 	*LastGarminGPSMsg;
short	LastLowrLen;
short	LastGarminLen;
//
// Global variables
//
int		UTM=0;					// Set to 1 if output is to be UTM
INT		dataread=0;				// Set to 1 when data is read from a GPS
char	*Text;					// Used in 'pushing' items
INT		route0=0;				// nth point in route 0
INT		Sused=0;				// Sxxxxx already used up to here
long	ZeroL=0L;				// a long 0
char	*infiles[20];			// array of input files
INT		current_in=0;			// index into infiles[] for current file
INT		input_files=0;			// number of input files
INT		in_file=0;				// file system file input found
char	*outfiles[20];			// array of output files
INT		output_files=0;			// number of output files
char	**waypoint_push;		// array of pointer to save waypoints
int		waypoints=0;			// Number of waypoints read into memory
char	**track_push;			// array of pointer to save track waypoints
char	**icon_push;			// array of pointer to save track waypoints
unsigned INT tracks=0;			// Number of track entries pushed into memory
unsigned INT icons=0;			// Number of icon entries pushed into memory
char 	**proximity_push;		// array of pointer to save proximity
INT		proximityp=0;			// Number of proximity waypoints read
INT		next_is_new=0;			// set to 1 when a 'N' record is read
								// and set to 0 when a 'T' record is read

INT 	*routeXpts;				// # of waypoints in route number 'x' is
								//    held in routeXpts[x]
char	*route_push[MAXROUTES+1][MAXPOINTS+1];// array of pointers to save route
INT		routes=0;				// Number of route points in route 1-> MAXROUTE
char	*route_comment;			// route name of current route 
INT		route_number=-1;		// route number of current route
INT		route_points=0;			// route number of current route
INT		route_point=0;			// point number in current route
char	*routename1;			// used in sa3 -> text for routes
INT		in_route;				// set to 1 if reading a route
char	rtn[4];					// ASCII of current route number
INT		in_track;				// set to 1 if reading a track
INT		first_track;			// set to 1 if outputting first track point
								//  after an 'N' record
INT		first_track_push=1;		// pushing the first track
INT		first_icon_push=1;		// pushing the first icon
INT		first_waypoint_push=1;	// pushing the first waypoint
INT		first_proximity_push=1;	// pushing the first proximity waypoint
INT		trk_seg=0;				// number of track segments read
INT		*trks;					// elements in xth track seg
short	**deltas;				// holds track deltas for Lowrance units
INT		cur_trk=0;				// track element currently being read
INT		nosort=0;				//  if 0 waypoints are sorted on input

INT 	symb=0;					// 1 = reading SA Symbol
								// 2 = reading SA Line
								// 3 = reading SA Circle
INT		mapCir=0;				// number of circles read from map

char	*drive;					// used by fnsplit
char	*dir;					// used by fnsplit
char	*file;					// used by fnsplit
char	*ext;					// used by fnsplit
INT		flags;					// used by fnsplit

INT		opterr = 1;				// argument expansion variable
INT		optind = 1;				// argument expansion variable
INT		optopt;					// argument expansion variable
char	*optarg;				// argument expansion variable

INT		IOaddr=0x3f8;			// COM port I/O address
INT		IRQnumber=4;			// COM port IRQ
INT		nocmdline=0;			// set to 1 if sa3->text is to have
								//   command lines

INT		firstR=0;				// used in nav.exe route processing
INT		firstW=0;				// used in nav.exe route processing

INT		input=0;				// we have valid input to process
INT		output=0;				// we have valid output	to process

INT		pwr=0;					// power off to GPS flag
INT		light=-1;				// Backlight on (1) off (0)
INT		contrast_val=-1;		// Set Contrast value
double  InternalVolts;			// Internal (AA) voltage returned by Garmin
double  ExternalVolts;			// External voltage returned by Garmin

BYTE	p1[]	= "\x06\x02\x1b\x00";	// Get 1st packet
BYTE	p2[]	= "\x06\x02\x0c\x00";	// Get last packet
BYTE	rte2[]	= "\x06\x02\x1d\x00";	// Get next route packet
BYTE	alm2[]	= "\x06\x02\x1f\x00";	// Get next almanac packet
BYTE	trk2[]	= "\x06\x02\x22\x00";	// Get next track packet
BYTE	wpt2[]	= "\x06\x02\x23\x00";	// Get next waypoint packet
BYTE	ack1[]	= "\x06\x02\xff\x00";	// ack for received mod/ver info

BYTE	Gabort[]= "\x0a\x02\x00\x00";	// Abort Transfer
BYTE	alm1[]	= "\x0a\x02\x01\x00";	// Send almanac
BYTE	GPSPos[]= "\x0a\x02\x02\x00";	// send position
BYTE	pwpt1[]	= "\x0a\x02\x03\x00";	// send Proximity waypoints
BYTE	rte1[]	= "\x0a\x02\x04\x00";	// send routes
BYTE	display[]="\x0a\x02\x20\x00";	// send GPS III display
BYTE	GPStime[]="\x0a\x02\x05\x00";	// send UTC time
BYTE	trk1[]	= "\x0a\x02\x06\x00";	// send tracks
BYTE	wpt1[]	= "\x0a\x02\x07\x00";	// send waypoints
BYTE	pwroff[]= "\x0a\x02\x08\x00";	// Power off command
BYTE	VoltsM[]= "\x0a\x02\x11\x00";	// send voltages
BYTE	PVTon[] = "\x0a\x02\x31\x00";	// start sending PVT records
BYTE	PVToff[]= "\x0a\x02\x32\x00";	// stop sending PVT records

BYTE	almt[]	= "\x0c\x02\x01\x00";	// Almanac data base terminator
BYTE	prxt[]	= "\x0c\x02\x03\x00";	// Proximity data base terminator
BYTE	rtet[]	= "\x0c\x02\x04\x00";	// Route data base terminator
BYTE	trkt[]	= "\x0c\x02\x06\x00";	// Track data base terminator
BYTE	wptt[]	= "\x0c\x02\x07\x00";	// Waypoint data base terminator

BYTE	nak1[]	= "\x15\x02\xff\x00";	// nak for received mod/ver info

BYTE	bgnxfr[]= "\x1b\x02\x00\x00";   // 0000 filled in with number

BYTE	lighton[]=  "\x0f\x01\x00";		// send light on (some units)
BYTE	lightoff[]= "\x0f\x01\x01";		// send light off (some units)
BYTE	lightiiP[]= "\x0f\x01\x80";		// send light on II+
BYTE	contrast[]= "\x0b\x01\x08";		// set contrast
BYTE	m1[]	  = "\xfe\x01\x20";		// Get the model and version number

BYTE	*SerialMessage;
BYTE	*SerialMessageOut;
BYTE	*message;

INT	lx=0;  /* 1=95lx, 2=100lx */

unsigned INT SWVersion;		/* version * 100				     */
INT		VersionSubStrings=0;
char	VersionString[99];	/* model/version in string format    */
char	*VersionSubString[10];// version substrings

BYTE newTrack=255;  		/* 255 no track records this session */
                    		/*  0 sending tracks                 */
		    				/*  1 sending first track            */
struct RECORD record;

INT 	ok=-1;

unsigned INT len;				/* misc length param	 			 */
INT		tog45=0;			/* 1 = sending data to GPS 45		 */
INT		toLowr=0;			/* 1 = sending data to Lowrance GPS */
INT		ComPort=COM1;
INT		AlmanacEOF;
INT		RouteEOF;
INT		TrackEOF;
INT		ProxWaypointEOF;
INT		WaypointEOF;

struct PREFS gPrefs;

INT		com_open=0;
BYTE	output_format;

/*
 * Structures
 */
#if __BORLANDC__
struct 	ftime ft;
#else
struct	mftime ft;
#endif

INT two=2;
INT ObjCode=0;
double  setlat=1000.0;
double  setlon=1000.0;
double  lastlat=0.0;
double  lastlon=0.0;

INT	setmag;

INT 	Last_ObjSize=-1;
INT 	Last_ObjColor=-1;
INT 	Last_TextSize=-1;
INT 	Last_TextColor=-1;
INT 	Last_TextAlign=-1;

INT 	Last_LineColor=-1;
INT 	Last_LineWidth=-1;
INT 	Last_LineStyle=-1;

INT		Last_CirLineDraw=-1;
INT		Last_CirFillArea=-1;
INT		Last_CirLineColor=-1;
INT		Last_CirLineWidth=-1;
INT 	Last_CirFillColor=-1;
INT 	Last_CirFillStyle=-1;

char LowrProducts[20][17] = {
			"Unknown",
 			"GlobalMap Sport",
 			"AirMap",
 			"AccuMap",
 			"GlobalNav 310",
 			"Eagle View",
 			"Eagle Explorer",
 			"GlobalNav 200",
 			"Expedition II",
 			"GlobalNav 212",
 			"GlobalMap 12",
			"Unknown",
			"AccuMap 12",
			"Unknown",
			"GlobalMap 100",
			"Unknown",
			"Unknown",
			"Unknown",
			"Unknown",
			"Unknown"
};
char days[7][4] = {
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" 
};

char months[13][4] = { "Bad",
	"Jan", "Feb", "Mar", "Apr", "May", "Jun", 
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec" 
};

unsigned char *genConst;

//===================================================================
//This format is used by DeLorme Map'n'Go 3.0 and Street Atlas 4.0 to
//store GPS tracks.  The file is composed of equal length records.  Each
//record is 56 bytes long.
//
//The format of the record is:
//
//	4 bytes - status (unsigned long) 
//	4 bytes - ????? 
//	8 bytes - latitude (floating point double, decimal degrees) 
//	8 bytes - longitude (floating point double, decimal degrees) 
//	8 bytes - altitude (floating point double, meters) 
//	8 bytes - heading (floating point double, decimal degrees) 
//	8 bytes - speed (floating point double, MPH) 
//	4 bytes - time (unsigned long, C 'time_t' type) 
//	4 bytes - ????? 
//
//The following 'C' structure can be used to access the data in each record.

struct SA_gpl_record
{
	unsigned long status;
	unsigned long dummy;
	double        latitude;
	double        longitude;
	double        altitude;
	double        heading;
	double        speed;
	unsigned long time;  	// in <time.h format
	unsigned long dummy3;
} SA_gpl_record;


//===================================================================
INT		LowrType=0;		// 1=Track 1,  2=Track 2, 3=Waypoints
						// 4=Routes,   5=Icons

INT		g45type=0;		// 1=Tracks,  2=Waypoints, 3=Routes
						// 4=iD,      5=tIme,      6=Position
						// 7=Almanac, 8=proXimity waypoints 
						// 9=Voltages 10=Light on, 11=Light off

INT intype=0;			// 	1=txt/gd7 		2=GARMIN GPS i/o 3=SA3
						//  4=almanac data	5=Navigate route 6=SA4
						//  7=unused        8=SA gpl file    9=SA6
						// 10=Fugawi wpt   11=Fugawi track	12=OZI_OWP
						// 13=             14=CSV           15=LOWRANCE GPS i/o
						// 16=OZI Plot     17=OZI Waypoint  18=OZI Route
						//  99=GERROR

long	numrecords;		// number of input records in file
unsigned INT s4o_trk_recs;  // number of line objects in SA4 file
INT 	firstwaypoint=1;
INT 	firstPwaypoint=1;
INT 	firsttrackpoint=1;


char	*p;				// general pointer for string functions
char	*buf;			// general string

unsigned long LatConst=0x6ae187b1L;
unsigned long LonConst=0x494ae39bL;
double	LatC,LonC;

INT	sa3number=0;  	/* number of 'items' written to a SA file */
INT	Id=0x100,
		MagC=4,
		Mapfeatures=0x3fff;

char	*MapTitle;

INT	nameonlytxt=0;
INT	nameonly=0; 	// Handles comment and symbol display options
						
						// 0  - all items written
						// 1  - comment not written on regular waypoints
						// 2  - comment not written on route waypoints
						// 4  - the symbol display  parameter not written
						// 8  - route name is not written on first route point
						//16  - (nn:nn) not written on routes

INT	noname=0;		// 1 = no text info is output into SA files
INT	ShowGrids=1, NumObjs;
INT	ObjColor=0,TextColor=2,TextSize=0,ObjSize=0,TextAlign=2;
INT	LineWidth=1,LineColor=0,LineStyle=0;
INT	Route_LineWidth=1,Route_LineColor=0,Route_LineStyle=0;

INT	CirLineWidth=0,CirLineColor=0,CirFillStyle=0;
INT	CirLineDraw=1,CirFillArea=0,CirFillColor=0;

INT	ItemType,
		Item;

unsigned char MtLen;
unsigned long Const1=0x1a2b3c4dL;

BYTE	*bin;
INT	optchar;
INT	navmode=0,		// 1 = navigate.exe output
    	tmode=0,		// 1 = text output desired
    	g6=0,	 		// 1 = garmin64 output
    	s3o=0,			// 1 = output is sa3 file
		s4o=0,			// 1 = output is sa4 file
    	s5o=0,			// 1 = output is sa5 file
    	s6o=0,			// 1 = output is sa6 file
		gpl_out=0,		// 1 = output is to SA .gpl file
		csv_out=0,		// 1 = output is a comma separated file
		TextFileOutput=0, // 1 = output is to a text file
		GarDownWP=0,	// 1 = Waypoint name length is set to be 6 chars on output
		getGarminDisp=0,// 1 = output GPS III/SP display to a file
		DisplayIsLowrance=0,// if set to 1 then Lowrance display is output to .bmp
							//   instead of a Garmin Display
		oziwpt=0,		// 1 = output is a OziExplorer Saved wpt file
		ozievt=0,		// 1 = output is a OziExplorer Exported wpt file
		oziplt=0,		// 1 = output is a Ozi track (plot) file
		ozirte=0,		// 1 = output is a Ozi route file
		fugawiwpt=0,	// 1 = output is a FUGAWI wpt file
		fugawitrk=0,	// 1 = output is a FUGAWI trk file
		igctrackout=0,  // 1 = output is "B" record in an IGC file
		waypoint2trk=0;	// 1 = output waypoints as a track file


char align[8][3]={"nw","n","ne","w","e","sw","s","se"};
char sizes[5][3]={"vs","s","m","l","vl"};
char colors[5][7]={"black","red","blue","green","yellow"};
char width[5][3]={"vt","t","m","k","vk"};
char style[3][3]={"n","ha","*h"};
char noyes[2][2]={"n","y"};

double ReadLatLonVal(char *LL)
{
    char *str, *p;
    double lastlat;

//printf("LL: '%s'\n",LL);
    switch(DMSMode) {
// Wddd MM SS.ss  (DMS)
        case DMS:
            str=strdup(LL);
            p=strtok(str," ");
            if(p!=NULL) lastlat=atof(p);
            p=strtok(NULL," ");
            if(p!=NULL) lastlat+=atof(p)/60.0;
            p=strtok(NULL," ");
            if(p!=NULL) lastlat+=atof(p)/3600.0;
            free(str);
            break;
// Wddd MM.mmmm  (DM)
        case DMM:
            str=strdup(LL);
            p=strtok(str," ");
            if(p!=NULL) lastlat=atof(p);
            p=strtok(NULL," ");
            if(p!=NULL) lastlat+=atof(p)/60.0;
            free(str);
            break;
// DDD.ddddd
        case DDD:
            lastlat=atof(LL);
            break;
    } // switch(DMSMode)
//printf("LE: '%lf'\n",lastlat);
    return lastlat;
} // double ReadLatLonVal(
/* getstrings:
 * char *getstrings(s1,s2,s3)
 * char *s1, *s2;
 * INT  s3;
 *
 *  Works somewhat like strtok(3).  In fact, if s3 is 0 this routine
 *  operates *exactly* like strtok3.
 *
 *  When s3 is 1, the static variable ch is bumped up by the value
 *   of s3.  This will allow a linear array of characters separated by
 *   a NULL to be decoded.
 *
 *  Example:
 *
 *
 *char a[100]="One\0Two\0Three\0Four\0Five";
 *main() {
 *
 *	INT i;
 *	char *p;
 *
 *	for(i=0;i<30;i++) printf("%c  ",a[i]);
 *
 *	p=getstring(a,"\0",0);
 *	printf("'\n%s'\n",p);
 *
 *	p=getstring(NULL,"",1);
 *	printf("'%s'\n",p);
 *
 *	p=getstring(NULL,"",1);
 *	printf("'%s'\n",p);
 *
 *	p=getstring(NULL,"",1);
 *	printf("'%s'\n",p);
 *
 *	p=getstring(NULL,"",1);
 *	printf("'%s'\n",p);
 *
 *	p=getstring(NULL,"",1);
 *	printf("'%s'\n",p);
 * 
 *}
 *	will print:
 *			'One'
 *			'Two'
 *			'Three'
 *			'Four'
 *			'Five'
 *			'(null)'
 *	
 *
 */
char *getstrings(char *source, char *separators, INT bump )
{
	static char *ch;
	register char *sep, *token;

	/* if no source supplied, use the previous one.
	 */
	if( source != (char *) NULL )
		ch = source;

	/* For each character in the source string, see if it is a separator
	 * character.
	 */
	if(bump) ch+=bump;
	for( token = ch; *ch; ++ch ) {
		for( sep = separators; *sep; ++sep ) {

			/* look for a separator
			 */
			if( *ch == *sep ) {
				/* Got one, put a null there and move the
				 * saved source pointer up one for next time.
				 */
				*ch = 0;
				++ch;
				return token;
			}
		}
	}

	/* If nothing was found, then return nothing
	 * else return the token
	 */
	if( token == ch )
		return (char *) NULL;
	else
		return token;
} /* getstrings */

/* -------------------------------------------------------------------------- */
/***** hpcvmb:net.sources / dolphy!jmg /  2:55 pm  Oct 15, 1985*/
/**** RE: a program that stands up for America ***

It seems that the evil empire has struck again: there is no
strtok(3) in ucb UNIX, or 4.2 at least...and that means that
those of you who received typo(1), a program to prevent
typing errors caused by the red scourge, were left defenseless.

So, I've oil't down my body, built up my pecks, plugged a few
slant-eye commie automatons, donned the clothes of a middle-america
down home television minister and implemented strtok(3) according
to the specs of at&t 5.2 manual.  Here is its, caveats and all:
*/

/* strtok(3) (from the manual system 5.2):
 * char *strtok(s1,s2)
 * char *s1, *s2;
 *  strtok considers the string s1 to consist of a sequence
 * of zero or more text tokens separated by spans of one or more
 * characters from the separator string s2.  The first call (with
 * pointer s1 specified) returns a pointer to the first character of
 * the first token, and will have written a null character into s1
 * immediatlely following the returned token.  The function keeps
 * track of its position in the string between separate calls, so
 * that subsequent calls (which must be made with the first arguemtn
 * a NULL pointer) will work through the string s1 immediately
 * following that token.  In this way subsequent calls will work
 * through the string s1 until no tokens remain.  The separator
 * string s2 may be different from call to call.  When no token
 * remains in s1, a NULL pointer is returned.
 *
 * Below is my simulation of at&t unix 5.2 strtok(3) function for use
 * with the typo(1) program for ucb unix 4.2... I tried to make
 * it do what the description above says, but I didn't try very
 * hard...just enough for it to work with typo(1), which I
 * submitted a few days ago.  That is, it may be correct...but, I
 * haven't rigorously tested it... If it's adequate in general, tell me!
 * 
 * Jeffrey Greenberg ihnp4!allegra!phri!dolphy!jmg
 * Tue Oct 15 17:25:23 EDT 1985
 */
PROCX char *strtok3(char *source, char *separators )
{
	static char *ch;
	register char *sep, *token;

	/* if no source supplied, use the previous one.
	 */
	if( source != (char *) NULL )
		ch = source;

	/* For each character in the source string, see if it is a separator
	 * character.
	 */
	for( token = ch; *ch; ++ch ) {
		for( sep = separators; *sep; ++sep ) {

			/* look for a separator
			 */
			if( *ch == *sep ) {
				/* Got one, put a null there and move the
				 * saved source pointer up one for next time.
				 */
				*ch = 0;
				++ch;
				return token;
			}
		}
	}

	/* If nothing was found, then return nothing
	 * else return the token
	 */
	if( token == ch )
		return (char *) NULL;
	else
		return token;
} /* strtok3 */

/* -------------------------------------------------------------------------- */
// convert datums
PROCX void convert_datum(char *datum)
{
		if(strcmp(datum,"WGS-84") != 0) {
			datumconv(record.la,record.lo);
			record.la=LA;
			record.lo=LO;
			set_ns();
		}
}
/* -------------------------------------------------------------------------- */
PROCX char *latlongstr(void)
{
	static char bfr[50];
	double x,y;
	char zone[12] = { ' ', ' ', ' ', ' ', ' ', ' ',
                          ' ', ' ', ' ', ' ', ' ', 0};

	if(UTM) {
		UTMf=UTMf_out;
		UTMa=UTMa_out;
		DegToUTM(record.la,record.lo, zone, &x, &y);
		sprintf(bfr,"%s %9.1lf %10.1lf ",zone,x,y);
	}
	else {
		sprintf(bfr,"%s %s ",toDMlat(record.la),toDMlon(record.lo));
	}
	return bfr;
} // latlongstr

/* -------------------------------------------------------------------------- */
//  set_sign works when the values of record.ns and record.ew are correct
//    it sets the values of record.la (N+,S-), record.lo (E+,W-)
//
PROCX void set_sign(void)
{
	record.la=fabs(record.la);
	record.lo=fabs(record.lo);
	if(record.ns=='S') record.la=-record.la; // restore sign
	if(record.ew=='W') record.lo=-record.lo; // restore sign
} // set_sign(void)

/* -------------------------------------------------------------------------- */
//
// set_ns works when the sign of record.la and record.lo are correct.  It sets
//   the value of record.ns and record.ew
//
PROCX void set_ns(void)
{
	if(record.la<0.0) record.ns='S'; else record.ns='N';
	if(record.lo<0.0) record.ew='W'; else record.ew='E';
} // set_ns

/* -------------------------------------------------------------------------- */
PROCX void set_datetime(void)
{
/*
 * date/time
 */
		sprintf(record.datetime, "%s %s %02d %02d:%02d:%02d %04d", 
			days[dow(record.dayofmonth,record.monthn,record.year)],
			months[record.monthn], 
			record.dayofmonth, record.ht, record.mt, record.st,
			record.year);
} // set_datetime()

/* -------------------------------------------------------------------------- */
// when input a Ozi icon number.. this returns the Garmin icon type
PROCX INT convert_Garmin_to_Ozi(INT ict)
{
	INT i;

	i=0;
	while(Garmin_Symbol_Table[i].Garmin >=0) {
		if(Garmin_Symbol_Table[i].Garmin==ict) {
			if(G45out) { 
				if(Garmin_Symbol_Table[i].OziG>=0) return Garmin_Symbol_Table[i].OziG;
			}
			else  {
				if(Garmin_Symbol_Table[i].GM100>=0) return Garmin_Symbol_Table[i].GM100;
			}
			return 0;
		}
		i++;
	}
	return 0;
} // convert_Garmin_to_Ozi

/* -------------------------------------------------------------------------- */
//
//  When command line -1 is set and input is from Ozi output to the 12XL is
//   assumed.
PROCX INT convert_Ozi_to_12XL(INT ict)
{
	return convert_from_12xl(ict);
} // convert_Ozi_to_12XL

/* -------------------------------------------------------------------------- */
//
//  When command line -1 is set and input is from Ozi output to the 12XL is
//   assumed.
PROCX INT convert_12XL_to_Ozi(INT ict)
{
	return convert_to_12xl(ict);
} // convert_12XL_to_Ozi

/* -------------------------------------------------------------------------- */
// when input a Ozi icon number.. this returns the Garmin icon type
PROCX INT convert_Ozi_to_Garmin(INT ict)
{
	INT i;

	i=0;
	while(Garmin_Symbol_Table[i].Garmin >=0) {
		if(G45out) {
			if(Garmin_Symbol_Table[i].OziG==ict) return Garmin_Symbol_Table[i].Garmin;
		}
		else {
			if(Garmin_Symbol_Table[i].GM100==ict) return Garmin_Symbol_Table[i].Garmin;
		}
		i++;
	}
	return default_Garmin_icon;
} // convert_Ozi_to_Garmin

/* -------------------------------------------------------------------------- */
// when input a 12xl icon type this returns the internal icon type
PROCX INT convert_from_12xl(INT ict)
{
	INT i;

	i=0;
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].XL==ict) return Garmin_Symbol_Table[i].Garmin;
		i++;
	}
	return default_Garmin_icon;
} // convert_from_12xl

/* -------------------------------------------------------------------------- */
// when input a Garmin icon type this returns the 12XL icon type
PROCX INT convert_to_12xl(INT ict)
{
	INT i;

	i=0;
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].Garmin==ict) return Garmin_Symbol_Table[i].XL;
		i++;
	}
	return default_G12_icon;
} // convert_to_12xl

/* -------------------------------------------------------------------------- */
// when input a Lowr icon type this returns the internal icon type
PROCX INT convert_from_Lowr(INT ict)
{
	INT i;
	
	i=0;
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].GM100==ict) return Garmin_Symbol_Table[i].Garmin;
		i++;
	}
	return default_Garmin_icon;
} // convert_from_Lowr

static INT xm(INT i, INT j)
{
	div_t x;

	x=div(i,j);
	return x.rem;
}

PROCX INT convert_to_Lowr(INT ict)
{
	INT i;

	i=0;
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].Garmin==ict)  {
			if(Garmin_Symbol_Table[i].GM100==(-1)) return default_LWR_icon;
			return xm(Garmin_Symbol_Table[i].GM100,LowrID.NumOfIconSym);
		}
		i++;
	}
	return default_LWR_icon;
} // convert_to_Lowr

/* -------------------------------------------------------------------------- */
// simple bubble sort from Grogono
PROCX void sortit(char **a, int *items)
{
	INT jump,m,n,alldone,len;
	char *temp,*p1,*p2;
	char t1[MAX_LENGTH], t2[MAX_LENGTH];
	char name1[50],name2[50];
//	char lat1[50],lat2[50],lon1[50],lon2[50];

	jump=len=*items;
	while(jump>1) {
		jump=jump/2;
		do {
			alldone=1;
			for(m=1;m<=(len-jump);m++) {
				n=m+jump;
				strcpy(t1,a[m]);
				strcpy(t2,a[n]);
				p1=strtok3(t1,";");
				p1=strtok3(NULL,";");
				p1=strtok3(NULL,";");
				p2=strtok3(t2,";");
				p2=strtok3(NULL,";");
				p2=strtok3(NULL,";");
				if(strcmp(p1,p2)>0) {
					temp=a[m];
					a[m]=a[n];
					a[n]=temp;
					alldone=0;
				}
			}
		} while(alldone!=1);
	} /* while(jump>1) */
/*
 * a pseudo unique function
 */
doitagain:;
 	for(m=1;m<len;m++) {
		strcpy(t1,a[m]);
		strcpy(t2,a[m+1]);

		p1=strtok3(t1,";");
		p1=strtok3(NULL,";");
		p1=strtok3(NULL,";");
		strcpy(name1,p1);
//		p1=strtok3(NULL,";");
//		p1=strtok3(NULL,"!");
//		p1=strtok3(NULL,";");
//		strcpy(lat1,p1);
//		p1=strtok3(NULL,";");
//		strcpy(lon1,p1);

		p2=strtok3(t2,";");
		p2=strtok3(NULL,";");
		p2=strtok3(NULL,";");
		strcpy(name2,p2);
//		p2=strtok3(NULL,";");
//		p2=strtok3(NULL,"!");
//		p2=strtok3(NULL,";");
//		strcpy(lat2,p2);
//		p2=strtok3(NULL,";");
//		strcpy(lon2,p2);

		if(strcmp(name1,name2)!=0) continue;
//		if(strcmp(lat1,lat2)!=0) continue;
//		if(strcmp(lon1,lon2)!=0) continue;
		for(n=m+1;n<=len;n++) {
			a[n]=a[n+1];
		}
		len--;
		(*items)--;
		if(len==0) return;
		goto doitagain;
	}
} /* sortit */

/*
     Sinnott's Formula (from R.W. Sinnott, "Virtues of the Haversine",
     Sky and Telescope, vol. 68, no. 2, 1984, p. 159):

          dlon = lon2 - lon1
          dlat = lat2 - lat1
          a = sin^2(dlat/2) + cos(lat1) cos(lat2) sin^2(dlon/2)
          c = 2 arcsin(sqrt(a))
          d = R c

     will give mathematically and computationally exact results.  The
     intermediate result c is the great circle distance in radians.

	 R= 6367.5 KM
*/
#if 1
/* -------------------------------------------------------------------------- */
PROCX double distance(double lat1,double lon1,double lat2,double lon2)
{
	double  dlon,dlat;
	double a,c,d;


	dlat=lat2-lat1;
	dlon=lon2-lon1;
    a = pow(sin(Degree*(dlat/2.0)),2.0) +
	    cos(lat1*Degree)*cos(lat2*Degree)*pow(sin(Degree*(dlon/2.0)),2.0);
    c = 2*asin(sqrt(a));
    d = (6367.5/1.852)*c;
	return d;

} /* distance */

#else
/* -------------------------------------------------------------------------- */
PROCX double distance(double lat1,double lon1,double lat2,double lon2)
{
	double d1, dx, dy;

	d1 = cos((lat1 + lat2)/2.0*Degree);
	dy = (lat2 - lat1)*60.0;
	dx = (lon2 - lon1)*60.0*d1;
	return sqrt(dy*dy + dx*dx);
} /* xdistance */
#endif

/* -------------------------------------------------------------------------- */
PROCX void chk_cmdline(void)
{
	if(nocmdline) return;
	if(symb==SA_SYMBOL) {
		if(
		   Last_ObjSize==ObjSize     &&
		   Last_ObjColor==ObjColor   &&
		   Last_TextSize==TextSize   &&
		   Last_TextColor==TextColor &&
		   Last_TextAlign==TextAlign ) return;

		if(TextFileOutput) {
			fprintf(out,"! -w co%s -w ct%s -w so%s -w st%s -w a%s\n",
        	             colors[ObjColor],
        	             colors[TextColor],
					     sizes[ObjSize],
					     sizes[TextSize],
			             align[TextAlign]);
		}
		else {
			if(tmode)printf("! -w co%s -w ct%s -w so%s -w st%s -w a%s\n",
        	             colors[ObjColor],
        	             colors[TextColor],
					     sizes[ObjSize],
					     sizes[TextSize],
			             align[TextAlign]);
		}

		Last_ObjSize=ObjSize;
		Last_ObjColor=ObjColor;
		Last_TextSize=TextSize;
		Last_TextColor=TextColor;
		Last_TextAlign=TextAlign;
		return;
	}
	if(symb==SA_TRACK) {
		if(Last_LineColor==LineColor     &&
		   Last_LineWidth==LineWidth     &&
	   	   Last_LineStyle==LineStyle ) return;

		if(TextFileOutput) {
			fprintf(out,"! -t c%s -t w%s -t s%s\n",
			     colors[LineColor],
			     width[LineWidth],
			     style[LineStyle]);
		}
		else {
			if(tmode)printf("! -t c%s -t w%s -t s%s\n",
			     colors[LineColor],
			     width[LineWidth],
			     style[LineStyle]);
		}

		Last_LineColor=LineColor;
		Last_LineWidth=LineWidth;
	   	Last_LineStyle=LineStyle;
		return;
	}
	if(symb==SA_CIRCLE) {
			
		if(Last_CirLineDraw==CirLineDraw &&
		   Last_CirFillArea==CirFillArea &&
		   Last_CirLineColor==LineColor &&
		   Last_CirLineWidth==LineWidth &&
		   Last_CirFillColor==CirFillColor &&
		   Last_CirFillStyle==CirFillStyle) return;

		if(TextFileOutput) {
			fprintf(out,"! -p l%s -p f%s -p c%s -p w%s -p a%s -p s%s\n",
			     noyes[CirLineDraw],
			     noyes[CirFillArea],
			     colors[LineColor],
			     width[LineWidth],
			     colors[CirFillColor],
			     style[CirFillStyle]);
		}
		else {
			if(tmode)printf("! -p l%s -p f%s -p c%s -p w%s -p a%s -p s%s\n",
			     noyes[CirLineDraw],
			     noyes[CirFillArea],
			     colors[LineColor],
			     width[LineWidth],
			     colors[CirFillColor],
			     style[CirFillStyle]);
		}

		Last_CirLineDraw= CirLineDraw;
		Last_CirFillArea= CirFillArea;
		Last_CirLineColor= CirLineColor; 
		Last_CirLineWidth= CirLineWidth;
		Last_CirFillColor= CirFillColor;
		Last_CirFillStyle= CirFillStyle;
		return;
	}
} /* chk_cmdline */

/* dt is the date and time in the format "Wed Apr 10 hh:mm:ss 1996" and secs
   is the number of seconds since 12/31/1989 00:00:00, as defined by the
   'define' START
*/
/* -------------------------------------------------------------------------- */
PROCX char *secs2dt(long secs, short offset)
{
	static char dt[50];
	long daysn = (secs + (long)(offset*3600.0)) / 86400L;
	long rem = secs + (long)(offset*3600.0) - daysn *  86400L;

	if(rem<0L) rem=-rem; /* saw it once, don't know what it ment */
	
	days2date(daysn,(short*)&record.monthn,
		        (short*)&record.dayofmonth,
		        (short*)&record.year);

	strcpy(record.day_week,
	               days[dow(record.dayofmonth,record.monthn,record.year)]);

	record.ht = (int)(rem/3600L);
	record.mt = (int)((rem-(long)record.ht*3600L)/60L);
	record.st = (int)((rem-(long)record.ht*3600L)-(long)record.mt*60L);

	sprintf(dt, "%s %s %02d %02d:%02d:%02d %04d", 
			days[dow(record.dayofmonth,record.monthn,record.year)],
			months[record.monthn], 
			record.dayofmonth, record.ht, record.mt, record.st,
			record.year);

	return dt;
} /* secs2dt */

/* -------------------------------------------------------------------------- */
PROCX void oomem(char *s)
{
	fprintf(stderr,"Out of memory in %s -- aborting\n",s);
	byebye(2);
} /* oomem */

/* -------------------------------------------------------------------------- */
/*
 *  returns GARMIN time in seconds.
 * Note:  unix_time = garmin_time + 631065600L
 *        garmin_time = unix time - 631065600L 
 *
 * Note:  unix_time = Lowrance_time + 694224000L
 *        Lowrance_time = unix time - 694224000L
 */
PROCX long dt2secs(short offset)
{
	return (86400L*date2days(record.monthn, record.dayofmonth, record.year) +
			  3600L*(long)record.ht + 
			  60L*(long)record.mt   +
			  (long)record.st       -
			  ((long)offset*3600L));
} /* dt2secs */

/* -------------------------------------------------------------------------- */
/*
 * input date time string: "Wed Dec 20 08:24:38 1995" 
 *  sets datetime stuff in record.
 */
PROCX void datetime2record(char *in)
{
	char buf[MAX_LENGTH],*p;

	strcpy(buf,in);
	buf[24]=0;
//	p=strtok3(buf," ");			// DOW
	p=strtok3(&buf[4]," ");		// Month
	record.monthn=decode_month(p);
	record.dayofmonth=atoi(strtok3(NULL," "));
	record.ht=atoi(strtok3(NULL,":"));
	record.mt=atoi(strtok3(NULL,":"));
	record.st=atoi(strtok3(NULL," "));
	record.year=atoi(strtok3(NULL,";"));
} /* datetime2record */

/* -------------------------------------------------------------------------- */
PROCX long date2days(short mm, short dd, short yy)
{
	long jul;
	short ja, jy, jm;
	
	if (yy < 0)
		++yy;
	if (mm > 2) {
		jy = yy;
		jm = mm + 1;
	}
	else {
		jy = yy - 1;
		jm = mm + 13;
	}
	ja = .01 * jy;
	jul = (long)(floor(365.25 * jy) + floor(30.6001 * jm) +
				(long)dd + 1720997L - (long)ja +
				(long)(0.25 * (long)ja));

	return jul-START;
} /* date2days */

/* -------------------------------------------------------------------------- */
PROCX void days2date(long days, short *mm, short *dd, short *yy)
{
	long ja, jalpha, jb, jc, jd, je;

	jalpha = ((float)(days+START-1867216L)-0.25)/36524.25;
	ja = days+START+1+jalpha-(long)(0.25*jalpha);

	jb = ja + 1524L;
	jc = 6680.0 + ((double)(jb - 2439870L) - 122.1) / 365.25;
	jd = 365.25 * jc;
	je = (jb - jd) / 30.6001;
	*dd = jb - jd - (short)(30.6001 * je);
	*mm = je - 1;
	if (*mm > 12)
		*mm -= 12;
	*yy = jc - 4715;
	if (*mm > 2)
		--(*yy);
	if (*yy <= 0)
		--(*yy);
} /* days2date */

/* -------------------------------------------------------------------------- */
/*
 * Converts a latitude passed in as DDD.dddddddd to the string
 *
 *    NDD MM.SSSS which is returned by the function.
 *
 *  This routine also sets the elements dla, mla, tnthsla, minla and secla
 *   in the record 'record'.
 */
PROCX char *toDMlat(double a)
{
	static char dm[15];
	double frac, ttt;
	char mm[15];
	double d;

	if(a<0.0) {
		record.ns='S';
		a=fabs(a);
	}
	else    record.ns='N';
	frac=modf(a,&d);
	record.minla=frac*60.0;
	record.secla=60.0*modf(record.minla,&ttt);

	sprintf(mm, "%c%02.0f %07.4f", record.ns, d, record.minla);
	strcpy(dm,mm);
	record.dla=atoi(strtok3(&mm[1]," "));
	record.mla=atoi(strtok3(NULL,"."));
	record.tnthsla=atoi(&mm[7]);
	return dm;
} /* toDMlat */

/* -------------------------------------------------------------------------- */
/*
 * Converts a longitude passed in as DDD.dddddddd to the string
 *
 *    WDDD MM.SSSS which is returned by the function.
 *
 *  This routine also sets the elements dlo, mlo, tnthslo, minlo and seclo
 *   in the record 'record'.
 */
PROCX char *toDMlon(double a)
{
	static char cm[15];
	double frac, ttt;
	char mm[15];
	double d;

	if(a<0.0) {
		record.ew='W';
		a=fabs(a);    
	}
	else      record.ew='E';
	frac=modf(a,&d);
	record.minlo=frac*60.0;
	record.seclo=60.0*modf(record.minlo,&ttt);

	sprintf(mm, "%c%03.0f %07.4f", record.ew, d, record.minlo);
	strcpy(cm,mm);
	record.dlo=atoi(strtok3(&mm[1]," "));
	record.mlo=atoi(strtok3(NULL,"."));
	record.tnthslo=atoi(&mm[8]);
	return cm;
} /* toDMlon */

#if !__BORLANDC__
void delay(long ms)
{
   struct _timeb timebuffer;
   long t1,t2;
   
   _ftime( &timebuffer );
   t1=timebuffer.millitm+timebuffer.time*1000;
   _ftime( &timebuffer );
   t2=timebuffer.millitm+timebuffer.time*1000;
   while((t2-t1)<ms){
		_ftime( &timebuffer );
		t2=timebuffer.millitm+timebuffer.time*1000;
   }
} //sleep()
#endif

/* -------------------------------------------------------------------------- */
/*
 * exits closing COM port if necessary
 */

PROCX void byebye(INT rt)
{
#if __BORLANDC__
	if(com_open) {
		if(doAsyncStat) doasystat();
		AsyncStop(IOaddr);
	}
	if(lx==2) light_sleep(ENABLE);
#else
	if(com_open) {
		if(doAsyncStat) doasystat();
		AsyncStop();
	}
	consoff();
#endif
	if(COMtimeout) fprintf(stderr,"GPS Receiver not responding.\n");
	(void)delay(100);
	if(Gdebug==1) {
			fclose(Gdebug_out);
	}
	fflush(stdout);
	(void)delay(100);
	exit(rt);
} /* byebye */


/* -------------------------------------------------------------------------- */
/*
 * converts string DEGdMMmmmm to deg.decimal
 */
PROCX double mhr(char * tt)
{
	char *p;
	double h,q,m;
	double sign;

	strupr(tt);
	if((h=atof(strtok3(tt,"D")))<0.0) {
		h=fabs(h);
		sign=-1.0;
	}
	else sign=1.0;
	p=strtok3(NULL,"");
	m=atof(p);
	q=sign*(h+m/60.0);
	return q;
} /* mhr */

/* -------------------------------------------------------------------------- */
/*
 * remove interior spaces, make sure all chars are A-Z 0-9 '-'
 */
PROCX void fixname(INT j,unsigned char *name)
{
	unsigned INT i;

	trim((char*)name);
	strupr((char*)name);
	for(i=0;i<strlen((char*)name);i++) {
		if(name[i]==0x0d || name[i]==0x10) name[i]=' ';
		if(name[i]==0x27) name[i]='M';
		if(name[i]==0xb0) name[i]='D';
		if(!j && name[i]==' ') name[i]='-';

		if(!((name[i]>='A' && name[i] <='Z') || 
		     (name[i]>='0' && name[i] <='9') || (name[i]==' '))) name[i]='-';
	}
} /* fixname */

/* -------------------------------------------------------------------------- */
/*
 * trims leading blanks
 */
PROCX char *ltrim(char *s)
{
	register char *p;

	p=s;
	while((*p)==' ') p++;
	strcpy(s,p);
	return(s);
}

/* -------------------------------------------------------------------------- */
/*
 * Strips trailing blanks from the string
 */
PROCX char *rtrim(char *s)
{
	register INT i;

	if(!(i=strlen(s))) return(s);
	i--;
	while((s[i]==' ') && (i>=0)) s[i--]='\0';
	return(s);
}

/* -------------------------------------------------------------------------- */
/*
 * converts the newline character (0x0a) to a NUL (0x00) in a char array
 */
PROCX char *null_newline(char *s)
{
	register INT i;
	if(!(i=strlen(s))) return(s);
	i--;
	while(i>=0) {
		if(s[i]==0x0a) s[i]=0;
		i--;
	}
	return(s);
} /* null_newline */

/* -------------------------------------------------------------------------- */
/*
 * Strips leading and trailing blanks from the string.
 */
PROCX char *trim(char *s)
{
	ltrim(s);
	rtrim(s);
	return(s);
}

/******************************************************************************
 * returns the character position of the substring pat within the string
 *  src if the substring exists, 0 if the substring does not exist.
 *  the first character position is considered to be 1, not 0 which
 *  is the first position within the array.
 */
PROCX INT instr(char *src,char *pat)
{
	register char *s_src, *s_pat;
	INT rt;

	s_src=src;
	s_pat=pat;
	rt=1;
	while(*s_src) {
		while((*s_pat) && (*s_src==*s_pat)) { s_src++; s_pat++; }
		if(!(*s_pat)) return(rt);
		rt++; s_pat=pat; s_src=(++src);
	}
	return(0);
}
/******************************************************************************
 * returns the character position of the substring pat within the string
 *  src if the substring exists, 0 if the substring does not exist.
 *  the first character position is considered to be 1, not 0 which
 *  is the first position within the array.  This is a case comparison ignore
 */
PROCX INT instri(char *s,char *p)
{
    register char *s_src, *s_pat;
    int rt;
    char *patorg,*srcorg,*src, *pat;

    srcorg=src=strdup(s);
    patorg=pat=strdup(p);
    strlwr(pat);
    strlwr(src);
    s_src=src;
    s_pat=pat;
    rt=1;
    while(*s_src) {
        while((*s_pat) && (*s_src==*s_pat)) { s_src++; s_pat++; }
        if(!(*s_pat)) {
            free(srcorg);
            free(patorg);
            return((INT)rt);
        }
        rt++; s_pat=pat; s_src=(++src);
    }
    free(srcorg);
    free(patorg);
    return(0);
} // instri(
/* -------------------------------------------------------------------------- */
PROCX INT decode_month(char *s)
{
	INT i;
	for(i=1;i<13;i++) if(!strcmp(s,months[i])) return(i);
	return(0);
} /* decode_month */

/* -------------------------------------------------------------------------- */
/*01234567890123456789212345678931234567894123456789512345678961234567897123456789812345678*/
//I  N44 35.8936 W123 15.5252 ;    n;
//
//  Used in input and output
//
PROCX void fill_icon(int i,unsigned char *ix,INT convert)
{
	char hold[255];
	char *p;
	double x,y;
	short aa,bb,cc;
	short zone;
	char lstr[50],zl;
	char ahold[20],lhold[20];

	if(i==0) {  // we're preparing this icon for a push_icon call
		strcpy(hold,(char*)ix);
//
// fill record structure from text entry
//
		record.type=hold[0];
		record.icon_smbl=atoi(&hold[29]);

//  01234567890
//  I  10T  455510.3  4929209.1 ;   18;
/*
 * decode latitude/longitude
 */
// DMS
// 012345678911234567892123456789212345678941234567890
//     12345678911  123456789112
// I  N44 30 35.50 W123 35 00.97 ;   18;

// UTM
// 012345678911234567892123456789212345678941234567890
// I  10T  453612.8  4928670.2 ;   18;

// DDD
// 012345678911234567892123456789212345678941234567890
//     1234567890  12345678911
// I  N44.5098617 W123.5836017 ;   18;

// DMM
// 012345678911234567892123456789212345678941234567890
//     1234567890  12345678911
// I  N44 30.5917 W123 35.0161 ;   18;
		switch(DMSMode) {
		    case DMS:
		        aa=4;
				bb=17;
				cc=12;
		        break;
		
		    case DMM:
		    case DDD:
		        aa=4;
				bb=16;
				cc=11;
		        break;
		}
		if(DMSMode!=UTMMODE) {
			strncpy(ahold,&hold[aa],cc-1);
			strncpy(lhold,&hold[bb],cc);
			ahold[cc-1]=0;
			lhold[cc]=0;
			trim(ahold);
			trim(lhold);
			record.ns=hold[aa-1];
			record.ew=hold[bb-1];
		}
	    switch(DMSMode) {
	        case DMS:
	        case DMM:
	            record.la=ReadLatLonVal(ahold);
	            record.lo=ReadLatLonVal(lhold);
	            break;
	        case DDD:
	            record.la=atof(ahold);
	            record.lo=atof(lhold);
	            break;
	        case UTMMODE:
	            strncpy(lstr,(char*)&ix[3],24);
	            zl=ix[5];
	            zone=atoi(strtok(lstr," "));
	            x=atof(strtok(NULL," "));
	            y=atof(strtok(NULL," "));
	            UTMf=UTMf_in;
	            UTMa=UTMa_in;
	            UTMtoDeg(zone,(short)(zl <= 'M'), x, y, &record.la, &record.lo);
	    		set_ns();
	            break;
	    }
		set_sign();
		if(convert) convert_datum(inputdatum);
		return;
	}
//
// it's not a push_icon, it's a flesh out icon call
//
// fill record structure from pushed icon
//
// I;10000;;!44.595748;-123.259272;0;
//
	strcpy(hold,(char*)icon_push[i]);
	p=strtok3(hold,";");
	record.type=p[0];
	datatype=20000+atoi(strtok3(NULL,";"));
	p=strtok3(NULL,"!");
	record.la=atof(strtok3(NULL,";"));
	record.lo=atof(strtok3(NULL,";"));
	set_ns();
	record.icon_smbl=atoi(strtok3(NULL,";"));
	ObjColor=atoi(strtok3(NULL,";"));
	if(convert) convert_datum(outputdatum);
} // void fill_icon

/* -------------------------------------------------------------------------- */
/*
 * Converts a latitude passed in as a double, i.e. DDD.dddddddd to the string
 *
 *    NDD MM SS.ss which is returned by the function.
 *
 */
PROCX char *toDMSlat(double a)
{
    static char dm[15];
    char pb[20];
    double frac;
    double d,m;
    double  secla;

    strcpy(pb,toDMlat(a)); // sets up some items in the RECORD
    if(a<0.0) {
        record.ns='S';
        a=fabs(a);
    }
    else    record.ns='N';
    frac=modf(a,&d);
    minla=frac*60.0;
    secla=60.0*modf(minla,&m);
    switch(DMSMode) {
        case DMS:
            sprintf(dm, "%c%02.0f %02.0f %05.2f", record.ns, d, m, secla);
            break;
        case DMM:
            sprintf(dm, "%s",pb);
            break;
        case DDD:
            sprintf(dm,"%c%010.7f",record.ns,fabs(record.la));
            break;
    }
    return dm;
} /* toDMSlat */
/* -------------------------------------------------------------------------- */
/*
 * Converts a longitude passed in as DDD.dddddddd to the string
 *
 *    WDDD MM.SSSS which is returned by the function.
 *
 */
PROCX char *toDMSlon(double a)
{
    static char cm[15];
    char pb[20];
    double frac;
    double d,m;
    double seclo;

    strcpy(pb,toDMlon(a)); // sets up some items in the RECORD
    if(a<0.0) {
        record.ew='W';
        a=fabs(a);
    }
    else record.ew='E';
    frac=modf(a,&d);
    minlo=frac*60.0;
    seclo=60.0*modf(minlo,&m);
    switch(DMSMode) {
        case DMS:
            sprintf(cm, "%c%03.0f %02.0f %05.2f", record.ew, d, m, seclo);
            break;
        case DMM:
            sprintf(cm, "%s",pb);
            break;
        case DDD:
            sprintf(cm,"%c%011.7f",record.ew,fabs(record.lo));
            break;
    }
    return cm;
} /* toDMSlon */
/* -------------------------------------------------------------------------- */
/*01234567890123456789212345678931234567894123456789512345678961234567897123456789812345678*/
//W  HOME   N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL;a;n;
//P  HOME   N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL;a;n;dist*/
// New:
/*01234567890123456789212345678931234567894123456789512345678961234567897123456789812345678*/
//W  HOME            N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL;a;n;
//P  HOME            N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL;a;n;dist*/
//
// Used in input of text files
//
PROCX void fill_record_from_text(unsigned char *ix,INT convert)
{
	char mm[MAX_LENGTH],bf[MAX_LENGTH],*p;
	time_t t;
	double x,y;
	short zone;
	int aa,bb,cc;
	char ahold[20],lhold[20];
	char lstr[50],zl;

	record.type=ix[0];
	if((ix[0]=='N') || (ix[0]=='R') || (ix[0]=='E')) {
	 	record.comment[0]=record.ident[0]=0;
		return;
	}
	if(ix[0]=='I') {
		fill_icon(0,ix,1);
		return;
	}
    if(DMSMode==DMS) {
        aa=2;
        bb=1;
		cc=12;
    }
    else {
        aa=bb=0;
		cc=11;
    }
//
// Check for text files previous to version 3.03
//
	if(((ix[10] == 'N')||(ix[10]=='S')) && ix[16]=='.' && ix[29] == '.') {
		memset(bf,' ',MAX_LENGTH);
		memcpy((char*)bf,(char*)ix,9);
		bf[19]=0;
		strcat(bf,(char*)&ix[10]);
		strcpy((char*)ix,bf);
	}
	strncpy(record.datetime,(char*)&ix[44],24);
	record.datetime[24]=0;
/*
 * adjust Track ascii record 
 */
	if(ix[0]=='T') {
		sprintf(mm,"T                  %s",(char*)&ix[3]);
	}
	else strcpy(mm,(char*)ix);
	if(strlen(mm) <= (44+aa)) {
		t=time(NULL);
		mm[43+aa]=0;
		strcat(mm,null_newline(ctime(&t)));
	}
	strncpy((char*)record.ident,(char*)&mm[3],15);
	record.ident[15]=0;
	strcpy(record.comment," ");
	if(strlen((char*)mm)>(69+aa)) {
		strcpy(bf,(char*)&mm[69+aa]);
		strncpy(record.comment,strtok3(bf,";"),40);
	}
	if(mm[0]=='P') {
//
// A ';' indicates that the record has icon_smbl and icon_dspl
//
// P  HWY-34          N44 33.8269 W123 14.1090 Wed May 28 17:44:04 1997 HWY 34 - PEORIA ;p;n;dist
		if((p=strchr(mm,';')) != NULL) {
			strncpy(bf,++p,49);  // skip over leading ';'
			record.icon_smbl=atoi(strtok3(bf,";"));
			record.icon_dspl=atoi(strtok3(NULL,";"));
			record.ProxDist=atoi(strtok3(NULL,";"));
		}
	}
	if(strncpy(record.datetime,(char*)&mm[44+aa],24));
	record.datetime[24]=0;
/*
 * get month, day, year, hours, minutes
 */
	datetime2record(record.datetime);
/*
 * decode latitude/longitude
 */
    strncpy(ahold,&mm[20],cc);
    strncpy(lhold,&mm[32+bb],cc+1);
    trim(ahold);
    trim(lhold);
    ahold[cc-1]=0;
    lhold[cc]=0;
    record.ns=mm[19];
    record.ew=mm[31+bb];
    switch(DMSMode) {
        case DMS:
        case DMM:
            x=record.la=ReadLatLonVal(ahold);
            y=record.lo=ReadLatLonVal(lhold);
            break;
        case DDD:
            record.la=atof(ahold);
            record.lo=atof(lhold);
            break;
        case UTMMODE:
            strncpy(lstr,&mm[19],24);
            zl=mm[21];
            zone=atoi(strtok(lstr," "));
            x=atof(strtok(NULL," "));
            y=atof(strtok(NULL," "));
            UTMf=UTMf_in;
            UTMa=UTMa_in;
            UTMtoDeg(zone,(short)(zl <= 'M'), x, y, &record.la, &record.lo);
            set_ns();
            break;
    }
    set_sign();
    toDMSlat(record.la);
    toDMSlon(record.lo);
#if 0
/*
 * decode latitude
 */
//  012345678911234567892123456
//  T  10T  453934.7  4928367.8 Mon Dec 14 22:46:41 1998
//  012345678911234567892123456
//  10T  453934.7  4928367.8 Mon Dec 14 22:46:41 1998

 	if(mm[19]!='N' && mm[19]!='S') { // must be UTM input format
		strncpy(lstr,&mm[19],24);
		zl=mm[21];
		zone=atoi(strtok(lstr," "));
		x=atof(strtok(NULL," "));
		y=atof(strtok(NULL," "));
		UTMf=UTMf_in;
		UTMa=UTMa_in;
		UTMtoDeg(zone,(short)(zl <= 'M'), x, y, &record.la, &record.lo);
		set_ns();
	}
	else {
		p=(char*)&mm[20];
		record.dla=atoi(strtok3(p," "));
		record.mla=atoi(strtok3(NULL,". "));
		record.tnthsla=atoi(strtok3(NULL," "));
		record.minla=(double)record.mla+record.tnthsla/10000.0;
		record.secla=(double)record.tnthsla*60.0/10000.0;
		record.la=(double)record.dla+record.minla/60.0;
		record.ns=mm[19];
/*
 * decode longitude
 */
/*01234567890123456789212345678931234567894123456789512345678961234567897123456789812345678*/
//W  HOME            N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL;a;n;
//P  HOME            N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL;a;n;dist*/
	
		p=(char*)&mm[32];
		record.dlo=atoi(strtok3(p," "));
		record.mlo=atoi(strtok3(NULL,". "));
		record.tnthslo=atoi(strtok3(NULL," "));
		record.minlo=(double)record.mlo+record.tnthslo/10000.0;
		record.seclo=(double)record.tnthslo*60.0/10000.0;
		record.lo=(double)record.dlo+record.minlo/60.0;
		record.ew=mm[31];
		set_sign();
	}
#endif 
//
// data conversion, i.e. is the input in WGS-84? if not, convert to WGS-84
//
	if(convert) convert_datum(inputdatum);
	if(strlen((char*)ix) > 86) {
		strcpy(mm,(char*)&ix[86]);
	}
} /* fill_record_from_text */

/* -------------------------------------------------------------------------- */
/* D  100	WGS 84  */
/*01234567890123456789...*/
/*R  01 ANYTOWN OR  */
PROCX void decode_route_start(unsigned char *ix)
{
	char in[150];
	strcpy(in,(char*)ix);
	if((in[0] != 'R') || (in[1] != ' ') || (in[2] != ' ')) return;
	if(strlen(in)>6) 
		strcpy(route_comment,(char*)&in[6]);
	else
		strcpy(route_comment," ");
	strcpy(record.comment,route_comment);
	in_route=1;
	strcpy(rtn,strtok3((char*)&in[3]," "));
	route_number=atoi(rtn);
	strcpy(record.ident,rtn);
	route_point=0;
} /* decode_route_start */

/* -------------------------------------------------------------------------- */
PROCX void print_g64_w()
{
//	fixname(0,(BYTE *)record.ident);
	record.comment[20]=0;
	if(in_route) {
		fprintf(out,"%#02d ",route_number);
	}
      fprintf(out,"%-6s %#03d%c%06.3lf%c%c %#03d%c%06.3lf%c%c %#02d-%#02d-%#02d %#02d:%#02d %-16s",
      record.ident, record.dla,0xb0,record.minla,0x27,record.ns,
      record.dlo,0xb0,record.minlo,0x27,record.ew,record.year-1900,
      record.monthn,record.dayofmonth, record.ht,record.mt,record.comment);
      if(in_route) fprintf(out," %-20s",route_comment);
      fprintf(out,"\n");
} /* print_g64_w */

/* -------------------------------------------------------------------------- */
PROCX void print_g64_t()
{
	fprintf(out,"%#03d%c%06.3lf%c%c %#03d%c%06.3lf%c%c %#02d-%#02d-%#02d %#02d:%#02d\n",
	  record.dla,0xb0,record.minla,0x27,record.ns,
	  record.dlo,0xb0,record.minlo,0x27,record.ew,record.year-1900,
	  record.monthn,record.dayofmonth,record.ht,record.mt);
} /* print_g64_t */

/* -------------------------------------------------------------------------- */
//
// convert from a SA4/5 object number to the internal icon
//
PROCX INT from_sa3object(BYTE val)
{
	INT i;
	if(default_GM2_icon!=-1 && default_SA52_icon == val) {
		return(default_GM2_icon);
	}

	i=0;
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].SA==val) return Garmin_Symbol_Table[i].Garmin;
		i++;
	}
	return default_Garmin_icon;
} // from_sa3object()

/* -------------------------------------------------------------------------- */
//
// convert from the internal icon number to the SA4/5 object number
//
PROCX BYTE to_sa3object(INT val)
{
	INT i,j;

	if(val == default_GM2_icon && default_SA52_icon!=-1) {
		return(default_SA52_icon);
	}

	i=0;
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].Garmin==val) {
				j=Garmin_Symbol_Table[i].SA;
				if(j>=0) return j;
				return default_SA5_icon;
		}
		i++;
	}
	return default_SA5_icon;
} // to_saeobject()

/* -------------------------------------------------------------------------- */
// struct SA_gpl_record {
//	unsigned long status;
//	unsigned long dummy;
//	double        latitude;
//	double        longitude;
//	double        altitude;
//	double        heading;
//	double        speed;
//	unsigned long time;  	// in <time.h format
//	unsigned long dummy3;
//} SA_gpl_record;

PROCX void read_GPL(void)
{

	while(fread(&SA_gpl_record,56,1,in)) {
		record.class = 255;  // default to 'user'
		record.la=SA_gpl_record.latitude;
		record.lo=SA_gpl_record.longitude;
		set_ns();
		strcpy(record.datetime, 
			null_newline(
			ctime(
			(time_t*)&SA_gpl_record.time)));

		memset(bin,0,MAX_LENGTH);

		sprintf((char*)bin,"%c  %s %s %s", 'T',toDMlat(record.la), toDMlon(record.lo), record.datetime);
		valid_records++;
		push_record((char*)bin,0);
	}
	fclose(in);
	
} // read_GPL 

/* -------------------------------------------------------------------------- */
// struct SA_gpl_record {
//	unsigned long status;
//	unsigned long dummy;
//	double        latitude;
//	double        longitude;
//	double        altitude;
//	double        heading;
//	double        speed;
//	unsigned long time;  	// in <time.h format
//	unsigned long dummy3;
//} SA_gpl_record;

PROCX void output_GPL()
{
	unsigned INT i;

	if(open_output("wb")==0) return;

	for(i=1;i<=tracks;i++) {
			fill_track(i,0);
			SA_gpl_record.status = 3L;
			SA_gpl_record.dummy = 0L;
			SA_gpl_record.latitude = record.la;
			SA_gpl_record.longitude = record.lo;
			SA_gpl_record.altitude = 0.0;
			SA_gpl_record.heading = 0.0;
			SA_gpl_record.speed = 0.0;
			SA_gpl_record.time = dt2secs((short)gPrefs.offset) + 631065600L;
			SA_gpl_record.dummy3 = 0L;

			fwrite(&SA_gpl_record,56,1,out);
	}
	fclose(out);
} // output_GPL

/* -------------------------------------------------------------------------- */
PROCX void set_params()
{
	sa3symbol.TextAlign=TextAlign;
	sa3symbol.TextColor=TextColor;
	sa3symbol.ObjColor=ObjColor;
	sa3symbol.ObjCode=ObjCode;
	sa3symbol.ObjSize=ObjSize;
	sa3symbol.TextSize=TextSize;
	sa4mapline.LineColor=LineColor;
	sa4mapline.LineStyle=LineStyle;
	sa4mapline.LineWidth=LineWidth;
	sa4mapcircle.area_draw_line=CirLineDraw;
	sa4mapcircle.area_draw_fill=CirFillArea;
	sa4mapcircle.LineColor=CirLineColor;
	sa4mapcircle.LineWidth=CirLineWidth;
	sa4mapcircle.area_fill_color=CirFillColor;
	sa4mapcircle.area_fill_style=CirFillStyle;
} /* set_params */

/* -------------------------------------------------------------------------- */
/*
 *  process an input command line
 */
PROCX void do_command(unsigned char *b)
{
	INT i,j;
	char *p;
	char *argv[40];  /* allow 40 elements on the command line */
    char *opts="aAb:B:c:C:dDeEm:j:J:kKlLM:nNp:P:q:Q:r:R:sSt:T:vVw:W:";

	opterr=0;
	p=strtok((char*)b," \t");
	if((argv[0]=malloc(strlen(p)+2)) == NULL) oomem("do_command");
	strcpy(argv[0],p);
	i=1;	
	while (p!=NULL) {
		if((p=strtok(NULL," \t")) == NULL) break;
		if((argv[i]=malloc(strlen(p)+2)) == NULL) oomem("do_command1");
		strcpy(argv[i],p);
		i++;
	}
	optind=1;
	while ((optchar=getopt(i,argv,opts)) != -1) {
	     switch(optchar) {

			case 'a':
			case 'A':	tmode++; output++; break;

			case 'b':
			case 'B':	strupr(optarg);
						if(optarg[0]=='Y') {
							draw_route_1_19_lines=1;
							draw_route_0_line=1;
							draw_track_lines=1;
							draw_waypoints=1;
							draw_prox_circles=1;
							draw_route_1_19_obj=1;
							draw_route_0=1;
							draw_route_0_obj=1;
							break;
						}
						if(optarg[0]=='N') {
							draw_route_1_19_lines=0;
							draw_route_0_line=0;
							draw_track_lines=0;
							draw_waypoints=0;
							draw_prox_circles=0;
							draw_route_1_19_obj=0;
							draw_route_0=0;
							draw_route_0_obj=0;
							break;
						}
						Usage(23);
						break;

			case 'c':
			case 'C':	if(setlat==1000.0) setlat=mhr(optarg);
						else setlon=mhr(optarg);
						break;
		
			case 'd':
			case 'D':	total_dist++; break;

			case 'e':
			case 'E':	nocmdline=1; break;
				
			case 'j':
			case 'J':  	nameonlytxt=atoi(optarg); break;

			case 'l':
			case 'L':	SendLowrInactives++; break;

			case 'm':
			case 'M':	setmag=atoi(optarg); break;

			case 'n':
			case 'N':  	noname++; break;

			case 'q':
			case 'Q':  	nameonly=atoi(optarg); 
						break;
				
			case 'p':
			case 'P':	set_circle_parms(); break;

			case 'r':
			case 'R':	set_line_parms(1); break;

			case 's':
			case 'S':	nosort=1; break;

			case 't':
			case 'T':	set_line_parms(0); break;
	
			case 'v':
			case 'V':	
#if __BORLANDC__
						doAsyncStat++; break;
#else
						fprintf(stderr,"Not valid under windows version\n");
						break;
#endif

			case 'w':
			case 'W':   set_symbol_parms(); break;

	     }
	}
	for(j=0;j<i;j++) free(argv[j]);
	set_params();
	opterr=1;
} /* do_command */

/* -------------------------------------------------------------------------- */


/*
ATHENS 03754.800'N 02342.200'E 95-08-27 16:50 KALAMAKI MARINA                          05.0
0123456789012345678921234567893123456789412345678951234567896123456789712345
045x40.753'N 013x44.395'E 94-10-09 08:04

0123456789012345678921234567893123456789412345678951234567896123456789712345
1ST-B  044x34.000'N 123x16.030'W 95-12-07 03:55 07-DEC-95 03:55

0123456789012345678921234567893123456789412345678951234567896123456789712345
YAQUIN 044x40.522'N 124x04.605'W 97-05-28 20:44 YAQUINA-HEAD    

0123456789012345678921234567893123456789412345678951234567896123456789712345
00 HW138  043x12.901'N 123x21.405'W 97-05-28 20:44 ROSEBURG HWY183  ROSEBURG TO WINSTON 

0123456789012345678921234567893123456789412345678951234567896123456789712345
W  YAQHED N44 40.5217 W124 04.6048 Mon Mar 25 15:28:04 1996 YAQUINA HEAD
*/
PROCX void convert_g64(unsigned char *in)
{
	unsigned char bx[MAX_LENGTH];
	char rc[4];
	INT i,offset=0;
	INT mm,dd,yy;

	memset(bx,0,MAX_LENGTH);
	i=strlen((char*)in);

	if(in[ 3]==0xb0) offset=0;	// track point
	if(in[10]==0xb0) offset=7;	// normal waypoint
	if(in[13]==0xb0) offset=10;	// route waypoint

	if(offset==10) {
		strncpy(rc,(char*)in,3);
		rc[3]=0;
		route_number=atoi(rc);
		strncpy(route_comment,(char*)&in[68],39);
		trim(route_comment);
		in_route=1;
	}
	else in_route=0;

	if(offset) {
		strcpy((char*)bx,"W  ");
		if(offset==7) strncat((char*)bx,(char*)(in),6);
		if(offset==10) strncat((char*)bx,(char*)(in+3),6);
	}
	else strcpy((char*)bx,"T        ");
	strcat((char*)bx," ");
	bx[10]=in[offset+11];
	strncat((char*)bx,(char*)(in+offset+1),10);

	bx[13]=' '; bx[20]='0';
	bx[21]=' '; bx[22]=in[offset+24];
	strncat((char*)bx,(char*)(in+offset+13),11);
	bx[26]=' '; bx[33]='0'; bx[34]=' ';
	yy=atoi(strtok3((char*)(in+offset+26),"-"));
	mm=atoi(strtok3(NULL,"-"));
	dd=atoi(strtok3(NULL," "));
	strcat((char*)bx,days[dow(dd,mm,yy)]);
	strcat((char*)bx," ");
	strcat((char*)bx,months[mm]);
	strcat((char*)bx," ");
	strncat((char*)bx,(char*)(in+offset+32),2);  /* day */
	strcat((char*)bx," ");
	strncat((char*)bx,(char*)(in+offset+35),5);  /* hr:mm */
	strcat((char*)bx,":00 19");
	strncat((char*)bx,(char*)(in+offset+26),2);
	if(offset && i>50) strcat((char*)bx,(char*)(in+47+(offset-7)));
	if(bx[0]=='T') strcpy((char*)(bx+3),(char*)(bx+10));
	strcpy((char*)in,(char*)bx);
	trim((char*)in);
} /* convert_g64 */

/* -------------------------------------------------------------------------- */
PROCX void cont_line(BYTE *bin)
{
	char *p;
	INT i;

	switch(bin[1]) {
		case '1':
				datatype=105;
				if(strlen((char*)bin)>3)
					strcpy((char*)StreetPilotWptName,(char*)&bin[3]);
				else
					StreetPilotWptName[0]=0;
				break;
		case '2':
				datatype=106;
				if(strlen((char*)bin)>3)
					strcpy((char*)StreetPilotLnk_ident,(char*)&bin[3]);
				else
					StreetPilotLnk_ident[0]=0;
				break;
				
		case '3':
				if(strlen((char*)bin)<20) {
					fprintf(stderr,"c3 line error: %s\n",bin);
					byebye(9);
				}
				datatype=106;
				p=(char*)&bin[3];
				p=strtok3(p," ");
				if(p==NULL) {
					fprintf(stderr,"c3 line error: %s\n",bin);
					byebye(9);
				}
				record.class=htoi(p);
				for(i=0;i<13;i++) {
					p=strtok3(NULL," ");
					if(p==NULL) {
						fprintf(stderr,"c3 line error: %s\n",bin);
						byebye(9);
					}
					record.subclass[i]=htoi(p);
				}
				break;
		case '4':
				strcpy(record.name,strtok3((char*)&bin[3],";"));
				strcpy(record.city,strtok3(NULL,";"));
				strcpy(record.state,strtok3(NULL,";"));
				strcpy(record.cc,strtok3(NULL,";"));
				record.class = atoi(strtok3(NULL,";"));
				datatype = atoi(strtok3(NULL,";"));
				break;
	} // switch(bin[1])
	return;
} // cont_line(BYTE *bin)

/* -------------------------------------------------------------------------- */
PROCX void set_record_icon(void)
{
	record.icon_smbl=default_Garmin_icon;
	record.icon_dspl=1;
} /* set_record_icon */

/* -------------------------------------------------------------------------- */
PROCX void read_text(void)
{
	INT c,i,done=0,done2=0;
	char qq;
	BYTE b2[MAX_LENGTH];

	NoM=1;
	DMSMode=DMM;
	trk_seg=0;
	symb=NONE;
	while(!done) {
		record.class = 255;							// default to 'user' class
		if(fgets((char*)bin,MAX_LENGTH,in)==NULL) {
			done=1;
			break;
		}
		null_newline((char*)bin);
		if(strchr("0123456789",bin[0]) != NULL) goto dr; // assume g64
		if(strchr("DMNPWREIT!",bin[0]) == NULL) continue;  // assume comment
		trim((char*)bin);
		if(strlen((char*)bin)<2) continue;
		if(bin[0]=='!') {
			do_command(bin);
			continue;
		}
		i=strlen((char*)bin);
//
// Mode switch?
//
        if(bin[0]=='M') { // dms mode selector
			NoM=0;
            p=strtok3((char*)bin," ");
            p=strtok3(NULL,"");
            trim(p);
            if(instri(p,"UTM") ==1 ) {
                DMSMode=UTMMODE;
                continue;
            }
            if(instri(p,"DMS") ==1 ) {
                DMSMode=DMS;
                continue;
            }
            if(instri(p,"DMM") ==1 ) {
                DMSMode=DMM;
                continue;
            }
            if(instri(p,"DDD") ==1 ) {
                DMSMode=DDD;
                continue;
            }
            continue;
        }
//
// check next line for a continuation line
//
		D105orD106=0;
		if(bin[0]=='W') {
			done2=0;
			while(!done2) {
				c=fgetc(in);
				ungetc(c,in);
				if(c==EOF) goto dr;
//
// Command lines and valid data records end the possibility it is a continuation line
//
				if(strchr("!DNPWREIT",c) != NULL) goto dr;
//
// skip comments
//
				if(c!='c') {
					fgets((char*)b2,MAX_LENGTH,in);
					continue;
				}
//
// we have a continuation line
//
				fgets((char*)b2,MAX_LENGTH,in);
				null_newline((char*)b2);
				trim((char*)b2);
				if(b2[1]!='4') D105orD106=1;
				cont_line(b2);
			} // while(!done2)
		} //if(bin[0]=='W')
dr:;
/*
 * strip gardown trailers from waypoints
 */
		if(bin[i-1]==0xff || bin[i-1]==0x7f) bin[i-1]=0;
		if(!strlen((char*)bin)) continue;
		if(i>26) {
			if((bin[3] ==0xb0 && bin[16]==0xb0) ||
			   (bin[10]==0xb0 && bin[23]==0xb0) ||
			   (bin[13]==0xb0 && bin[26]==0xb0)) convert_g64(bin);
		}
		if(bin[0]!='N' && bin[0]!='D') {
			if(bin[1]!=' ') continue;
			if(bin[2]!=' ') continue;
		}
		valid_records++;
		set_record_icon();
//
// Check to see if this is a file with UTM but without the 'M UTM' line.  If so, set mode to UTM
//   this will only be done if the DMSMode is still the default, i.e. DMM
//
		if((DMSMode == DMM) && (NoM==1)) {
			switch(bin[0]) {
				case 'W':
				case 'P':
					qq = bin[19];
					if(qq == 'N' || qq == 'S') break;
					qq = bin[10];
					if(qq == 'N' || qq == 'S') break;
					DMSMode=UTMMODE;
					break;

				case 'T':
				case 'I':
					qq = bin[3];
					if(qq != 'N' && qq !='S') DMSMode=UTMMODE;
			}
		}
		push_record((char*)bin,1);
	} while(!done)
	fclose(in);
} /* read_text */

/* -------------------------------------------------------------------------- */
//  Waypoint format:
//  name, comment, lat (s is -), long (w is -), mm/dd/yy hh:mm:ss AM/PM
//
// 001,,44.66204,-123.25742,9/22/97 8:49:00 PM
//
PROCX void read_FUGAWI_wpt()
{
	char b[MAX_LENGTH],rest[MAX_LENGTH];

	while(fgets((char*)bin,MAX_LENGTH,in) != NULL) {
		record.class = 255;  // default to 'user'
		null_newline((char*)bin);
		trim((char*)bin);
		strcpy(b,strtok3((char*)bin,","));
		trim(b);
		b[15]=0;
		strcpy(record.ident,b);
		strncpy(b,strtok3(NULL,","),MAX_LENGTH); // to end of comment
		strncpy(rest,strtok3(NULL,"!"),MAX_LENGTH);
		set_record_icon();
		p=strtok3(b,";");
		if(p!=NULL) {
			strncpy(record.comment,p,40);
			p=strtok3(NULL,";");
			if(p!=NULL) {
				record.icon_smbl=atoi(p);
				p=strtok3(NULL,";");
				if(p!=NULL) record.icon_dspl=atoi(p);
			}
		}
		else
			strcpy(record.comment," ");
		record.la=atof(strtok3(rest,","));
		record.lo=atof(strtok3(NULL,","));
		set_ns();
		memset(bin,0,MAX_LENGTH);
		sprintf((char*)bin,"%c  %-15s %s %s %s %s;%d;%d",
			'W',record.ident,toDMlat(record.la), toDMlon(record.lo),
			record.datetime,record.comment,record.icon_smbl,
			record.icon_dspl);
		valid_records++;
		push_record((char*)bin,0);
	}
	fclose(in);
} /* read_FUGAWI_wpt */

/* -------------------------------------------------------------------------- */
//
//  Waypoint format:
//  name, comment, lat (s is -), long (w is -), mm/dd/yy hh:mm:ss AM/PM
//
// 001,,44.66204,-123.25742,9/22/97 8:49:00 PM
//
PROCX void output_FUGAWI_wpt()
{
	int i,ht;
	char b[30],c[30],ampm[3];

	if(open_output("w")==0) return;

	for(i=1;i<=waypoints;i++) {
			fill_waypoint_from_push(i,NORMAL_WP,0);
			datetime2record(record.datetime);
			if(record.ht>12) {
				ht=record.ht-12;
				strcpy(ampm,"PM");
			}
			else {
				ht=record.ht;
				strcpy(ampm,"AM");
			}
			sprintf(b,"%lf",record.la);
			strip_tr_0(b);
			sprintf(c,"%lf",record.lo);
			strip_tr_0(c);
			fprintf(out,"%s,%s;%d;%d,%s,%s,%d/%02d/%02d %d:%02d:%02d %s\n",
					    record.ident, record.comment, record.icon_smbl,
						record.icon_dspl,b,c,
				record.monthn, record.dayofmonth,record.year-1900,
				ht, record.mt, record.st, ampm);
	}
} /* output_FUGAWI_wpt */

/* -------------------------------------------------------------------------- */
struct fugawi_trk {
	double la;				//  8 bytes
	double lo;				//  8 bytes
	double days;			//  8 bytes -- days since 12/31/1899
	long m1;				//  4 bytes
	unsigned char newt;		//  1 byte
};

struct fugawi_trk fug_trk;

PROCX void read_FUGAWI_trk()
{
	double seconds;
	time_t t;
	struct tm *gmt;

//
// fug_trk->days holds fractional days since 0000
//
	while(fread(&fug_trk,29,1,in)) {
//
// 719163.0 is offset to convert fug_trk->days days to
//   days since 1970 so the asctime(gmt) works
//   with the unix version time routines in BCC
//
		seconds=(fug_trk.days-719163.0)*86400.0;
		t = (long)(seconds+.01);  // the .01 takes care of the trunc problem
		gmt = gmtime(&t);
		record.la = fug_trk.la;
		record.lo = fug_trk.lo;
		strcpy(record.datetime,asctime(gmt));
		record.datetime[24]=0;
		memset(bin,0,MAX_LENGTH);
		sprintf((char*)bin,"%c  %s %s %s %-20s",
			'T',toDMlat(record.la), toDMlon(record.lo),
			record.datetime," ");
		valid_records++;
		if(fug_trk.newt==1) bin[0]='N';
		trim((char*)bin);
		push_record((char*)bin,0);
	}
	fclose(in);
} /* read_FUGAWI_trk */

//struct fugawi_trk {
//	double la;				//  8 bytes
//	double lo;				//  8 bytes
//	double days;			//  8 bytes -- days since 12/31/1899
//	long m1;				//  4 bytes
//	unsigned char newt;		//  1 byte
//};

/* -------------------------------------------------------------------------- */
PROCX void output_FUGAWI_trk()
{
	unsigned INT i;
	long t;

	if(open_output("wb")==0) return;

	for(i=1;i<=tracks;i++) {
			fill_track(i,0); // also sets chch
			t=dt2secs((short)gPrefs.offset) + 631065600L;
			fug_trk.days = (double)t/86400.0+719163.0;
			fug_trk.la=record.la;
			fug_trk.lo=record.lo;
			if(chch == 'T')
				fug_trk.newt=0;
			else
				fug_trk.newt=1;
			fug_trk.m1=-10000000L;
			fwrite(&fug_trk,29,1,out);
	}
	fclose(out);
} /* output_FUGAWI_trk */

PROCX void read_CSV(void)
{
	char b[MAX_LENGTH],Datum[100],*p;
	short zone;
	char zl;
	double x,y;

	while(fgets(b,MAX_LENGTH,in) != NULL) {
		record.class = 255;  // default to 'user'
		null_newline(b);
		trim(b);
		strupr(b);
//Datum:,WGS-84
		if(b[0]=='D') { // Datum line
			strtok3(b,",");
			strcpy(Datum,strtok3(NULL,","));
			memset((char*)bin,0,MAX_LENGTH);
			sprintf((char*)bin,"D  %s",Datum);
			push_record((char*)bin,0);
			continue;
		}
// Lat/Long:
//W,126TRN,44.42130300,-122.00185300,8,16,1998,21,16,15,HWY 20-126,18,2

// UTM:
//W,003,10,T,460251.1,4927530.7,8,16,1998,21,16,15,TEST POINT,18,2
		if(b[0]=='W') { // Waypoint line
			record.type='W';
			strtok3(b,",");							// skip "W",
			strcpy(record.ident,strtok3(NULL,","));
			p=strtok3(NULL,",");
			if(strlen(p)==2) {				// UTM
				zone=atoi(p);
				p=strtok3(NULL,",");
				zl=p[0];
				x=atof(strtok3(NULL,","));
				y=atof(strtok3(NULL,","));
				UTMf=UTMf_in;
				UTMa=UTMa_in;
				UTMtoDeg(zone,(short)(zl <= 'M'), x, y, &record.la, &record.lo);
			}
			else {
				record.la=atof(p);						// lat
				record.lo=atof(strtok3(NULL,","));		// lo
			}
			record.monthn=atoi(strtok3(NULL,","));		// monthn
			record.dayofmonth=atoi(strtok3(NULL,","));	// dayofmonth
			record.year=atoi(strtok3(NULL,","));		// year
			record.ht=atoi(strtok3(NULL,","));
			record.mt=atoi(strtok3(NULL,","));
			record.st=atoi(strtok3(NULL,","));
			strcpy(record.comment,strtok3(NULL,","));
			record.icon_smbl=atoi(strtok3(NULL,","));
			record.icon_dspl=atoi(strtok3(NULL,","));
			set_datetime();
			set_ns();
			convert_datum(inputdatum);
			sprintf((char*)bin,"W  %-15s %s %s %s %s;%d;%d",
				record.ident,toDMlat(record.la), toDMlon(record.lo),
				record.datetime,record.comment,record.icon_smbl,
				record.icon_dspl);
			valid_records++;
			push_record((char*)bin,0);
			continue;
		} // if waypoint
// Lat/Long:
// I,,44.51483200,-123.55977700,18

// UTM:
// I,,10,T,453512.8,4928362.8,18
		if(b[0]=='I') { // Icon
			record.type='I';
			strtok3(b,",");
			strtok3(NULL,",");
			p=strtok3(NULL,",");
			if(strlen(p)==2) {				// UTM
				zone=atoi(p);
				p=strtok3(NULL,",");
				zl=p[0];
				x=atof(strtok3(NULL,","));
				y=atof(strtok3(NULL,","));
				UTMf=UTMf_in;
				UTMa=UTMa_in;
				UTMtoDeg(zone,(short)(zl <= 'M'), x, y, &record.la, &record.lo);
			}
			else {
				record.la=atof(p);
				record.lo=atof(strtok3(NULL,","));
			}
			record.icon_smbl=atoi(strtok3(NULL,","));
			set_ns();
			convert_datum(inputdatum);
			sprintf((char*)bin,"I  %s %s ;%5d", toDMlat(record.la), toDMlon(record.lo),
					record.icon_smbl);
			push_record((char*)bin,0);
			continue;
		}
// Lat/Long:
// T,,44.50744700,-123.57912800,12,14,1998,22,46,41,
// N,,44.50744700,-123.57912800,12,14,1998,22,46,41,

// UTM:
// T,,10,T,453966.5,4928399.5,12,14,1998,22,46,41,
// N,,10,T,453966.5,4928399.5,12,14,1998,22,46,41,
		if(b[0]=='T' || b[0]=='N') { // Plot trail
			if(b[0]=='N') {
				strcpy((char*)bin,"N  New Track Start");
				push_record((char*)bin,0);
			}
			record.type=b[1];
			strtok3(b,",");					// N or T
			strtok3(NULL,",");				// ,
			p=strtok3(NULL,",");			// zone
			if(strlen(p)==2) {				// UTM
				zone=atoi(p);
				p=strtok3(NULL,",");
				zl=p[0];
				x=atof(strtok3(NULL,","));
				y=atof(strtok3(NULL,","));
				UTMf=UTMf_in;
				UTMa=UTMa_in;
				UTMtoDeg(zone,(short)(zl <= 'M'), x, y, &record.la, &record.lo);
			}
			else {
				record.la=atof(p);
				record.lo=atof(strtok3(NULL,","));
			}
			record.monthn=atoi(strtok3(NULL,","));
			record.dayofmonth=atoi(strtok3(NULL,","));
			record.year=atoi(strtok3(NULL,","));
			record.ht=atoi(strtok3(NULL,","));
			record.mt=atoi(strtok3(NULL,","));
			record.st=atoi(strtok3(NULL,","));
			set_datetime();
			set_ns();
			convert_datum(inputdatum);
			memset((char*)bin,0,MAX_LENGTH);
			sprintf((char*)bin,"T  %s %s %s s;",
				toDMlat(record.la), toDMlon(record.lo), record.datetime);
			push_record((char*)bin,0);
			valid_records++;
		}
	} // while
	fclose(in);
} // read_CSV

/* -------------------------------------------------------------------------- */
//  Waypoint format:
//
//Datum,WGS 84
//WP,D,name, lat (s is -), long (w is -),mm/dd/yy,hh:mm:ss,comment,A,N
//
// example:
//
//WP,D,HOME         ,  44.598027,-123.258666,05/05/1998,16:04:46,HOME WAYPOINT,A,N
//
// The 'A' is an index into the waypoint symbol table.  The 'N' is the symbol display type.
//
//
PROCX void read_OZI_evt()
{
	char b[MAX_LENGTH];
	long fg;


	fgets((char*)bin,MAX_LENGTH,in); // OziExplorer Event File Version 1.0
	fgets((char*)bin,MAX_LENGTH,in); // WGS 84
	fgets((char*)bin,MAX_LENGTH,in); // Reserved 2
	fgets((char*)bin,MAX_LENGTH,in); // Reserved 3 

	while(fgets((char*)bin,MAX_LENGTH,in) != NULL) {
		null_newline((char*)bin);
		trim((char*)bin);
		strupr((char*)bin);
		strcpy(b,strtok3((char*)bin,",")); // skip #
		set_record_icon();
		record.la=atof(strtok3(NULL,",")); // get latitude
		record.lo=atof(strtok3(NULL,",")); // get longitude
		set_ns();
		record.icon_smbl=atoi(strtok3(NULL,","));// get symbol
		if(Ozi_to_12==1) {
			record.icon_smbl=convert_Ozi_to_12XL(record.icon_smbl);
		}
		else {
			record.icon_smbl=convert_Ozi_to_Garmin(record.icon_smbl);
		}
		strtok3(NULL,",");			// skip MapDisplay Format
		fg=atol(strtok3(NULL,","));			// get foreground color

		ObjColor=0;
		if(fg==0L) 			ObjColor=0;	// Black
		else if(fg==0xffL)		ObjColor=1;	// Red
		else if(fg==0xff0000L)	ObjColor=2;	// Blue
		else if(fg==0x8000L)		ObjColor=3;	// Green
		else if(fg==0xffffL)		ObjColor=4;	// Yellow

		sprintf((char*)bin,"%c  %s %s;%5d;",
			'I',toDMlat(record.la), toDMlon(record.lo), record.icon_smbl);
		valid_records++;
		push_record((char*)bin,0);
	}
	fclose(in);
} /* read_OZI_evt */

/* -------------------------------------------------------------------------- */
//
PROCX void read_OZI_wpt()
{
	char b[MAX_LENGTH],rest[MAX_LENGTH];
	unsigned char *p;
	INT dsp;
	long t;
	double ozitime;
	struct tm *gmt;

	fgets((char*)bin,MAX_LENGTH,in); // skip OziExp file version
	fgets((char*)bin,MAX_LENGTH,in); // skip Datum
	fgets((char*)bin,MAX_LENGTH,in); // skip Reserved 2
	fgets((char*)bin,MAX_LENGTH,in); // skip Reserved 2

	while(fgets((char*)bin,MAX_LENGTH,in) != NULL) {
		record.class = 255;  // default to 'user'
		null_newline((char*)bin);
		trim((char*)bin);
		strupr((char*)bin);
		strcpy(b,strtok3((char*)bin,",")); // skip WP #
		strcpy(b,strtok3(NULL,",")); // get wp name
		trim(b);
		b[15]=0;
		strcpy(record.ident,b);
		set_record_icon();
		record.la=atof(strtok3(NULL,",")); // get latitude
		record.lo=atof(strtok3(NULL,",")); // get longitude
		set_ns();	
		ozitime=atof(strtok3(NULL,","));

		ozitime=(ozitime-25569.0)*86400.0;
		t = (long)(ozitime+.01);  // the .01 takes care of the trunc problem
		gmt = gmtime(&t);
		strcpy(record.datetime,asctime(gmt));

		dsp=atoi(strtok3(NULL,",")); // skip display symbol for now
		if(Ozi_to_12==1) {
			record.icon_smbl=convert_Ozi_to_12XL((INT)(dsp));
		}
		else {
			record.icon_smbl=convert_Ozi_to_Garmin((INT)(dsp));
		}

		strtok3(NULL,","); // skip '1'
		strtok3(NULL,","); // skip Map display format
		strtok3(NULL,","); // skip Map foreground color
		strtok3(NULL,","); // skip Map background color

		p=(unsigned char*)strtok3(NULL,",");  // get comment
		strcpy(rest,(char*)p);
		strtok3(NULL,","); // skip pointer direction
		dsp=atoi(strtok3(NULL,",")); // get Garmin gps display format

//
// check for smbl&dsply
//
//                                  Ozi
//	    Program   12/II+    Ozi    Display mode
//	       3        0        0      Symbol with Waypoint Name
//	       1        1        1      Symbol
//	       5        2        2      Symbol with Waypoint Comment
//
//  The icon symbol in the comment field, if it exists, will override the OZI icon
//
		if((p=(unsigned char*)strchr(rest,';')) != NULL) {
			strcpy(record.comment,strtok3(rest,";"));
			record.icon_smbl=atoi(strtok3(NULL,";"));
		}
		else strcpy(record.comment,trim(rest));
		record.icon_dspl=2;
		switch(dsp) {
			case 0: record.icon_dspl=3; break;
			case 1: record.icon_dspl=1; break;
			case 2: record.icon_dspl=5; break;
		}

		memset(bin,0,MAX_LENGTH);

		sprintf((char*)bin,"%c  %-15s %s %s %s %s;%d;%d",
			'W',record.ident,toDMlat(record.la), toDMlon(record.lo),
			record.datetime,record.comment,record.icon_smbl,
			record.icon_dspl);
		valid_records++;
		push_record((char*)bin,0);
	}
	fclose(in);
} /* read_OZI_wpt */

/* -------------------------------------------------------------------------- */
PROCX void read_OZI_rte()
{
	char b[MAX_LENGTH],rest[MAX_LENGTH];
	unsigned char *p;
	INT dsp;
	long t;
	double ozitime;
	struct tm *gmt;

	fgets((char*)bin,MAX_LENGTH,in); // skip OziExp file version
	fgets((char*)bin,MAX_LENGTH,in); // skip Datum
	fgets((char*)bin,MAX_LENGTH,in); // skip Reserved 1
	fgets((char*)bin,MAX_LENGTH,in); // skip Reserved 2

	while(fgets((char*)bin,MAX_LENGTH,in) != NULL) {
		record.class = 255;  // default to 'user'
		null_newline((char*)bin);
		trim((char*)bin);
		strupr((char*)bin);
		switch(bin[0]) {
			case 'R': {
				strcpy(b,strtok3((char*)bin,","));	// 'R'
				strcpy(b,strtok3(NULL,","));		// route #
				route_number=atoi(b);
				route_point=0;
				strcpy(route_comment,strtok3(NULL,",")); // route name
				sprintf((char*)bin,"%c  %02d %s",'R',route_number,route_comment);

				push_record((char*)bin,0);
				break;
			}
			case 'W': {
				record.type='W';
				strcpy(b,strtok3((char*)bin,",")); // get (skip) 'W'
				strcpy(b,strtok3(NULL,",")); // get (skip) rt #
				strcpy(b,strtok3(NULL,",")); // get (skip) rt array # #
				strcpy(b,strtok3(NULL,",")); // get (skip) rt array pt # #
				strcpy(b,strtok3(NULL,",")); // get rte wpt name
				trim(b);
				b[15]=0;
				strcpy(record.ident,b);
				set_record_icon();
				record.la=atof(strtok3(NULL,",")); // get latitude
				record.lo=atof(strtok3(NULL,",")); // get longitude
				set_ns();
			
				ozitime=atof(strtok3(NULL,","));
	
				ozitime=(ozitime-25569.0)*86400.0;
				t = (long)(ozitime+.01);  // the .01 takes care of the trunc problem
				gmt = gmtime(&t);
				strcpy(record.datetime,asctime(gmt));
	
				dsp=atoi(strtok3(NULL,",")); // skip display symbol for now
				if(Ozi_to_12==1) {
					record.icon_smbl=convert_Ozi_to_12XL((INT)(dsp));
				}
				else {
					record.icon_smbl=convert_Ozi_to_Garmin((INT)(dsp));
				}
	
				strtok3(NULL,","); // skip '1'
				strtok3(NULL,","); // skip Map display format
				strtok3(NULL,","); // skip Map foreground color
				strtok3(NULL,","); // skip Map background color
		
				p=(unsigned char*)strtok3(NULL,",");  // get comment
				strcpy(rest,(char*)p);
				strtok3(NULL,","); // skip pointer direction
				dsp=atoi(strtok3(NULL,",")); // get Garmin gps display format
	
//
// check for smbl&dsply
//
//                                  Ozi
//	    Program   12/II+    Ozi    Display mode
//	       3        0        N      Symbol with Waypoint Name
//	       1        1        S      Symbol
//	       5        2        C      Symbol with Waypoint Comment
//
//  The icon symbol in the comment field, if it exists, will override the OZI icon
//
				if((p=(unsigned char*)strchr(rest,';')) != NULL) {
					strcpy(record.comment,strtok3(rest,";"));
					record.icon_smbl=atoi(strtok3(NULL,";"));
				}
				else strcpy(record.comment,trim(rest));
				record.icon_dspl=2;
				switch(dsp) {
					case 'S': record.icon_dspl=1; break;
					case 'N': record.icon_dspl=3; break;
					case 'C': record.icon_dspl=5; break;
				}
	
				memset(bin,0,MAX_LENGTH);
		
				sprintf((char*)bin,"%c  %-15s %s %s %s %s;%d;%d",
					'W',record.ident,toDMlat(record.la), toDMlon(record.lo),
					record.datetime,record.comment,record.icon_smbl,
					record.icon_dspl);
				valid_records++;
				push_record((char*)bin,0);
			}
		} // switch(bin[0]);
	}
	fclose(in);

} /* read_OZI_rte */

/* -------------------------------------------------------------------------- */
PROCX void read_OZI_plt(void)
{
	char b[MAX_LENGTH];
	time_t t;

	fgets((char*)bin,MAX_LENGTH,in); // file type, i.e.:
									 // OziExplorer Track Point File Version 2.0
	fgets((char*)bin,MAX_LENGTH,in); // Datum:
									 // WGS 84
	fgets((char*)bin,MAX_LENGTH,in); // Altitude is in feet
	fgets((char*)bin,MAX_LENGTH,in); // Reserved 3
	fgets((char*)bin,MAX_LENGTH,in); // 0,trk width, trk color (RGB), description, trk skip value
									 // 0,2,255,9/14/98 5:54:01 PM       ,0
	fgets((char*)bin,MAX_LENGTH,in); // Number of points in track.
	
	
	while(fgets((char*)bin,MAX_LENGTH,in) != NULL) {
		strcpy(b,(char*)bin);
		null_newline((char*)bin);
		trim(b);
		strupr(b);
		record.la=atof(strtok3(b,","));	// get latitude
		record.lo=atof(strtok3(NULL,","));	// get longitude
		set_ns();
		newTrack=atoi(strtok3(NULL,","));
		if(newTrack==1) {
			next_is_new=1;
			no_N=0;
		}
		record.type='T';

		memset(bin,0,MAX_LENGTH);
		t = time(NULL) - 631065600L;
    	strcpy(record.datetime,secs2dt(t, (short)gPrefs.offset));

		sprintf((char*)bin,"%c  %s %s %s %-20s",
			record.type,toDMlat(record.la), toDMlon(record.lo),
			record.datetime," ");

		valid_records++;
		push_record((char*)bin,0);
	}
	fclose(in);
} // void read_OZI_plt()

PROCX char * fmt_OZI_wpt(int i)
{
	static char bf[MAX_LENGTH];
	char is,dspl;
	char b[30],c[30];
	double ozit;

	datetime2record(record.datetime);
	set_sign();
	sprintf(b,"%12.6lf",record.la);
	sprintf(c,"%12.6lf",record.lo);
	trim(b);
	trim(c);

	ozit=date2days(record.monthn, record.dayofmonth, record.year);
	ozit=ozit+(3600.0*record.ht + 60.0*record.mt + 1.0*record.st)/86400.0;
	ozit+=32873.0;  // offset from garmin days to OziDays

//	    Program   12/II+    Ozi    Display mode
//	       3        0        0      Symbol with Waypoint Name
//	       1        1        1      Symbol
//	       5        2        2      Symbol with Waypoint Comment
//  
	if(Ozi_to_12==1) {
		is=convert_12XL_to_Ozi(record.icon_smbl);
	}
	else {
		is=convert_Garmin_to_Ozi(record.icon_smbl);
	}
	switch(record.icon_dspl) {
		case 1: dspl=1; break;
		case 3: dspl=0; break;
		case 5: dspl=2; break;
		default: dspl=0;
	}

	sprintf(bf,"%4d,%-14s,%11s,%11s,%11.6lf,%2d, 1, 4,         0,    65535,%-40s, 0,%d,0, -777",
				i,record.ident,b,c, ozit,is,record.comment,dspl);
	return bf;

} // fmt_OZI_wpt

/* -------------------------------------------------------------------------- */
//
//  Waypoint format:
//
//
//
PROCX void output_OZI_wpt()
{
	int i;

	if(open_output("w")==0) return;
	fprintf(out,"OziExplorer Waypoint File Version 1.0\n");
	fprintf(out,"WGS 84\n");
	fprintf(out,"Reserved 2\n");
	fprintf(out,"Reserved 3\n");

	for(i=1;i<=waypoints;i++) {
			fill_waypoint_from_push(i,NORMAL_WP,0);
			fprintf(out,"%s\n",fmt_OZI_wpt(i));
	}
	fclose(out);
} /* output_OZI_wpt */

/* -------------------------------------------------------------------------- */
//
//  Waypoint format:
//
//
//
PROCX void output_OZI_evt()
{
	INT i;
	char is;
	long fg;
	char b[30],c[30];

	if(open_output("w")==0) return;
	fprintf(out,"OziExplorer Event File Version 1.0\n");
	fprintf(out,"WGS 84\n");
	fprintf(out,"Reserved 2\n");
	fprintf(out,"Reserved 3\n");
	for(i=1;i<=icons;i++) {
		fill_icon(i,(unsigned char *)"",0);
		set_sign();
		sprintf(b,"%12.6lf",record.la);
		sprintf(c,"%12.6lf",record.lo);
		trim(b);
		trim(c);
		switch(ObjColor) {
			case 0: fg=0L; break;			// Black
			case 1: fg=0xffL; break;		// Red
			case 2: fg=0xff0000L; break;	// Blue
			case 3: fg=0x8000L; break;		// Green
			case 4: fg=0xffffL; break;		// Yellow
			default: fg=0;
		}
		if(Ozi_to_12==1) {
			is=convert_12XL_to_Ozi(record.icon_smbl);
		}
		else {
			is=convert_Garmin_to_Ozi(record.icon_smbl);
		}
  		fprintf(out,"%3d,%11s,%11s,%2d,0,%10ld,  16777215\n",i,b,c,is,fg);
	}
	fclose(out);
} /* output_OZI_evt */

/* -------------------------------------------------------------------------- */
PROCX void output_OZI_plt(void)
{
	unsigned INT i;
	char b[30],c[30];
	time_t t;
	double ozit;

	if(open_output("w")==0) return;
	t = time(NULL) - 631065600L;
    strcpy(record.datetime,secs2dt(t, (short)gPrefs.offset));
	
	fprintf(out,"OziExplorer Track Point File Version 2.0\n");
	fprintf(out,"WGS 84\n");
	fprintf(out,"Altitude is in Feet\n");
	fprintf(out,"Reserved 3\n");
	fprintf(out,"0,2,255,%s,0\n",record.datetime);
	fprintf(out,"%d\n",tracks);

	for(i=1;i<=tracks;i++) {
			fill_track(i,0);
			set_sign();
			sprintf(b,"%14.6lf",record.la);
			sprintf(c,"%14.6lf",record.lo);
			trim(b);
			trim(c);
			ozit=dt2secs((short)gPrefs.offset);// + 631065600L;    // seconds
			ozit=ozit/86400.0;      // convert to days
			ozit+=32873.0;          // offset from garmin days to OziDays
			fprintf(out,"%11s,%11s,%d,-777,%11.7lf\n",b,c,newTrack,ozit);
	}
	fclose(out);
} /* output_OZI_plt */


/* -------------------------------------------------------------------------- */
//
//H S D T E D D M M Y Y CR LF
//
// Date record is a 'H' record.  The P says the source is the Pilot
//
//    HPDTEddmmyyCRLF
//
//The format of the mandatory data is: 
//
// B H H M M S S D D M M M M M N D D D M M M M M E V P P P P P G G G G G CR LF 
//
//     Description 	Size	Element			Remarks
//		Time UTC	6 bytes HHMMSS 			Valid characters 0-9
//		Latitude 	8 bytes DDMMmmmN 		Valid characters N, S, 0-9
//		Longitude 	9 bytes DDDMMmmmE 		Valid characters E,W, 0-9
//		Fix valid 	1 byte  V 				A: valid, V:nav warning
//		Press Alt.  5 bytes PPPPP 			Valid characters -, 0-9
//		GNSS Alt.  	5 bytes GGGGG 			Valid characters -, 0-9
//
//The "fix valid" byte should be the equivalent of the "Nav receiver 
//     status flag" from the NMEA GPRMC sentence. 
PROCX void output_IGC_trk()
{
	unsigned INT i,j;
	char b[30],outs[50];

	INT lastd,lastm,lasty;

	lastd=lastm=lasty=0;

	if(open_output("w")==0) return;
	for(j=1;j<=tracks;j++) {
			fill_track(j,0);
			if(lastd!=record.dayofmonth || lastm!=record.monthn     ||
			   									lasty!=record.year )  {
			   	fprintf(out,"HFDTE%02d%02d%02d\n",
						 record.monthn,
				         record.dayofmonth,
						 record.year-1900);
				lastd=record.dayofmonth;
				lastm=record.monthn;
				lasty=record.year;
			}

			sprintf(outs,"B%02d%02d%02dDDMMmmmNDDDMMmmmEA0000000000",
						record.ht,record.mt,record.st);
//    012345678901234567890123456789012345
//    BHHMMSSDDMMmmmNDDDMMmmmEAPPPPPPPPPP

//    012345678901234567890123456789012345
//    NDD MM.SSSS which is returned by the function.
			sprintf(b,"%s",toDMlat(record.la));
			outs[14]=b[0];
			for(i=1;i<3;i++) outs[i+6]=b[i];
			for(i=4;i<6;i++) outs[i+5]=b[i];
			for(i=7;i<10;i++) outs[i+4]=b[i];


//    012345678901234567890123456789012345
//    NDDD MM.SSSS which is returned by the function.

			sprintf(b,"%s",toDMlon(record.lo));
			outs[23]=b[0];
			for(i=1;i<4;i++) outs[i+14]=b[i];
			for(i=5;i<7;i++) outs[i+13]=b[i];
			for(i=8;i<11;i++) outs[i+12]=b[i];
			fprintf(out,"%s\n",outs);
	}
#if !__BORLANDC__
	fprintf(out,"L   g7tow %s%s%s\n",PGMVER,PGMBETA,PGMSUF); 
#else
	fprintf(out,"L   g7to %s%s%s\n",PGMVER,PGMBETA,PGMSUF);
#endif
	fprintf(out,"L   %s\n",record.datetime);
	fclose(out);
} // output_IGC_trk

/* -------------------------------------------------------------------------- */
PROCX double fm_diskLL(unsigned long l)
{
	unsigned long ff7f,m80;

	ff7f=0x7fffffL;
	m80=0x80000000L;

	if(l<=m80 ) 
		return (double)((m80-l)/(double)ff7f);
	else
		return -(double)((l-m80)/(double)ff7f);
} /* fm_diskLL */

/* -------------------------------------------------------------------------- */
PROCX unsigned long to_diskLL(double l)
{
	unsigned long ff7f,m80;

	ff7f=0x7fffffL;
	m80=0x80000000L;

	return (unsigned long)(m80 - (unsigned long)(l*(double)ff7f));
} /* to_diskLL */

/* -------------------------------------------------------------------------- */
/*
 * output a complete area element to the 'output' file.  This assumes
 *  the element header has already been read up to but not including
 *  the first point.
 */
PROCX void outsa4_area(void)
{
	void *p;

	sa4maparea.ItemNum=sa3number++;

	fwrite(&ItemType,2,1,out);
	if(sa4maparea.paramlen==0) {
		fwrite(&sa4maparea,29,1,out);
	}
	else {
		fwrite(&sa4maparea,13,1,out);
		fwrite(&genConst,sa4maparea.paramlen,1,out);
		fwrite(&sa4maparea.area_draw_line,16,1,out);
	}
	if((p=(void *)malloc(sa4maparea.Points+1)) == NULL)  oomem("outsa4_area");
/*
 * Read the area Points from the input file and write them
 *  to the output file
 */
	fread(p,(sa4maparea.Points)*8,1,in);
	fwrite(p,(sa4maparea.Points)*8,1,out);
	free(p);
} /* outsa4_area */

/* -------------------------------------------------------------------------- */
/*
 * output a complete circle element to the 'output' file.  This assumes
 *  the element has already been read into the structure sa4mapcircle.
 */
PROCX void outsa4_cir(void)
{
	sa4mapcircle.ItemNum=sa3number++;

	fwrite(&ItemType,2,1,out);
	if(sa4mapcircle.paramlen==0) {
		fwrite(&sa4mapcircle,45,1,out);
	}
	else {
		fwrite(&sa4mapcircle,13,1,out);
		fwrite(&genConst,sa4mapcircle.paramlen,1,out);
		fwrite(&sa4mapcircle.area_draw_line,32,1,out);
	}
} /* outsa4_cir */

/* -------------------------------------------------------------------------- */
PROCX void UsagehD(void)
{

	int i;
	char GM100[5],XL[5],SA[5],giii[3],OziG[5];

	i=0;
	printf("'*' indicates a GPS III icon\n\n");
	printf("Garmin#  Garmin Name                   LEI#   12XL#  OziG   SA#   SAName\n");
	printf("=======  ===========================   ====   =====  ====   ===   ======\n");
	while(Garmin_Symbol_Table[i].Garmin>=0) {
		if(Garmin_Symbol_Table[i].GM100>=0) sprintf(GM100,"%2d",Garmin_Symbol_Table[i].GM100);
		else sprintf(GM100,"--");
		if(Garmin_Symbol_Table[i].XL>=0) sprintf(XL,"%2d",Garmin_Symbol_Table[i].XL);
		else sprintf(XL,"--");
		if(Garmin_Symbol_Table[i].OziG!=(-1)) sprintf(OziG,"%2d",Garmin_Symbol_Table[i].OziG);
		else sprintf(OziG,"--");
		if(Garmin_Symbol_Table[i].SA>=0) sprintf(SA,"%2d",Garmin_Symbol_Table[i].SA);
		else sprintf(SA,"--");
		if(Garmin_Symbol_Table[i].giii==0) sprintf(giii," ");
		else sprintf(giii,"*");

		printf("%5d  %1s %-30s  %2s      %s    %2s    %2s   %-20s\n",
				Garmin_Symbol_Table[i].Garmin,
				giii,
				Garmin_Symbol_Table[i].Garminname,
				GM100,
				XL,
				OziG,
				SA,
				Garmin_Symbol_Table[i].SAname);
		i++;
	}
#if 0
  printf("Codes for use with text files COMMENT;xx;DisplayType\n"); 
  printf(" 0 = Agricultural                            35 = One Way Up\n");
  printf(" 1 = Airport        18 = Education           36 = Park\n");
  printf(" 2 = Amusement      19 = Emergency           37 = Parking\n");
  printf(" 3 = Arrow, Down    20 = Fishing             38 = Phone\n");
  printf(" 4 = Arrow, Left    21 = Fuel                39 = Picnic\n");
  printf(" 5 = Arrow, Right   22 = Golf Course         40 = Post Office\n");
  printf(" 6 = Arrow, Up      23 = Government Building 41 = Power\n");
  printf(" 7 = Bank           24 = Historic Site       42 = Religious Star\n");
  printf(" 8 = Beach          25 = Home                43 = Religious Cross\n");
  printf(" 9 = Boat Ramp      26 = Industrial          44 = Restaurant\n");
  printf("10 = Campground     27 = Information         45 = Sports\n");
  printf("11 = Cemetary       28 = Library             46 = Square\n");
  printf("12 = Circle         29 = Lodging             47 = Star\n");
  printf("13 = Construction   30 = Mountain            48 = State Capitol\n");
  printf("14 = Cross          31 = National capitol    49 = Stop Sign\n");
  printf("15 = Delivery Stop  32 = One Way Down        50 = Triangle Down \n");
  printf("16 = Diamond        33 = One Way Left        51 = Triangle Up\n");
  printf("17 = Doctor/Dentist 34 = One Way Right       52 = Zoo\n");
  printf("53 = Bike           54 = Bridge              55 = Church 56 = Police\n");
#endif
  byebye(0);
} /* UsagehD */

/* -------------------------------------------------------------------------- */
PROCX void Usageh0(void)
{
	printf("GARMIN/Lowrance/Eagle\n Upload/Download/File Conversion %s%s%s %s %s PST\n",PGMVER,PGMBETA,PGMSUF,__DATE__,__TIME__);
#if !__BORLANDC__
	printf("Windows Command Line Version\n");
	printf("\nUSAGE:g7tow <options> <-i input -i input ...> <-o output -i output ...>\n");
#else
	printf("\nUSAGE:g7to <options> <-i input -i input ...> <-o output -i output ...>\n");
#endif
	printf("\nFor more information:\n");
	printf("-h I for input help\n");
	printf("-h O for output help\n");
	byebye(0);
} /* Usageh0 */

/* -------------------------------------------------------------------------- */
PROCX void UsagehI()
{
 printf("  SA, text;Garmin64;Fugawi:.fwp,.trk;Ozi:.evt,.plt,.rte,.wpt or GPS units\n");
 printf(" -i <fname> - input file  (?.sa[345], ?.g64 ?.gpl ?.fwp ?.trk, etc)\n");
 printf("Use -2,-3 or -4 to set standard COM Port 2-4  (default is COM1 IO: 0x3f8 IRQ: 4)\n\n");
 printf("  To specify the port parameters use:\n");
 printf("  -5 Port,IOaddr,IRQ (no spaces allowed) where:\n");
 printf("     Port is 1-4, IOaddr in hex (0xnnn) or decimal, IRQ (3-15) decimal\n");
 printf("  -6 BaudRate to set serial port speed\n");
 printf("\n  g7to -5 1,0x3f8,4  -6 9600 defines a standard COM1 port at 9600 Baud\n\n");
 printf("    Garmin Lowrance/Eagle\n");     
 printf(" -i G45Pn  -------- Send Time/Position record every n seconds (press 'x' to stop)\n");
 printf(" -i G45A   -------- Send Almanac data\n");
 printf(" -i G45I   -------- Send current Time\n");
 printf(" -i G45D   LWRD   - Send software iD\n");
 printf(" -i G45J   -------- Display the GRMN/GRMN protocols this unit supports\n");
 printf(" -i G45G   -------- Send Garmin PVT data (if supported by the GPS) ('x' to stop)\n");
 printf(" -i G45R   LWRR   - Send Routes\n");
 printf(" -i G45T   LWR<12>- Send Tracks (-d to sum distances)\n");
 printf(" -i G45W   LWRW   - Send Waypoints\n");
 printf(" -i G45X   -------- Send proXimity waypoints\n");
 printf(" -i G45V   -------- Send Voltages\n");
 printf(" -i        LWRI   - Send Icons\n\n");
 printf(" -e Do not print symbol attributes to text file (! line)\n");
 byebye(0);
} /* UsagehI */

/* -------------------------------------------------------------------------- */
PROCX void UsagehO()
{
 printf(" -o G45O GPS Off; -o G45Cx set contrast x=0 to 15 (tested on 12XL/II+/III)\n");
 printf(" -o G45Lx (x=0-255) 12XL: 1=light on; II+: x=intensity level; -o G45, -o LWR(12)\n");
 printf("-----------------------------------------------------------------\n");
 printf(" -o <fname> - output file  (?.sa3, ?.sa4, ?.prj ?.g64 ?.fwp ?.trk, etc)\n");
 printf("   -a - Text output\n");
 printf("   -b y/n - Turn on/off all SA output options\n");
 printf("   -c - 1st-center map Lat|2nd-center map Long (DDdMM.mmmm)\n");
 printf("   -g - No Lat/Long Grid on SA files\n");
 printf("   -m - map magnitude\n");
 printf("   -n - No name and no description\n");
 printf("   -p - Circle (Proximity) Parameters\n");
 printf("   -r - Line (route) Parameters\n");
 printf("   -s - Don't sort waypoints and don't remove duplicate waypoints\n");
 printf("   -t - Line (track) Parameters      - C-color, T-thickness, S-style\n");
 printf("-----------------------------------------------------------------\n");
 printf("   -w <parms> - set waypoint (Map Symbol) parameters where:\n");
 printf("      text alignment:  .NW .N .NE .W .E .SW .S .SE           | .  = a\n");
 printf("      text colors:     ..black ..red ..blue ..green ..yellow | .. = ct\n");
 printf("      obj  colors:     ..black ..red ..blue ..green ..yellow | .. = co\n");
 printf("      text sizes:      ..vs ..s ..m ..l ..vl                 | .. = st\n");
 printf("      obj  sizes:      ..vs ..s ..m ..l ..vl                 | .. = so\n");
 printf("      default icon:      dGxxx where xxx is Garmin symbol #  | .  = d\n");
 printf("      default SA5 obj:   dSxxx where xxx is SA4/5 object #   | .  = d\n");
 printf("      default 12XL icon: dLxxx where xxx is 12XL/II+ icon #  | .  = d\n");
 printf("-----------------------------------------------------------------\n");
 printf("   -qx- (x=0-31) remove text from waypoints in SA files.\n");
 printf("   -jx- (x=0-3)  remove text from waypoints in text files. See g7to.doc\n");
 byebye(0);
} /* UsagehO */

/* -------------------------------------------------------------------------- */
PROCX void Usage(INT i)
{
	static doneit=0;
	switch(i) {
		case 1: printf("Bad color input\n"); break;
		case 2: printf("Color must have 'T' or 'O' as first character\n");
				break;
		case 3: printf("Bad size input\n"); break;
		case 4: printf("Size must have 'T' or 'O' as first character\n"); break;
		case 5: printf("Alignment must be NW N NE W E SW S or SE: -w %s\n",optarg); break;
		case 7: printf("Object code must be 0-56\n"); break;
		case 9: printf("Invalid COM port specification\n");break;
		case 10:if(doneit==0) printf("Output w/o proper input\n"); doneit=1;
				break;
		case 11:printf("Warning...unknown input file type.n"); break;
		case 15:printf("COM Port must 1-4\n");break;
		case 17:printf("Invalid line style selection -r %s\n",optarg); break; 
		case 18:printf("Invalid line width selection -r %s\n",optarg); break; 
		case 19:printf("Invalid line color selection -r %s\n",optarg); break; 
		case 20:printf("Invalid circle parameter selection -p %s\n",optarg); break; 
		case 21:printf("Invalid output file name: %s, file skipped\n",
				fname_out_all); 
				break; 
		case 22:printf("Invalid -r parameter: -r %s\n",optarg); break; 
		case 23:printf("Invalid -b parameter: -b %s\n",optarg); break; 
		case 26:printf("Can't open output file '%s'\n",fname_out_all); break;
		case 27:printf("Invalid line style selection -t %s\n",optarg); break; 
		case 28:printf("Invalid line width selection -t %s\n",optarg); break; 
		case 29:printf("Invalid line color selection -t %s\n",optarg); break; 
		case 40:printf("Too many Proximity waypoints read\n"); break;
		case 41:printf("Too many waypoints read\n"); break;
		case 42:printf("Too many track points read\n"); break;
		case 43:printf("Too many routes read\n"); break;
		case 44:printf("Too many Route points\n"); break;
		case 46: printf("Too many waypoints from .lwo file read\n"); break;
		default:printf("bad Usage: %d\n  Please inform author of this message",i);
	}
	fflush(stdout);
	if(opterr==0) return;
	byebye(3);
} /* Usage */

/* -------------------------------------------------------------------------- */
/*
 *          INT  dow( INT iDay, INT iMon, INT iYear ) - This is my
 *             implementation of the Zeller function.  It takes day/
 *             month/year and returns the day of the week as an int
 *             with Sunday being 0.....etc.
 ******/
PROCX INT dow( INT day, INT mon, INT year )
{
   INT adj_mo, adj_yr, cent, cent_yrs;
 
   adj_mo = ( mon > 2 ) ? mon - 2 : mon + 10;
   adj_yr = ( mon > 2 ) ? year    : year - 1;
   cent = adj_yr / 100;
   cent_yrs = adj_yr % 100;
   return((((( 13 * adj_mo - 1 ) / 5 ) + day + cent_yrs +
             ( cent_yrs / 4 ) + ( cent / 4 ) - 2 * cent + 77 ) % 7 ));
} /* dow */

/* -------------------------------------------------------------------------- */
PROCX void navSRouteS(void)
{
	INT i,Numr=0;
	unsigned INT xx=0xffff, z=0, fo=4;
	char mm[5]="CRte";
	unsigned char len;

	if(firstR==0) {
		for(i=0;i<MAXROUTES;i++) if(routeXpts[i]>0) Numr++;
		fwrite(&Numr,2,1,out);
		fwrite(&xx,2,1,out);
		fwrite(&z,2,1,out);
		fwrite(&fo,2,1,out);
		fwrite(mm,4,1,out);
		firstR++;
	}
	else {
		z=0x8001;
		fwrite(&z,2,1,out);
	}
	len=strlen(route_comment);
	fwrite(&len,1,1,out);
	fwrite(route_comment,len,1,out);
	fwrite(&routeXpts[route_number],2,1,out);
	
} /* navSRouteS */

/* -------------------------------------------------------------------------- */
PROCX void navSWaypoint(void)
{
	unsigned INT xx=0xffff, z=0, fo=4;
	char mm[5]="CWpt";
	unsigned char len;
	double t;
	long ll, lo;

	t=record.la; ll=(long)(t*60000.0);
	if(record.ns=='S') ll=-ll;
	t=record.lo; lo=(long)(t*60000.0);
	if(record.ew=='E') lo=-lo;
	if(firstW==0) {
		fwrite(&xx,2,1,out);
		fwrite(&z,2,1,out);
		fwrite(&fo,2,1,out);
		fwrite(mm,4,1,out);
		firstW++;
	}
	else {
		z=0x8003;
		fwrite(&z,2,1,out);
	}
	trim(record.ident);
	len=strlen(record.ident);
	fwrite(&len,1,1,out);
	fwrite(record.ident,len,1,out);
	trim(record.comment);
	len=strlen(record.comment);
	fwrite(&len,1,1,out);
	fwrite(&record.comment,len,1,out);
	fwrite(&ll,4,1,out);
	fwrite(&lo,4,1,out);

} /* navSWaypoint */

/* -------------------------------------------------------------------------- */
//PROCX void prhex(unsigned char *message,INT c)
//{
//	INT i;
//
//	printf("Read %d bytes\n",c);
//	for(i=0;i<c;i++) printf("%02x ",message[i]);
//	printf("\n");
//} /* prhex */

/*
 *	@(#)getopt.c	2.2 (smail) 1/26/87
 */

/*
 * Here's something you've all been waiting for:  the AT&T public domain
 * source for getopt(3).  It is the code which was given out at the 1985
 * UNIFORUM conference in Dallas.  I obtained it by electronic mail
 * directly from AT&T.  The people there assure me that it is indeed
 * in the public domain.
 * 
 * There is no manual page.  That is because the one they gave out at
 * UNIFORUM was slightly different from the current System V Release 2
 * manual page.  The difference apparently involved a note about the
 * famous rules 5 and 6, recommending using white space between an option
 * and its first argument, and not grouping options that have arguments.
 * Getopt itself is currently lenient about both of these things White
 * space is allowed, but not mandatory, and the last option in a group can
 * have an argument.  That particular version of the man page evidently
 * has no official existence, and my source at AT&T did not send a copy.
 * The current SVR2 man page reflects the actual behavor of this getopt.
 * However, I am not about to post a copy of anything licensed by AT&T.
 */

/*LINTLIBRARY*/
#ifndef	NULL
#define NULL	0
#endif
#define EOF	(-1)
#define ERR(s, c)	if(opterr){\
	extern int write();\
	char errbuf[2];\
	errbuf[0] = c; errbuf[1] = '\n';\
	(void) write(1, argv[0], (unsigned int)strlen(argv[0]));\
	(void) write(1, s, (unsigned int)strlen(s));\
	(void) write(1, errbuf, 2);\
	(void) write(1, "g7to -h [I|O|D] for help\n",25);byebye(0);}

/* -------------------------------------------------------------------------- */
PROCX INT getopt(INT argc, char **argv, char *opts)
{
	static INT sp = 1;
	register INT c;
	register char *cp;

	if(sp == 1) {
		if(optind >= argc )
			return (EOF);
		if((c=argv[optind][0]) != '-' )
			ERR(": illegal option -- ", c);
		if((c=argv[optind][1]) == '\0')
			ERR(": illegal option -- ", c);
		/*else*/ if(strcmp(argv[optind], "--") == 0) {
			optind++;
			return(EOF);
		}
	}
	optopt = c = argv[optind][sp];

	if(c == ':' || (cp=strchr(opts, c)) == NULL) {
		ERR(": illegal option -- ", c);
		if(argv[optind][++sp] == '\0') {
			optind++;
			sp = 1;
		}
		return('?');
	}
	if(*++cp == ':') {
		if(argv[optind][sp+1] != '\0')
			optarg = &argv[optind++][sp+1];
		else if(++optind >= argc) {
			ERR(": option requires an argument -- ", c);
			sp = 1;
			return('?');
		} else
			optarg = argv[optind++];
		sp = 1;
	} else {
		if(argv[optind][++sp] == '\0') {
			sp = 1;
			optind++;
		}
		optarg = NULL;
	}
	return(c);
} /* getopt */

/* -------------------------------------------------------------------------- */
/* Not all Unix Systems will pass dd */
PROCX void Catcher(unsigned dd)
{
	printf("\nCatcher abort: ");
	switch(dd) {
		case SIGFPE : printf("Floating point trap\n");break;
		case SIGILL : printf("Illegal instruction\n"); break;
		case SIGINT : printf("Break or CNTL-C pressed\n");break;
		case SIGSEGV: printf("Memory access violation\n");break;
		case SIGTERM: printf("Termination signal received\n");break;
		case SIGABRT: printf("Abort signal\n");
		default: printf("Unknown reason\n");
	}
	fflush(stdout);
	byebye(1);	
} /* Catcher */

/* -------------------------------------------------------------------------- */
/*
 * allowable colors:    oblack ored oblue ogreen oyellow
 *			tblack tred tblue tgreen tyellow
 */
PROCX void set_color(char * optarg)
{
	INT color,hold;

	hold=opterr;
	opterr=0;
	strupr(optarg);
	switch(optarg[1]) {
		case 'R': color=1; break;
		case 'G': color=3; break;
		case 'Y': color=4; break;
		case 'B': switch(optarg[3]) {
				case 'A': color=0; goto tp;
				case 'U': color=2; goto tp;
			}
		default: Usage(1);
	}
tp:;
	switch(optarg[0]) {
		case 'T': TextColor=color; return;
		case 'O': ObjColor=color; return;
		default: Usage(2);
	}
	opterr=hold;
} /* set_color */

/* -------------------------------------------------------------------------- */
/*
 * allowable sizes:  ovs, os, om, ol, ovl
 *                   tvs, ts, tm, tl, tvl
 */
PROCX void set_size(char * optarg)
{
	INT size,hold;

	hold=opterr;
	opterr=0;
	strupr(optarg);
	switch(optarg[1]) {
		case 'S': size=1; break;
		case 'M': size=2; break;
		case 'L': size=3; break;
		case 'V': switch(optarg[2]) {
				case 'S': size=0; goto tp;
				case 'L': size=4; goto tp;
			}
		default: Usage(3);
	}
tp:;
	switch(optarg[0]) {
		case 'T': TextSize=size; break;
		case 'O': ObjSize=size; break;
		default: Usage(4);
	}
	opterr=hold;
} /* set_size */

/* -------------------------------------------------------------------------- */
/*
 * lt=0
 *  -t y   = turn on track line drawing
 *
 *  -t cxx = set line color
 *  -t txx = set line thickness
 *  -t sxx = set line style

 * lt=1
 *
 *  -ry    = turn on route line drawing for routes 1-19
 *  -rn    = turn off route line drawing for routes 1-19

 *  -rwy   = turn on route waypoints for routes 1-19
 *  -rwn   = turn off route waypoints for routes 1-19

 *  -r0y   = turn on route 0 to sa4/sa5
 *  -r0n   = turn off route 0 to sa4/sa5

 *  -r0ly  = turn on route 0 line drawing to sa4/sa5
 *  -r0ln  = turn off route 0 line drawing to sa4/sa5

 *  -r0wy  = turn on route 0 waypoints
 *  -r0wn  = turn off route 0 waypoints
 *
 *  -r cxx = set route line color
 *  -r txx = set route line thickness
 *  -r sxx = set route line style

 * allowable thickness: VT T M K VK
 * allowable colors   : black red blue green yellow
 * allowable styles   : normal hatched *highlight
 */
PROCX void set_line_parms(INT lt)
{
	INT hold;
	INT LW,LC,LS;

	hold=opterr;
	opterr=0;
	strupr(optarg);
	if(lt==1) {			// route line thickness
		switch(optarg[0]) {
			case '0': if(optarg[1]=='Y') {draw_route_0=1;goto setexit;}
			          if(optarg[1]=='N') {draw_route_0=0;goto setexit;}
					  if(optarg[1]=='W') {
					  	if(optarg[2]=='Y') {draw_route_0_obj=1;goto setexit;}
					  	if(optarg[2]=='N') {draw_route_0_obj=0;goto setexit;}
					    Usage(22);
					  }
					  if(optarg[1]=='L') {
					  	if(optarg[2]=='Y') {draw_route_0_line=1;goto setexit;}
					  	if(optarg[2]=='N') {draw_route_0_line=0;goto setexit;}
					  }
					  Usage(22);
					  break;
			case 'Y': 
					  draw_route_1_19_lines=1; goto setexit;
		    case 'N':
					  draw_route_1_19_lines=0; goto setexit;
			case 'W':
					  if(optarg[1]=='Y') {draw_route_1_19_obj=1; goto setexit;}
					  if(optarg[1]=='N') {draw_route_1_19_obj=0; goto setexit;}
					  Usage(22);
					  break;
					
		}
		LW=Route_LineWidth;
		LS=Route_LineStyle;
		LC=Route_LineColor;
	}
	else {  // normal line thickness
		if(optarg[0]=='Y'){ draw_track_lines=1; goto setexit;}
		if(optarg[0]=='N'){ draw_track_lines=0; goto setexit;}
		LW=LineWidth;
		LS=LineStyle;
		LC=LineColor;
	}

	if(optarg[0] == 'C') {
		switch(optarg[1]) {
			case 'R': LC=1; goto setliner;
			case 'G': LC=3; goto setliner;
			case 'Y': LC=4; goto setliner;
			case 'B': switch(optarg[3]) {
					case 'A': LC=0; goto setliner;
					case 'U': LC=2; goto setliner;
					default: if(lt==1) Usage(19);
						     else Usage(29);
				}
			default: if(lt==1) Usage(19);
				     else Usage(29);
		}
	}
	if(optarg[0] == 'T') {
		switch(optarg[1]) {
			case 'T': LW=1; goto setliner;
			case 'M': LW=2; goto setliner;
			case 'K': LW=3; goto setliner;
			case 'V': switch(optarg[2]) {
					case 'T': LW=0; goto setliner;
					case 'K': LW=4; goto setliner;
					default: if(lt==1) Usage(18);
							 else Usage(28);
				}
			default: if(lt==1) Usage(18);
					 else Usage(28);
		}
	}
	if(optarg[0] == 'S') {
		switch(optarg[1]) {
			case 'N' : LS=0; goto setliner;
			case 'H' : LS=1; goto setliner;
			case '*' : LS=2; goto setliner;
			default: if(lt==1) Usage(17);
					 else Usage(27);
		}
	}
setliner:;
	if(lt==0) {
		LineWidth=LW;
		LineColor=LC;
		LineStyle=LS;
		goto setexit;
	}
	if(lt==1) {
		Route_LineWidth=LW;
		Route_LineColor=LC;
		Route_LineStyle=LS;
		goto setexit;
	}
setexit:;
	opterr=hold;
} /* set_line_parms */

/* -------------------------------------------------------------------------- */
/*
 *
 *  -p y   = turn on proximity circle drawing
 *
 *  -p lxx = set circle outer line draw no/yes
 *  -p fxx = set circle fill no/yes
 *  -p cxx = set circle line color
 *  -p txx = set circle line thickness
 *  -p axx = set circle area fill color
 *  -p sxx = set circle area fill style

 * allowable thickness: VT T M K VK
 * allowable colors   : black red blue green yellow
 * allowable styles   : normal hatched *highlight
 * allowable drawline : no yes
 * allowable drawfill : no yes
 */
PROCX void set_circle_parms(void)
{
	INT hold;

	hold=opterr;
	opterr=0;
	strupr(optarg);

	if(optarg[0]=='Y') {
		draw_prox_circles=1;
		goto setcirpr;
	}

	if(optarg[0]=='N') {
		draw_prox_circles=0;
		goto setcirpr;
	}

	if(optarg[0] == 'C') 
		switch(optarg[1]) {
			case 'R': CirLineColor=1; goto setcirpr;
			case 'G': CirLineColor=3; goto setcirpr;
			case 'Y': CirLineColor=4; goto setcirpr;
			case 'B': switch(optarg[3]) {
					case 'A': CirLineColor=0; goto setcirpr;
					case 'U': CirLineColor=2; goto setcirpr;
					default: Usage(20);
				}
			default: Usage(20);
		}
	if(optarg[0] == 'T')
		switch(optarg[1]) {
			case 'T': CirLineWidth=1; goto setcirpr;
			case 'M': CirLineWidth=2; goto setcirpr;
			case 'K': CirLineWidth=3; goto setcirpr;
			case 'V': switch(optarg[2]) {
					case 'T': CirLineWidth=0; goto setcirpr;
					case 'K': CirLineWidth=4; goto setcirpr;
					default: Usage(20);
				}
			default: Usage(20);
		}
	if(optarg[0] == 'S')
		switch(optarg[1]) {
			case 'N' : CirFillStyle=0; goto setcirpr;
			case 'H' : CirFillStyle=1; goto setcirpr;
			case '*' : CirFillStyle=2; goto setcirpr;
			default: Usage(20);
		}
	if(optarg[0] == 'F')
		switch(optarg[1]) {
			case 'N' : CirFillArea=0; goto setcirpr;
			case 'Y' : CirFillArea=1; goto setcirpr;
			default: Usage(20);
		}
	if(optarg[0] == 'L')
		switch(optarg[1]) {
			case 'N' : CirLineDraw=0; goto setcirpr;
			case 'Y' : CirLineDraw=1; goto setcirpr;
			default: Usage(20);
		}
	if(optarg[0] == 'A') 
		switch(optarg[1]) {
			case 'R': CirFillColor=1; goto setcirpr;
			case 'G': CirFillColor=3; goto setcirpr;
			case 'Y': CirFillColor=4; goto setcirpr;
			case 'B': switch(optarg[3]) {
					case 'A': CirFillColor=0; goto setcirpr;
					case 'U': CirFillColor=2; goto setcirpr;
					default: Usage(20);
				}
			default: Usage(20);
		}
setcirpr:;
	opterr=hold;
} /* set_circle_parms */

PROCX void set_GSA5_defaults(char *opt)
{
	if(strchr(opt,',') == NULL) {
		fprintf(stderr,"Illegal -w x option: X%s\n",opt);
		return;
	}
	default_GM2_icon=atoi(strtok3(opt,","));
	default_SA52_icon=atoi(strtok3(NULL,","));
} // set_GSA5_defaults

/* -------------------------------------------------------------------------- */
/*
 *
 * -wy  = turn on waypoint drawing
 *
 *  lead in is -w xxx where xxx is defined below
 *
 * -w Dxxx set default icon to SA4 object # xxx
 *
 * set text alignment:	.NW .N .NE .W .E .SW .S .SE           where .  = a
 * set text colors:		..black ..red ..blue ..green ..yellow where .. = ct
 * set obj  colors:		..black ..red ..blue ..green ..yellow where .. = co
 * set text sizes:		..vs ..s ..m ..l ..vl                 where .. = st
 * set obj  sizes:		..vs ..s ..m ..l ..vl                 where .. = so
 * set obj  icon:       .00 to .55                            where .  = i
 *                   
 */
PROCX void set_symbol_parms()
{
	INT i;

	null_newline(optarg);
	strupr(optarg);
	trim(optarg);
	switch(optarg[0]) {
		case 'A': set_align(&optarg[1]); break;
		case 'C': set_color(&optarg[1]); break;
		case 'D': 
					if(strlen(optarg)>2)
						i=atoi(&optarg[2]);
					else {
						fprintf(stdout,"Illegal -w D<GSL> param %s\n",optarg);
						return;
					}
						
					switch(optarg[1]) {
						case 'G':
							default_Garmin_icon=i; return;
						case 'S':
							default_SA5_icon=i; return;
						case '2':
							default_G12_icon=i; return;
						case 'L':
							default_LWR_icon=i; return;
						default: fprintf(stdout,"Illegal -w D<G2SL> param %s\n",optarg);
					}
					return;
		case 'N': draw_waypoints=0; break;
		case 'S': set_size(&optarg[1]); break;
		case 'X': set_GSA5_defaults(&optarg[1]); break;
		case 'Y': draw_waypoints=1; break;
		default: fprintf(stdout,"Illegal -w param: %s\n",optarg);
	}
} /* set_symbol_parms */
 /* -------------------------------------------------------------------------- */
/*
 * allowable alignment: NW N NE W E SW S SE
 */
PROCX void set_align(char * optarg)
{
	INT hold;

	hold=opterr;
	opterr=0;
	null_newline(optarg);
	strupr(optarg);

	if(strlen(optarg) == 1) 
		switch(optarg[0]) {
			case 'N': TextAlign=1; goto setaln;
			case 'E': TextAlign=4; goto setaln;
			case 'S': TextAlign=6; goto setaln;
			case 'W': TextAlign=3; goto setaln;
			default: Usage(5);
		}

	if(strlen(optarg) == 2) 
		switch(optarg[0]) {
			case 'N':
				  if(optarg[1]=='E') {
					TextAlign=2;
					goto setaln;
				  }
				  if(optarg[1]=='W') {
				  	TextAlign=0;
					goto setaln;
				  }
				  Usage(5);

			case 'S': if(optarg[1]=='E') {
					TextAlign=7;
					goto setaln;
				  }
				  if(optarg[1]=='W') {
				  	TextAlign=5;
					goto setaln;
				  }
				  Usage(5);
		}
	Usage(5);
setaln:;
	opterr=hold;
} /* set_align */

/* -------------------------------------------------------------------------- */
/* Convert hex-ascii to integer */
PROCX INT htoi(char *s)
{
    INT i = 0;
    char c;
  
    while((c = *s++) != '\0'){
        if(c == 'x')
            continue;   /* allow 0x notation */
        if('0' <= c && c <= '9')
            i = (i * 16) + (c - '0');
        else if('a' <= c && c <= 'f')
            i = (i * 16) + (c - 'a' + 10);
        else if('A' <= c && c <= 'F')
            i = (i * 16) + (c - 'A' + 10);
        else
            break;
    }
    return i;
} /* htoi */

/* -------------------------------------------------------------------------- */
/* format is port,ioaddr,irq,baud_rate */
PROCX void decode_COM(char *b)
{
	char *p;

	trim(b);
	strlwr(b);
	p=strtok3(b,",");
	if(p==NULL) Usage(9);
	ComPort=atoi(p);
	ComPort--;
	if(ComPort<0 || ComPort>3) Usage(15);
	p=strtok3(NULL,",");
	if(p==NULL) Usage(9);
	if(p[0]=='0' && p[1]=='x') IOaddr=htoi(p);
	else IOaddr=atoi(p);
	p=strtok3(NULL,",");
	if(p==NULL) Usage(9);
	IRQnumber=atoi(p);
	if(IRQnumber<3 || IRQnumber>15) Usage(9);
	new_com=1;
} /* decode_COM */

/* -------------------------------------------------------------------------- */
//		COM1 = 03f8 IRQ 4
//		COM2 = 02f8 IRQ 3
//		COM3 = 03e8 IRQ 4
//		COM4 = 02e8 IRQ 3
PROCX void open_COM(INT rcvr)
{
	int count;

	count=0;
	if(com_open) return;
	if(ComPort==-1) ComPort=COM1; /* assume COM1 */
	if(ComPort<0 || ComPort>3) Usage(15);

/*
 * safely exit for all SIG's
 */
	signal(SIGABRT,Catcher);
	signal(SIGFPE,Catcher);
	signal(SIGILL,Catcher);
	signal(SIGINT,Catcher);
	signal(SIGSEGV,Catcher);
	signal(SIGTERM,Catcher);
	if(port_speed == 0) {
		switch(rcvr) {
			case LOWRANCE: port_speed=LOWR_BAUD_RATE; break;
			case GARMIN:   port_speed=GARMIN_BAUD_RATE;
		}
	}
#if __BORLANDC__
	if(!new_com) switch(ComPort) {
		case COM1: IOaddr=0x3f8; IRQnumber=4; break;
		case COM2: IOaddr=0x2f8; IRQnumber=3; break;
		case COM3: IOaddr=0x3e8; IRQnumber=4; break;
		case COM4: IOaddr=0x2e8; IRQnumber=3; break;
	}
startitup:;
/*
 * running on a HP 100LX/200LX?
 */
	if((lx=get_model())==2) light_sleep(DISABLE);
	if(AsyncInit(IOaddr,IRQnumber) != 0) {
		fprintf(stderr,"Error opening COM%d port: UART not found\n",ComPort+1);
		byebye(9);
	}
	AsyncSet((port_speed==115200L)?0:(int)port_speed, COM_SETTINGS);
#else
startitup:;
	AsyncInit(commp);
	AsyncSet((int)port_speed, BYTESIZE, ONESTOPBIT, NOPARITY);
#endif

	com_open=1;
//
// ID the unit the first time we open the port
//
	if(gotID==0) {
		if(rcvr==GARMIN) getID();
		if(rcvr==LOWRANCE) GetLowrID();
		if(COMtimeout==1 && rcvr==LOWRANCE) {
			count++;
			if(count>9) {
				fprintf(stderr,"Cannot find default port speed.\n");
				byebye(0);
			}
#if __BORLANDC__
			AsyncStop(IOaddr);
#else
			AsyncStop();
#endif
			switch(port_speed) {
				case 115200L: port_speed=19200L; break;
				case  19200: port_speed=57600L; break;
				case  57600L: port_speed= 9600; break;
				case   9600: port_speed=4800; break;
				case   4800: port_speed=2400; break;
				case   2400: port_speed=1200; break;
				case   1200: port_speed=115200L; break;
			}
			goto startitup;
		}
	}
} /* open_COM */

PROCX void domagmaxmin(char *in)
{
	double la,lo;
	char b[MAX_LENGTH];
	strcpy(b,in);
	(void)strtok3(b,"!");
	la=atof(strtok3(NULL,";"));
	lo=atof(strtok3(NULL,";"));
	minlat=min(minlat,la);
	maxlat=max(maxlat,la);
	minlon=min(minlon,lo);
	maxlon=max(maxlon,lo);
} /* domagmaxmin */

PROCX void calc_sa_items()
{
	unsigned int i;
	INT j,rt,magla,maglo;
	double xx,yy,ff;
	char buf[100];

	maxlat=-90.0;minlat=90.0;maxlon=-180.0;minlon=180.0;

	if(draw_waypoints)
		for(i=1;i<=waypoints;i++) domagmaxmin(waypoint_push[i]);
	if(icons) for(i=1;i<=icons;i++) domagmaxmin(icon_push[i]);
	if(draw_track_lines) {
		if(maxtrkptrs==0) {
			for(i=1;i<=tracks;i++) {
				fgets(buf,100,trks_out);
				domagmaxmin(buf);
			}
			rewind(trks_out);
		}
		else {	  // maxtrkptrs>0;
			for(i=1;i<=tracks;i++) domagmaxmin(track_push[i]);
		}
	}
	if(draw_prox_circles)
		for(i=1;i<=proximityp;i++) domagmaxmin(proximity_push[i]);
	if(draw_route_0) {
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[0][j] == NULL) continue;
			domagmaxmin(route_push[0][j]);
		}
	}

	if(draw_route_1_19_obj || draw_route_1_19_lines) {
		for(i=1;i<=MAXROUTES;i++) {
			for(j=1;j<=MAXPOINTS;j++) {
				if(route_push[i][j] == NULL) continue;
				domagmaxmin(route_push[i][j]);
			}
		}
	}
	if(s5o || s6o) magla=maglo=18;
	else magla=maglo=16;
	xx=(maxlat-minlat)/2.0;
	xx=xx*70.0;
	rt=19;
	while(--rt>3) {
		if((26500.0/pow(2.0,(double)rt)) > xx) {
			magla=rt;
			break;
		}
	}
	xx=(maxlat+minlat)/2.0;
	yy=(maxlon-minlon)/2.0;
	ff=yy*10.0;
	xx=xx*Degree;
	xx=cos(xx);
	yy=yy*60.0+ff; // fudge factor
	rt=19;
	while(--rt>3) {
		if(29800.0/pow(2.0,(double)rt)/xx > yy) {
			maglo=rt;
			break;
		}
	}
	if(setlat==1000.0) setlat=(maxlat+minlat)/2.0;
	if(setlon==1000.0) setlon=(maxlon+minlon)/2.0;
	if(setlon==0.0) {
		setlon=100.0;
		setmag=4;
	}
	if(setlat==0.0) {
		setlat=40.0;
		setmag=4;
	}
	if(setmag==0) setmag=min(magla,maglo);
	if(s5o || s6o)
		if(setmag>18) setmag=18;
	else
		if(setmag>16) setmag=16;
	if(setmag<1) setmag=1;
} /* calc_sa_items */

PROCX valid_name(char b)
{
	if(b>='A' && b<='Z') return 1;
	if(b>='0' && b<='9') return 1;
	if(b=='-') return 1;
	return 0;
} //valid_name(char b)

PROCX count_commas(unsigned char *b)
{
	INT i,j,comma;

	comma=0;
	j=strlen((char*)b);
	for(i=0;i<j;i++) if(b[i]==',') comma++;
	return comma;
} // count_commas(char *b)
/* -------------------------------------------------------------------------- */
//
//  evaluate_text_file(char *fname_in)
//
//  several file types are actually in a text format.  These currently include
//
//   .TXT, .FWP, .OWP, .OTR or an almanac file
//
// .TXT - The first non blank line's first character can be a '#', '!',
//        ';', 'D', 'R', 'E', 'I', 'W', 'T', 'N' or '0'-'9'
//        If the first character is a comment indicator, i.e. '#', '!' or ';'
//        the file must be a TEXT_IO file.
//
// .FWP - The first character can be any character that is valid in a Garmin
//        GPS waypoint.  This is 'A'-'Z', '0'-'9' and '-'.  There are 4 commas
//        per line.
//
// .OWP - The first character is 'W' the first character after the first ','
//        is a 'D' and there must be 9 commas
//
// .OTR - The first character is a 'T' and there are 6 comma's per line.

PROCX INT evaluate_text_file(char *fname_in)
{
	int done=0;
	if((in=fopen(fname_in,"r")) == NULL) {
		return NOFILE;
	}
//
// Read first non blank line
//
	while(!done) {
		if(fgets(buf,MAX_LENGTH,in) == NULL) return UNKNOWN;
		null_newline(buf);
		if(strlen(buf)) done=1;
	}

//
// back to top of file
//
	fseek(in,0L,0);

	if(instr(buf,"OziExplorer Event")) return OZI_EVT;
	if(instr(buf,"OziExplorer Track")) return OZI_PLT;
	if(instr(buf,"OziExplorer Route")) return OZI_RTE;
	if(instr(buf,"OziExplorer Waypoint")) return OZI_WPT;
//
// Almanac files start with ****
//
	if(strncmp(buf,"****",4) == 0) {
		in_file++;
		strcpy(fname_in_all,fname_in);
		return ALMANAC_D;
	}
//
// Standard Text files shouldn't have a comma
//
	done=count_commas((unsigned char*)buf);
	switch(done) {
		case 4:  if(valid_name(buf[0])) return FUGAWI_WPT;
				 else return 0;
	}
//
// Is it a standard type?
//
	if(strchr("#!DEINMZRT;W 0123456789",buf[0]) != NULL) return TEXT_IO;
	return UNKNOWN;
} // INT evaluate_text_file(char *f)

/* -------------------------------------------------------------------------- */
/*
 * returns type of input file
 *
 *  1 = gardown7 or txt
 *  2 = GPS
 *   subtypes (returned in variable g45type):
 *				 TRACKS		 1
 *				 WAYPOINTS	 2
 *				 ROUTES		 3
 *				 ID			 4
 *				 TIME		 5
 *				 POSITION	 6
 *				 ALMANAC	 7
 *				 PROXIMITY	 8
 *				 VOLTAGES 	 9
 *				 PVT		12
 *				 PPROTOCOLS	14
 *            
 *  3 = SA3
 *  4 = Almanac Data
 *  5 = Navigate Route file (*.clg)
 *  6 = SA4
 *  7 = SA5
 *  8 = Street Atlas GPL files
 *  9 = comma separated (output only)
 * 10 = Fugawi waypoint files
 * 11 = Fugawi track files
 * 12 = OziExplorer waypoint files (exported, not saved)
 * 13 = OziExplorer track files (exported, not saved)
 */
PROCX INT determine_input(char *fname_in)
{
	char b[255];
	INT i;

	strcpy(b,fname_in);
	if(strncmp(strupr(b),"G45",3) == 0) {
		in_file++;
		if(gotID==0) open_COM(GARMIN); 
		if(b[3]=='T') { g45type=TRACKS; return GARMIN; }
		if(b[3]=='W') { g45type=WAYPOINTS; return GARMIN; }
		if(b[3]=='R') { g45type=ROUTES; return GARMIN; }
		if(b[3]=='D') { g45type=ID; return GARMIN; }
		if(b[3]=='G') { 
			g45type=PVT;
			interval=atol(&b[4]);
			return GARMIN;
		}
		if(b[3]=='I') { g45type=TIME; return GARMIN; }
		if(b[3]=='J') { g45type=PPROTOCOLS; return GARMIN; }
		if(b[3]=='P') {
			g45type=POSITION;
			interval=atol(&b[4]);
			return GARMIN;
		}
		if(b[3]=='A') { g45type=ALMANAC; return GARMIN; }
		if(b[3]=='X') { g45type=PROXIMITY; return GARMIN; }
		if(b[3]=='V') { g45type=VOLTAGES; return GARMIN; }
		in_file--;
		return GERROR;
	}
	if(strncmp(strupr(b),"LWR",3) == 0) {
		in_file++;
		if(gotID==0) open_COM(LOWRANCE); 
		if(b[3]=='1') { LowrType=TRACK1; return LOWRANCE; }
		if(b[3]=='2') { LowrType=TRACK2; return LOWRANCE; }
		if(b[3]=='W') { LowrType=LWRWPTS; return LOWRANCE; }
		if(b[3]=='R') { LowrType=LWRRTS; return LOWRANCE; }
		if(b[3]=='D') { LowrType=LWRID; return LOWRANCE; }
		if(b[3]=='I') { LowrType=LWRICONS; return LOWRANCE; }
		if(b[3]=='S') { 
			LwrRangeLo=atoi(&b[4]);
			p=strrchr(b,',');
			LwrRangeHi=atoi(++p);
			LowrType=LWRWPTS;
			return LOWRANCE;
		}
		in_file--;
		return LOWRERROR;
	}
	strcpy(fname_in_all,fname_in);
//
// Check for pre-defined file types
//
	(void)fnsplit(fname_in,drive,dir,file,ext);

	if(strlen(ext)) {
		if(strcmp(strupr(ext),".CLG") == 0) { in_file++; return NAVROUTE; }
		if(strcmp(strupr(ext),".FWP") == 0) { in_file++; return FUGAWI_WPT; }
		if(strcmp(strupr(ext),".GPL") == 0) { in_file++; return SA_GPL; }
		if(strcmp(strupr(ext),".EVT") == 0) { in_file++; return OZI_EVT; }
		if(strcmp(strupr(ext),".PLT") == 0) { in_file++; return OZI_PLT; }
		if(strcmp(strupr(ext),".RTE") == 0) { in_file++; return OZI_RTE; }
		if(strcmp(strupr(ext),".WPT") == 0) { in_file++; return OZI_WPT; }
		if(strcmp(strupr(ext),".SA3") == 0) { in_file++; return SA3; }
		if(strcmp(strupr(ext),".SA4") == 0) { in_file++; return SA4; }
		if(strcmp(strupr(ext),".SA5") == 0) { in_file++; return SA5; }
		if(strcmp(strupr(ext),".SA6") == 0) { in_file++; return SA6; }
		if(strcmp(strupr(ext),".TRK") == 0) { in_file++; return FUGAWI_TRK; }
//		if(strcmp(strupr(ext),".TXT") == 0) { in_file++; return TEXT_IO; }
		if(strcmp(strupr(ext),".CSV") == 0) { in_file++; return CSV_IN; }
	} // if(strlen(ext))
/*
 * check input filetype
 */
	if((i=evaluate_text_file(fname_in)) > 0) {
		in_file++;
		return i;
	}
	if(i==NOFILE) {
		return NOFILE;
	}
	return UNKNOWN;
} /* determine_input*/

#if __BORLANDC__
/* -------------------------------------------------------------------------- */
/*
 * returns:   0 - not an HP LX calculator
 *            1 - is an HP95LX
 *            2 - is an HP100LX
 */
PROCX INT get_model(void)
{

	INT HP;
	INT model;
	INT family;

asm {
	push bx;
	push cx;
	push dx;

	xor bx,bx
	mov ax,4dd4h
	INT 15h

	mov HP,bx
	xor ah,ah
	mov al,ch
	mov family,ax
	xor ah,ah
	mov al,cl
	mov model,ax

	pop dx;
	pop cx;
	pop bx;

}
	if(HP!=0x4850) return(0);
	if(family!=1) return(0);
	return model;

} /* get_model */

/* -------------------------------------------------------------------------- */
/*
 * HP100/200LX:  If light sleep is enabled during interrupt driven serial
 *  communications the system *will* eventually crash and burn....turn it off
 *
 * onoff = 0, light sleep disabled
 * onoff = 1, light sleep enabled
 *
 */
PROCX void light_sleep(char onoff)
{
    asm {
	mov	ah,0x4e;
	mov	al,onoff;
	INT 0x15;
/*
 * we will also turn the rs232 port to the wire
 */
 	mov	ah,0x49;
	mov	al,0;		/* 1 selects IR, 0 selects wire */
	int	0x15;
    }
/*
 * and turn it on or off
 */
 	if(onoff==DISABLE) {   /* turn power off when light sleep is off*/
		asm mov ax,0x4a01;
		asm INT 0x15;
	}
	else {			/* turn it on */
		asm mov ax,0x4a00;
		asm INT 0x15;
	}
} /* light_sleep */

extern unsigned long RXints,TXints,Is_16550a;
extern INT RXhw,TXhw,TXoverrun,RXoverrun;

/* -------------------------------------------------------------------------- */
PROCX void doasystat(void)
{
       /* printf(" Baud : %lu, I/O Addr: %x, IRQ:%x\n",
		asyp->speed, asyp->addr, asyp->vec); */
        
    printf(" Rcvr Ints: %5lu, Rcvr HiWtr: %3d, Rcvr Overruns: %d\n",
    	     RXints,RXhw,RXoverrun);
    
    printf(" Xmtr Ints: %5lu, Xmtr HiWtr: %3d, Xmtr Overruns: %d\n",
    	     TXints,TXhw,TXoverrun);
    fflush(stdout);
} /* doasystat */
#else
PROCX void doasystat(void){}
#endif

/* -------------------------------------------------------------------------- */
/*
 * strip_chars
 *
 *  Strips spaces and # characters from an input string
 */
PROCX void strip_chars(char *s)
{
	INT i,o;

	i=o=0;

	for(i=0;i<strlen(s);i++) {
		if(s[i]==' ' || s[i]=='#') continue;
		s[o++]=s[i];
	}
	s[o]=0;
	s[15]=0;
} // strip_chars()

#if !__BORLANDC__
PROCX getftime(int fn, struct mftime *ft)
{
	struct _stat buf;   
	struct tm *tm;
	INT result;
  
// Get data associated with "fh":
	result = _fstat( fn, &buf );
// Check if statistics are valid:
	if( result == 0 ) {
		tm=localtime(&buf.st_mtime);
		ft->ft_day = tm->tm_mday;
		ft->ft_month = tm->tm_mon+1;
		ft->ft_year = tm->tm_year-80;
		ft->ft_hour = tm->tm_hour;
		ft->ft_min = tm->tm_min;
		ft->ft_tsec = tm->tm_sec/2;
		return 0;
	}
	return 1;
} // INT getftime (INT fn, struct ft *ft)
#endif

/* -------------------------------------------------------------------------- */
/*
 * reads navigate.exe route.clg file
 */
PROCX void read_nav_route()
{
	long lat,lon;
	char b[100];
	double ll,lo;
	INT first_w;
	unsigned INT filetype;
	INT NumWaypoints,numroutes,i,j;
	unsigned char dummy[11];
	char Rname_len,Wname_len,Wnote_len;
	char *RouteName=NULL,*WayPointNote=NULL, *WayPointName=NULL;

	for(i=0;i<=MAXROUTES;i++) routeXpts[i]=0;

	openit("rb");

 	fread(&numroutes,2,1,in);
 	fread(&filetype,2,1,in);
	if(filetype!=0xffff) {
		fclose(in);
		fprintf(stderr,"File %s is not a valid routes.clg file\n",fname_in_all);
		return;
	}
	fseek(in,0L,0);
 	fread(&numroutes,2,1,in);
/*
 * read route name
 */
 	first_w=1;
 	for(j=1;j<=numroutes;j++) {
		in_route=1;
	 	route_number=j;
 		route_point=0;
		sprintf(rtn," %02d",j);
		if(j==1)
			fread(dummy,10,1,in); /* skip 0xffff,0x0000,4, CRte */
		else
			fread(dummy,2,1,in); /* skip 0x8001 */
		fread(&Rname_len,1,1,in);
	 	ChkFree(RouteName);
	 	if((RouteName=(char *)malloc(Rname_len+1)) == NULL) oomem("readNavRoute");
	 	fread(RouteName,Rname_len,1,in);
		RouteName[Rname_len]=0;
		if(Rname_len>40) RouteName[40]=0;
		strcpy(route_comment,RouteName);
		fread(&NumWaypoints,2,1,in);
		routeXpts[j]=NumWaypoints;
/*
 * read waypoints
 */
		for(i=1;i<=NumWaypoints;i++) {
			record.class = 255;  // default to 'user'
			if(first_w)
				fread(dummy,10,1,in); /* skip 0xffff,
				                         0x0000,4, CWpt */
			else
				fread(&dummy,2,1,in);  /* skip 0x8003 */
			first_w=0;

			fread(&Wname_len,1,1,in);
	 		ChkFree(WayPointName);
	 		if((WayPointName=(char *)malloc(Wname_len+1)) == NULL) oomem("readNavRoute1");


			fread(WayPointName,Wname_len,1,in);
			WayPointName[Wname_len]=0;

			fread(&Wnote_len,1,1,in);
	 		ChkFree(WayPointNote);

	 		if((WayPointNote=(char *)malloc(Wnote_len+1)) == NULL) oomem("readNavRoute2");
	 		fread(WayPointNote,Wnote_len,1,in);
			WayPointNote[Wnote_len]=0;

	 		fread(&lat,4,1,in);
			fread(&lon,4,1,in);
			ll=(double)lat; record.la=ll/=60000.0;
			lo=-(double)lon; record.lo=lo/=60000.0;

			(void)toDMlat(record.la);
			(void)toDMlon(record.lo);

			strip_chars(WayPointName);

			strncpy(record.ident,WayPointName,15);
			record.ident[15]=0;
/*
 * Comment, up to 40 characters
 */
			strncpy(record.comment, WayPointNote,40);
			record.comment[40]=0;
			trim(record.ident);
			trim(record.comment);
			strupr(record.comment);
			sprintf(Text,"%c;0;%s;%s",'W',record.ident,record.comment);
			strcpy(b,Text);
			push_route();
			strcpy(Text,b);
			push_waypoint();
		} /* for each point in route */
	} /* for each route */
} /* read_nav_route */

/* -------------------------------------------------------------------------- */
PROCX void strip_tr_0(char *b)
{
	INT i;
	for(i=0;i<strlen(b);i++) if(b[i]=='0') b[i]=' ';
	trim(b);
	for(i=0;i<strlen(b);i++) if(b[i]==' ') b[i]='0';
} /* strip_tr_0 */

/* -------------------------------------------------------------------------- */
PROCX void openit(char *mode)
{
	if((in=fopen(fname_in_all,mode))==NULL) {
		fprintf(stderr,"Can't open file '%s'\n",fname_in_all);
		byebye(8);
	}
	if(getftime(fileno(in),&ft) != 0) {
	    fprintf(stderr,"File time err, File:%s\n", fname_in_all);
		fclose(in);
	    byebye(7);
	}
	record.dayofmonth=ft.ft_day;
	record.monthn=ft.ft_month;
	record.year=ft.ft_year+1980;
	record.ht=ft.ft_hour;
	record.mt=ft.ft_min;
	record.st=ft.ft_tsec*2;
/*
 * date/time
 */
	set_datetime();
} /* openit */
/* -------------------------------------------------------------------------- */
PROCX void do_input(INT i)
{
	INT c,hold;
	time_t t;

	hold=opterr;
	opterr=0;
	intype=determine_input(infiles[i]);
	current_in=i;
//
// assume the input is WGS-84...it is for everything except text
//
	strcpy(inputdatum,"WGS-84");
	set_datum(inputdatum,outputdatum);
	switch(intype) {
		case UNKNOWN: fprintf(stderr,"Unknown input file type: '%s'\n",infiles[i]);
					  break;
		case NOFILE: fprintf(stderr,"Unable to open input file:'%s'\n",infiles[i]);
					 break;
		case TEXT_IO: read_text();
					if(valid_records==0) fprintf(stderr,"No valid records found in file '%s'\n",infiles[i]);
				   break;
		case ALMANAC_D: 
				open_COM(GARMIN);
				if(AlmanacDataRecord==500||AlmanacDataRecord==501) {
					doSAlmanac500();
				}
				else fprintf(stderr,"Almanac Protocol Record D%03d not implemented\n",
							AlmanacDataRecord);
				break;
		case GARMIN: 
				switch(g45type) {
					case TRACKS: getTrack(); break;
					case WAYPOINTS: getWaypoints(); break;
					case ROUTES: getRoute(); break;
					case ID: printf("Product ID: %d\n",Product_ID);
							 printf("%s\n",VersionString);
							 for(c=0;c<VersionSubStrings;c++) {
							 	if(VersionSubString[c] != NULL) printf("%s\n",VersionSubString[c]);
								else break;
							 }
							 break;
					case TIME:	getGPSTime();
								printf("%s\n",record.datetime);	
								break;
					case PPROTOCOLS:
							print_protocols();
							break;
					case PVT:
							if(PVTXferProtocol<0) {
								fprintf(stderr,"PVT Not supported by this GPS (%s).\n",VersionString);
								break;
							}
							if(interval) {
								getPVT();
								while(interval-->0) {
									c=kbraw();
									if(c=='x' || c=='X') break;
									getGarminMessage(1);
								}
								stopPVT();
							}
							else {
								getPVT();
								while(1) {
									c=kbraw();
									if(c=='x' || c=='X') break;
									getGarminMessage(1);
								}
								stopPVT();
							}
							break;

					case POSITION: if(!interval) {
							getGPSPosition();
							getGPSTime();
							printf("T  %s %s %s\n",
								toDMlat(record.la),toDMlon(record.lo),record.datetime);
							fflush(stdout);
						}
						else {
							getGPSPosition();
							getGPSTime();
							printf("T  %s %s %s\n",
								toDMlat(record.la),toDMlon(record.lo),record.datetime);
							while(1) {
								t=time(NULL);
								while(time(NULL)-t < interval) {
									c=kbraw();
									if(c=='x' || c=='X') return;
								}
								getGPSPosition();
								getGPSTime();
								printf("T  %s %s %s\n",
									toDMlat(record.la),toDMlon(record.lo),record.datetime);
							}
						}
						break;
					case ALMANAC:
							getAlmanac();
							break;
			
					case PROXIMITY: 
							if(ProxXferProtocol>0) getProxWaypoints();
							else fprintf(stderr,"Proximity not supported by %s.\n",VersionString);
							break;
			
					case VOLTAGES:
							getGPSVolts();
							break;
			
					default: fprintf(stderr,"Unknown GPS-45 read function: %s\n",infiles[current_in]);
				} //switch(g45type)
				if((dataread==0) &&
				   (gotID>0) &&
				   ((waypoints>0) || (proximityp>0) || (tracks>0))) {
				    dataread=1;
				   	if(tmode) printf("# Data read from : %s\n",VersionString);
			    }
			    if(doAsyncStat) doasystat();
			    break;

		case LOWRANCE:
				switch(LowrType) {
					case TRACK1:
					case TRACK2:
								if(LowrID.ProtocolVersion==0)
									GetLowrTrackMem((INT)LowrType);	// Protocol version 1.0
								else
									GetLowrTrack((INT)LowrType);	// Protocol version 2.0
								break;
					case LWRWPTS: GetLowrWpts(); break;
					case LWRRTS: GetLowrRts(); break;
					case LWRICONS: GetLowrIcons(); break;
					case LWRID: GetLowrID();
								NumOfPlotTrails=LowrID.NumOfPlotTrails;
								printf("GPS Is a Lowrance %s\n",LowrProducts[LowrID.ProductID]);
								printf("ProtocolVersion       : %d.0\n",1+LowrID.ProtocolVersion);
								printf("Screentype            : %d\n",LowrID.ScreenType);
								printf("ScreenWidth           : %d\n",LowrID.ScreenWidth);
								printf("ScreenHeight          : %d\n",LowrID.ScreenHeight);
								printf("NumOfWaypoints        : %d\n",LowrID.NumOfWaypoints);
								printf("NumOfIcons            : %d\n",LowrID.NumOfIcons);
								printf("NumOfRoutes           : %d\n",LowrID.NumOfRoutes);
								printf("NumOfWaypointsPerRoute: %d\n",LowrID.NumOfWaypointsPerRoute);
								printf("NumOfPlotTrails       : %d\n",LowrID.NumOfPlotTrails);
								printf("NumOfIconSym          : %d\n",LowrID.NumOfIconSym);
								printf("ScreenRotateAngle     : %d\n",LowrID.ScreenRotateAngle);
								printf("RunTime               : %ld\n",LowrID.RunTime);
								break;
					default: fprintf(stderr,"Unknown Lowrance read function: %s\n",infiles[current_in]);
				}
				break;
		case SA3:
		case SA4:
		case SA5:
		case SA6:
				openit("rb");
				if(read_sa3_header(in,fname_in_all) == -1) break;
				read_sa3(in);
				break;

		case SA_GPL:
				openit("rb");
				read_GPL();
				break;
			
		case NAVROUTE:
				openit("rb");
				read_nav_route();
				break;

		case FUGAWI_WPT:
				openit("rb");
				read_FUGAWI_wpt();
				break;

		case FUGAWI_TRK:
				openit("rb");
				read_FUGAWI_trk();
				break;

		case OZI_RTE:
				openit("r");
				read_OZI_rte();
				break;

		case OZI_WPT:
				openit("r");
				read_OZI_wpt();
				break;

		case OZI_EVT:
				openit("r");
				read_OZI_evt();
				break;

		case OZI_PLT:
				openit("r");
				read_OZI_plt();
				break;

		case CSV_IN:
				openit("r");
				read_CSV();
				break;

		case GERROR: break;
		default: Usage(11);
	} /* switch */
	opterr=hold;
} /* do_input */

/* -------------------------------------------------------------------------- */
PROCX void determine_output(INT fno)
{
	INT hold;
	char b[255];

	strcpy(b,outfiles[fno]);
	if(strncmp(strupr(b),"G45",3)==0) {
		tog45=1;
		if((gotID==0) || (com_open==0)) open_COM(GARMIN);
		if(b[3]==0) return;
		if(b[3]=='O') {pwr++; return;}
		if(b[3]=='L') {
			light=atoi(&b[4]);
			return;
		}
		if(b[3]=='C') {
			contrast_val=atoi(&b[4]);
			return;
		}
		fprintf(stderr,"'-o %s' is not a valid g45 output command.\n",
					outfiles[fno]);
		return;
	}
	if(strncmp(strupr(b),"LWR",3)==0) {
		toLowr=1;
		if(strlen(b)>3) {
			if(b[3]>='1' && b[3]<='9') {
				to_lowr_track=b[3]-'0';
				b[3]=0;
			}
			if(b[3]=='S') { 				// New Start Point?
				LwrStartPt=atoi(&b[4]);
				b[3]=0;
			}
		}
		else {
			to_lowr_track=0;
		}

		if((gotID==0) || (com_open==0)) open_COM(LOWRANCE);
		if(b[3]==0) return;
		fprintf(stderr,"'-o %s' is not a valid Lowrance output command.\n",
					outfiles[fno]);
		return;
	}
	else {
	   (void)fnsplit(b,drive,dir,file,ext);
		strcpy(fname_out_all,outfiles[fno]);
		if(strlen(ext)) {
				if(strcmp(ext,".SA3") == 0) { s3o=1; return; }
                if(strcmp(ext,".SA4") == 0) { s4o=1; return; }
                if(strcmp(ext,".SA5") == 0) { s5o=1; return; }
                if(strcmp(ext,".SA6") == 0) { s6o=1; return; }
                if(strcmp(ext,".G64") == 0) { g6=1; return; }
                if(strcmp(ext,".CLG") == 0) { navmode=1; return; }

                if(strcmp(ext,".EVT") == 0) { ozievt=1; return; }
                if(strcmp(ext,".WPT") == 0) { oziwpt=1; return; }
                if(strcmp(ext,".PLT") == 0) { oziplt=1; return; }
                if(strcmp(ext,".RTE") == 0) { ozirte=1; return; }

                if(strcmp(ext,".FWP") == 0) { fugawiwpt=1; return; }
                if(strcmp(ext,".TRK") == 0) { fugawitrk=1; return; }

                if(strcmp(ext,".WTT") == 0) { waypoint2trk=1; return; }
                if(strcmp(ext,".IGC") == 0) { igctrackout=1; return; }
                if(strcmp(ext,".GPL") == 0) { gpl_out=1; return; }
                if(strcmp(ext,".CSV") == 0) { csv_out=1; return; }
                if(strcmp(ext,".BMP") == 0) { getGarminDisp=1; in_file++; return; }
                if(strcmp(ext,".TXT") == 0) { tmode=0; TextFileOutput=1; return; }
		} // if(strlen(ext))
	}
	hold=opterr;
	opterr=0;
	Usage(21);
	opterr=hold;
} /* determine_output */

PROCX INT open_output(char *mode)
{
	INT i;

	if((out=fopen(fname_out_all,mode))==NULL) {
		i=opterr;
		opterr=0;
		Usage(26);
		opterr=i;
		return 0;
	}
	return 1;
} /* open_output */

/* -------------------------------------------------------------------------- */
PROCX void output_g64()
{
	unsigned int i;
	int j;

	if(open_output("w")==0) return;
	in_route=0;
	if(waypoints) {
		for(i=1;i<=waypoints;i++) {
			fill_waypoint_from_push(i,NORMAL_WP,0);
			print_g64_w();
		}
	}
	if(tracks) {
		for(i=1;i<=tracks;i++) {
			fill_track(i,0);
			print_g64_t();
		}
	}
	in_route=1;
	for(i=0;i<MAXROUTES;i++) {
		route_number=i;
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j]==NULL) continue;
			strcpy((char*)bin,route_push[i][j]);
			if(j==1)
				fill_waypoint_from_push(i,ROUTE_1_WP,0);
			else
				fill_waypoint_from_push(i,ROUTE_WP,0);
			print_g64_w();
		}
	}
	in_route=0;
	fclose(out);
} /* output_g64 */

/* -------------------------------------------------------------------------- */
PROCX void output_nav()
{
	int i,j;

	if(open_output("wb")==0) return;
	firstR=firstW=0;
	in_route=1;
	for(i=0;i<MAXROUTES;i++) {
		route_number=i;
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j]==NULL) continue;
			strcpy((char*)bin,route_push[i][j]);
			if(j==1) {
				fill_waypoint_from_push(i,ROUTE_1_WP,0);
				navSRouteS();
			}
			else {
				fill_waypoint_from_push(i,ROUTE_WP,0);
			}
			navSWaypoint();
		}
	}
	in_route=0;
	fclose(out);

} /* output_nav */

/* -------------------------------------------------------------------------- */
PROCX void do_output(INT fno)
{
	
	s3o=s6o=s5o=s4o=g6=navmode=csv_out=gpl_out=getGarminDisp=oziplt=ozievt=ozirte=
	                            tog45=oziwpt=fugawiwpt=fugawitrk=
								igctrackout=waypoint2trk=0;
//
// input is stored in WGS-84 format
//
//  The output datum can be changed by the -U parameter
//
	set_datum("WGS-84",outputdatum);
	determine_output(fno);
	if(in_file) {
		if(tracks) count_tracks();
		count_routes();
		if(TextFileOutput) {output_text(); return; }
		if(s3o) 	{output_sa3(); return;}
		if(s4o) 	{output_sa4(); return;}
		if(s5o || s6o){output_sa4(); return;}
		if(g6) 		{output_g64(); return;}
		if(navmode)	{output_nav(); return;}
		if(ozievt)	{output_OZI_evt(); return;}
		if(oziwpt)	{output_OZI_wpt(); return;}
		if(oziplt)	{output_OZI_plt(); return;}
		if(ozirte)	{output_OZI_rte(); return;}
		if(igctrackout)	{output_IGC_trk(); return;}
		if(fugawiwpt)	{output_FUGAWI_wpt(); return;}
		if(fugawitrk)	{output_FUGAWI_trk(); return;}
		if(waypoint2trk)	{output_wpt2trk(); return;}
		if(gpl_out)	{output_GPL(); return;}
		if(csv_out) {output_CSV(); return;}
		if(DisplayIsLowrance) {
			if(getGarminDisp) { open_COM(LOWRANCE); GetLowrDisplay(); return;}
		}
		else {
			if(getGarminDisp) { open_COM(GARMIN); getGarminDisplay(); return;}
		}
	}
	else {
		if(s3o || s6o || s5o || s4o || g6 ||   
		   navmode || gpl_out || fugawiwpt || fugawitrk || waypoint2trk) {
			opterr=0;
			Usage(10);
		}
	}
	if(tog45) 	output_g45();
	if(toLowr)	OutputLowr();
} /* do_output */

/*
 *  Items stored in a pushed waypoint string.  All items are separated by
      a trailing ';' except the date string which is trailed by a '!'.
	The datum for lat/long stored in the record is WGS-84
	Note:  even the last item is trailed by a ';'

 	W			- record type
	HWY99-		- waypoint name
	HWY99-HWY42	- waypoint comment
	ROUTE NAME	- only present on the first route waypoint
	Date string	- date  (separated from rest of record by a '!', NOT a ';')
	Latitude	-  dd.mmmmmmm '-' for S
	Longitude	- ddd.mmmmmmm '-' for E
----------------------
 all records except Proximity
	sa3/4 object- 0-55
----------------------
 Proximity Record:
	Prox dist	- Proximity distance in meters ONLY IN A PROXIMITY RECORD
	CirLineDraw - sa4 circle parameters
	CirFillArea - sa4 circle parameters
	CirLineColor- sa4 circle parameters
	CirLineWidth- sa4 circle parameters
	CirFillColor- sa4 circle parameters
	CirFillStyle- sa4 circle parameters
----------------------
 Normal waypoint record:
	ObjCode     - sa3/4 symbol parameters
	ObjSize     - sa3/4 symbol parameters
	ObjColor    - sa3/4 symbol parameters
	TextSize    - sa3/4 symbol parameters
	TextColor   - sa3/4 symbol parameters
	TextAlign   - sa3/4 symbol parameters
----------------------
 all records
	icon_smbl   - Garmin icon type
----------------------
 all route waypoint records (sa4 output with -b on command line)
	Route_LineColor - route line color
	Route_LineWidth - route line width
	Route_LineStyle - route line width
----------------------
 all records
	nameonly parameter
----------------------
 */
//
// Used in output
//
PROCX void fill_waypoint_from_push(int i,int wayp_type, int convert)
{
	char *p;
	char bfr[MAX_LENGTH];

	switch(wayp_type) {
		case NORMAL_WP: 
			strcpy(bfr,waypoint_push[i]);
			break;

		case PROX_WP: 
			strcpy(bfr,proximity_push[i]);
			break;

		case NORMAL_WP_1:
		case ROUTE_1_WP:
		case ROUTE_WP: 
			strcpy(bfr,(char*)bin);
			break;
	}
	p=strtok3(bfr,";");
	if(p==NULL) record.type='W';
	else record.type=p[0];

	if(record.type=='W' || record.type=='T' || record.type=='P') {
		datatype=atoi(strtok3(NULL,";"));
	}
	p=strtok3(NULL,";");
	if(p==NULL) strcpy(record.ident," ");
	else strcpy(record.ident,p);
	record.ident[15]=0;

	p=strtok3(NULL,";");
	if(p==NULL) strcpy(record.comment," ");
	else strcpy(record.comment,p);

	if(wayp_type==ROUTE_1_WP) {
		p=strtok3(NULL,";");
		strcpy(route_comment,p);
	}

	p=strtok3(NULL,"!");
	if(p==NULL) strcpy(record.datetime,"Wed May 28 19:44:04 1997");
	else strcpy(record.datetime,p);

	p=strtok3(NULL,";");
	record.la=atof(p);    // - = S.  

	p=strtok3(NULL,";");
	record.lo=atof(p);    // - = W.  
	set_ns();
	if(convert) convert_datum(outputdatum);
	if(wayp_type==PROX_WP) {
		p=strtok3(NULL,";");
		record.ProxDist=(float)atof(p);
		CirLineDraw=sa4mapcircle.area_draw_line=atoi(strtok3(NULL,";"));
		CirFillArea=sa4mapcircle.area_draw_fill=atoi(strtok3(NULL,";"));
		CirLineColor=sa4mapcircle.LineColor=atoi(strtok3(NULL,";"));
		CirLineWidth=sa4mapcircle.LineWidth=atoi(strtok3(NULL,";"));
		CirFillColor=sa4mapcircle.area_fill_color=atoi(strtok3(NULL,";"));
		CirFillStyle=sa4mapcircle.area_fill_style=atoi(strtok3(NULL,";"));
	}
	else {
		ObjCode=atoi(strtok3(NULL,";"));
		ObjSize=atoi(strtok3(NULL,";"));
		ObjColor=atoi(strtok3(NULL,";"));
		TextSize=atoi(strtok3(NULL,";"));
		TextColor=atoi(strtok3(NULL,";"));
		TextAlign=atoi(strtok3(NULL,";"));
	}
	record.icon_smbl=atoi(strtok3(NULL,";"));
	record.icon_dspl=atoi(strtok3(NULL,";"));
	nameonly=atoi(strtok3(NULL,";"));

	if(wayp_type!=PROX_WP) {
		record.class=atoi(strtok3(NULL,";"));
		strcpy(record.name,strtok3(NULL,";"));
		strcpy(record.city,strtok3(NULL,";"));
		strcpy(record.state,strtok3(NULL,";"));
		strcpy(record.cc,strtok3(NULL,";"));
	}

	if((wayp_type==ROUTE_1_WP) || (wayp_type==ROUTE_WP)) {
		Route_LineColor=atoi(strtok3(NULL,";"));
		Route_LineWidth=atoi(strtok3(NULL,";"));
		Route_LineStyle=atoi(strtok3(NULL,";"));
	}
	p=strtok3(NULL,";");
	if(p!=NULL) via=atol(p);
	else via=0;
	p=strtok3(NULL,";");
	if(p!=NULL) record.color=atoi(p);
	else record.color=0;
//
// get StreetPilot info
//
	D105orD106=0;
	if(instr(record.ident,"SPW")==1) {
		D105orD106=1;
		p=strtok3(NULL,";");
		if(p!=NULL)
			strcpy((char*)StreetPilotWptName,p);
		else
			strcpy((char*)StreetPilotWptName,record.comment);
			
		if(wayp_type==ROUTE_WP) {
			strcpy((char*)StreetPilotLnk_ident,strtok3(NULL,";"));
			record.class=atoi(strtok3(NULL,";"));
			for(i=0;i<13;i++) record.subclass[i]=atoi(strtok3(NULL,";"));
		}
	}
	datetime2record(record.datetime);
	set_ns();
} /* fill_waypoint_from_push */

/* -------------------------------------------------------------------------- */
PROCX  void count_routes()
{
	INT i,j;

	route_lines=0;
	for(i=0;i<=MAXROUTES;i++) {
		routeXpts[i]=0;
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j]==NULL) continue;
			routeXpts[i]++;
		}
		if(i>0 && routeXpts[i]>1) route_lines++;
	}
	routes=0;
	for(i=0;i<=MAXROUTES;i++)
		routes=routes+routeXpts[i];
	route0=routeXpts[0];
} /* count_routes */

/* -------------------------------------------------------------------------- */
PROCX void count_tracks()
{
	unsigned INT i;
	INT trk=0;

	s4o_trk_recs=0;
	trk=0;
	if(maxtrkptrs>0) {
		for(i=1;i<=tracks;i++) {
			if(track_push[i][0]=='N') {
				trks[++trk]=1;
				s4o_trk_recs++;
				continue;
			}
			trks[trk]++;
		}
	}
	else {
		for(i=1;i<=tracks;i++) {
			fgets(buf,100,trks_out);
			if(buf[0]=='N') {
				trks[++trk]=1;
				s4o_trk_recs++;
				continue;
			}
			trks[trk]++;
		}
		rewind(trks_out);
	}
} /* count_tracks */

/* -------------------------------------------------------------------------- */
//N;;!43.678912;122.461515;0;1;0;Wed Apr 10 09:23:56 1996
//T;;!43.528912;122.406617;0;1;0;Wed Apr 10 19:23:56 1996//
//
// Used in output
//
PROCX void fill_track(int ele, INT convert)
{
	char bfr[MAX_LENGTH],*p;
	time_t t;

	if(strlen(record.datetime)==0) {
		t = time(NULL) - 631065600L;
    	strcpy(record.datetime,secs2dt(t, (short)gPrefs.offset));
	}
	if(maxtrkptrs>0) {
		strcpy(bfr,track_push[ele]);
	}
	else {
//
// this works because fill_track is only called from within
//  a for loop.  The next returned is always the next one
//
		fgets(bfr,100,trks_out);
	}
	chch=bfr[0];
	p=strtok3(bfr,";");
	if(p==NULL) record.type='T';
	else record.type=p[0];

	if(record.type=='N') {
		newTrack=1;
		record.type='T';
	}
	else newTrack=0;
	p=strtok3(NULL,"!"); // skip junk and get to latitude

	p=strtok3(NULL,";");
	record.la=atof(p);

	p=strtok3(NULL,";");
	record.lo=atof(p);
	set_ns();

	if(convert) convert_datum(outputdatum);

	LineColor=sa4mapline.LineColor=atoi(strtok3(NULL,";"));
	LineWidth=sa4mapline.LineWidth=atoi(strtok3(NULL,";"));
	LineStyle=sa4mapline.LineStyle=atoi(strtok3(NULL,";"));
	p=strtok3(NULL,";");
	if(p!=NULL) {
		strcpy(record.datetime,p);
		datetime2record(record.datetime);
	}
	if(ZeroTime==1) {
		strcpy(record.datetime,"Sun Dec 31 00:00:00 1989");
	}
	if(s3o) {
		sa3symbol.ObjColor=sa4mapline.LineColor;
	}
} /* fill_track */
/* -------------------------------------------------------------------------- */
/*
N;;!44.184018;122.073652;0;1;0;
T;;!44.183368;122.073243;0;1;0;
 */
PROCX void print_tracks()
{
	unsigned INT i;
	INT points;

	sum_dist=0.0;
	track_d=0.0;
	points=0;
	symb=SA_TRACK;
	for(i=1;i<=tracks;i++) {
		fill_track(i,1);  // also sets chch;
		chk_cmdline();
		if(total_dist) {
			if(chch=='N') {
				if(points>0) {
					sum_dist+=track_d;
					if(TextFileOutput) {
						fprintf(out," Dist: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
						        track_d,track_d*1.15078,track_d*1.852);
						fprintf(out," DSum: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
							sum_dist, sum_dist*1.15078, sum_dist*1.852);
					}
					else {
						printf(" Dist: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
						        track_d,track_d*1.15078,track_d*1.852);
						printf(" DSum: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
							sum_dist, sum_dist*1.15078, sum_dist*1.852);
					}
					track_d=0.0;
					points=1;
				}
				if(TextFileOutput) {
					fprintf(out,"N  New Track Start\n");
				}
				else {
					if(tmode)printf("N  New Track Start\n");
				}
			}
			else {
				points++;
				if(points>0) track_d+=distance(lastlat,lastlon,record.la,record.lo);
			}
			lastlat=record.la;
			lastlon=record.lo;
		}
		else {
			if(TextFileOutput) {
				if(chch=='N') fprintf(out,"N  New Track Start\n");
			}
			else {
				if(chch=='N' && tmode) printf("N  New Track Start\n");
			}
		}
		if(TextFileOutput) {
			fprintf(out,"%c  %s%s\n", record.type,latlongstr(), record.datetime);
		}
		else {
			printf("%c  %s%s\n", record.type,latlongstr(), record.datetime);
		}
	}
	if(total_dist) {
		sum_dist+=track_d;
		if(TextFileOutput) {
			if(points>1)
				fprintf(out," Dist: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
				        track_d,track_d*1.15078,track_d*1.852);
				fprintf(out," DSum: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
					sum_dist, sum_dist*1.15078, sum_dist*1.852);
		}
		else {
			if(points>1)
				printf(" Dist: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
				        track_d,track_d*1.15078,track_d*1.852);
				printf(" DSum: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
					sum_dist, sum_dist*1.15078, sum_dist*1.852);
		}
	}
	sum_dist=track_d=0.0;
} /* print_tracks */

/* -------------------------------------------------------------------------- */
PROCX void print_icons()
{
	INT j;

	symb=SA_SYMBOL;
	for(j=1;j<=icons;j++) {
		fill_icon(j,(unsigned char *)"",1);
		chk_cmdline();
		if(TextFileOutput) {
			fprintf(out,"%c  %s;%5d;\n",record.type,latlongstr(), record.icon_smbl);
		}
		else {
			printf("%c  %s;%5d;\n",record.type,latlongstr(), record.icon_smbl);
		}
	}

} // void print_icons
/* -------------------------------------------------------------------------- */
/*
01234567890123456789212345678931234567894123456789512345678961234567897123456789
P  99-FAY          N44 27.7018 W123 06.6170 Mon Jan  1 11:22:33 1989 99-FAYETTEVILLE  16093.5
 */
PROCX void print_waypoints(INT wayp_type,INT pb)
{
	int i,j=1;
	char bfr[MAX_LENGTH];
	char hold[3*MAX_LENGTH];

	symb=SA_SYMBOL;
	switch(wayp_type) {
		case NORMAL_WP	: j=waypoints; break;
		case PROX_WP	: j=proximityp; symb=SA_CIRCLE; break;
		case ROUTE_1_WP	:
		case ROUTE_WP	: j=1; break;
		case NORMAL_WP_1: j=1; break;
	}
	for(i=1;i<=j;i++) {
		fill_waypoint_from_push(i,wayp_type,1);
		chk_cmdline();
		if(wayp_type == ROUTE_1_WP) {
			null_newline(route_comment);
			if(TextFileOutput) {
				fprintf(out,"R  %02d %s\n",route_number,route_comment);
			}
			else {
				if(tmode)printf("R  %02d %s\n",route_number,route_comment);
			}
		}
//		fixname(0,(BYTE *)record.ident);
		record.ident[15]=0;
		if(GarDownWP) {
			record.ident[6]=0;
			sprintf(bfr,"%c  %-6s ",record.type,record.ident);
		}
		else {
			sprintf(bfr,"%c  %-15s ",record.type,record.ident);
		}

		strcpy(hold,bfr);
		sprintf(bfr,latlongstr());

//		sprintf(bfr,"%c%#02d %#02d.%#04d %c%#03d %#02d.%#04d ",
//		      record.ns,record.dla,record.mla,record.tnthsla,record.ew,
//		      record.dlo,record.mlo,record.tnthslo);

		strcat(hold,bfr);	

		if(ZeroTime==1) 
			sprintf(bfr,"%s ", "Sun Dec 31 00:00:00 1989");
		else
			sprintf(bfr,"%s ", record.datetime);
		strcat(hold,bfr);
//==============================================================================
//INT	nameonlytxt=0; 	// Handles comment and symbol display options on text
//                      //  output
//						//	
//						// 0  - all items written
//						// 1  - comment not written on regular waypoints
//						// 2  - the symbol display  information not written
//						// 3  - Comment & symbol display information not written
//==============================================================================
		if((nameonlytxt&1)==0 || wayp_type==PROX_WP) {
			sprintf(bfr,"%-20s",record.comment);
			strcat(hold,bfr);
		}

		if((nameonlytxt&2)==0 || wayp_type==PROX_WP) {
			sprintf(bfr,";%5d;%d;%d",record.icon_smbl,record.icon_dspl,via);
			strcat(hold,bfr);
		}
				
		if(wayp_type==PROX_WP) {
			sprintf(bfr,";%-7.1f",record.ProxDist);
			strcat(hold,bfr);
		}
		trim(hold);
		if(pb==1) {
			strcpy((char*)bin,hold);
			return;
		}
		if(TextFileOutput) {
			fprintf(out,"%s\n",hold);
		}
		else {
			printf("%s\n",hold);
		}
		if(datatype==151 || datatype == 152 || datatype == 154 || datatype == 155) {
			if(TextFileOutput) {
				fprintf(out,"c4 %s;%s;%s;%s;%d;%d;\n",record.name,record.city,record.state,record.cc,
					record.class,datatype);
			}
			else {
				printf("c4 %s;%s;%s;%s;%d;%d;\n",record.name,record.city,record.state,record.cc,
					record.class,datatype);
			}
		}
		if(D105orD106) {
			if(TextFileOutput) {
				fprintf(out,"c1 %s\n",StreetPilotWptName);
			}
			else {
				printf("c1 %s\n",StreetPilotWptName);
			}
			if(wayp_type==ROUTE_WP || wayp_type==ROUTE_1_WP) {
				if(TextFileOutput) {
					fprintf(out,"c2 %s\n",StreetPilotLnk_ident);
					fprintf(out,"c3 %02X",record.class);
					for(i=0;i<12;i++) fprintf(out," %02X",record.subclass[i]);
					fprintf(out," %02X\n",record.subclass[12]);
				}
				else {
					printf("c2 %s\n",StreetPilotLnk_ident);
					printf("c3 %02X",record.class);
					for(i=0;i<12;i++) printf(" %02X",record.subclass[i]);
					printf(" %02X\n",record.subclass[12]);
				}
			}
		}
	}
} /* print_waypoints */

PROCX int wpt_in_route(char *wpt, int rt)
{
	INT i,j,mr,st;
	unsigned char bfr[MAX_LENGTH];
	char *p;

	if(rt) {
		mr=MAXROUTES;
		st=1;
	}
	else {
		mr=0;
		st=0;
	}

	for(i=st;i<=mr;i++) {
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j]==NULL) continue;
			strcpy((char*)bfr,route_push[i][j]);
			p=strtok3((char*)bfr,";");
			p=strtok3(NULL,";");
			p=strtok3(NULL,";");
			if(strcmp(p,wpt) == 0) return 1;
			
		}
	}
	return 0;
} // wpt_in_route(char *wpt)

/* -------------------------------------------------------------------------- */
PROCX void print_routes()
{
	INT i,j,points;

	sum_dist=0.0;
	for(i=0;i<=MAXROUTES;i++) {
		route_number=i;
		track_d=0.0;
		points=0;
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j]==NULL) continue;
			strcpy((char*)bin,route_push[i][j]);
			if(j==1) 
				print_waypoints(ROUTE_1_WP,0);
			else
				print_waypoints(ROUTE_WP,0);
			points++;
			if(points>1) track_d+=distance(lastlat,lastlon,record.la,record.lo);
			lastlat=record.la;
			lastlon=record.lo;
		}
		if(points==0) continue;
		if(TextFileOutput) {
			fprintf(out,"E  %02d\n",i);
		}
		else {
			printf("E  %02d\n",i);
		}
		if(total_dist) {
			sum_dist+=track_d;
			if(TextFileOutput) {
				if(points>1)
					fprintf(out," Dist: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
					        track_d,track_d*1.15078,track_d*1.852);
					fprintf(out," DSum: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
						sum_dist, sum_dist*1.15078, sum_dist*1.852);
			}
			else {
				if(points>1)
					printf(" Dist: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
					        track_d,track_d*1.15078,track_d*1.852);
					printf(" DSum: %8.4lf nm, %8.4lf sm, %8.4lf km\n",
						sum_dist, sum_dist*1.15078, sum_dist*1.852);
			}
		}
	}
} /* print_routes */

/* -------------------------------------------------------------------------- */
PROCX void output_OZI_rte(void)
{
	int i,j;
	char bb[MAX_LENGTH];

	if(open_output("w")==0) return;
	fprintf(out,"OziExplorer Route File Version 1.0\n");
	fprintf(out,"WGS 84\n");
	fprintf(out,"Reserved 1\n");
	fprintf(out,"Reserved 2\n");

	for(i=0;i<=MAXROUTES;i++) {
		route_number=i;
		track_d=0.0;
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j]==NULL) continue;
			strcpy((char*)bin,route_push[i][j]);
			if(j==1) {
				fprintf(out,"R,%3d,%-14s,,255\n",route_number,route_comment);
				fill_waypoint_from_push(i,ROUTE_1_WP,0);
			}
			else
				fill_waypoint_from_push(i,ROUTE_WP,0);
			strcpy(bb,fmt_OZI_wpt(j));
			fprintf(out,"W,%3d,%3d,%3d,%s\n",i,j,j,&bb[5]);
		}
	}
} /* output_OZI_rte */

/* -------------------------------------------------------------------------- */
PROCX void send_g45_routes()
{
	int i,j,sentr,cc;

	for(i=0;i<=MAXROUTES;i++) {
		in_route=1;
		sentr=0;
		route_number=i;
		if(route_number==20) route_number=0;
		for(j=1;j<=MAXPOINTS;j++) {
			if(route_push[i][j] == NULL) continue;
			strcpy((char*)bin,route_push[i][j]);
			if(j==1) {
				fprintf(stderr,"R%03d\n",i);
				fill_waypoint_from_push(i,ROUTE_1_WP,0);
				doSRouteHdr();
				fprintf(stderr,"RW%02d of %02d\r",j,routeXpts[route_number]);
				doSWaypoint(0);
				sentr=1;
			}
			else {
				fill_waypoint_from_push(i,ROUTE_WP,0);
				fprintf(stderr,"RW%02d\r",j);
				doSWaypoint(0);
			}
			cc=kbraw();
			if(cc=='x' || cc=='X') {
				SendGarminMessage(Gabort,4,"Gabort");  // Abort the transfer
				getGarminMessage(1);                   // get ACK/NAK
				fprintf(stderr,"\nOperator Abort\n");
				in_route=0;
				return;
			}
		}
		if(sentr) {
			fprintf(stderr,"\n");
			SendGarminMessage(rtet, 4,"Route DB terminator");
			getGarminMessage(1);
		}
	}
	in_route=0;
} /* send_g45_routes */

/* -------------------------------------------------------------------------- */
PROCX void output_g45()
{
	unsigned int i,cc;

	if(input_files) {
		if(proximityp) {
			fprintf(stderr,"P00000 of %d\r",proximityp);
			for(i=1;i<=proximityp;i++) {
				fprintf(stderr,"P%05d\r",i);
				fill_waypoint_from_push(i,PROX_WP,0);
				doSWaypoint(1);
			}
			fprintf(stderr,"P%05d\n",proximityp);
			SendGarminMessage(prxt, 4,"Prox Waypoint Terminator");
			getGarminMessage(1);
		}
		if(waypoints) {
			fprintf(stderr,"W00000 of %d\r",waypoints);
			for(i=1;i<=waypoints;i++) {
				fprintf(stderr,"W%05d\r",i);
				fill_waypoint_from_push(i,NORMAL_WP,0);
				doSWaypoint(0);
				cc=kbraw();
				if(cc=='x' || cc=='X') {
					SendGarminMessage(Gabort,4,"Gabort");  // Abort the transfer
					getGarminMessage(1);                   // get ACK/NAK
					fprintf(stderr,"\nOperator Abort\n");
					goto rtss;
				}
			}
			fprintf(stderr,"W%05d\n",waypoints);
			SendGarminMessage(wptt, 4,"Waypoint Terminator");
			getGarminMessage(1);
		}
rtss:;
		send_g45_routes();
		if(tracks) {
			fprintf(stderr,"T00000 of %05u\r",tracks);
			for(i=1;i<=tracks;i++) {
				fprintf(stderr,"T%05d\r",i);
				fill_track(i,0);
				doSTrack();
				cc=kbraw();
				if(cc=='x' || cc=='X') {
					SendGarminMessage(Gabort,4,"Gabort");  // Abort the transfer
					getGarminMessage(1);                   // get ACK/NAK
					fprintf(stderr,"\nOperator Abort\n");
					goto rtss1;
				}
			}
			fprintf(stderr,"T%05u\n",tracks);
			SendGarminMessage(trkt, 4,"Track Terminator");
			getGarminMessage(1);
		}
	}
rtss1:;
	if(light!=-1) {
		if(light==0) light_off();
		else light_on();
	}
	if(contrast_val>=0) set_contrast();
	if(pwr==1) poweroff();
} /* output_g45 */

/* -------------------------------------------------------------------------- */
PROCX void print_csv_w()
{
	char zone[12] = { ' ', ' ', ' ', ' ', ' ', ' ',
                          ' ', ' ', ' ', ' ', ' ', 0};
	double x,y;


	fprintf(out,"%c,%s,", record.type,record.ident);
	if(UTM) {
		UTMf=UTMf_out;
		UTMa=UTMa_out;
		DegToUTM(record.la,record.lo, zone, &x, &y);
		fprintf(out,"%c%c,%c,%.4lf,%.3lf,",zone[0],zone[1],zone[2],x,y);
	}
	else {
		fprintf(out,"%3.8lf,%3.8lf,",record.la,record.lo);
	}
	fprintf(out,"%d,%d,%d,%d,%d,%d,%s,%d,%d\n",
		record.monthn,record.dayofmonth,record.year,
		record.ht,record.mt,record.st,
		record.comment,record.icon_smbl,record.icon_dspl);
} // print_csv_w()

/* -------------------------------------------------------------------------- */
PROCX void print_csv_i()
{
	char zone[12] = { ' ', ' ', ' ', ' ', ' ', ' ',
                          ' ', ' ', ' ', ' ', ' ', 0};
	double x,y;

	fprintf(out,"%c,%s,",record.type,"");
	if(UTM) {
		UTMf=UTMf_out;
		UTMa=UTMa_out;
		DegToUTM(record.la,record.lo, zone, &x, &y);
		fprintf(out,"%c%c,%c,%.4lf,%.3lf,",zone[0],zone[1],zone[2],x,y);
	}
	else {
		fprintf(out,"%3.8lf,%3.8lf,",record.la,record.lo);
	}

	fprintf(out,"%d\n",record.icon_smbl);
} // print_csv_i()

/* -------------------------------------------------------------------------- */
PROCX void print_csv_t()
{
	char pp;
	char zone[12] = { ' ', ' ', ' ', ' ', ' ', ' ',
                          ' ', ' ', ' ', ' ', ' ', 0};
	double x,y;

	if(newTrack) pp='N'; else pp=record.type;

	fprintf(out,"%c,%s,",pp, "");
	if(UTM) {
		UTMf=UTMf_out;
		UTMa=UTMa_out;
		DegToUTM(record.la,record.lo, zone, &x, &y);
		fprintf(out,"%c%c,%c,%.4lf,%.3lf,",zone[0],zone[1],zone[2],x,y);
	}
	else {
		fprintf(out,"%3.8lf,%3.8lf,",record.la,record.lo);
	}
	fprintf(out,"%d,%d,%d,%d,%d,%d\n",
		record.monthn, record.dayofmonth, record.year,
		record.ht, record.mt, record.st);
} // print_csv_t()

/* -------------------------------------------------------------------------- */
PROCX void output_CSV()
{
	unsigned int i;

	if(open_output("w")==0) return;
	in_route=0;
	fprintf(out,"Datum:,%s\n",outputdatum);
	if(waypoints) {
		for(i=1;i<=waypoints;i++) {
			fill_waypoint_from_push(i,NORMAL_WP,1);
			datetime2record(record.datetime);
			print_csv_w();
		}
	}
	if(tracks) {
		for(i=1;i<=tracks;i++) {
			fill_track(i,1);
			datetime2record(record.datetime);
			print_csv_t();
		}
	}
	if(icons) {
		for(i=1;i<=icons;i++) {
			fill_icon(i,(unsigned char *)"",1);
			print_csv_i();
		}
	}
	fclose(out);
} // output_CSV()

/* -------------------------------------------------------------------------- */
PROCX void output_text()
{
	time_t t;
	struct tm *gmt;

	if(TextFileOutput) {
		if(open_output("w")==0) return;
	}
	if(waypoints||proximityp||tracks||icons||route_points) {
		t=time(NULL);
		gmt=gmtime(&t);
		if(TextFileOutput) {
			fprintf(out,"#%s GMT\n",null_newline(asctime(gmt)));
			fprintf(out,"D %s\n",outputdatum);
			if(UTM) {
				fprintf(out,"M UTM\n");
			}
			else {
				fprintf(out,"M DMM\n");
			}
		}
		else {
			printf("#%s GMT\n",null_newline(asctime(gmt)));
			printf("D %s\n",outputdatum);
			if(UTM) {
				printf("M UTM\n");
			}
			else {
				printf("M DMM\n");
			}
		}
	}
	if(waypoints) print_waypoints(NORMAL_WP,0);
	if(proximityp) print_waypoints(PROX_WP,0);
	if(tracks) print_tracks();
	if(icons) print_icons();
	print_routes();
	if(TextFileOutput) fclose(out);

} /* output_text */

PROCX void output_wpt2trk()
{
	int i;

	char *n="N  New Track Start\n";

	if(waypoints) {
		if(open_output("w")==0) return;
		fprintf(out,n);
		for(i=1;i<=waypoints;i++) {
			fill_waypoint_from_push(i,NORMAL_WP,0);
			if(strcmp(record.comment,"NEW") == 0) 
				fprintf(out,n);
			fprintf(out,"%c  %s %s\n", 'T', latlongstr(),record.datetime);
		}
		fclose(out);
	}
} /* output_wpt2trk */

/* -------------------------------------------------------------------------- */
PROCX void clear_route_dupes()
{
	int i,j,k,nexti;
	char t[MAX_LENGTH],w[MAX_LENGTH],r[MAX_LENGTH];

	for(i=1;i<=waypoints;i++) {
		strcpy(t,waypoint_push[i]);
		(void*)strtok3(t,";");			// skip 'W' waypoint type
		(void*)strtok3(NULL,";");		// skip '0' datatype
		strcpy(w,strtok3(NULL,";"));	// get name
		for(j=0;j<=MAXROUTES;j++) {
			for(k=1;k<=MAXPOINTS;k++) {
				nexti=0;
				if(route_push[j][k]==NULL) continue;
				strcpy(t,route_push[j][k]);
				p=strtok3(t,";");
				p=strtok3(NULL,";");
				strcpy(r,strtok3(NULL,";"));
				if(strcmp(w,r)==0) {
					waypoint_push[i]=NULL;
					nexti=1;
					break;
				}
			}
			if(nexti) break;
		}
	}
doit:;	
	for(i=1;i<=waypoints;i++) {
		if(waypoint_push[i]==NULL) {
			waypoint_push[i]=waypoint_push[i+1];
			for(j=i+1;j<waypoints;j++) {
				waypoint_push[j]=waypoint_push[j+1];
			}
			waypoints--;
			goto doit;
		}
	}
} /* clear_route_dupes */

/* -------------------------------------------------------------------------- */
/*
W;99-FA;99-FAYETTEVILLE;Wed Jun 18 23:31:24 1997!44.461697;123.110283;12;0;0;0;2;2;-1;
P;PROX01;;Wed Jun 18 23:31:24 1997!44.461697;123.110283;100.501404;1;1;1;1;2;2;
 *
 *  If a proximity waypoint has the same latitude and longitude as an existing
 *   waypoint, replace the proximity name, comment and date with the 
 *   waypoint name, comment and date.
 */
PROCX void clean_proximity()
{
	char buf[MAX_LENGTH];
	char typew[5],typep[5];
	char namew[50],namep[50];
	char commentw[50],commentp[50];
	char datetimew[50],datetimep[50];
	char latw[20],latp[20];
	char lonw[20],lonp[20];
	char restp[150];
	char dist[20];
	int i,j;

	for(i=1;i<=proximityp;i++) {
		strcpy(buf,proximity_push[i]);
		strcpy(typep,strtok3(buf,";"));
		strcpy(namep,strtok3(NULL,";"));
		strcpy(commentp,strtok3(NULL,";"));
		strcpy(datetimep,strtok3(NULL,"!"));
		strcpy(latp,strtok3(NULL,";"));
		strcpy(lonp,strtok3(NULL,";"));
		strcpy(dist,strtok3(NULL,";"));
		strcpy(restp,strtok3(NULL,"*"));
		for(j=1;j<=waypoints;j++) {
			strcpy(buf,waypoint_push[j]);
			strcpy(typew,strtok3(buf,";"));
			strcpy(namew,strtok3(NULL,";"));
			strcpy(commentw,strtok3(NULL,";"));
			strcpy(datetimew,strtok3(NULL,"!"));
			strcpy(latw,strtok3(NULL,";"));
			strcpy(lonw,strtok3(NULL,";"));
			if(strcmp(latw,latp)==0 && strcmp(lonw,lonp)==0) {
				free(proximity_push[i]);
				sprintf(buf,"%s;%s;%s;%s!%s;%s;%s;%s",
					typep,namew,commentw,datetimew,latw,lonw,dist,restp);
				if((proximity_push[i]=calloc(strlen(buf)+1,1)) == NULL)  oomem("clean_proximity");
				strcpy(proximity_push[i],buf);
				continue;
			}
		}
	}
} /* clean_proximity */

/* -------------------------------------------------------------------------- */
PROCX void push_files(char *b)
{
	if((infiles[++input_files]=malloc(strlen(b)+1)) == NULL)  oomem("push_files");
	strcpy(infiles[input_files],b);
} /* push_files */

/* -------------------------------------------------------------------------- */
PROCX void process_g45_in()
{
	char b[40],b1[40],b2[10];
	INT i,j;

	strcpy(b,&optarg[3]);
	strupr(b);
	i=0;
	while(b[i]) {
		switch(b[i]) {
			case 'A': 	strcpy(b1,"G45A");
						break;
			case 'I': 	strcpy(b1,"G45I");
						break;
			case 'D': 	strcpy(b1,"G45D");
						break;
			case 'G': 	i++;
						j=0;
						while(b[i] && b[i]<='9' && b[i]>=0) {
							b2[j++]=b[i++];
						}
						i--;
						b2[j]=0;
						strcpy(b1,"G45G");
						strcat(b1,b2);
						break;
			case 'J': 	strcpy(b1,"G45J");
						break;
			case 'Q':   strcpy(b1,"G45Q");
						break;
			case 'R': 	strcpy(b1,"G45R");
						break;
			case 'T': 	strcpy(b1,"G45T");
						break;
			case 'W': 	strcpy(b1,"G45W");
						break;
			case 'X': 	strcpy(b1,"G45X");
						break;
			case 'V': 	strcpy(b1,"G45V");
						break;
			case 'P': 	i++;
						j=0;
						while(b[i] && b[i]<='9' && b[i]>=0) {
							b2[j++]=b[i++];
						}
						i--;
						b2[j]=0;
						strcpy(b1,"G45P");
						strcat(b1,b2);
						break;
			default:
						strcpy(b1,"G45");
						b2[0]=b[i];
						b2[1]=0;
						strcat(b1,b2);
						fprintf(stderr,
			              "'-i %s' is not a valid GARMIN input command.\n",b1);
						break;
		}
		push_files(b1);
		i++;
	}
} /* process_g45_in */

/* -------------------------------------------------------------------------- */
PROCX void process_lwr_in(void)
{
	char b[40],b1[40];
	INT i,j,err=0;

	strcpy(b,&optarg[3]);
	strupr(b);
	i=j=0;
	while(b[i]) {
		switch(b[i]) {
			case '1': 	strcpy(b1,"LWR1");
						break;
			case '2': 	strcpy(b1,"LWR2");
						break;
			case 'D': 	strcpy(b1,"LWRD");
						break;
			case 'I': 	strcpy(b1,"LWRI");
						break;
			case 'R': 	strcpy(b1,"LWRR");
						break;
			case 'W': 	strcpy(b1,"LWRW");
						break;
			case 'S':   strcpy(b1,"LWRS");
						i++;
						j=4;
						while((b[i]>='0' && b[i] <= '9') || b[i]==',') {
							b1[j++]=b[i++];
						}
						b1[j]=0;
						i--;
						break;

			default:	strcpy(b1,b);
						fprintf(stderr,"'-i lwr%s' is not a valid Lowrance input command.\n",b1);
						err=1;
		}
		if(err==0) {
			push_files(b1);
		}
		i++;
		err=0;
	}
} /* process_lwr_in */

PROCX void initialize()
{
	INT i,j;
//
// allocate space for variables
//
	if((SerialMessage=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((SerialMessageOut=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((message=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((routename1=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((route_comment=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((Text=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((LastGarminGPSMsg=(BYTE*)malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((LastLowrGPSMsg=(BYTE*)malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((trks=malloc(20000*sizeof(INT))) == NULL) oomem("init");;
	if((buf=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((bin=(BYTE*)malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((routeXpts=malloc(MAXROUTES*sizeof(int)+1)) == NULL) oomem("init");;
	if((fname_in_all=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((fname_out_all=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((drive=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((dir=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((file=malloc(MAX_LENGTH)) == NULL) oomem("init");
	if((ext=malloc(MAX_LENGTH)) == NULL) oomem("init");

	for(i=0;i<=MAXROUTES;i++) routeXpts[i]=0; // initialize to no route
					 	  					  //  elements in xth route
						 					  //  segment

	maxtrkptrs=MAXTRACK;
	maxiconptrs=MAXICON;
	for(i=0;i<=MAXROUTES;i++)
		for(j=0;j<=MAXPOINTS;j++)
			route_push[i][j] = NULL;
/*
 * clear out track segment array
 */
	for(i=0;i<20000;i++) trks[i]=-1;

	gPrefs.offset = 0;						// gmt offset in hours
	gPrefs.datum = 100;						// WGS 84
	if((StreetPilotWptName=calloc(MAX_LENGTH,1)) == NULL) oomem("init");
	if((StreetPilotLnk_ident=calloc(MAX_LENGTH,1)) == NULL) oomem("init");
#if !__BORLANDC__
	SetConsoleTitle("g7tow Windows Version");
#endif
	set_datum("WGS-84","WGS-84");
	strcpy(debugin_name,"testin");
} // initialize()

/* -------------------------------------------------------------------------- */
PROCX int main(INT argc, char **argv)
{
	INT i;
	char b[MAX_LENGTH];
	char debug_file[MAX_LENGTH];    // name of debug output file if used

    char *opts=
"!12345:6:789:0aAb:B:c:C:dDeEf:F:GgH:h:i:I:j:J:KkLlm:M:nNo:O:p:P:q:Q:r:R:sSt:T:UuvVw:W:xXY:y:z:Z:";

	if(argc<2) Usageh0();
	initialize();
#if !__BORLANDC__
	strcpy(ProgramName,argv[0]);
#endif

	while ((optchar=getopt(argc,argv,opts))!=-1) {

	    switch (optchar)
	    {
			case '!':	GarDownWP=1;break;
			case '0':   ZeroTime=1; break;

			case '1':   Ozi_to_12=1; break;
	    	case '2':	ComPort=COM2; strcpy(commp,"COM2"); break;
	    	case '3':	ComPort=COM3; strcpy(commp,"COM3"); break;
	    	case '4':	ComPort=COM4; strcpy(commp,"COM4"); break;
	    	case '5':	
#if __BORLANDC__
						decode_COM(optarg); break;
#else
#ifdef unix
						strcpy(commp, optarg);
#else
						fprintf(stderr,"Not valid under windows version\n");
#endif
						break;
#endif
	
			case '6':   port_speed=atol(optarg); break;

			case '7':	DisplayIsLowrance++; break;

			case '8':   timeonsa3=1; break;

			case '9':	strcpy(debugin_name,optarg); break;

			case 'a':
			case 'A':	tmode++; output++; break;

			case 'b':
			case 'B':	strupr(optarg);
						if(optarg[0]=='Y') {
							draw_route_1_19_lines=1;
							draw_track_lines=1;
							draw_waypoints=1;
							draw_prox_circles=1;
							draw_route_1_19_obj=1;
							draw_route_0=1;
							draw_route_0_obj=1;
							break;
						}
						if(optarg[0]=='N') {
							draw_route_1_19_lines=0;
							draw_track_lines=0;
							draw_waypoints=0;
							draw_prox_circles=0;
							draw_route_1_19_obj=0;
							draw_route_0=0;
							draw_route_0_obj=0;
							break;
						}
						Usage(23);
						break;

			case 'c':
			case 'C':	if(setlat==1000.0) setlat=mhr(optarg);
						else setlon=mhr(optarg);
						break;
		
			case 'd':
			case 'D':	total_dist++; break;

			case 'e':
			case 'E':	nocmdline=1; break;

			case 'f':
			case 'F':	maxtrkptrs=atoi(optarg);
						if(maxtrkptrs==0) {
							if((trks_out=fopen("1225422","w"))==NULL) {
								printf("Cannot open track temp file, reverting to internal\n");
								maxtrkptrs=MAXTRACK;
							}
						}
						break;

			case 'g':
			case 'G':   ShowGrids=0;break;

			case 'h':
			case 'H': 	strupr(optarg);
						switch(optarg[0]) {
							case 'D': UsagehD();
							case 'I': UsagehI();
							case 'O': UsagehO();
							default: Usageh0();
						}

		   	case 'i':
		   	case 'I':   
						if(strncmpi(optarg,"G45",3) == 0) {
							process_g45_in();
							break;
						}
						if(strncmpi(optarg,"LWR",3) == 0) {
							process_lwr_in();
							break;
						}

						if((infiles[++input_files]=malloc(strlen(optarg) +1))==NULL) oomem("main");
						strcpy(infiles[input_files],optarg);
						break;
				
			case 'j':
			case 'J':  	nameonlytxt=atoi(optarg); break;

			case 'k':
			case 'K':   cycle_track_colors++; break;

			case 'l':
			case 'L':   SendLowrInactives++; break;

			case 'm':
			case 'M':	setmag=atoi(optarg); break;

			case 'n':
			case 'N':  	noname++; break;

			case 'o':
			case 'O':	if((outfiles[++output_files]=malloc(strlen(optarg)+1))==NULL) oomem("main");
						strcpy(outfiles[output_files],optarg);
						if(strnicmp(optarg,"lwr",3) == 0) {Lwrout=1; G45out=0; }
						if(strnicmp(optarg,"g45",3) == 0) {G45out=1; Lwrout=0; }
	    				(void)fnsplit(optarg,drive,dir,file,ext);
	    				if(strlen(ext)) {
                			if(strcmp(strupr(ext),".SA3") == 0) sa_fileout=1;
                			if(strcmp(strupr(ext),".SA4") == 0) sa_fileout=1;
                			if(strcmp(strupr(ext),".SA5") == 0) sa_fileout=1;
                			if(strcmp(strupr(ext),".SA6") == 0) sa_fileout=1;
	    				}
						output++;
						break;
			case 'p':
			case 'P':	set_circle_parms(); break;
				
			case 'q':
			case 'Q':  	nameonly=atoi(optarg); 
						break;

			case 'r':
			case 'R':	set_line_parms(1); break;

			case 's':
			case 'S':	nosort=1; break;

			case 't':
			case 'T':	set_line_parms(0); break;

			case 'u':
			case 'U':	UTM=1; break;

			case 'v':
			case 'V':	
#if __BORLANDC__
						doAsyncStat++; break;
#else
						fprintf(stderr,"Not valid under windows version\n");
						break;
#endif

			case 'w':
			case 'W':   set_symbol_parms(); break;

			case 'x':
			case 'X':   Lwrout=1; G45out=0; break;
	
			case 'y':
			case 'Y':	if(strcmp(optarg,"1") == 0) {
							print_datums();
							break;
						}
						strcpy(outputdatum,optarg);
						set_datum("WGS-84",outputdatum);
						break;

			case 'z':
			case 'Z':	Gdebug=1;
						if(optarg[0]=='!') {
							strcpy(debug_file, &optarg[1]); 
							strcpy(outfmt,"%3d");
						}
						else {
							strcpy(debug_file,optarg);
							strcpy(outfmt," %02x");
						}
						break;
		} // switch()
	}

#if __BORLANDC__
	os=getenv("OS");
	if(os==NULL) WinNT=0;
	else if(stricmp(os,"Windows_NT") == 0) WinNT=1;
#endif
//
// Open debug file?
//
	if(Gdebug==1) {
		if((Gdebug_out=fopen(debug_file,"w")) == NULL) {
			fprintf(stderr,"Error opening file:'%s'\n",debug_file);
		}
		fprintf(Gdebug_out,"Program version: %s%s%s\n",PGMVER,PGMBETA,PGMSUF);
	}
	for(i=1;i<=input_files;i++) do_input(i);

//
// Sort and 'unique' waypoints
//
	if(waypoints>1 && nosort==0)  sortit(waypoint_push,&waypoints);
	if(proximityp>1) sortit(proximity_push,(int*)&proximityp);
	if(!output) tmode++;
	in_route=0;
	clean_proximity();
	if(maxtrkptrs==0) {
		fclose(trks_out);
		if((trks_out=fopen("1225422","r"))==NULL) {
			fprintf(stderr,"Cannot open trk temp file for reading\n");
			tracks=0;
		}
	}
	calc_sa_items();
//
// do lwr output first if it exists
//
	for(i=1;i<=output_files;i++) {
		strcpy(b,outfiles[i]);
		strupr(b);
		if(strnicmp(b,"LWR",3) == 0) do_output(i);
	}
//
// remove waypoints that are also in routes
//
	clear_route_dupes();
//
// outputting text?
//
	if(tmode) output_text();
	tmode=0;
//
// do rest of output next
//
	for(i=1;i<=output_files;i++) {
		strcpy(b,outfiles[i]);
		strupr(b);
		if(strnicmp(b,"LWR",3) !=0) do_output(i);
	}
	if(com_open) {
#if __BORLANDC__
			AsyncStop(IOaddr);
#else
			AsyncStop();
#endif
	}
	if(maxtrkptrs==0) {
		fclose(trks_out);
		unlink("1225422");
	}
	com_open=0;
	byebye(0);
} /* main */
